'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.remove = exports.add = exports.getCurrentPermissions = exports.get = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var get = exports.get = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', /* await */this.getAllAcls());

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function get() {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var getCurrentPermissions = exports.getCurrentPermissions = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt('return', /* await */this.getPermissionsForUser(this.session.get('user_id')));

          case 1:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getCurrentPermissions() {
    return _ref2.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var add = exports.add = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref4) {
    var subject = _ref4.subject,
        object = _ref4.object,
        action = _ref4.action;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return this.addAcl(subject, object, action);

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function add(_x) {
    return _ref3.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var remove = exports.remove = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref6) {
    var subject = _ref6.subject,
        object = _ref6.object,
        action = _ref6.action;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.removeAcl(subject, object, action);

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function remove(_x2) {
    return _ref5.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

get.permission = 'admin';

get.description = 'get existing ACLs';

getCurrentPermissions.permission = '';

getCurrentPermissions.description = 'get (explicit) permissions by object for the current user';

add.permission = 'admin';

add.params = {
  subject: { type: 'string' },
  object: { type: 'string' },
  action: { type: 'string' }
};

add.description = 'add a new ACL entry';

remove.permission = 'admin';

remove.params = {
  subject: { type: 'string' },
  object: { type: 'string' },
  action: { type: 'string' }
};

remove.description = 'remove an existing ACL entry';
//# sourceMappingURL=acl.js.map
