'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchFiles = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _forEach2 = require('lodash/forEach');

var _forEach3 = _interopRequireDefault(_forEach2);

var fetchFiles = exports.fetchFiles = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref6) {
    var _ref6$format = _ref6.format,
        format = _ref6$format === undefined ? 'zip' : _ref6$format,
        params = (0, _objectWithoutProperties3.default)(_ref6, ['format']);
    var fileName;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            fileName = params.paths.length > 1 ? `restore_${new Date().toJSON()}.${format}` : (0, _path.basename)(params.paths[0]);
            return _context.abrupt('return', this.registerHttpRequest(handleFetchFiles, (0, _extends3.default)({}, params, { format }), {
              suffix: encodeURI(`/${fileName}`)
            }).then(function (url) {
              return { $getFrom: url };
            }));

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function fetchFiles(_x) {
    return _ref5.apply(this, arguments);
  };
}();

exports.list = list;
exports.scanDisk = scanDisk;
exports.scanFiles = scanFiles;

var _archiver = require('archiver');

var _archiver2 = _interopRequireDefault(_archiver);

var _path = require('path');

var _jsonRpcPeer = require('json-rpc-peer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

function list(_ref) {
  var remote = _ref.remote;

  return this.listVmBackups(remote);
}

list.permission = 'admin';
list.params = {
  remote: { type: 'string' }
};

// -------------------------------------------------------------------

function scanDisk(_ref2) {
  var remote = _ref2.remote,
      disk = _ref2.disk;

  return this.scanDiskBackup(remote, disk);
}

scanDisk.permission = 'admin';
scanDisk.params = {
  remote: { type: 'string' },
  disk: { type: 'string' }
};

// -------------------------------------------------------------------

function scanFiles(_ref3) {
  var remote = _ref3.remote,
      disk = _ref3.disk,
      partition = _ref3.partition,
      path = _ref3.path;

  return this.scanFilesInDiskBackup(remote, disk, partition, path);
}

scanFiles.permission = 'admin';
scanFiles.params = {
  remote: { type: 'string' },
  disk: { type: 'string' },
  partition: { type: 'string', optional: true },
  path: { type: 'string' }
};

// -------------------------------------------------------------------

function handleFetchFiles(req, res, _ref4) {
  var remote = _ref4.remote,
      disk = _ref4.disk,
      partition = _ref4.partition,
      paths = _ref4.paths,
      archiveFormat = _ref4.format;

  this.fetchFilesInDiskBackup(remote, disk, partition, paths).then(function (files) {
    res.setHeader('content-disposition', 'attachment');
    res.setHeader('content-type', 'application/octet-stream');

    var nFiles = paths.length;

    // Send lone file directly
    if (nFiles === 1) {
      files[0].pipe(res);
      return;
    }

    var archive = (0, _archiver2.default)(archiveFormat);
    archive.on('error', function (error) {
      console.error(error);
      res.end(_jsonRpcPeer.format.error(0, error));
    });

    (0, _forEach3.default)(files, function (file) {
      archive.append(file, { name: (0, _path.basename)(file.path) });
    });
    archive.finalize();

    archive.pipe(res);
  }).catch(function (error) {
    console.error(error);
    res.writeHead(500);
    res.end(_jsonRpcPeer.format.error(0, error));
  });
}

fetchFiles.permission = 'admin';
fetchFiles.params = {
  remote: { type: 'string' },
  disk: { type: 'string' },
  format: { type: 'string', optional: true },
  partition: { type: 'string', optional: true },
  paths: {
    type: 'array',
    items: { type: 'string' },
    minLength: 1
  }
};
//# sourceMappingURL=backup.js.map
