'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resize = exports.create = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// ===================================================================

var create = exports.create = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var name = _ref2.name,
        size = _ref2.size,
        sr = _ref2.sr;
    var vdi;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this.getXapi(sr).createVdi((0, _utils.parseSize)(size), {
              name_label: name,
              sr: sr._xapiId
            });

          case 2:
            vdi = _context.sent;
            return _context.abrupt('return', vdi.$id);

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function create(_x) {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var resize = exports.resize = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
    var vdi = _ref4.vdi,
        size = _ref4.size;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.getXapi(vdi).resizeVdi(vdi._xapiId, (0, _utils.parseSize)(size));

          case 2:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function resize(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

create.description = 'create a new disk on a SR';

create.params = {
  name: { type: 'string' },
  size: { type: ['integer', 'string'] },
  sr: { type: 'string' }
};

create.resolve = {
  sr: ['sr', 'SR', 'administrate']
};

resize.description = 'resize an existing VDI';

resize.params = {
  id: { type: 'string' },
  size: { type: ['integer', 'string'] }
};

resize.resolve = {
  vdi: ['id', ['VDI', 'VDI-snapshot'], 'administrate']
};
//# sourceMappingURL=disk.js.map
