'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unpause = exports.pause = exports.restart = exports.stop = exports.start = exports.deregister = exports.register = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var register = exports.register = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var vm = _ref2.vm;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this.getXapi(vm).registerDockerContainer(vm._xapiId);

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function register(_x) {
    return _ref.apply(this, arguments);
  };
}();

// -----------------------------------------------------------------------------

var deregister = exports.deregister = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
    var vm = _ref4.vm;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.getXapi(vm).unregisterDockerContainer(vm._xapiId);

          case 2:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function deregister(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

// -----------------------------------------------------------------------------

var start = exports.start = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref6) {
    var vm = _ref6.vm,
        container = _ref6.container;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return this.getXapi(vm).startDockerContainer(vm._xapiId, container);

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function start(_x3) {
    return _ref5.apply(this, arguments);
  };
}();

var stop = exports.stop = function () {
  var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref8) {
    var vm = _ref8.vm,
        container = _ref8.container;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.getXapi(vm).stopDockerContainer(vm._xapiId, container);

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function stop(_x4) {
    return _ref7.apply(this, arguments);
  };
}();

var restart = exports.restart = function () {
  var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref10) {
    var vm = _ref10.vm,
        container = _ref10.container;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return this.getXapi(vm).restartDockerContainer(vm._xapiId, container);

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function restart(_x5) {
    return _ref9.apply(this, arguments);
  };
}();

var pause = exports.pause = function () {
  var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(_ref12) {
    var vm = _ref12.vm,
        container = _ref12.container;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this.getXapi(vm).pauseDockerContainer(vm._xapiId, container);

          case 2:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function pause(_x6) {
    return _ref11.apply(this, arguments);
  };
}();

var unpause = exports.unpause = function () {
  var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(_ref14) {
    var vm = _ref14.vm,
        container = _ref14.container;
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return this.getXapi(vm).unpauseDockerContainer(vm._xapiId, container);

          case 2:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));

  return function unpause(_x7) {
    return _ref13.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

register.description = 'Register the VM for Docker management';

register.params = {
  vm: { type: 'string' }
};

register.resolve = {
  vm: ['vm', 'VM', 'administrate']
};
deregister.description = 'Deregister the VM for Docker management';

deregister.params = {
  vm: { type: 'string' }
};

deregister.resolve = {
  vm: ['vm', 'VM', 'administrate']
};var _arr = [start, stop, restart, pause, unpause];


for (var _i = 0; _i < _arr.length; _i++) {
  var fn = _arr[_i];
  fn.params = {
    vm: { type: 'string' },
    container: { type: 'string' }
  };

  fn.resolve = {
    vm: ['vm', 'VM', 'operate']
  };
}
//# sourceMappingURL=docker.js.map
