'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.set = exports.removeUser = exports.addUser = exports.setUsers = exports.getAll = exports.delete = exports.create = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var create = exports.create = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var name = _ref2.name;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this.createGroup({ name });

          case 2:
            return _context.abrupt('return', _context.sent.id);

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function create(_x) {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

// Deletes an existing group.
var delete_ = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
    var id = _ref4.id;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.deleteGroup(id);

          case 2:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function delete_(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

// delete is not a valid identifier.


// -------------------------------------------------------------------

var getAll = exports.getAll = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt('return', /* await */this.getAllGroups());

          case 1:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function getAll() {
    return _ref5.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

// sets group.users with an array of user ids
var setUsers = exports.setUsers = function () {
  var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref7) {
    var id = _ref7.id,
        userIds = _ref7.userIds;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.setGroupUsers(id, userIds);

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function setUsers(_x3) {
    return _ref6.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

// adds the user id to group.users
var addUser = exports.addUser = function () {
  var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref9) {
    var id = _ref9.id,
        userId = _ref9.userId;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return this.addUserToGroup(userId, id);

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function addUser(_x4) {
    return _ref8.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

// remove the user id from group.users
var removeUser = exports.removeUser = function () {
  var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(_ref11) {
    var id = _ref11.id,
        userId = _ref11.userId;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this.removeUserFromGroup(userId, id);

          case 2:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function removeUser(_x5) {
    return _ref10.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

// -------------------------------------------------------------------

var set = exports.set = function () {
  var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(_ref13) {
    var id = _ref13.id,
        name = _ref13.name;
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return this.updateGroup(id, { name });

          case 2:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));

  return function set(_x6) {
    return _ref12.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

create.description = 'creates a new group';
create.permission = 'admin';
create.params = {
  name: { type: 'string' }
};exports.delete = delete_;


delete_.description = 'deletes an existing group';
delete_.permission = 'admin';
delete_.params = {
  id: { type: 'string' }
};

getAll.description = 'returns all the existing group';
getAll.permission = 'admin';

setUsers.description = 'sets the users belonging to a group';
setUsers.permission = 'admin';
setUsers.params = {
  id: { type: 'string' },
  userIds: {}
};

addUser.description = 'adds a user to a group';
addUser.permission = 'admin';
addUser.params = {
  id: { type: 'string' },
  userId: { type: 'string' }
};removeUser.description = 'removes a user from a group';
removeUser.permission = 'admin';
removeUser.params = {
  id: { type: 'string' },
  userId: { type: 'string' }
};

set.description = 'changes the properties of an existing group';
set.permission = 'admin';
set.params = {
  id: { type: 'string' },
  name: { type: 'string', optional: true }
};
//# sourceMappingURL=group.js.map
