'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.delete = undefined;

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

exports.create = create;
exports.getAll = getAll;
exports.set = set;

var _apiErrors = require('xo-common/api-errors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function create(props) {
  return this.createIpPool(props);
}

create.permission = 'admin';
create.description = 'Creates a new ipPool';

// -------------------------------------------------------------------

function delete_(_ref) {
  var id = _ref.id;

  return this.deleteIpPool(id);
}
exports.delete = delete_;


delete_.permission = 'admin';
delete_.description = 'Delete an ipPool';

// -------------------------------------------------------------------

function getAll(params) {
  var user = this.user;


  if (!user) {
    throw (0, _apiErrors.unauthorized)();
  }

  return this.getAllIpPools(user.permission === 'admin' ? params && params.userId : user.id);
}

getAll.description = 'List all ipPools';

// -------------------------------------------------------------------

function set(_ref2) {
  var id = _ref2.id,
      props = (0, _objectWithoutProperties3.default)(_ref2, ['id']);

  return this.updateIpPool(id, props);
}

set.permission = 'admin';
set.description = 'Allow to modify an existing ipPool';
//# sourceMappingURL=ip-pool.js.map
