'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runSequence = exports.delete = exports.set = exports.create = exports.get = exports.getAll = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// FIXME so far, no acls for jobs

var getAll = exports.getAll = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', /* await */this.getAllJobs());

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getAll() {
    return _ref.apply(this, arguments);
  };
}();

var get = exports.get = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(id) {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt('return', /* await */this.getJob(id));

          case 1:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function get(_x) {
    return _ref2.apply(this, arguments);
  };
}();

var create = exports.create = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref4) {
    var job = _ref4.job;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!job.userId) {
              job.userId = this.session.get('user_id');
            }

            _context3.next = 3;
            return this.createJob(job);

          case 3:
            return _context3.abrupt('return', _context3.sent.id);

          case 4:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function create(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

var set = exports.set = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref6) {
    var job = _ref6.job;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.updateJob(job);

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function set(_x3) {
    return _ref5.apply(this, arguments);
  };
}();

var delete_ = function () {
  var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref8) {
    var id = _ref8.id;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return this.removeJob(id);

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function delete_(_x4) {
    return _ref7.apply(this, arguments);
  };
}();

var runSequence = exports.runSequence = function () {
  var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(_ref10) {
    var idSequence = _ref10.idSequence;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this.runJobSequence(idSequence);

          case 2:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function runSequence(_x5) {
    return _ref9.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

getAll.permission = 'admin';
getAll.description = 'Gets all available jobs';

get.permission = 'admin';
get.description = 'Gets an existing job';
get.params = {
  id: { type: 'string' }
};

create.permission = 'admin';
create.description = 'Creates a new job from description object';
create.params = {
  job: {
    type: 'object',
    properties: {
      userId: { type: 'string', optional: true },
      name: { type: 'string', optional: true },
      timeout: { type: 'number', optional: true },
      type: { type: 'string' },
      key: { type: 'string' },
      method: { type: 'string' },
      paramsVector: {
        type: 'object',
        properties: {
          type: { type: 'string' },
          items: {
            type: 'array',
            items: {
              type: 'object'
            }
          }
        },
        optional: true
      }
    }
  }
};

set.permission = 'admin';
set.description = 'Modifies an existing job from a description object';
set.params = {
  job: {
    type: 'object',
    properties: {
      id: { type: 'string' },
      name: { type: 'string', optional: true },
      timeout: { type: ['number', 'null'], optional: true },
      type: { type: 'string', optional: true },
      key: { type: 'string', optional: true },
      method: { type: 'string', optional: true },
      paramsVector: {
        type: 'object',
        properties: {
          type: { type: 'string' },
          items: {
            type: 'array',
            items: {
              type: 'object'
            }
          }
        },
        optional: true
      }
    }
  }
};

delete_.permission = 'admin';
delete_.description = 'Deletes an existing job';
delete_.params = {
  id: { type: 'string' }
};

exports.delete = delete_;


runSequence.permission = 'admin';
runSequence.description = 'Runs jobs sequentially, in the provided order';
runSequence.params = {
  idSequence: { type: 'array', items: { type: 'string' } }
};
//# sourceMappingURL=job.js.map
