'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.delete = exports.get = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var get = exports.get = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var namespace = _ref2.namespace;
    var logger;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this.getLogger(namespace);

          case 2:
            logger = _context.sent;
            return _context.abrupt('return', new _promise2.default(function (resolve, reject) {
              var logs = {};

              logger.createReadStream().on('data', function (data) {
                logs[data.key] = data.value;
              }).on('end', function () {
                resolve(logs);
              }).on('error', reject);
            }));

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function get(_x) {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var delete_ = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
    var namespace = _ref4.namespace,
        id = _ref4.id;
    var logger;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.getLogger(namespace);

          case 2:
            logger = _context2.sent;

            logger.del(id);

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function delete_(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

get.description = 'returns logs list for one namespace';
get.params = {
  namespace: { type: 'string' }
};
get.permission = 'admin';

delete_.description = 'deletes one or several logs from a namespace';
delete_.params = {
  id: { type: ['array', 'string'] },
  namespace: { type: 'string' }
};
delete_.permission = 'admin';

exports.delete = delete_;
//# sourceMappingURL=log.js.map
