'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.editPif = exports.reconfigureIp = exports.connect = exports.disconnect = exports.delete = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// ===================================================================
// Delete

var delete_ = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var pif = _ref2.pif;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this.getXapi(pif).call('PIF.destroy', pif._xapiRef);

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function delete_(_x) {
    return _ref.apply(this, arguments);
  };
}();

// ===================================================================
// Disconnect

var disconnect = exports.disconnect = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
    var pif = _ref4.pif;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.getXapi(pif).call('PIF.unplug', pif._xapiRef);

          case 2:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function disconnect(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

// ===================================================================
// Connect

var connect = exports.connect = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref6) {
    var pif = _ref6.pif;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return this.getXapi(pif).call('PIF.plug', pif._xapiRef);

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function connect(_x3) {
    return _ref5.apply(this, arguments);
  };
}();

// ===================================================================
// Reconfigure IP

var reconfigureIp = exports.reconfigureIp = function () {
  var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref8) {
    var pif = _ref8.pif,
        _ref8$mode = _ref8.mode,
        mode = _ref8$mode === undefined ? 'DHCP' : _ref8$mode,
        ip = _ref8.ip,
        netmask = _ref8.netmask,
        gateway = _ref8.gateway,
        dns = _ref8.dns;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.getXapi(pif).call('PIF.reconfigure_ip', pif._xapiRef, mode, ip, netmask, gateway, dns);

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function reconfigureIp(_x4) {
    return _ref7.apply(this, arguments);
  };
}();

// ===================================================================

var editPif = exports.editPif = function () {
  var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref10) {
    var pif = _ref10.pif,
        vlan = _ref10.vlan;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return this.getXapi(pif).editPif(pif._xapiId, { vlan });

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function editPif(_x5) {
    return _ref9.apply(this, arguments);
  };
}();

exports.getIpv4ConfigurationModes = getIpv4ConfigurationModes;
exports.getIpv6ConfigurationModes = getIpv6ConfigurationModes;

var _xapi = require('../xapi');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getIpv4ConfigurationModes() {
  return _xapi.IPV4_CONFIG_MODES;
} // TODO: too low level, move into host.

function getIpv6ConfigurationModes() {
  return _xapi.IPV6_CONFIG_MODES;
}exports.delete = delete_;


delete_.params = {
  id: { type: 'string' }
};

delete_.resolve = {
  pif: ['id', 'PIF', 'administrate']
};

disconnect.params = {
  id: { type: 'string' }
};

disconnect.resolve = {
  pif: ['id', 'PIF', 'administrate']
};

connect.params = {
  id: { type: 'string' }
};

connect.resolve = {
  pif: ['id', 'PIF', 'administrate']
};

reconfigureIp.params = {
  id: { type: 'string', optional: true },
  mode: { type: 'string', optional: true },
  ip: { type: 'string', optional: true },
  netmask: { type: 'string', optional: true },
  gateway: { type: 'string', optional: true },
  dns: { type: 'string', optional: true }
};

reconfigureIp.resolve = {
  pif: ['id', 'PIF', 'administrate']
};

editPif.params = {
  id: { type: 'string' },
  vlan: { type: ['integer', 'string'] }
};

editPif.resolve = {
  pif: ['id', 'PIF', 'administrate']
};
//# sourceMappingURL=pif.js.map
