'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.test = exports.purgeConfiguration = exports.unload = exports.load = exports.enableAutoload = exports.disableAutoload = exports.configure = exports.get = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var get = exports.get = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', /* await */this.getPlugins());

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function get() {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var configure = exports.configure = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref3) {
    var id = _ref3.id,
        configuration = _ref3.configuration;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.configurePlugin(id, configuration);

          case 2:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function configure(_x) {
    return _ref2.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var disableAutoload = exports.disableAutoload = function () {
  var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref5) {
    var id = _ref5.id;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return this.disablePluginAutoload(id);

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function disableAutoload(_x2) {
    return _ref4.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var enableAutoload = exports.enableAutoload = function () {
  var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref7) {
    var id = _ref7.id;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.enablePluginAutoload(id);

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function enableAutoload(_x3) {
    return _ref6.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var load = exports.load = function () {
  var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref9) {
    var id = _ref9.id;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return this.loadPlugin(id);

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function load(_x4) {
    return _ref8.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var unload = exports.unload = function () {
  var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(_ref11) {
    var id = _ref11.id;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this.unloadPlugin(id);

          case 2:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function unload(_x5) {
    return _ref10.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var purgeConfiguration = exports.purgeConfiguration = function () {
  var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(_ref13) {
    var id = _ref13.id;
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return this.purgePluginConfiguration(id);

          case 2:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));

  return function purgeConfiguration(_x6) {
    return _ref12.apply(this, arguments);
  };
}();

// ---------------------------------------------------------------------

var test = exports.test = function () {
  var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(_ref15) {
    var id = _ref15.id,
        data = _ref15.data;
    return _regenerator2.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            _context8.next = 2;
            return this.testPlugin(id, data);

          case 2:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, this);
  }));

  return function test(_x7) {
    return _ref14.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

get.description = 'returns a list of all installed plugins';

get.permission = 'admin';

configure.description = 'sets the configuration of a plugin';

configure.params = {
  id: {
    type: 'string'
  },
  configuration: {}
};

configure.permission = 'admin';

disableAutoload.description = '';

disableAutoload.params = {
  id: {
    type: 'string'
  }
};

disableAutoload.permission = 'admin';

enableAutoload.description = 'enables a plugin, allowing it to be loaded';

enableAutoload.params = {
  id: {
    type: 'string'
  }
};

enableAutoload.permission = 'admin';

load.description = 'loads a plugin';

load.params = {
  id: {
    type: 'string'
  }
};

load.permission = 'admin';

unload.description = 'unloads a plugin';

unload.params = {
  id: {
    type: 'string'
  }
};

unload.permission = 'admin';

purgeConfiguration.description = 'removes a plugin configuration';

purgeConfiguration.params = {
  id: {
    type: 'string'
  }
};

purgeConfiguration.permission = 'admin';

test.description = 'Test a plugin with its current configuration';

test.params = {
  id: {
    type: 'string'
  },
  data: {
    optional: true
  }
};

test.permission = 'admin';

// ---------------------------------------------------------------------
//# sourceMappingURL=plugin.js.map
