'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.installSupplementalPack = exports.getLicenseState = exports.mergeInto = exports.patch = exports.uploadPatch = exports.installAllPatches = exports.installPatch = exports.setDefaultSr = exports.set = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// ===================================================================

var set = exports.set = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var pool = _ref2.pool,
        nameDescription = _ref2.name_description,
        nameLabel = _ref2.name_label;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this.getXapi(pool).setPoolProperties({
              nameDescription,
              nameLabel
            });

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function set(_x) {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var setDefaultSr = exports.setDefaultSr = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
    var sr = _ref4.sr;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.hasPermissions(this.user.id, [[sr.$pool, 'administrate']]);

          case 2:
            _context2.next = 4;
            return this.getXapi(sr).setDefaultSr(sr._xapiId);

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function setDefaultSr(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var installPatch = exports.installPatch = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref6) {
    var pool = _ref6.pool,
        patchUuid = _ref6.patch;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return this.getXapi(pool).installPoolPatchOnAllHosts(patchUuid);

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function installPatch(_x3) {
    return _ref5.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var installAllPatches = exports.installAllPatches = function () {
  var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref8) {
    var pool = _ref8.pool;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.getXapi(pool).installAllPoolPatchesOnAllHosts();

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function installAllPatches(_x4) {
    return _ref7.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var handlePatchUpload = function () {
  var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(req, res, _ref10) {
    var pool = _ref10.pool;
    var contentLength;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            contentLength = req.headers['content-length'];

            if (contentLength) {
              _context5.next = 5;
              break;
            }

            res.writeHead(411);
            res.end('Content length is mandatory');
            return _context5.abrupt('return');

          case 5:
            _context5.next = 7;
            return this.getXapi(pool).uploadPoolPatch(req, contentLength);

          case 7:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function handlePatchUpload(_x5, _x6, _x7) {
    return _ref9.apply(this, arguments);
  };
}();

var uploadPatch = exports.uploadPatch = function () {
  var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(_ref12) {
    var pool = _ref12.pool;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this.registerHttpRequest(handlePatchUpload, { pool });

          case 2:
            _context6.t0 = _context6.sent;
            return _context6.abrupt('return', {
              $sendTo: _context6.t0
            });

          case 4:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function uploadPatch(_x8) {
    return _ref11.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var mergeInto = exports.mergeInto = function () {
  var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(_ref14) {
    var source = _ref14.source,
        target = _ref14.target,
        force = _ref14.force;
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return this.mergeXenPools(source._xapiId, target._xapiId, force);

          case 2:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));

  return function mergeInto(_x9) {
    return _ref13.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var getLicenseState = exports.getLicenseState = function () {
  var _ref15 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(_ref16) {
    var pool = _ref16.pool;
    return _regenerator2.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            return _context8.abrupt('return', this.getXapi(pool).call('pool.get_license_state', pool._xapiId.$ref));

          case 1:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, this);
  }));

  return function getLicenseState(_x10) {
    return _ref15.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var handleInstallSupplementalPack = function () {
  var _ref17 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(req, res, _ref18) {
    var poolId = _ref18.poolId;
    var xapi;
    return _regenerator2.default.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            xapi = this.getXapi(poolId);

            // Timeout seems to be broken in Node 4.
            // See https://github.com/nodejs/node/issues/3319

            req.setTimeout(43200000); // 12 hours
            req.length = req.headers['content-length'];

            _context9.prev = 3;
            _context9.next = 6;
            return xapi.installSupplementalPackOnAllHosts(req);

          case 6:
            res.end(_jsonRpcPeer.format.response(0));
            _context9.next = 13;
            break;

          case 9:
            _context9.prev = 9;
            _context9.t0 = _context9['catch'](3);

            res.writeHead(500);
            res.end(_jsonRpcPeer.format.error(0, new Error(_context9.t0.message)));

          case 13:
          case 'end':
            return _context9.stop();
        }
      }
    }, _callee9, this, [[3, 9]]);
  }));

  return function handleInstallSupplementalPack(_x11, _x12, _x13) {
    return _ref17.apply(this, arguments);
  };
}();

var installSupplementalPack = exports.installSupplementalPack = function () {
  var _ref19 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(_ref20) {
    var pool = _ref20.pool;
    return _regenerator2.default.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            _context10.next = 2;
            return this.registerHttpRequest(handleInstallSupplementalPack, { poolId: pool.id });

          case 2:
            _context10.t0 = _context10.sent;
            return _context10.abrupt('return', {
              $sendTo: _context10.t0
            });

          case 4:
          case 'end':
            return _context10.stop();
        }
      }
    }, _callee10, this);
  }));

  return function installSupplementalPack(_x14) {
    return _ref19.apply(this, arguments);
  };
}();

var _jsonRpcPeer = require('json-rpc-peer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

set.params = {
  id: {
    type: 'string'
  },
  name_label: {
    type: 'string',
    optional: true
  },
  name_description: {
    type: 'string',
    optional: true
  }
};

set.resolve = {
  pool: ['id', 'pool', 'administrate']
};

setDefaultSr.permission = ''; // signed in

setDefaultSr.params = {
  sr: {
    type: 'string'
  }
};

setDefaultSr.resolve = {
  sr: ['sr', 'SR']
};

installPatch.params = {
  pool: {
    type: 'string'
  },
  patch: {
    type: 'string'
  }
};

installPatch.resolve = {
  pool: ['pool', 'pool', 'administrate']
};

installAllPatches.params = {
  pool: {
    type: 'string'
  }
};

installAllPatches.resolve = {
  pool: ['pool', 'pool', 'administrate']
};

installAllPatches.description = 'Install automatically all patches for every hosts of a pool';

uploadPatch.params = {
  pool: { type: 'string' }
};

uploadPatch.resolve = {
  pool: ['pool', 'pool', 'administrate']
};

// Compatibility
//
// TODO: remove when no longer used in xo-web
exports.patch = uploadPatch;


mergeInto.params = {
  force: { type: 'boolean', optional: true },
  source: { type: 'string' },
  target: { type: 'string' }
};

mergeInto.resolve = {
  source: ['source', 'pool', 'administrate'],
  target: ['target', 'pool', 'administrate']
};

getLicenseState.params = {
  pool: {
    type: 'string'
  }
};

getLicenseState.resolve = {
  pool: ['pool', 'pool', 'administrate']
};

installSupplementalPack.description = 'installs supplemental pack from ISO file on all hosts';

installSupplementalPack.params = {
  pool: { type: 'string' }
};

installSupplementalPack.resolve = {
  pool: ['pool', 'pool', 'admin']
};
//# sourceMappingURL=pool.js.map
