'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.delete = exports.set = exports.create = exports.list = exports.test = exports.get = exports.getAll = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getAll = exports.getAll = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', this.getAllRemotes());

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getAll() {
    return _ref.apply(this, arguments);
  };
}();

var get = exports.get = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref3) {
    var id = _ref3.id;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt('return', this.getRemote(id));

          case 1:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function get(_x) {
    return _ref2.apply(this, arguments);
  };
}();

var test = exports.test = function () {
  var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref5) {
    var id = _ref5.id;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt('return', this.testRemote(id));

          case 1:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function test(_x2) {
    return _ref4.apply(this, arguments);
  };
}();

var list = exports.list = function () {
  var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref7) {
    var id = _ref7.id;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt('return', this.listRemoteBackups(id));

          case 1:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function list(_x3) {
    return _ref6.apply(this, arguments);
  };
}();

var create = exports.create = function () {
  var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref9) {
    var name = _ref9.name,
        url = _ref9.url;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            return _context5.abrupt('return', this.createRemote({ name, url }));

          case 1:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function create(_x4) {
    return _ref8.apply(this, arguments);
  };
}();

var set = exports.set = function () {
  var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(_ref11) {
    var id = _ref11.id,
        name = _ref11.name,
        url = _ref11.url,
        enabled = _ref11.enabled;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this.updateRemote(id, { name, url, enabled });

          case 2:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function set(_x5) {
    return _ref10.apply(this, arguments);
  };
}();

var delete_ = function () {
  var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(_ref13) {
    var id = _ref13.id;
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return this.removeRemote(id);

          case 2:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));

  return function delete_(_x6) {
    return _ref12.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

getAll.permission = 'admin';
getAll.description = 'Gets all existing fs remote points';

get.permission = 'admin';
get.description = 'Gets an existing fs remote point';
get.params = {
  id: { type: 'string' }
};

test.permission = 'admin';
test.description = 'Performs a read/write matching test on a remote point';
test.params = {
  id: { type: 'string' }
};

list.permission = 'admin';
list.description = 'Lists the files found in a remote point';
list.params = {
  id: { type: 'string' }
};

create.permission = 'admin';
create.description = 'Creates a new fs remote point';
create.params = {
  name: { type: 'string' },
  url: { type: 'string' }
};

set.permission = 'admin';
set.description = 'Modifies an existing fs remote point';
set.params = {
  id: { type: 'string' },
  name: { type: 'string', optional: true },
  url: { type: 'string', optional: true },
  enabled: { type: 'boolean', optional: true }
};

delete_.permission = 'admin';
delete_.description = 'Deletes an existing fs remote point';
delete_.params = {
  id: { type: 'string' }
};

exports.delete = delete_;
//# sourceMappingURL=remote.js.map
