'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.delete = exports.set = exports.create = exports.get = exports.getAll = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// FIXME so far, no acls for schedules

var getAll = exports.getAll = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', /* await */this.getAllSchedules());

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getAll() {
    return _ref.apply(this, arguments);
  };
}();

var get = exports.get = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(id) {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt('return', /* await */this.getSchedule(id));

          case 1:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function get(_x) {
    return _ref2.apply(this, arguments);
  };
}();

var create = exports.create = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref4) {
    var jobId = _ref4.jobId,
        cron = _ref4.cron,
        enabled = _ref4.enabled,
        name = _ref4.name,
        timezone = _ref4.timezone;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt('return', /* await */this.createSchedule(this.session.get('user_id'), { job: jobId, cron, enabled, name, timezone }));

          case 1:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function create(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

var set = exports.set = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref6) {
    var id = _ref6.id,
        jobId = _ref6.jobId,
        cron = _ref6.cron,
        enabled = _ref6.enabled,
        name = _ref6.name,
        timezone = _ref6.timezone;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.updateSchedule(id, { job: jobId, cron, enabled, name, timezone });

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function set(_x3) {
    return _ref5.apply(this, arguments);
  };
}();

var delete_ = function () {
  var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref8) {
    var id = _ref8.id;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return this.removeSchedule(id);

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function delete_(_x4) {
    return _ref7.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

getAll.permission = 'admin';
getAll.description = 'Gets all existing schedules';

get.permission = 'admin';
get.description = 'Gets an existing schedule';
get.params = {
  id: { type: 'string' }
};

create.permission = 'admin';
create.description = 'Creates a new schedule';
create.params = {
  jobId: { type: 'string' },
  cron: { type: 'string' },
  enabled: { type: 'boolean', optional: true },
  name: { type: 'string', optional: true }
};

set.permission = 'admin';
set.description = 'Modifies an existing schedule';
set.params = {
  id: { type: 'string' },
  jobId: { type: 'string', optional: true },
  cron: { type: 'string', optional: true },
  enabled: { type: 'boolean', optional: true },
  name: { type: 'string', optional: true }
};

delete_.permission = 'admin';
delete_.description = 'Deletes an existing schedule';
delete_.params = {
  id: { type: 'string' }
};

exports.delete = delete_;
//# sourceMappingURL=schedule.js.map
