'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.disconnect = exports.connect = exports.set = exports.remove = exports.add = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var add = exports.add = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var label = _ref2.label,
        host = _ref2.host,
        username = _ref2.username,
        password = _ref2.password,
        readOnly = _ref2.readOnly,
        _ref2$autoConnect = _ref2.autoConnect,
        autoConnect = _ref2$autoConnect === undefined ? true : _ref2$autoConnect;

    var server, _context;

    return _regenerator2.default.wrap(function _callee$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.registerXenServer({ label, host, username, password, readOnly });

          case 2:
            server = _context2.sent;


            if (autoConnect) {
              // Connect asynchronously, ignore any errors.
              (_context = this.connectXenServer(server.id), _utils.pCatch).call(_context, _utils.noop);
            }

            return _context2.abrupt('return', server.id);

          case 5:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee, this);
  }));

  return function add(_x) {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var remove = exports.remove = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
    var id = _ref4.id;
    return _regenerator2.default.wrap(function _callee2$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return this.unregisterXenServer(id);

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee2, this);
  }));

  return function remove(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var set = exports.set = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref6) {
    var id = _ref6.id,
        label = _ref6.label,
        host = _ref6.host,
        username = _ref6.username,
        password = _ref6.password,
        readOnly = _ref6.readOnly;
    return _regenerator2.default.wrap(function _callee3$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.updateXenServer(id, { label, host, username, password, readOnly });

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee3, this);
  }));

  return function set(_x3) {
    return _ref5.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var connect = exports.connect = function () {
  var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref8) {
    var _context5;

    var id = _ref8.id;
    return _regenerator2.default.wrap(function _callee4$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            (_context5 = this.updateXenServer(id, { enabled: true }), _utils.pCatch).call(_context5, _utils.noop);
            _context6.next = 3;
            return this.connectXenServer(id);

          case 3:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee4, this);
  }));

  return function connect(_x4) {
    return _ref7.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var disconnect = exports.disconnect = function () {
  var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref10) {
    var _context7;

    var id = _ref10.id;
    return _regenerator2.default.wrap(function _callee5$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            (_context7 = this.updateXenServer(id, { enabled: false }), _utils.pCatch).call(_context7, _utils.noop);
            _context8.next = 3;
            return this.disconnectXenServer(id);

          case 3:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee5, this);
  }));

  return function disconnect(_x5) {
    return _ref9.apply(this, arguments);
  };
}();

exports.getAll = getAll;

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

add.description = 'register a new Xen server';

add.permission = 'admin';

add.params = {
  label: {
    optional: true,
    type: 'string'
  },
  host: {
    type: 'string'
  },
  username: {
    type: 'string'
  },
  password: {
    type: 'string'
  },
  autoConnect: {
    optional: true,
    type: 'boolean'
  }
};

remove.description = 'unregister a Xen server';

remove.permission = 'admin';

remove.params = {
  id: {
    type: 'string'
  }
};

// -------------------------------------------------------------------

// TODO: remove this function when users are integrated to the main
// collection.
function getAll() {
  return this.getAllXenServers();
}

getAll.description = 'returns all the registered Xen server';

getAll.permission = 'admin';

set.description = 'changes the properties of a Xen server';

set.permission = 'admin';

set.params = {
  id: {
    type: 'string'
  },
  label: {
    type: 'string',
    optional: true
  },
  host: {
    type: 'string',
    optional: true
  },
  username: {
    type: 'string',
    optional: true
  },
  password: {
    type: 'string',
    optional: true
  }
};

connect.description = 'connect a Xen server';

connect.permission = 'admin';

connect.params = {
  id: {
    type: 'string'
  }
};

disconnect.description = 'disconnect a Xen server';

disconnect.permission = 'admin';

disconnect.params = {
  id: {
    type: 'string'
  }
};
//# sourceMappingURL=server.js.map
