'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getUser = exports.signInWithToken = exports.signInWithPassword = exports.signIn = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// ===================================================================

var signIn = exports.signIn = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(credentials) {
    var user;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this.authenticateUser(credentials);

          case 2:
            user = _context.sent;

            if (user) {
              _context.next = 5;
              break;
            }

            throw (0, _apiErrors.invalidCredentials)();

          case 5:
            this.session.set('user_id', user.id);

            return _context.abrupt('return', (0, _utils.getUserPublicProperties)(user));

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function signIn(_x) {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var getUser = exports.getUser = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
    var userId;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            userId = this.session.get('user_id');

            if (!(userId === undefined)) {
              _context2.next = 5;
              break;
            }

            _context2.t0 = null;
            _context2.next = 10;
            break;

          case 5:
            _context2.t1 = _utils.getUserPublicProperties;
            _context2.next = 8;
            return this.getUser(userId);

          case 8:
            _context2.t2 = _context2.sent;
            _context2.t0 = (0, _context2.t1)(_context2.t2);

          case 10:
            return _context2.abrupt('return', _context2.t0);

          case 11:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getUser() {
    return _ref2.apply(this, arguments);
  };
}();

exports.signOut = signOut;

var _util = require('util');

var _utils = require('../utils');

var _apiErrors = require('xo-common/api-errors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

signIn.description = 'sign in';

// -------------------------------------------------------------------

var signInWithPassword = exports.signInWithPassword = (0, _util.deprecate)(signIn, 'use session.signIn() instead');

signInWithPassword.params = {
  email: { type: 'string' },
  password: { type: 'string' }
};

// -------------------------------------------------------------------

var signInWithToken = exports.signInWithToken = (0, _util.deprecate)(signIn, 'use session.signIn() instead');

signInWithToken.params = {
  token: { type: 'string' }
};

// -------------------------------------------------------------------

function signOut() {
  this.session.unset('user_id');
}

signOut.description = 'sign out the user from the current session';

// This method requires the user to be signed in.
signOut.permission = '';

getUser.description = 'return the currently connected user';
//# sourceMappingURL=session.js.map
