'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reattachIso = exports.reattach = exports.probeNfsExists = exports.probeIscsiExists = exports.probeIscsiLuns = exports.probeIscsiIqns = exports.createIscsi = exports.probeHba = exports.probeNfs = exports.createLvm = exports.createHba = exports.createNfs = exports.createIso = exports.disconnectAllPbds = exports.connectAllPbds = exports.forget = exports.destroy = exports.scan = exports.set = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// ===================================================================

var set = exports.set = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var sr = _ref2.sr,
        nameDescription = _ref2.name_description,
        nameLabel = _ref2.name_label;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this.getXapi(sr).setSrProperties(sr._xapiId, {
              nameDescription,
              nameLabel
            });

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function set(_x) {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var scan = exports.scan = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
    var SR = _ref4.SR;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.getXapi(SR).call('SR.scan', SR._xapiRef);

          case 2:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function scan(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

// TODO: find a way to call this "delete" and not destroy
var destroy = exports.destroy = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref6) {
    var sr = _ref6.sr;
    var xapi, config;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            xapi = this.getXapi(sr);

            if (!(sr.SR_type === 'xosan')) {
              _context3.next = 8;
              break;
            }

            config = xapi.xo.getData(sr, 'xosan_config');
            // we simply forget because the hosted disks are been destroyed with the VMs

            _context3.next = 5;
            return xapi.forgetSr(sr._xapiId);

          case 5:
            _context3.next = 7;
            return _promise2.default.all(config.nodes.map(function (node) {
              return xapi.deleteVm(node.vm.id, true);
            }));

          case 7:
            return _context3.abrupt('return', xapi.deleteNetwork(config.network));

          case 8:
            _context3.next = 10;
            return xapi.destroySr(sr._xapiId);

          case 10:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function destroy(_x3) {
    return _ref5.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var forget = exports.forget = function () {
  var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref8) {
    var SR = _ref8.SR;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.getXapi(SR).forgetSr(SR._xapiId);

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function forget(_x4) {
    return _ref7.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var connectAllPbds = exports.connectAllPbds = function () {
  var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref10) {
    var SR = _ref10.SR;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return this.getXapi(SR).connectAllSrPbds(SR._xapiId);

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function connectAllPbds(_x5) {
    return _ref9.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var disconnectAllPbds = exports.disconnectAllPbds = function () {
  var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(_ref12) {
    var SR = _ref12.SR;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this.getXapi(SR).disconnectAllSrPbds(SR._xapiId);

          case 2:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function disconnectAllPbds(_x6) {
    return _ref11.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var createIso = exports.createIso = function () {
  var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(_ref14) {
    var host = _ref14.host,
        nameLabel = _ref14.nameLabel,
        nameDescription = _ref14.nameDescription,
        path = _ref14.path,
        type = _ref14.type,
        user = _ref14.user,
        password = _ref14.password;
    var xapi, deviceConfig, srRef, sr;
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            xapi = this.getXapi(host);
            deviceConfig = {};

            if (type === 'local') {
              deviceConfig.legacy_mode = 'true';
            } else if (type === 'smb') {
              path = path.replace(/\\/g, '/');
              deviceConfig.type = 'cifs';
              deviceConfig.username = user;
              deviceConfig.cifspassword = password;
            }

            deviceConfig.location = path;

            _context7.next = 6;
            return xapi.call('SR.create', host._xapiRef, deviceConfig, '0', // SR size 0 because ISO
            nameLabel, nameDescription, 'iso', // SR type ISO
            'iso', // SR content type ISO
            type !== 'local', {});

          case 6:
            srRef = _context7.sent;
            _context7.next = 9;
            return xapi.call('SR.get_record', srRef);

          case 9:
            sr = _context7.sent;
            return _context7.abrupt('return', sr.uuid);

          case 11:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));

  return function createIso(_x7) {
    return _ref13.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// NFS SR

// This functions creates a NFS SR

var createNfs = exports.createNfs = function () {
  var _ref15 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(_ref16) {
    var host = _ref16.host,
        nameLabel = _ref16.nameLabel,
        nameDescription = _ref16.nameDescription,
        server = _ref16.server,
        serverPath = _ref16.serverPath,
        nfsVersion = _ref16.nfsVersion;
    var xapi, deviceConfig, srRef, sr;
    return _regenerator2.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            xapi = this.getXapi(host);
            deviceConfig = {
              server,
              serverpath: serverPath
            };

            //  if NFS version given

            if (nfsVersion) {
              deviceConfig.nfsversion = nfsVersion;
            }

            _context8.next = 5;
            return xapi.call('SR.create', host._xapiRef, deviceConfig, '0', nameLabel, nameDescription, 'nfs', // SR LVM over iSCSI
            'user', // recommended by Citrix
            true, {});

          case 5:
            srRef = _context8.sent;
            _context8.next = 8;
            return xapi.call('SR.get_record', srRef);

          case 8:
            sr = _context8.sent;
            return _context8.abrupt('return', sr.uuid);

          case 10:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, this);
  }));

  return function createNfs(_x8) {
    return _ref15.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// HBA SR

// This functions creates an HBA SR

var createHba = exports.createHba = function () {
  var _ref17 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(_ref18) {
    var host = _ref18.host,
        nameLabel = _ref18.nameLabel,
        nameDescription = _ref18.nameDescription,
        scsiId = _ref18.scsiId;
    var xapi, deviceConfig, srRef, sr;
    return _regenerator2.default.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            xapi = this.getXapi(host);
            deviceConfig = {
              scsiId
            };
            _context9.next = 4;
            return xapi.call('SR.create', host._xapiRef, deviceConfig, '0', nameLabel, nameDescription, 'lvmoohba', // SR LVM over HBA
            'user', // recommended by Citrix
            true, {});

          case 4:
            srRef = _context9.sent;
            _context9.next = 7;
            return xapi.call('SR.get_record', srRef);

          case 7:
            sr = _context9.sent;
            return _context9.abrupt('return', sr.uuid);

          case 9:
          case 'end':
            return _context9.stop();
        }
      }
    }, _callee9, this);
  }));

  return function createHba(_x9) {
    return _ref17.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// Local LVM SR

// This functions creates a local LVM SR

var createLvm = exports.createLvm = function () {
  var _ref19 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(_ref20) {
    var host = _ref20.host,
        nameLabel = _ref20.nameLabel,
        nameDescription = _ref20.nameDescription,
        device = _ref20.device;
    var xapi, deviceConfig, srRef, sr;
    return _regenerator2.default.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            xapi = this.getXapi(host);
            deviceConfig = {
              device
            };
            _context10.next = 4;
            return xapi.call('SR.create', host._xapiRef, deviceConfig, '0', nameLabel, nameDescription, 'lvm', // SR LVM
            'user', // recommended by Citrix
            false, {});

          case 4:
            srRef = _context10.sent;
            _context10.next = 7;
            return xapi.call('SR.get_record', srRef);

          case 7:
            sr = _context10.sent;
            return _context10.abrupt('return', sr.uuid);

          case 9:
          case 'end':
            return _context10.stop();
        }
      }
    }, _callee10, this);
  }));

  return function createLvm(_x10) {
    return _ref19.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// This function helps to detect all NFS shares (exports) on a NFS server
// Return a table of exports with their paths and ACLs

var probeNfs = exports.probeNfs = function () {
  var _ref21 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11(_ref22) {
    var host = _ref22.host,
        server = _ref22.server;
    var xapi, deviceConfig, xml, nfsExports;
    return _regenerator2.default.wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            xapi = this.getXapi(host);
            deviceConfig = {
              server
            };
            xml = void 0;
            _context11.prev = 3;
            _context11.next = 6;
            return xapi.call('SR.probe', host._xapiRef, deviceConfig, 'nfs', {});

          case 6:
            throw new Error('the call above should have thrown an error');

          case 9:
            _context11.prev = 9;
            _context11.t0 = _context11['catch'](3);

            if (!(_context11.t0.code !== 'SR_BACKEND_FAILURE_101')) {
              _context11.next = 13;
              break;
            }

            throw _context11.t0;

          case 13:

            xml = (0, _utils2.parseXml)(_context11.t0.params[2]);

          case 14:
            nfsExports = [];

            (0, _utils2.forEach)((0, _utils2.ensureArray)(xml['nfs-exports'].Export), function (nfsExport) {
              nfsExports.push({
                path: nfsExport.Path.trim(),
                acl: nfsExport.Accesslist.trim()
              });
            });

            return _context11.abrupt('return', nfsExports);

          case 17:
          case 'end':
            return _context11.stop();
        }
      }
    }, _callee11, this, [[3, 9]]);
  }));

  return function probeNfs(_x11) {
    return _ref21.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// This function helps to detect all HBA devices on the host

var probeHba = exports.probeHba = function () {
  var _ref23 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12(_ref24) {
    var host = _ref24.host;
    var xapi, xml, hbaDevices;
    return _regenerator2.default.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            xapi = this.getXapi(host);
            xml = void 0;
            _context12.prev = 2;
            _context12.next = 5;
            return xapi.call('SR.probe', host._xapiRef, 'type', {});

          case 5:
            throw new Error('the call above should have thrown an error');

          case 8:
            _context12.prev = 8;
            _context12.t0 = _context12['catch'](2);

            if (!(_context12.t0.code !== 'SR_BACKEND_FAILURE_107')) {
              _context12.next = 12;
              break;
            }

            throw _context12.t0;

          case 12:

            xml = (0, _utils2.parseXml)(_context12.t0.params[2]);

          case 13:
            hbaDevices = [];

            (0, _utils2.forEach)((0, _utils2.ensureArray)(xml.Devlist.BlockDevice), function (hbaDevice) {
              hbaDevices.push({
                hba: hbaDevice.hba.trim(),
                path: hbaDevice.path.trim(),
                scsciId: hbaDevice.SCSIid.trim(),
                size: hbaDevice.size.trim(),
                vendor: hbaDevice.vendor.trim()
              });
            });

            return _context12.abrupt('return', hbaDevices);

          case 16:
          case 'end':
            return _context12.stop();
        }
      }
    }, _callee12, this, [[2, 8]]);
  }));

  return function probeHba(_x12) {
    return _ref23.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// ISCSI SR

// This functions creates a iSCSI SR

var createIscsi = exports.createIscsi = function () {
  var _ref25 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee13(_ref26) {
    var host = _ref26.host,
        nameLabel = _ref26.nameLabel,
        nameDescription = _ref26.nameDescription,
        size = _ref26.size,
        target = _ref26.target,
        port = _ref26.port,
        targetIqn = _ref26.targetIqn,
        scsiId = _ref26.scsiId,
        chapUser = _ref26.chapUser,
        chapPassword = _ref26.chapPassword;
    var xapi, deviceConfig, srRef, sr;
    return _regenerator2.default.wrap(function _callee13$(_context13) {
      while (1) {
        switch (_context13.prev = _context13.next) {
          case 0:
            xapi = this.getXapi(host);
            deviceConfig = {
              target,
              targetIQN: targetIqn,
              SCSIid: scsiId
            };

            // if we give user and password

            if (chapUser && chapPassword) {
              deviceConfig.chapUser = chapUser;
              deviceConfig.chapPassword = chapPassword;
            }

            //  if we give another port than default iSCSI
            if (port) {
              deviceConfig.port = (0, _utils.asInteger)(port);
            }

            _context13.next = 6;
            return xapi.call('SR.create', host._xapiRef, deviceConfig, '0', nameLabel, nameDescription, 'lvmoiscsi', // SR LVM over iSCSI
            'user', // recommended by Citrix
            true, {});

          case 6:
            srRef = _context13.sent;
            _context13.next = 9;
            return xapi.call('SR.get_record', srRef);

          case 9:
            sr = _context13.sent;
            return _context13.abrupt('return', sr.uuid);

          case 11:
          case 'end':
            return _context13.stop();
        }
      }
    }, _callee13, this);
  }));

  return function createIscsi(_x13) {
    return _ref25.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// This function helps to detect all iSCSI IQN on a Target (iSCSI "server")
// Return a table of IQN or empty table if no iSCSI connection to the target

var probeIscsiIqns = exports.probeIscsiIqns = function () {
  var _ref27 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee14(_ref28) {
    var host = _ref28.host,
        targetIp = _ref28.target,
        port = _ref28.port,
        chapUser = _ref28.chapUser,
        chapPassword = _ref28.chapPassword;
    var xapi, deviceConfig, xml, targets;
    return _regenerator2.default.wrap(function _callee14$(_context14) {
      while (1) {
        switch (_context14.prev = _context14.next) {
          case 0:
            xapi = this.getXapi(host);
            deviceConfig = {
              target: targetIp
            };

            // if we give user and password

            if (chapUser && chapPassword) {
              deviceConfig.chapUser = chapUser;
              deviceConfig.chapPassword = chapPassword;
            }

            //  if we give another port than default iSCSI
            if (port) {
              deviceConfig.port = (0, _utils.asInteger)(port);
            }

            xml = void 0;
            _context14.prev = 5;
            _context14.next = 8;
            return xapi.call('SR.probe', host._xapiRef, deviceConfig, 'lvmoiscsi', {});

          case 8:
            throw new Error('the call above should have thrown an error');

          case 11:
            _context14.prev = 11;
            _context14.t0 = _context14['catch'](5);

            if (!(_context14.t0.code === 'SR_BACKEND_FAILURE_141')) {
              _context14.next = 15;
              break;
            }

            return _context14.abrupt('return', []);

          case 15:
            if (!(_context14.t0.code !== 'SR_BACKEND_FAILURE_96')) {
              _context14.next = 17;
              break;
            }

            throw _context14.t0;

          case 17:

            xml = (0, _utils2.parseXml)(_context14.t0.params[2]);

          case 18:
            targets = [];

            (0, _utils2.forEach)((0, _utils2.ensureArray)(xml['iscsi-target-iqns'].TGT), function (target) {
              // if the target is on another IP adress, do not display it
              if (target.IPAddress.trim() === targetIp) {
                targets.push({
                  iqn: target.TargetIQN.trim(),
                  ip: target.IPAddress.trim()
                });
              }
            });

            return _context14.abrupt('return', targets);

          case 21:
          case 'end':
            return _context14.stop();
        }
      }
    }, _callee14, this, [[5, 11]]);
  }));

  return function probeIscsiIqns(_x14) {
    return _ref27.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// This function helps to detect all iSCSI ID and LUNs on a Target
//  It will return a LUN table

var probeIscsiLuns = exports.probeIscsiLuns = function () {
  var _ref29 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee15(_ref30) {
    var host = _ref30.host,
        targetIp = _ref30.target,
        port = _ref30.port,
        targetIqn = _ref30.targetIqn,
        chapUser = _ref30.chapUser,
        chapPassword = _ref30.chapPassword;
    var xapi, deviceConfig, xml, luns;
    return _regenerator2.default.wrap(function _callee15$(_context15) {
      while (1) {
        switch (_context15.prev = _context15.next) {
          case 0:
            xapi = this.getXapi(host);
            deviceConfig = {
              target: targetIp,
              targetIQN: targetIqn
            };

            // if we give user and password

            if (chapUser && chapPassword) {
              deviceConfig.chapUser = chapUser;
              deviceConfig.chapPassword = chapPassword;
            }

            //  if we give another port than default iSCSI
            if (port) {
              deviceConfig.port = (0, _utils.asInteger)(port);
            }

            xml = void 0;
            _context15.prev = 5;
            _context15.next = 8;
            return xapi.call('SR.probe', host._xapiRef, deviceConfig, 'lvmoiscsi', {});

          case 8:
            throw new Error('the call above should have thrown an error');

          case 11:
            _context15.prev = 11;
            _context15.t0 = _context15['catch'](5);

            if (!(_context15.t0.code !== 'SR_BACKEND_FAILURE_107')) {
              _context15.next = 15;
              break;
            }

            throw _context15.t0;

          case 15:

            xml = (0, _utils2.parseXml)(_context15.t0.params[2]);

          case 16:
            luns = [];

            (0, _utils2.forEach)((0, _utils2.ensureArray)(xml['iscsi-target'].LUN), function (lun) {
              luns.push({
                id: lun.LUNid.trim(),
                vendor: lun.vendor.trim(),
                serial: lun.serial.trim(),
                size: lun.size.trim(),
                scsiId: lun.SCSIid.trim()
              });
            });

            return _context15.abrupt('return', luns);

          case 19:
          case 'end':
            return _context15.stop();
        }
      }
    }, _callee15, this, [[5, 11]]);
  }));

  return function probeIscsiLuns(_x15) {
    return _ref29.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// This function helps to detect if this target already exists in XAPI
// It returns a table of SR UUID, empty if no existing connections

var probeIscsiExists = exports.probeIscsiExists = function () {
  var _ref31 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee16(_ref32) {
    var host = _ref32.host,
        targetIp = _ref32.target,
        port = _ref32.port,
        targetIqn = _ref32.targetIqn,
        scsiId = _ref32.scsiId,
        chapUser = _ref32.chapUser,
        chapPassword = _ref32.chapPassword;
    var xapi, deviceConfig, xml, srs;
    return _regenerator2.default.wrap(function _callee16$(_context16) {
      while (1) {
        switch (_context16.prev = _context16.next) {
          case 0:
            xapi = this.getXapi(host);
            deviceConfig = {
              target: targetIp,
              targetIQN: targetIqn,
              SCSIid: scsiId
            };

            // if we give user and password

            if (chapUser && chapPassword) {
              deviceConfig.chapUser = chapUser;
              deviceConfig.chapPassword = chapPassword;
            }

            //  if we give another port than default iSCSI
            if (port) {
              deviceConfig.port = (0, _utils.asInteger)(port);
            }

            _context16.t0 = _utils2.parseXml;
            _context16.next = 7;
            return xapi.call('SR.probe', host._xapiRef, deviceConfig, 'lvmoiscsi', {});

          case 7:
            _context16.t1 = _context16.sent;
            xml = (0, _context16.t0)(_context16.t1);
            srs = [];

            (0, _utils2.forEach)((0, _utils2.ensureArray)(xml['SRlist'].SR), function (sr) {
              // get the UUID of SR connected to this LUN
              srs.push({ uuid: sr.UUID.trim() });
            });

            return _context16.abrupt('return', srs);

          case 12:
          case 'end':
            return _context16.stop();
        }
      }
    }, _callee16, this);
  }));

  return function probeIscsiExists(_x16) {
    return _ref31.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// This function helps to detect if this NFS SR already exists in XAPI
// It returns a table of SR UUID, empty if no existing connections

var probeNfsExists = exports.probeNfsExists = function () {
  var _ref33 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee17(_ref34) {
    var host = _ref34.host,
        server = _ref34.server,
        serverPath = _ref34.serverPath;
    var xapi, deviceConfig, xml, srs;
    return _regenerator2.default.wrap(function _callee17$(_context17) {
      while (1) {
        switch (_context17.prev = _context17.next) {
          case 0:
            xapi = this.getXapi(host);
            deviceConfig = {
              server,
              serverpath: serverPath
            };
            _context17.t0 = _utils2.parseXml;
            _context17.next = 5;
            return xapi.call('SR.probe', host._xapiRef, deviceConfig, 'nfs', {});

          case 5:
            _context17.t1 = _context17.sent;
            xml = (0, _context17.t0)(_context17.t1);
            srs = [];


            (0, _utils2.forEach)((0, _utils2.ensureArray)(xml['SRlist'].SR), function (sr) {
              // get the UUID of SR connected to this LUN
              srs.push({ uuid: sr.UUID.trim() });
            });

            return _context17.abrupt('return', srs);

          case 10:
          case 'end':
            return _context17.stop();
        }
      }
    }, _callee17, this);
  }));

  return function probeNfsExists(_x17) {
    return _ref33.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// This function helps to reattach a forgotten NFS/iSCSI SR

var reattach = exports.reattach = function () {
  var _ref35 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee18(_ref36) {
    var host = _ref36.host,
        uuid = _ref36.uuid,
        nameLabel = _ref36.nameLabel,
        nameDescription = _ref36.nameDescription,
        type = _ref36.type;
    var xapi, srRef, sr;
    return _regenerator2.default.wrap(function _callee18$(_context18) {
      while (1) {
        switch (_context18.prev = _context18.next) {
          case 0:
            xapi = this.getXapi(host);


            if (type === 'iscsi') {
              type = 'lvmoiscsi'; // the internal XAPI name
            }

            _context18.next = 4;
            return xapi.call('SR.introduce', uuid, nameLabel, nameDescription, type, 'user', true, {});

          case 4:
            srRef = _context18.sent;
            _context18.next = 7;
            return xapi.call('SR.get_record', srRef);

          case 7:
            sr = _context18.sent;
            return _context18.abrupt('return', sr.uuid);

          case 9:
          case 'end':
            return _context18.stop();
        }
      }
    }, _callee18, this);
  }));

  return function reattach(_x18) {
    return _ref35.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// This function helps to reattach a forgotten ISO SR

var reattachIso = exports.reattachIso = function () {
  var _ref37 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee19(_ref38) {
    var host = _ref38.host,
        uuid = _ref38.uuid,
        nameLabel = _ref38.nameLabel,
        nameDescription = _ref38.nameDescription,
        type = _ref38.type;
    var xapi, srRef, sr;
    return _regenerator2.default.wrap(function _callee19$(_context19) {
      while (1) {
        switch (_context19.prev = _context19.next) {
          case 0:
            xapi = this.getXapi(host);


            if (type === 'iscsi') {
              type = 'lvmoiscsi'; // the internal XAPI name
            }

            _context19.next = 4;
            return xapi.call('SR.introduce', uuid, nameLabel, nameDescription, type, 'iso', true, {});

          case 4:
            srRef = _context19.sent;
            _context19.next = 7;
            return xapi.call('SR.get_record', srRef);

          case 7:
            sr = _context19.sent;
            return _context19.abrupt('return', sr.uuid);

          case 9:
          case 'end':
            return _context19.stop();
        }
      }
    }, _callee19, this);
  }));

  return function reattachIso(_x19) {
    return _ref37.apply(this, arguments);
  };
}();

var _utils = require('../xapi/utils');

var _utils2 = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

set.params = {
  id: { type: 'string' },

  name_label: { type: 'string', optional: true },

  name_description: { type: 'string', optional: true }
};

set.resolve = {
  sr: ['id', 'SR', 'operate']
};

scan.params = {
  id: { type: 'string' }
};

scan.resolve = {
  SR: ['id', 'SR', 'operate']
};

destroy.params = {
  id: { type: 'string' }
};

destroy.resolve = {
  sr: ['id', 'SR', 'administrate']
};

forget.params = {
  id: { type: 'string' }
};

forget.resolve = {
  SR: ['id', 'SR', 'administrate']
};

connectAllPbds.params = {
  id: { type: 'string' }
};

connectAllPbds.resolve = {
  SR: ['id', 'SR', 'administrate']
};

disconnectAllPbds.params = {
  id: { type: 'string' }
};

disconnectAllPbds.resolve = {
  SR: ['id', 'SR', 'administrate']
};

createIso.params = {
  host: { type: 'string' },
  nameLabel: { type: 'string' },
  nameDescription: { type: 'string' },
  path: { type: 'string' },
  type: { type: 'string' },
  user: { type: 'string', optional: true },
  password: { type: 'string', optional: true }
};

createIso.resolve = {
  host: ['host', 'host', 'administrate']
};

createNfs.params = {
  host: { type: 'string' },
  nameLabel: { type: 'string' },
  nameDescription: { type: 'string' },
  server: { type: 'string' },
  serverPath: { type: 'string' },
  nfsVersion: { type: 'string', optional: true }
};

createNfs.resolve = {
  host: ['host', 'host', 'administrate']
};

createHba.params = {
  host: { type: 'string' },
  nameLabel: { type: 'string' },
  nameDescription: { type: 'string' },
  scsiId: { type: 'string' }
};

createHba.resolve = {
  host: ['host', 'host', 'administrate']
};

createLvm.params = {
  host: { type: 'string' },
  nameLabel: { type: 'string' },
  nameDescription: { type: 'string' },
  device: { type: 'string' }
};

createLvm.resolve = {
  host: ['host', 'host', 'administrate']
};

probeNfs.params = {
  host: { type: 'string' },
  server: { type: 'string' }
};

probeNfs.resolve = {
  host: ['host', 'host', 'administrate']
};

probeHba.params = {
  host: { type: 'string' }
};

probeHba.resolve = {
  host: ['host', 'host', 'administrate']
};

createIscsi.params = {
  host: { type: 'string' },
  nameLabel: { type: 'string' },
  nameDescription: { type: 'string' },
  target: { type: 'string' },
  port: { type: 'integer', optional: true },
  targetIqn: { type: 'string' },
  scsiId: { type: 'string' },
  chapUser: { type: 'string', optional: true },
  chapPassword: { type: 'string', optional: true }
};

createIscsi.resolve = {
  host: ['host', 'host', 'administrate']
};

probeIscsiIqns.params = {
  host: { type: 'string' },
  target: { type: 'string' },
  port: { type: 'integer', optional: true },
  chapUser: { type: 'string', optional: true },
  chapPassword: { type: 'string', optional: true }
};
probeIscsiIqns.resolve = {
  host: ['host', 'host', 'administrate']
};

probeIscsiLuns.params = {
  host: { type: 'string' },
  target: { type: 'string' },
  port: { type: 'integer', optional: true },
  targetIqn: { type: 'string' },
  chapUser: { type: 'string', optional: true },
  chapPassword: { type: 'string', optional: true }
};

probeIscsiLuns.resolve = {
  host: ['host', 'host', 'administrate']
};

probeIscsiExists.params = {
  host: { type: 'string' },
  target: { type: 'string' },
  port: { type: 'integer', optional: true },
  targetIqn: { type: 'string' },
  scsiId: { type: 'string' },
  chapUser: { type: 'string', optional: true },
  chapPassword: { type: 'string', optional: true }
};

probeIscsiExists.resolve = {
  host: ['host', 'host', 'administrate']
};

probeNfsExists.params = {
  host: { type: 'string' },
  server: { type: 'string' },
  serverPath: { type: 'string' }
};

probeNfsExists.resolve = {
  host: ['host', 'host', 'administrate']
};

reattach.params = {
  host: { type: 'string' },
  uuid: { type: 'string' },
  nameLabel: { type: 'string' },
  nameDescription: { type: 'string' },
  type: { type: 'string' }
};

reattach.resolve = {
  host: ['host', 'host', 'administrate']
};

reattachIso.params = {
  host: { type: 'string' },
  uuid: { type: 'string' },
  nameLabel: { type: 'string' },
  nameDescription: { type: 'string' },
  type: { type: 'string' }
};

reattachIso.resolve = {
  host: ['host', 'host', 'administrate']
};
//# sourceMappingURL=sr.js.map
