'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.getPermissionsForUser = getPermissionsForUser;
exports.hasPermission = hasPermission;
exports.wait = wait;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getPermissionsForUser(_ref) {
  var userId = _ref.userId;

  return this.getPermissionsForUser(userId);
}

getPermissionsForUser.permission = 'admin';

getPermissionsForUser.params = {
  userId: {
    type: 'string'
  }
};

// -------------------------------------------------------------------

function hasPermission(_ref2) {
  var userId = _ref2.userId,
      objectId = _ref2.objectId,
      permission = _ref2.permission;

  return this.hasPermissions(userId, [[objectId, permission]]);
}

hasPermission.permission = 'admin';

hasPermission.params = {
  userId: {
    type: 'string'
  },
  objectId: {
    type: 'string'
  },
  permission: {
    type: 'string'
  }
};

// -------------------------------------------------------------------

function wait(_ref3) {
  var duration = _ref3.duration,
      returnValue = _ref3.returnValue;

  return new _promise2.default(function (resolve) {
    setTimeout(function () {
      resolve(returnValue);
    }, +duration);
  });
}

wait.params = {
  duration: {
    type: 'string'
  }
};
//# sourceMappingURL=test.js.map
