'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.changePassword = exports.set = exports.getAll = exports.delete = exports.create = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// ===================================================================

var create = exports.create = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var email = _ref2.email,
        password = _ref2.password,
        permission = _ref2.permission;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this.createUser({ email, password, permission });

          case 2:
            return _context.abrupt('return', _context.sent.id);

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function create(_x) {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

// Deletes an existing user.
var delete_ = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
    var id = _ref4.id;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(id === this.session.get('user_id'))) {
              _context2.next = 2;
              break;
            }

            throw (0, _apiErrors.invalidParameters)('a user cannot delete itself');

          case 2:
            _context2.next = 4;
            return this.deleteUser(id);

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function delete_(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

// delete is not a valid identifier.


// -------------------------------------------------------------------

// TODO: remove this function when users are integrated to the main
// collection.
var getAll = exports.getAll = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
    var users;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return this.getAllUsers();

          case 2:
            users = _context3.sent;
            return _context3.abrupt('return', (0, _utils.mapToArray)(users, _utils.getUserPublicProperties));

          case 4:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function getAll() {
    return _ref5.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var set = exports.set = function () {
  var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref7) {
    var id = _ref7.id,
        email = _ref7.email,
        password = _ref7.password,
        permission = _ref7.permission,
        preferences = _ref7.preferences;
    var isAdmin;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            isAdmin = this.user && this.user.permission === 'admin';

            if (!isAdmin) {
              _context4.next = 6;
              break;
            }

            if (!(permission && id === this.session.get('user_id'))) {
              _context4.next = 4;
              break;
            }

            throw (0, _apiErrors.invalidParameters)('a user cannot change its own permission');

          case 4:
            _context4.next = 8;
            break;

          case 6:
            if (!(email || password || permission)) {
              _context4.next = 8;
              break;
            }

            throw (0, _apiErrors.invalidParameters)('this properties can only changed by an administrator');

          case 8:
            _context4.next = 10;
            return this.updateUser(id, { email, password, permission, preferences });

          case 10:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function set(_x3) {
    return _ref6.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var changePassword = exports.changePassword = function () {
  var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref9) {
    var oldPassword = _ref9.oldPassword,
        newPassword = _ref9.newPassword;
    var id;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            id = this.session.get('user_id');
            _context5.next = 3;
            return this.changeUserPassword(id, oldPassword, newPassword);

          case 3:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function changePassword(_x4) {
    return _ref8.apply(this, arguments);
  };
}();

var _apiErrors = require('xo-common/api-errors');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

create.description = 'creates a new user';

create.permission = 'admin';

create.params = {
  email: { type: 'string' },
  password: { type: 'string' },
  permission: { type: 'string', optional: true }
};exports.delete = delete_;


delete_.description = 'deletes an existing user';

delete_.permission = 'admin';

delete_.params = {
  id: { type: 'string' }
};

getAll.description = 'returns all the existing users';

getAll.permission = 'admin';

set.description = 'changes the properties of an existing user';

set.permission = '';

set.params = {
  id: { type: 'string' },
  email: { type: 'string', optional: true },
  password: { type: 'string', optional: true },
  permission: { type: 'string', optional: true },
  preferences: { type: 'object', optional: true }
};

changePassword.description = 'change password after checking old password (user function)';

changePassword.permission = '';

changePassword.params = {
  oldPassword: { type: 'string' },
  newPassword: { type: 'string' }
};
//# sourceMappingURL=user.js.map
