'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var $coroutine, connect, delete_, disconnect, set, setBootable;

$coroutine = require('bluebird').coroutine;

delete_ = $coroutine(_regenerator2.default.mark(function _callee(arg) {
  var vbd, xapi;
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          vbd = arg.vbd;
          xapi = this.getXapi(vbd);
          _context.next = 4;
          return xapi.call('VBD.destroy', vbd._xapiRef);

        case 4:
          return _context.abrupt('return', true);

        case 5:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, this);
}));

delete_.params = {
  id: {
    type: 'string'
  }
};

delete_.resolve = {
  vbd: ['id', 'VBD', 'administrate']
};

exports["delete"] = delete_;

disconnect = $coroutine(_regenerator2.default.mark(function _callee2(arg) {
  var vbd, xapi;
  return _regenerator2.default.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          vbd = arg.vbd;
          xapi = this.getXapi(vbd);
          _context2.next = 4;
          return xapi.disconnectVbd(vbd._xapiRef);

        case 4:
        case 'end':
          return _context2.stop();
      }
    }
  }, _callee2, this);
}));

disconnect.params = {
  id: {
    type: 'string'
  }
};

disconnect.resolve = {
  vbd: ['id', 'VBD', 'administrate']
};

exports.disconnect = disconnect;

connect = $coroutine(_regenerator2.default.mark(function _callee3(arg) {
  var vbd, xapi;
  return _regenerator2.default.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          vbd = arg.vbd;
          xapi = this.getXapi(vbd);
          _context3.next = 4;
          return xapi.connectVbd(vbd._xapiRef);

        case 4:
        case 'end':
          return _context3.stop();
      }
    }
  }, _callee3, this);
}));

connect.params = {
  id: {
    type: 'string'
  }
};

connect.resolve = {
  vbd: ['id', 'VBD', 'administrate']
};

exports.connect = connect;

set = $coroutine(_regenerator2.default.mark(function _callee4(params) {
  var ref, vbd, xapi;
  return _regenerator2.default.wrap(function _callee4$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          vbd = params.vbd;
          xapi = this.getXapi(vbd);
          ref = vbd._xapiRef;

          if (!('position' in params)) {
            _context4.next = 7;
            break;
          }

          _context4.next = 6;
          return xapi.call('VBD.set_userdevice', ref, String(params.position));

        case 6:
          return _context4.abrupt('return', _context4.sent);

        case 7:
        case 'end':
          return _context4.stop();
      }
    }
  }, _callee4, this);
}));

set.params = {
  id: {
    type: 'string'
  },
  position: {
    type: ['string', 'number'],
    optional: true
  }
};

set.resolve = {
  vbd: ['id', 'VBD', 'administrate']
};

exports.set = set;

setBootable = $coroutine(_regenerator2.default.mark(function _callee5(arg) {
  var bootable, ref, vbd, xapi;
  return _regenerator2.default.wrap(function _callee5$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          vbd = arg.vbd, bootable = arg.bootable;
          xapi = this.getXapi(vbd);
          ref = vbd._xapiRef;
          _context5.next = 5;
          return xapi.call('VBD.set_bootable', ref, bootable);

        case 5:
        case 'end':
          return _context5.stop();
      }
    }
  }, _callee5, this);
}));

setBootable.params = {
  vbd: {
    type: 'string'
  },
  bootable: {
    type: 'boolean'
  }
};

setBootable.resolve = {
  vbd: ['vbd', 'VBD', 'administrate']
};

exports.setBootable = setBootable;

Object.defineProperty(exports, '__esModule', {
  value: true
});
//# sourceMappingURL=vbd.js.map
