'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var $coroutine, $isArray, JsonRpcError, delete_, format, invalidParameters, migrate, parseSize, ref1, set;

$coroutine = require('bluebird').coroutine;

format = require('json-rpc-peer').format;

invalidParameters = require('xo-common/api-errors').invalidParameters;

ref1 = require('../utils'), $isArray = ref1.isArray, parseSize = ref1.parseSize;

JsonRpcError = require('json-rpc-peer').JsonRpcError;

delete_ = $coroutine(_regenerator2.default.mark(function _callee(arg) {
  var vdi;
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          vdi = arg.vdi;
          _context.next = 3;
          return this.getXapi(vdi).deleteVdi(vdi._xapiId);

        case 3:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, this);
}));

delete_.params = {
  id: {
    type: 'string'
  }
};

delete_.resolve = {
  vdi: ['id', ['VDI', 'VDI-snapshot'], 'administrate']
};

exports["delete"] = delete_;

set = $coroutine(_regenerator2.default.mark(function _callee2(params) {
  var field, fields, i, len, param, ref, ref2, ref3, size, vdi, xapi;
  return _regenerator2.default.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          vdi = params.vdi;
          xapi = this.getXapi(vdi);
          ref = vdi._xapiRef;

          if (!('size' in params)) {
            _context2.next = 9;
            break;
          }

          size = parseSize(params.size);

          if (!(size < vdi.size)) {
            _context2.next = 7;
            break;
          }

          throw invalidParameters("cannot set new size (" + size + ") below the current size (" + vdi.size + ")");

        case 7:
          _context2.next = 9;
          return xapi.resizeVdi(ref, size);

        case 9:
          ref2 = {
            'name_label': 'name_label',
            'name_description': 'name_description'
          };
          _context2.t0 = _regenerator2.default.keys(ref2);

        case 11:
          if ((_context2.t1 = _context2.t0()).done) {
            _context2.next = 27;
            break;
          }

          param = _context2.t1.value;

          fields = ref2[param];

          if (param in params) {
            _context2.next = 16;
            break;
          }

          return _context2.abrupt('continue', 11);

        case 16:
          ref3 = $isArray(fields) ? fields : [fields];
          i = 0, len = ref3.length;

        case 18:
          if (!(i < len)) {
            _context2.next = 25;
            break;
          }

          field = ref3[i];
          _context2.next = 22;
          return xapi.call("VDI.set_" + field, ref, "" + params[param]);

        case 22:
          i++;
          _context2.next = 18;
          break;

        case 25:
          _context2.next = 11;
          break;

        case 27:
          return _context2.abrupt('return', true);

        case 28:
        case 'end':
          return _context2.stop();
      }
    }
  }, _callee2, this);
}));

set.params = {
  id: {
    type: 'string'
  },
  name_label: {
    type: 'string',
    optional: true
  },
  name_description: {
    type: 'string',
    optional: true
  },
  size: {
    type: ['integer', 'string'],
    optional: true
  }
};

set.resolve = {
  vdi: ['id', ['VDI', 'VDI-snapshot'], 'administrate']
};

exports.set = set;

migrate = $coroutine(_regenerator2.default.mark(function _callee3(arg) {
  var sr, vdi, xapi;
  return _regenerator2.default.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          vdi = arg.vdi, sr = arg.sr;
          xapi = this.getXapi(vdi);
          _context3.next = 4;
          return xapi.moveVdi(vdi._xapiRef, sr._xapiRef);

        case 4:
          return _context3.abrupt('return', true);

        case 5:
        case 'end':
          return _context3.stop();
      }
    }
  }, _callee3, this);
}));

migrate.params = {
  id: {
    type: 'string'
  },
  sr_id: {
    type: 'string'
  }
};

migrate.resolve = {
  vdi: ['id', ['VDI', 'VDI-snapshot'], 'administrate'],
  sr: ['sr_id', 'SR', 'administrate']
};

exports.migrate = migrate;

Object.defineProperty(exports, '__esModule', {
  value: true
});
//# sourceMappingURL=vdi.js.map
