'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.set = exports.connect = exports.disconnect = exports.delete = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// ===================================================================

// TODO: move into vm and rename to removeInterface
var delete_ = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var _context;

    var vif = _ref2.vif;
    return _regenerator2.default.wrap(function _callee$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            (_context = this.allocIpAddresses(vif.id, null, vif.allowedIpv4Addresses.concat(vif.allowedIpv6Addresses)), _utils.pCatch).call(_context, _utils.noop);

            _context2.next = 3;
            return this.getXapi(vif).deleteVif(vif._xapiId);

          case 3:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee, this);
  }));

  return function delete_(_x) {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

// TODO: move into vm and rename to disconnectInterface
var disconnect = exports.disconnect = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
    var vif = _ref4.vif;
    return _regenerator2.default.wrap(function _callee2$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return this.getXapi(vif).disconnectVif(vif._xapiId);

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee2, this);
  }));

  return function disconnect(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------
// TODO: move into vm and rename to connectInterface
var connect = exports.connect = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref6) {
    var vif = _ref6.vif;
    return _regenerator2.default.wrap(function _callee3$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.getXapi(vif).connectVif(vif._xapiId);

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee3, this);
  }));

  return function connect(_x3) {
    return _ref5.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var set = exports.set = function () {
  var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref8) {
    var vif = _ref8.vif,
        network = _ref8.network,
        mac = _ref8.mac,
        allowedIpv4Addresses = _ref8.allowedIpv4Addresses,
        allowedIpv6Addresses = _ref8.allowedIpv6Addresses,
        attached = _ref8.attached;

    var oldIpAddresses, newIpAddresses, push, xapi, vm, newVif, _diffItems, _diffItems2, addAddresses, removeAddresses;

    return _regenerator2.default.wrap(function _callee4$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            oldIpAddresses = vif.allowedIpv4Addresses.concat(vif.allowedIpv6Addresses);
            newIpAddresses = [];
            push = newIpAddresses.push;

            push.apply(newIpAddresses, allowedIpv4Addresses || vif.allowedIpv4Addresses);
            push.apply(newIpAddresses, allowedIpv6Addresses || vif.allowedIpv6Addresses);

            if (!(network || mac)) {
              _context5.next = 21;
              break;
            }

            xapi = this.getXapi(vif);
            vm = xapi.getObject(vif.$VM);

            mac == null && (mac = vif.MAC);
            network = xapi.getObject(network && network.id || vif.$network);
            attached == null && (attached = vif.attached);

            _context5.next = 13;
            return this.allocIpAddresses(vif.id, null, oldIpAddresses);

          case 13:
            _context5.next = 15;
            return xapi.deleteVif(vif._xapiId);

          case 15:
            _context5.next = 17;
            return xapi.createVif(vm.$id, network.$id, {
              mac,
              currently_attached: attached,
              ipv4_allowed: newIpAddresses
            });

          case 17:
            newVif = _context5.sent;
            _context5.next = 20;
            return this.allocIpAddresses(newVif.$id, newIpAddresses);

          case 20:
            return _context5.abrupt('return');

          case 21:
            _diffItems = (0, _utils.diffItems)(newIpAddresses, oldIpAddresses), _diffItems2 = (0, _slicedToArray3.default)(_diffItems, 2), addAddresses = _diffItems2[0], removeAddresses = _diffItems2[1];
            _context5.next = 24;
            return this.allocIpAddresses(vif.id, addAddresses, removeAddresses);

          case 24:
            return _context5.abrupt('return', this.getXapi(vif).editVif(vif._xapiId, {
              ipv4Allowed: allowedIpv4Addresses,
              ipv6Allowed: allowedIpv6Addresses
            }));

          case 25:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee4, this);
  }));

  return function set(_x4) {
    return _ref7.apply(this, arguments);
  };
}();

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.delete = delete_;


delete_.params = {
  id: { type: 'string' }
};

delete_.resolve = {
  vif: ['id', 'VIF', 'administrate']
};

disconnect.params = {
  id: { type: 'string' }
};

disconnect.resolve = {
  vif: ['id', 'VIF', 'operate']
};

connect.params = {
  id: { type: 'string' }
};

connect.resolve = {
  vif: ['id', 'VIF', 'operate']
};

set.params = {
  id: { type: 'string' },
  network: { type: 'string', optional: true },
  mac: { type: 'string', optional: true },
  allowedIpv4Addresses: {
    type: 'array',
    items: {
      type: 'string'
    },
    optional: true
  },
  allowedIpv6Addresses: {
    type: 'array',
    items: {
      type: 'string'
    },
    optional: true
  },
  attached: { type: 'boolean', optional: true }
};

set.resolve = {
  vif: ['id', 'VIF', 'operate'],
  network: ['network', 'network', 'operate']
};
//# sourceMappingURL=vif.js.map
