'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ModelAlreadyExists = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _model = require('./model');

var _model2 = _interopRequireDefault(_model);

var _makeError = require('make-error');

var _events = require('events');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var ModelAlreadyExists = exports.ModelAlreadyExists = function (_BaseError) {
  (0, _inherits3.default)(ModelAlreadyExists, _BaseError);

  function ModelAlreadyExists(id) {
    (0, _classCallCheck3.default)(this, ModelAlreadyExists);
    return (0, _possibleConstructorReturn3.default)(this, (ModelAlreadyExists.__proto__ || (0, _getPrototypeOf2.default)(ModelAlreadyExists)).call(this, 'this model already exists: ' + id));
  }

  return ModelAlreadyExists;
}(_makeError.BaseError);

// ===================================================================

var Collection = function (_EventEmitter) {
  (0, _inherits3.default)(Collection, _EventEmitter);

  function Collection() {
    (0, _classCallCheck3.default)(this, Collection);
    return (0, _possibleConstructorReturn3.default)(this, (Collection.__proto__ || (0, _getPrototypeOf2.default)(Collection)).apply(this, arguments));
  }

  (0, _createClass3.default)(Collection, [{
    key: 'add',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(models, opts) {
        var array, Model;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                array = (0, _utils.isArray)(models);

                if (!array) {
                  models = [models];
                }

                Model = this.Model;

                (0, _utils.map)(models, function (model) {
                  if (!(model instanceof Model)) {
                    model = new Model(model);
                  }

                  var error = model.validate();
                  if (error) {
                    // TODO: Better system inspired by Backbone.js
                    throw error;
                  }

                  return model.properties;
                }, models);

                _context.next = 6;
                return this._add(models, opts);

              case 6:
                models = _context.sent;

                this.emit('add', models);

                return _context.abrupt('return', array ? models : new this.Model(models[0]));

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function add(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return add;
    }()
  }, {
    key: 'first',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(properties) {
        var model;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(0, _utils.isObject)(properties)) {
                  properties = properties !== undefined ? { id: properties } : {};
                }

                _context2.next = 3;
                return this._first(properties);

              case 3:
                model = _context2.sent;
                return _context2.abrupt('return', model && new this.Model(model));

              case 5:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function first(_x3) {
        return _ref2.apply(this, arguments);
      }

      return first;
    }()
  }, {
    key: 'get',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(properties) {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(0, _utils.isObject)(properties)) {
                  properties = properties !== undefined ? { id: properties } : {};
                }

                return _context3.abrupt('return', /* await */this._get(properties));

              case 2:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function get(_x4) {
        return _ref3.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: 'remove',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(ids) {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!(0, _utils.isArray)(ids)) {
                  ids = [ids];
                }

                _context4.next = 3;
                return this._remove(ids);

              case 3:

                this.emit('remove', ids);
                return _context4.abrupt('return', true);

              case 5:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function remove(_x5) {
        return _ref4.apply(this, arguments);
      }

      return remove;
    }()
  }, {
    key: 'update',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(models) {
        var array, Model;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                array = (0, _utils.isArray)(models);

                if (!(0, _utils.isArray)(models)) {
                  models = [models];
                }

                Model = this.Model;

                (0, _utils.map)(models, function (model) {
                  if (!(model instanceof Model)) {
                    // TODO: Problems, we may be mixing in some default
                    // properties which will overwrite existing ones.
                    model = new Model(model);
                  }

                  var id = model.get('id');

                  // Missing models should be added not updated.
                  if (id === undefined) {
                    // FIXME: should not throw an exception but return a rejected promise.
                    throw new Error('a model without an id cannot be updated');
                  }

                  var error = model.validate();
                  if (error !== undefined) {
                    // TODO: Better system inspired by Backbone.js.
                    throw error;
                  }

                  return model.properties;
                }, models);

                _context5.next = 6;
                return this._update(models);

              case 6:
                models = _context5.sent;

                this.emit('update', models);

                return _context5.abrupt('return', array ? models : new this.Model(models[0]));

              case 9:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function update(_x6) {
        return _ref5.apply(this, arguments);
      }

      return update;
    }()

    // Methods to override in implementations.

  }, {
    key: '_add',
    value: function _add() {
      throw new Error('not implemented');
    }
  }, {
    key: '_get',
    value: function _get() {
      throw new Error('not implemented');
    }
  }, {
    key: '_remove',
    value: function _remove() {
      throw new Error('not implemented');
    }
  }, {
    key: '_update',
    value: function _update() {
      throw new Error('not implemented');
    }

    // Methods which may be overridden in implementations.

  }, {
    key: 'count',
    value: function count(properties) {
      return this.get(properties).get('count');
    }
  }, {
    key: 'exists',
    value: function exists(properties) {
      /* jshint eqnull: true */
      return this.first(properties).then(function (model) {
        return model != null;
      });
    }
  }, {
    key: '_first',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(properties) {
        var models;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.get(properties);

              case 2:
                models = _context6.sent;
                return _context6.abrupt('return', models.length ? models[0] : null);

              case 4:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _first(_x7) {
        return _ref6.apply(this, arguments);
      }

      return _first;
    }()
  }, {
    key: 'Model',

    // Default value for Model.
    get: function get() {
      return _model2.default;
    }

    // Make this property writable.
    ,
    set: function set(Model) {
      Object.defineProperty(this, 'Model', {
        configurable: true,
        enumerale: true,
        value: Model,
        writable: true
      });
    }
  }]);
  return Collection;
}(_events.EventEmitter);

exports.default = Collection;
//# sourceMappingURL=collection.js.map
