'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _events = require('events');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var Connection = function (_EventEmitter) {
  (0, _inherits3.default)(Connection, _EventEmitter);

  function Connection() {
    (0, _classCallCheck3.default)(this, Connection);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Connection.__proto__ || (0, _getPrototypeOf2.default)(Connection)).call(this));

    _this._data = (0, _utils.createRawObject)();
    return _this;
  }

  // Close the connection.


  (0, _createClass3.default)(Connection, [{
    key: 'close',
    value: function close() {
      // Prevent errors when the connection is closed more than once.
      this.close = _utils.noop;

      this.emit('close');
    }

    // Gets the value for this key.

  }, {
    key: 'get',
    value: function get(key, defaultValue) {
      var data = this._data;


      if (key in data) {
        return data[key];
      }

      if (arguments.length >= 2) {
        return defaultValue;
      }

      throw new Error('no value for `' + key + '`');
    }

    // Checks whether there is a value for this key.

  }, {
    key: 'has',
    value: function has(key) {
      return key in this._data;
    }

    // Sets the value for this key.

  }, {
    key: 'set',
    value: function set(key, value) {
      this._data[key] = value;
    }
  }, {
    key: 'unset',
    value: function unset(key) {
      delete this._data[key];
    }
  }]);
  return Connection;
}(_events.EventEmitter);

exports.default = Connection;
//# sourceMappingURL=connection.js.map
