'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var loadConfiguration = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var config;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _appConf2.default.load('xo-server', {
              ignoreUnknownFormats: true
            });

          case 2:
            config = _context.sent;


            debug('Configuration loaded.');

            // Print a message if deprecated entries are specified.
            (0, _utils.forEach)(DEPRECATED_ENTRIES, function (entry) {
              if ((0, _has2.default)(config, entry)) {
                warn(`${entry} configuration is deprecated.`);
              }
            });

            return _context.abrupt('return', config);

          case 6:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function loadConfiguration() {
    return _ref.apply(this, arguments);
  };
}();

// ===================================================================

var setUpPassport = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(express, xo) {
    var _this = this;

    var strategies, signInPage, SIGNIN_STRATEGY_RE;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            strategies = (0, _utils.createRawObject)();

            xo.registerPassportStrategy = function (strategy) {
              _passport2.default.use(strategy);

              var name = strategy.name;

              if (name !== 'local') {
                strategies[name] = strategy.label || name;
              }
            };

            // Registers the sign in form.
            _context5.t0 = _pug.compile;
            _context5.next = 5;
            return (0, _fsPromise.readFile)((0, _path.join)(__dirname, '..', 'signin.pug'));

          case 5:
            _context5.t1 = _context5.sent;
            signInPage = (0, _context5.t0)(_context5.t1);

            express.get('/signin', function (req, res, next) {
              res.send(signInPage({
                error: req.flash('error')[0],
                strategies
              }));
            });

            express.get('/signout', function (req, res) {
              res.clearCookie('token');
              res.redirect('/');
            });

            SIGNIN_STRATEGY_RE = /^\/signin\/([^/]+)(\/callback)?(:?\?.*)?$/;

            express.use(function () {
              var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(req, res, next) {
                var url, matches, token, isPersistent;
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        url = req.url;
                        matches = url.match(SIGNIN_STRATEGY_RE);

                        if (!matches) {
                          _context3.next = 4;
                          break;
                        }

                        return _context3.abrupt('return', _passport2.default.authenticate(matches[1], function () {
                          var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(err, user, info) {
                            return _regenerator2.default.wrap(function _callee2$(_context2) {
                              while (1) {
                                switch (_context2.prev = _context2.next) {
                                  case 0:
                                    if (!err) {
                                      _context2.next = 2;
                                      break;
                                    }

                                    return _context2.abrupt('return', next(err));

                                  case 2:
                                    if (user) {
                                      _context2.next = 5;
                                      break;
                                    }

                                    req.flash('error', info ? info.message : 'Invalid credentials');
                                    return _context2.abrupt('return', res.redirect('/signin'));

                                  case 5:
                                    _context2.t0 = req;
                                    _context2.next = 8;
                                    return xo.createAuthenticationToken({ userId: user.id });

                                  case 8:
                                    _context2.t1 = _context2.sent.id;

                                    _context2.t0.flash.call(_context2.t0, 'token', _context2.t1);

                                    // The session is only persistent for internal provider and if 'Remember me' box is checked
                                    req.flash('session-is-persistent', matches[1] === 'local' && req.body['remember-me'] === 'on');

                                    res.redirect(req.flash('return-url')[0] || '/');

                                  case 12:
                                  case 'end':
                                    return _context2.stop();
                                }
                              }
                            }, _callee2, _this);
                          }));

                          return function (_x6, _x7, _x8) {
                            return _ref4.apply(this, arguments);
                          };
                        }())(req, res, next));

                      case 4:
                        token = req.flash('token')[0];

                        if (!token) {
                          _context3.next = 11;
                          break;
                        }

                        isPersistent = req.flash('session-is-persistent')[0];


                        if (isPersistent) {
                          // Persistent cookie ? => 1 year
                          res.cookie('token', token, { maxAge: 1000 * 60 * 60 * 24 * 365 });
                        } else {
                          // Non-persistent : external provider as Github, Twitter...
                          res.cookie('token', token);
                        }

                        next();
                        _context3.next = 21;
                        break;

                      case 11:
                        if (!req.cookies.token) {
                          _context3.next = 15;
                          break;
                        }

                        next();
                        _context3.next = 21;
                        break;

                      case 15:
                        if (!/favicon|fontawesome|images|styles|\.(?:css|jpg|png)$/.test(url)) {
                          _context3.next = 19;
                          break;
                        }

                        next();
                        _context3.next = 21;
                        break;

                      case 19:
                        req.flash('return-url', url);
                        return _context3.abrupt('return', res.redirect('/signin'));

                      case 21:
                      case 'end':
                        return _context3.stop();
                    }
                  }
                }, _callee3, _this);
              }));

              return function (_x3, _x4, _x5) {
                return _ref3.apply(this, arguments);
              };
            }());

            // Install the local strategy.
            xo.registerPassportStrategy(new _passportLocal.Strategy(function () {
              var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(username, password, done) {
                var user;
                return _regenerator2.default.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        _context4.prev = 0;
                        _context4.next = 3;
                        return xo.authenticateUser({ username, password });

                      case 3:
                        user = _context4.sent;

                        done(null, user);
                        _context4.next = 10;
                        break;

                      case 7:
                        _context4.prev = 7;
                        _context4.t0 = _context4['catch'](0);

                        done(null, false, { message: _context4.t0.message });

                      case 10:
                      case 'end':
                        return _context4.stop();
                    }
                  }
                }, _callee4, _this, [[0, 7]]);
              }));

              return function (_x9, _x10, _x11) {
                return _ref5.apply(this, arguments);
              };
            }()));

          case 12:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function setUpPassport(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();

// ===================================================================

var registerPlugin = function () {
  var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(pluginPath, pluginName) {
    var _this2 = this;

    var plugin, _ref7, description, _ref7$version, version, _plugin$default, factory, configurationSchema, configurationPresets, testSchema, instance;

    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            plugin = require(pluginPath);
            _ref7 = function () {
              try {
                return require(pluginPath + '/package.json');
              } catch (_) {
                return {};
              }
            }(), description = _ref7.description, _ref7$version = _ref7.version, version = _ref7$version === undefined ? 'unknown' : _ref7$version;

            // Supports both “normal” CommonJS and Babel's ES2015 modules.

            _plugin$default = plugin.default, factory = _plugin$default === undefined ? plugin : _plugin$default, configurationSchema = plugin.configurationSchema, configurationPresets = plugin.configurationPresets, testSchema = plugin.testSchema;

            // The default export can be either a factory or directly a plugin
            // instance.

            instance = (0, _utils.isFunction)(factory) ? factory({
              xo: this,
              getDataDir: function getDataDir() {
                var dir = `${_this2._config.datadir}/${pluginName}`;
                return (0, _fsPromise.ensureDir)(dir).then(function () {
                  return dir;
                });
              } }) : factory;
            _context6.next = 6;
            return this.registerPlugin(pluginName, instance, configurationSchema, configurationPresets, description, testSchema, version);

          case 6:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function registerPlugin(_x12, _x13) {
    return _ref6.apply(this, arguments);
  };
}();

var registerPluginsInPath = function () {
  var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(path) {
    var _this3 = this;

    var files;
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return (0, _fsPromise.readdir)(path).catch(function (error) {
              if (error.code === 'ENOENT') {
                return [];
              }
              throw error;
            });

          case 2:
            files = _context7.sent;
            _context7.next = 5;
            return _promise2.default.all((0, _utils.mapToArray)(files, function (name) {
              if ((0, _startsWith2.default)(name, PLUGIN_PREFIX)) {
                return registerPluginWrapper.call(_this3, `${path}/${name}`, name.slice(PLUGIN_PREFIX_LENGTH));
              }
            }));

          case 5:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));

  return function registerPluginsInPath(_x14) {
    return _ref8.apply(this, arguments);
  };
}();

var registerPlugins = function () {
  var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(xo) {
    return _regenerator2.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            _context8.next = 2;
            return _promise2.default.all((0, _utils.mapToArray)([`${__dirname}/../node_modules/`, '/usr/local/lib/node_modules/'], registerPluginsInPath.bind(xo)));

          case 2:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, this);
  }));

  return function registerPlugins(_x15) {
    return _ref9.apply(this, arguments);
  };
}();

// ===================================================================

var makeWebServerListen = function () {
  var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(_ref11) {
    var certificate = _ref11.certificate,
        _ref11$cert = _ref11.cert,
        cert = _ref11$cert === undefined ? certificate : _ref11$cert,
        key = _ref11.key,
        opts = (0, _objectWithoutProperties3.default)(_ref11, ['certificate', 'cert', 'key']);

    var _ref12, _ref13, niceAddress, code;

    return _regenerator2.default.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            if (!(cert && key)) {
              _context9.next = 7;
              break;
            }

            _context9.next = 3;
            return _promise2.default.all([(0, _fsPromise.readFile)(cert), (0, _fsPromise.readFile)(key)]);

          case 3:
            _ref12 = _context9.sent;
            _ref13 = (0, _slicedToArray3.default)(_ref12, 2);
            opts.cert = _ref13[0];
            opts.key = _ref13[1];

          case 7:
            _context9.prev = 7;
            _context9.next = 10;
            return this.listen(opts);

          case 10:
            niceAddress = _context9.sent;

            debug(`Web server listening on ${niceAddress}`);
            _context9.next = 17;
            break;

          case 14:
            _context9.prev = 14;
            _context9.t0 = _context9['catch'](7);

            if (_context9.t0.niceAddress) {
              warn(`Web server could not listen on ${_context9.t0.niceAddress}`);

              code = _context9.t0.code;

              if (code === 'EACCES') {
                warn('  Access denied.');
                warn('  Ports < 1024 are often reserved to privileges users.');
              } else if (code === 'EADDRINUSE') {
                warn('  Address already in use.');
              }
            } else {
              warn('Web server could not listen:', _context9.t0.message);
            }

          case 17:
          case 'end':
            return _context9.stop();
        }
      }
    }, _callee9, this, [[7, 14]]);
  }));

  return function makeWebServerListen(_x16) {
    return _ref10.apply(this, arguments);
  };
}();

var createWebServer = function () {
  var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(opts) {
    var webServer;
    return _regenerator2.default.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            webServer = new _httpServerPlus2.default();
            _context10.next = 3;
            return _promise2.default.all((0, _utils.mapToArray)(opts, makeWebServerListen.bind(webServer)));

          case 3:
            return _context10.abrupt('return', webServer);

          case 4:
          case 'end':
            return _context10.stop();
        }
      }
    }, _callee10, this);
  }));

  return function createWebServer(_x17) {
    return _ref14.apply(this, arguments);
  };
}();

// ===================================================================

var _appConf = require('app-conf');

var _appConf2 = _interopRequireDefault(_appConf);

var _bind = require('lodash/bind');

var _bind2 = _interopRequireDefault(_bind);

var _blocked = require('blocked');

var _blocked2 = _interopRequireDefault(_blocked);

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _debug2 = require('debug');

var _debug3 = _interopRequireDefault(_debug2);

var _eventToPromise = require('event-to-promise');

var _eventToPromise2 = _interopRequireDefault(_eventToPromise);

var _has = require('lodash/has');

var _has2 = _interopRequireDefault(_has);

var _helmet = require('helmet');

var _helmet2 = _interopRequireDefault(_helmet);

var _includes = require('lodash/includes');

var _includes2 = _interopRequireDefault(_includes);

var _proxyConsole = require('./proxy-console');

var _proxyConsole2 = _interopRequireDefault(_proxyConsole);

var _serveStatic = require('serve-static');

var _serveStatic2 = _interopRequireDefault(_serveStatic);

var _startsWith = require('lodash/startsWith');

var _startsWith2 = _interopRequireDefault(_startsWith);

var _ws = require('ws');

var _ws2 = _interopRequireDefault(_ws);

var _pug = require('pug');

var _httpProxy = require('http-proxy');

var _path = require('path');

var _jsonRpcPeer = require('json-rpc-peer');

var _jsonRpcPeer2 = _interopRequireDefault(_jsonRpcPeer);

var _apiErrors = require('xo-common/api-errors');

var _fsPromise = require('fs-promise');

var _httpServerPlus = require('http-server-plus');

var _httpServerPlus2 = _interopRequireDefault(_httpServerPlus);

var _xo = require('./xo');

var _xo2 = _interopRequireDefault(_xo);

var _httpProxy2 = require('./http-proxy');

var _utils = require('./utils');

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _connectFlash = require('connect-flash');

var _connectFlash2 = _interopRequireDefault(_connectFlash);

var _cookieParser = require('cookie-parser');

var _cookieParser2 = _interopRequireDefault(_cookieParser);

var _expressSession = require('express-session');

var _expressSession2 = _interopRequireDefault(_expressSession);

var _passport = require('passport');

var _passport2 = _interopRequireDefault(_passport);

var _cookie = require('cookie');

var _passportLocal = require('passport-local');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var debug = (0, _debug3.default)('xo:main');

var warn = function warn() {
  var _console;

  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  (_console = console).warn.apply(_console, ['[Warn]'].concat(args));
};

// ===================================================================

var DEPRECATED_ENTRIES = ['users', 'servers'];

function createExpressApp() {
  var app = (0, _express2.default)();

  app.use((0, _helmet2.default)());

  // Registers the cookie-parser and express-session middlewares,
  // necessary for connect-flash.
  app.use((0, _cookieParser2.default)());
  app.use((0, _expressSession2.default)({
    resave: false,
    saveUninitialized: false,

    // TODO: should be in the config file.
    secret: 'CLWguhRZAZIXZcbrMzHCYmefxgweItKnS'
  }));

  // Registers the connect-flash middleware, necessary for Passport to
  // display error messages.
  app.use((0, _connectFlash2.default)());

  // Registers the body-parser middleware, necessary for Passport to
  // access the username and password from the sign in form.
  app.use(_bodyParser2.default.urlencoded({ extended: false }));

  // Registers Passport's middlewares.
  app.use(_passport2.default.initialize());

  return app;
}

var debugPlugin = (0, _debug3.default)('xo:plugin');

function registerPluginWrapper(pluginPath, pluginName) {
  debugPlugin('register %s', pluginName);

  return registerPlugin.call(this, pluginPath, pluginName).then(function () {
    debugPlugin(`successfully register ${pluginName}`);
  }, function (error) {
    debugPlugin(`failed register ${pluginName}`);
    debugPlugin(error);
  });
}

var PLUGIN_PREFIX = 'xo-server-';
var PLUGIN_PREFIX_LENGTH = PLUGIN_PREFIX.length;

var setUpProxies = function setUpProxies(express, opts, xo) {
  if (!opts) {
    return;
  }

  var proxy = (0, _httpProxy.createServer)({
    ignorePath: true
  }).on('error', function (error) {
    return console.error(error);
  });

  // TODO: sort proxies by descending prefix length.

  // HTTP request proxy.
  express.use(function (req, res, next) {
    var url = req.url;


    for (var prefix in opts) {
      if ((0, _startsWith2.default)(url, prefix)) {
        var target = opts[prefix];

        proxy.web(req, res, {
          target: target + url.slice(prefix.length)
        });

        return;
      }
    }

    next();
  });

  // WebSocket proxy.
  var webSocketServer = new _ws2.default.Server({
    noServer: true
  });
  xo.on('stop', function () {
    return (0, _utils.pFromCallback)(function (cb) {
      return webSocketServer.close(cb);
    });
  });

  express.on('upgrade', function (req, socket, head) {
    var url = req.url;


    for (var prefix in opts) {
      if ((0, _startsWith2.default)(url, prefix)) {
        var target = opts[prefix];

        proxy.ws(req, socket, head, {
          target: target + url.slice(prefix.length)
        });

        return;
      }
    }
  });
};

// ===================================================================

var setUpStaticFiles = function setUpStaticFiles(express, opts) {
  (0, _utils.forEach)(opts, function (paths, url) {
    if (!(0, _utils.isArray)(paths)) {
      paths = [paths];
    }

    (0, _utils.forEach)(paths, function (path) {
      debug('Setting up %s → %s', url, path);

      express.use(url, (0, _serveStatic2.default)(path));
    });
  });
};

// ===================================================================

var setUpApi = function setUpApi(webServer, xo, verboseLogsOnErrors) {
  var webSocketServer = new _ws2.default.Server({
    noServer: true
  });
  xo.on('stop', function () {
    return (0, _utils.pFromCallback)(function (cb) {
      return webSocketServer.close(cb);
    });
  });

  var onConnection = function onConnection(socket) {
    var remoteAddress = socket.upgradeReq.socket.remoteAddress;


    debug('+ WebSocket connection (%s)', remoteAddress);

    // Create the abstract XO object for this connection.
    var connection = xo.createUserConnection();
    connection.once('close', function () {
      socket.close();
    });

    // Create the JSON-RPC server for this connection.
    var jsonRpc = new _jsonRpcPeer2.default(function (message) {
      if (message.type === 'request') {
        return xo.callApiMethod(connection, message.method, message.params);
      }
    });
    connection.notify = (0, _bind2.default)(jsonRpc.notify, jsonRpc);

    // Close the XO connection with this WebSocket.
    socket.once('close', function () {
      debug('- WebSocket connection (%s)', remoteAddress);

      connection.close();
    });

    // Connect the WebSocket to the JSON-RPC server.
    socket.on('message', function (message) {
      jsonRpc.write(message);
    });

    var onSend = function onSend(error) {
      if (error) {
        warn('WebSocket send:', error.stack);
      }
    };
    jsonRpc.on('data', function (data) {
      // The socket may have been closed during the API method
      // execution.
      if (socket.readyState === _ws2.default.OPEN) {
        socket.send(data, onSend);
      }
    });
  };
  webServer.on('upgrade', function (req, socket, head) {
    if (req.url === '/api/') {
      webSocketServer.handleUpgrade(req, socket, head, onConnection);
    }
  });
};

// ===================================================================

var CONSOLE_PROXY_PATH_RE = /^\/api\/consoles\/(.*)$/;

var setUpConsoleProxy = function setUpConsoleProxy(webServer, xo) {
  var webSocketServer = new _ws2.default.Server({
    noServer: true
  });
  xo.on('stop', function () {
    return (0, _utils.pFromCallback)(function (cb) {
      return webSocketServer.close(cb);
    });
  });

  webServer.on('upgrade', function () {
    var _ref15 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11(req, socket, head) {
      var matches, _matches, id, _parseCookies, token, user, remoteAddress, xapi, vmConsole;

      return _regenerator2.default.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              matches = CONSOLE_PROXY_PATH_RE.exec(req.url);

              if (matches) {
                _context11.next = 3;
                break;
              }

              return _context11.abrupt('return');

            case 3:
              _matches = (0, _slicedToArray3.default)(matches, 2), id = _matches[1];
              _context11.prev = 4;
              _parseCookies = (0, _cookie.parse)(req.headers.cookie), token = _parseCookies.token;
              _context11.next = 8;
              return xo.authenticateUser({ token });

            case 8:
              user = _context11.sent;
              _context11.next = 11;
              return xo.hasPermissions(user.id, [[id, 'operate']]);

            case 11:
              if (_context11.sent) {
                _context11.next = 13;
                break;
              }

              throw (0, _apiErrors.invalidCredentials)();

            case 13:
              remoteAddress = socket.remoteAddress;

              debug('+ Console proxy (%s - %s)', user.name, remoteAddress);
              socket.on('close', function () {
                debug('- Console proxy (%s - %s)', user.name, remoteAddress);
              });
              xapi = xo.getXapi(id, ['VM', 'VM-controller']);
              vmConsole = xapi.getVmConsole(id);

              // FIXME: lost connection due to VM restart is not detected.

              webSocketServer.handleUpgrade(req, socket, head, function (connection) {
                (0, _proxyConsole2.default)(connection, vmConsole, xapi.sessionId);
              });
              _context11.next = 24;
              break;

            case 21:
              _context11.prev = 21;
              _context11.t0 = _context11['catch'](4);

              console.error(_context11.t0 && _context11.t0.stack || _context11.t0);

            case 24:
            case 'end':
              return _context11.stop();
          }
        }
      }, _callee11, undefined, [[4, 21]]);
    }));

    return function (_x18, _x19, _x20) {
      return _ref15.apply(this, arguments);
    };
  }());
};

// ===================================================================

var USAGE = function (_ref16) {
  var name = _ref16.name,
      version = _ref16.version;
  return `Usage: ${name} [--safe-mode]

${name} v${version}`;
}(require('../package.json'));

// ===================================================================

exports.default = function () {
  var _ref17 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12(args) {
    var _debug, config, webServer, user, group, xo, express, port;

    return _regenerator2.default.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            if (!((0, _includes2.default)(args, '--help') || (0, _includes2.default)(args, '-h'))) {
              _context12.next = 2;
              break;
            }

            return _context12.abrupt('return', USAGE);

          case 2:
            _debug = (0, _debug3.default)('xo:perf');

            (0, _blocked2.default)(function (ms) {
              _debug('blocked for %sms', ms | 0);
            });
            _context12.next = 6;
            return loadConfiguration();

          case 6:
            config = _context12.sent;
            _context12.next = 9;
            return createWebServer(config.http.listen);

          case 9:
            webServer = _context12.sent;


            // Now the web server is listening, drop privileges.
            try {
              user = config.user, group = config.group;

              if (group) {
                process.setgid(group);
                debug('Group changed to', group);
              }
              if (user) {
                process.setuid(user);
                debug('User changed to', user);
              }
            } catch (error) {
              warn('Failed to change user/group:', error);
            }

            if (config.httpProxy) {
              (0, _httpProxy2.setup)(config.httpProxy);
            }

            // Creates main object.
            xo = new _xo2.default(config);

            // Register web server close on XO stop.

            xo.on('stop', function () {
              return (0, _utils.pFromCallback)(function (cb) {
                return webServer.close(cb);
              });
            });

            // Connects to all registered servers.
            _context12.next = 16;
            return xo.start();

          case 16:

            // Express is used to manage non WebSocket connections.
            express = createExpressApp();


            if (config.http.redirectToHttps) {
              port = void 0;

              (0, _utils.forEach)(config.http.listen, function (listen) {
                if (listen.port && (listen.cert || listen.certificate)) {
                  port = listen.port;
                  return false;
                }
              });

              if (port === undefined) {
                warn('Could not setup HTTPs redirection: no HTTPs port found');
              } else {
                express.use(function (req, res, next) {
                  if (req.secure) {
                    return next();
                  }

                  res.redirect(`https://${req.hostname}:${port}${req.originalUrl}`);
                });
              }
            }

            // Must be set up before the API.
            setUpConsoleProxy(webServer, xo);

            // Must be set up before the API.
            express.use((0, _bind2.default)(xo._handleHttpRequest, xo));

            // Everything above is not protected by the sign in, allowing xo-cli
            // to work properly.
            _context12.next = 22;
            return setUpPassport(express, xo);

          case 22:

            // Attaches express to the web server.
            webServer.on('request', express);
            webServer.on('upgrade', function (req, socket, head) {
              express.emit('upgrade', req, socket, head);
            });

            // Must be set up before the static files.
            setUpApi(webServer, xo, config.verboseApiLogsOnErrors);

            setUpProxies(express, config.http.proxies, xo);

            setUpStaticFiles(express, config.http.mounts);

            if ((0, _includes2.default)(args, '--safe-mode')) {
              _context12.next = 30;
              break;
            }

            _context12.next = 30;
            return registerPlugins(xo);

          case 30:

            // Gracefully shutdown on signals.
            //
            // TODO: implements a timeout? (or maybe it is the services launcher
            // responsibility?)
            (0, _utils.forEach)(['SIGINT', 'SIGTERM'], function (signal) {
              var alreadyCalled = false;

              process.on(signal, function () {
                if (alreadyCalled) {
                  warn('forced exit');
                  process.exit(1);
                }
                alreadyCalled = true;

                debug('%s caught, closing…', signal);
                xo.stop();
              });
            });

            _context12.next = 33;
            return (0, _eventToPromise2.default)(xo, 'stopped');

          case 33:

            debug('bye :-)');

          case 34:
          case 'end':
            return _context12.stop();
        }
      }
    }, _callee12, this);
  }));

  function main(_x21) {
    return _ref17.apply(this, arguments);
  }

  return main;
}();
//# sourceMappingURL=index.js.map
