'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.UnsupportedVectorType = exports.UnsupportedJobType = exports.JobExecutorError = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.resolveParamsVector = resolveParamsVector;

var _assign = require('lodash/assign');

var _assign2 = _interopRequireDefault(_assign);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _every = require('lodash/every');

var _every2 = _interopRequireDefault(_every);

var _filter = require('lodash/filter');

var _filter2 = _interopRequireDefault(_filter);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _isPlainObject = require('lodash/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _mapValues = require('lodash/mapValues');

var _mapValues2 = _interopRequireDefault(_mapValues);

var _size = require('lodash/size');

var _size2 = _interopRequireDefault(_size);

var _some = require('lodash/some');

var _some2 = _interopRequireDefault(_some);

var _makeError = require('make-error');

var _promiseToolbox = require('promise-toolbox');

var _math = require('./math');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var JobExecutorError = exports.JobExecutorError = function (_BaseError) {
  (0, _inherits3.default)(JobExecutorError, _BaseError);

  function JobExecutorError() {
    (0, _classCallCheck3.default)(this, JobExecutorError);
    return (0, _possibleConstructorReturn3.default)(this, (JobExecutorError.__proto__ || (0, _getPrototypeOf2.default)(JobExecutorError)).apply(this, arguments));
  }

  return JobExecutorError;
}(_makeError.BaseError);

var UnsupportedJobType = exports.UnsupportedJobType = function (_JobExecutorError) {
  (0, _inherits3.default)(UnsupportedJobType, _JobExecutorError);

  function UnsupportedJobType(job) {
    (0, _classCallCheck3.default)(this, UnsupportedJobType);
    return (0, _possibleConstructorReturn3.default)(this, (UnsupportedJobType.__proto__ || (0, _getPrototypeOf2.default)(UnsupportedJobType)).call(this, 'Unknown job type: ' + job.type));
  }

  return UnsupportedJobType;
}(JobExecutorError);

var UnsupportedVectorType = exports.UnsupportedVectorType = function (_JobExecutorError2) {
  (0, _inherits3.default)(UnsupportedVectorType, _JobExecutorError2);

  function UnsupportedVectorType(vector) {
    (0, _classCallCheck3.default)(this, UnsupportedVectorType);
    return (0, _possibleConstructorReturn3.default)(this, (UnsupportedVectorType.__proto__ || (0, _getPrototypeOf2.default)(UnsupportedVectorType)).call(this, 'Unknown vector type: ' + vector.type));
  }

  return UnsupportedVectorType;
}(JobExecutorError);

// ===================================================================

var match = function match(pattern, value) {
  if ((0, _isPlainObject2.default)(pattern)) {
    if ((0, _size2.default)(pattern) === 1) {
      if (pattern.__or) {
        return (0, _some2.default)(pattern.__or, function (subpattern) {
          return match(subpattern, value);
        });
      }
      if (pattern.__not) {
        return !match(pattern.__not, value);
      }
    }

    return (0, _isPlainObject2.default)(value) && (0, _every2.default)(pattern, function (subpattern, key) {
      return value[key] !== undefined && match(subpattern, value[key]);
    });
  }

  if ((0, _isArray2.default)(pattern)) {
    return (0, _isArray2.default)(value) && (0, _every2.default)(pattern, function (subpattern) {
      return (0, _some2.default)(value, function (subvalue) {
        return match(subpattern, subvalue);
      });
    });
  }

  return pattern === value;
};

var paramsVectorActionsMap = {
  extractProperties(_ref) {
    var mapping = _ref.mapping,
        value = _ref.value;

    return (0, _mapValues2.default)(mapping, function (key) {
      return value[key];
    });
  },
  crossProduct(_ref2) {
    var _this4 = this;

    var items = _ref2.items;

    return (0, _utils.thunkToArray)((0, _math.crossProduct)((0, _map2.default)(items, function (value) {
      return resolveParamsVector.call(_this4, value);
    })));
  },
  fetchObjects(_ref3) {
    var pattern = _ref3.pattern;

    return (0, _filter2.default)(this.xo.getObjects(), function (object) {
      return match(pattern, object);
    });
  },
  map(_ref4) {
    var _this5 = this;

    var collection = _ref4.collection,
        iteratee = _ref4.iteratee,
        _ref4$paramName = _ref4.paramName,
        paramName = _ref4$paramName === undefined ? 'value' : _ref4$paramName;

    return (0, _map2.default)(resolveParamsVector.call(this, collection), function (value) {
      return resolveParamsVector.call(_this5, (0, _extends3.default)({}, iteratee, {
        [paramName]: value
      }));
    });
  },
  set: function set(_ref5) {
    var values = _ref5.values;
    return values;
  }
};

function resolveParamsVector(paramsVector) {
  var visitor = paramsVectorActionsMap[paramsVector.type];
  if (!visitor) {
    throw new Error(`Unsupported function '${paramsVector.type}'.`);
  }

  return visitor.call(this, paramsVector);
}

// ===================================================================

var JobExecutor = function () {
  function JobExecutor(xo) {
    var _this6 = this;

    (0, _classCallCheck3.default)(this, JobExecutor);

    this.xo = xo;
    this._extractValueCb = {
      'set': function set(items) {
        return items.values;
      }
    };

    // The logger is not available until Xo has started.
    xo.on('start', function () {
      return xo.getLogger('jobs').then(function (logger) {
        _this6._logger = logger;
      });
    });
  }

  (0, _createClass3.default)(JobExecutor, [{
    key: 'exec',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(job) {
        var runJobId, execStatus;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                runJobId = this._logger.notice(`Starting execution of ${job.id}.`, {
                  event: 'job.start',
                  userId: job.userId,
                  jobId: job.id,
                  key: job.key
                });
                _context.prev = 1;

                if (!(job.type === 'call')) {
                  _context.next = 9;
                  break;
                }

                _context.next = 5;
                return this._execCall(job, runJobId);

              case 5:
                execStatus = _context.sent;


                this.xo.emit('job:terminated', execStatus);
                _context.next = 10;
                break;

              case 9:
                throw new UnsupportedJobType(job);

              case 10:

                this._logger.notice(`Execution terminated for ${job.id}.`, {
                  event: 'job.end',
                  runJobId
                });
                _context.next = 17;
                break;

              case 13:
                _context.prev = 13;
                _context.t0 = _context['catch'](1);

                this._logger.error(`The execution of ${job.id} has failed.`, {
                  event: 'job.end',
                  runJobId,
                  error: (0, _utils.serializeError)(_context.t0)
                });

                throw _context.t0;

              case 17:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[1, 13]]);
      }));

      function exec(_x) {
        return _ref6.apply(this, arguments);
      }

      return exec;
    }()
  }, {
    key: '_execCall',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(job, runJobId) {
        var _this7 = this;

        var paramsVector, paramsFlatVector, connection, execStatus;
        return _regenerator2.default.wrap(function _callee2$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                paramsVector = job.paramsVector;
                paramsFlatVector = paramsVector ? resolveParamsVector.call(this, paramsVector) : [{}]; // One call with no parameters

                connection = this.xo.createUserConnection();


                connection.set('user_id', job.userId);

                execStatus = {
                  runJobId,
                  start: Date.now(),
                  calls: {}
                };
                _context3.next = 7;
                return _bluebird2.default.map(paramsFlatVector, function (params) {
                  var runCallId = _this7._logger.notice(`Starting ${job.method} call. (${job.id})`, {
                    event: 'jobCall.start',
                    runJobId,
                    method: job.method,
                    params
                  });

                  var call = execStatus.calls[runCallId] = {
                    method: job.method,
                    params,
                    start: Date.now()
                  };
                  var promise = _this7.xo.callApiMethod(connection, job.method, (0, _assign2.default)({}, params));
                  if (job.timeout) {
                    var _context2;

                    promise = (_context2 = promise, _promiseToolbox.timeout).call(_context2, job.timeout);
                  }

                  return promise.then(function (value) {
                    _this7._logger.notice(`Call ${job.method} (${runCallId}) is a success. (${job.id})`, {
                      event: 'jobCall.end',
                      runJobId,
                      runCallId,
                      returnedValue: value
                    });

                    call.returnedValue = value;
                    call.end = Date.now();
                  }, function (reason) {
                    _this7._logger.notice(`Call ${job.method} (${runCallId}) has failed. (${job.id})`, {
                      event: 'jobCall.end',
                      runJobId,
                      runCallId,
                      error: (0, _utils.serializeError)(reason)
                    });

                    call.error = reason;
                    call.end = Date.now();
                  });
                }, {
                  concurrency: 2
                });

              case 7:

                connection.close();
                execStatus.end = Date.now();

                return _context3.abrupt('return', execStatus);

              case 10:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee2, this);
      }));

      function _execCall(_x2, _x3) {
        return _ref7.apply(this, arguments);
      }

      return _execCall;
    }()
  }]);
  return JobExecutor;
}();

exports.default = JobExecutor;
//# sourceMappingURL=job-executor.js.map
