'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _highland = require('highland');

var _highland2 = _interopRequireDefault(_highland);

var _abstract = require('./abstract');

var _abstract2 = _interopRequireDefault(_abstract);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var lastDate = 0;
var increment = 0;

function generateUniqueKey(date) {
  if (date === lastDate) {
    return `${date}:${increment++}`;
  }

  increment = 0;
  return String(lastDate = date);
}

var LevelDbLogger = function (_AbstractLogger) {
  (0, _inherits3.default)(LevelDbLogger, _AbstractLogger);

  function LevelDbLogger(db, namespace) {
    (0, _classCallCheck3.default)(this, LevelDbLogger);

    var _this = (0, _possibleConstructorReturn3.default)(this, (LevelDbLogger.__proto__ || (0, _getPrototypeOf2.default)(LevelDbLogger)).call(this));

    _this._db = db;
    _this._namespace = namespace;
    return _this;
  }

  (0, _createClass3.default)(LevelDbLogger, [{
    key: '_add',
    value: function _add(level, message, data) {
      var time = Date.now();

      var log = {
        level,
        message,
        data,
        namespace: this._namespace,
        time
      };

      var key = generateUniqueKey(time);
      this._db.putSync(key, log);
      return key;
    }
  }, {
    key: 'createReadStream',
    value: function createReadStream() {
      var _this2 = this;

      return (0, _highland2.default)(this._db.createReadStream()).filter(function (_ref) {
        var value = _ref.value;
        return value.namespace === _this2._namespace;
      });
    }
  }, {
    key: 'del',
    value: function del(id) {
      var _this3 = this;

      if (!Array.isArray(id)) {
        id = [id];
      }
      (0, _utils.forEach)(id, function (id) {
        _this3._db.get(id).then(function (value) {
          if (value.namespace === _this3._namespace) {
            _this3._db.delSync(id, _utils.noop);
          }
        });
      });
    }
  }]);
  return LevelDbLogger;
}(_abstract2.default);

exports.default = LevelDbLogger;
//# sourceMappingURL=leveldb.js.map
