'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pvs = exports.lvs = undefined;

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _execa = require('execa');

var _execa2 = _interopRequireDefault(_execa);

var _splitLines = require('split-lines');

var _splitLines2 = _interopRequireDefault(_splitLines);

var _parsePairs = require('parse-pairs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var parse = (0, _parsePairs.createParser)({
  keyTransform: function keyTransform(key) {
    return key.slice(5).toLowerCase();
  }
});
var makeFunction = function makeFunction(command) {
  return function (fields) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return _execa2.default.stdout(command, ['--noheading', '--nosuffix', '--nameprefixes', '--unbuffered', '--units', 'b', '-o', String(fields)].concat(args)).then(function (stdout) {
      return (0, _map3.default)((0, _splitLines2.default)(stdout), (0, _isArray3.default)(fields) ? parse : function (line) {
        var data = parse(line);
        return data[fields];
      });
    });
  };
};

var lvs = exports.lvs = makeFunction('lvs');
var pvs = exports.pvs = makeFunction('pvs');
//# sourceMappingURL=lvm.js.map
