'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _events = require('events');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var Model = function (_EventEmitter) {
  (0, _inherits3.default)(Model, _EventEmitter);

  function Model(properties) {
    (0, _classCallCheck3.default)(this, Model);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Model.__proto__ || (0, _getPrototypeOf2.default)(Model)).call(this));

    _this.properties = (0, _extends3.default)({}, _this.default);

    if (properties) {
      _this.set(properties);
    }
    return _this;
  }

  // Initialize the model after construction.


  (0, _createClass3.default)(Model, [{
    key: 'initialize',
    value: function initialize() {}

    // Validate the defined properties.
    //
    // Returns the error if any.

  }, {
    key: 'validate',
    value: function validate(properties) {}

    // Get a property.

  }, {
    key: 'get',
    value: function get(name, def) {
      var value = this.properties[name];
      return value !== undefined ? value : def;
    }

    // Check whether a property exists.

  }, {
    key: 'has',
    value: function has(name) {
      return this.properties[name] !== undefined;
    }

    // Set properties.

  }, {
    key: 'set',
    value: function set(properties, value) {
      var _this2 = this;

      // This method can also be used with two arguments to set a single
      // property.
      if ((0, _utils.isString)(properties)) {
        properties = { [properties]: value };
      }

      var previous = {};

      (0, _utils.forEach)(properties, function (value, name) {
        var prev = _this2.properties[name];

        if (value !== prev) {
          previous[name] = prev;

          if (value === undefined) {
            delete _this2.properties[name];
          } else {
            _this2.properties[name] = value;
          }
        }
      });

      if (!(0, _utils.isEmpty)(previous)) {
        this.emit('change', previous);

        (0, _utils.forEach)(previous, function (value, name) {
          _this2.emit('change:' + name, value);
        });
      }
    }
  }]);
  return Model;
}(_events.EventEmitter);

exports.default = Model;
//# sourceMappingURL=model.js.map
