'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Acls = exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redis = require('../collection/redis');

var _redis2 = _interopRequireDefault(_redis);

var _model = require('../model');

var _model2 = _interopRequireDefault(_model);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

// Up until now, there were no actions, therefore the default
// action is used to update existing entries.
var DEFAULT_ACTION = 'admin';

// ===================================================================

var Acl = function (_Model) {
  (0, _inherits3.default)(Acl, _Model);

  function Acl() {
    (0, _classCallCheck3.default)(this, Acl);
    return (0, _possibleConstructorReturn3.default)(this, (Acl.__proto__ || (0, _getPrototypeOf2.default)(Acl)).apply(this, arguments));
  }

  return Acl;
}(_model2.default);

exports.default = Acl;


Acl.create = function (subject, object, action) {
  return Acl.hash(subject, object, action).then(function (hash) {
    return new Acl({
      id: hash,
      subject,
      object,
      action
    });
  });
};

Acl.hash = function (subject, object, action) {
  return (0, _utils.multiKeyHash)(subject, object, action);
};

// -------------------------------------------------------------------

var Acls = exports.Acls = function (_Collection) {
  (0, _inherits3.default)(Acls, _Collection);

  function Acls() {
    (0, _classCallCheck3.default)(this, Acls);
    return (0, _possibleConstructorReturn3.default)(this, (Acls.__proto__ || (0, _getPrototypeOf2.default)(Acls)).apply(this, arguments));
  }

  (0, _createClass3.default)(Acls, [{
    key: 'create',
    value: function create(subject, object, action) {
      var _this3 = this;

      return Acl.create(subject, object, action).then(function (acl) {
        return _this3.add(acl);
      });
    }
  }, {
    key: 'delete',
    value: function _delete(subject, object, action) {
      var _this4 = this;

      return Acl.hash(subject, object, action).then(function (hash) {
        return _this4.remove(hash);
      });
    }
  }, {
    key: 'aclExists',
    value: function aclExists(subject, object, action) {
      var _this5 = this;

      return Acl.hash(subject, object, action).then(function (hash) {
        return _this5.exists(hash);
      });
    }
  }, {
    key: 'get',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(properties) {
        var acls, toUpdate, hash;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _get3.default)(Acls.prototype.__proto__ || (0, _getPrototypeOf2.default)(Acls.prototype), 'get', this).call(this, properties);

              case 2:
                acls = _context.sent;


                // Finds all records that are missing a action and need to be updated.
                toUpdate = [];

                (0, _utils.forEach)(acls, function (acl) {
                  if (!acl.action) {
                    acl.action = DEFAULT_ACTION;
                    toUpdate.push(acl);
                  }
                });

                if (!toUpdate.length) {
                  _context.next = 13;
                  break;
                }

                _context.next = 8;
                return this.remove((0, _utils.mapToArray)(toUpdate, 'id'));

              case 8:

                // Compute the new ids (new hashes).
                hash = Acl.hash;
                _context.next = 11;
                return _promise2.default.all((0, _utils.mapToArray)(toUpdate, function (acl) {
                  return hash(acl.subject, acl.object, acl.action).then(function (id) {
                    acl.id = id;
                  });
                }));

              case 11:
                _context.next = 13;
                return this.add(toUpdate);

              case 13:
                return _context.abrupt('return', acls);

              case 14:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function get(_x) {
        return _ref.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: 'Model',
    get: function get() {
      return Acl;
    }
  }]);
  return Acls;
}(_redis2.default);
//# sourceMappingURL=acl.js.map
