'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Jobs = exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redis = require('../collection/redis');

var _redis2 = _interopRequireDefault(_redis);

var _model = require('../model');

var _model2 = _interopRequireDefault(_model);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var Job = function (_Model) {
  (0, _inherits3.default)(Job, _Model);

  function Job() {
    (0, _classCallCheck3.default)(this, Job);
    return (0, _possibleConstructorReturn3.default)(this, (Job.__proto__ || (0, _getPrototypeOf2.default)(Job)).apply(this, arguments));
  }

  return Job;
}(_model2.default);

exports.default = Job;

var Jobs = exports.Jobs = function (_Collection) {
  (0, _inherits3.default)(Jobs, _Collection);

  function Jobs() {
    (0, _classCallCheck3.default)(this, Jobs);
    return (0, _possibleConstructorReturn3.default)(this, (Jobs.__proto__ || (0, _getPrototypeOf2.default)(Jobs)).apply(this, arguments));
  }

  (0, _createClass3.default)(Jobs, [{
    key: 'create',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(job) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // Serializes.
                job.paramsVector = (0, _stringify2.default)(job.paramsVector);
                return _context.abrupt('return', /* await */this.add(new Job(job)));

              case 2:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function create(_x) {
        return _ref.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: 'save',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(job) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                // Serializes.
                job.paramsVector = (0, _stringify2.default)(job.paramsVector);
                return _context2.abrupt('return', /* await */this.update(job));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function save(_x2) {
        return _ref2.apply(this, arguments);
      }

      return save;
    }()
  }, {
    key: 'get',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(properties) {
        var jobs;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return (0, _get3.default)(Jobs.prototype.__proto__ || (0, _getPrototypeOf2.default)(Jobs.prototype), 'get', this).call(this, properties);

              case 2:
                jobs = _context3.sent;


                // Deserializes.
                (0, _utils.forEach)(jobs, function (job) {
                  var paramsVector = job.paramsVector;

                  try {
                    job.paramsVector = JSON.parse(paramsVector);
                  } catch (error) {
                    console.warn('cannot parse job.paramsVector:', paramsVector); // FIXME this is a warning as I copy/paste acl.js, but...
                    job.paramsVector = {};
                  }
                });

                return _context3.abrupt('return', jobs);

              case 5:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function get(_x3) {
        return _ref3.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: 'Model',
    get: function get() {
      return Job;
    }
  }]);
  return Jobs;
}(_redis2.default);
//# sourceMappingURL=job.js.map
