'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PluginsMetadata = exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redis = require('../collection/redis');

var _redis2 = _interopRequireDefault(_redis);

var _model = require('../model');

var _model2 = _interopRequireDefault(_model);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var PluginMetadata = function (_Model) {
  (0, _inherits3.default)(PluginMetadata, _Model);

  function PluginMetadata() {
    (0, _classCallCheck3.default)(this, PluginMetadata);
    return (0, _possibleConstructorReturn3.default)(this, (PluginMetadata.__proto__ || (0, _getPrototypeOf2.default)(PluginMetadata)).apply(this, arguments));
  }

  return PluginMetadata;
}(_model2.default);

// ===================================================================

exports.default = PluginMetadata;

var PluginsMetadata = exports.PluginsMetadata = function (_Collection) {
  (0, _inherits3.default)(PluginsMetadata, _Collection);

  function PluginsMetadata() {
    (0, _classCallCheck3.default)(this, PluginsMetadata);
    return (0, _possibleConstructorReturn3.default)(this, (PluginsMetadata.__proto__ || (0, _getPrototypeOf2.default)(PluginsMetadata)).apply(this, arguments));
  }

  (0, _createClass3.default)(PluginsMetadata, [{
    key: 'save',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
        var id = _ref2.id,
            autoload = _ref2.autoload,
            configuration = _ref2.configuration;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', /* await */this.update({
                  id,
                  autoload: autoload ? 'true' : 'false',
                  configuration: configuration && (0, _stringify2.default)(configuration)
                }));

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function save(_x) {
        return _ref.apply(this, arguments);
      }

      return save;
    }()
  }, {
    key: 'merge',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(id, data) {
        var pluginMetadata;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.first(id);

              case 2:
                pluginMetadata = _context2.sent;

                if (pluginMetadata) {
                  _context2.next = 5;
                  break;
                }

                throw new Error('no such plugin metadata');

              case 5:
                return _context2.abrupt('return', /* await */this.save((0, _extends3.default)({}, pluginMetadata.properties, data)));

              case 6:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function merge(_x2, _x3) {
        return _ref3.apply(this, arguments);
      }

      return merge;
    }()
  }, {
    key: 'get',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(properties) {
        var pluginsMetadata;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return (0, _get3.default)(PluginsMetadata.prototype.__proto__ || (0, _getPrototypeOf2.default)(PluginsMetadata.prototype), 'get', this).call(this, properties);

              case 2:
                pluginsMetadata = _context3.sent;


                // Deserializes.
                (0, _utils.forEach)(pluginsMetadata, function (pluginMetadata) {
                  var autoload = pluginMetadata.autoload,
                      configuration = pluginMetadata.configuration;

                  pluginMetadata.autoload = autoload === 'true';
                  try {
                    pluginMetadata.configuration = configuration && JSON.parse(configuration);
                  } catch (error) {
                    console.warn('cannot parse pluginMetadata.configuration:', configuration);
                    pluginMetadata.configuration = [];
                  }
                });

                return _context3.abrupt('return', pluginsMetadata);

              case 5:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function get(_x4) {
        return _ref4.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: 'Model',
    get: function get() {
      return PluginMetadata;
    }
  }]);
  return PluginsMetadata;
}(_redis2.default);
//# sourceMappingURL=plugin-metadata.js.map
