'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Servers = exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redis = require('../collection/redis');

var _redis2 = _interopRequireDefault(_redis);

var _model = require('../model');

var _model2 = _interopRequireDefault(_model);

var _utils = require('../utils');

var _utils2 = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var Server = function (_Model) {
  (0, _inherits3.default)(Server, _Model);

  function Server() {
    (0, _classCallCheck3.default)(this, Server);
    return (0, _possibleConstructorReturn3.default)(this, (Server.__proto__ || (0, _getPrototypeOf2.default)(Server)).apply(this, arguments));
  }

  return Server;
}(_model2.default);

// -------------------------------------------------------------------

exports.default = Server;

var Servers = exports.Servers = function (_Collection) {
  (0, _inherits3.default)(Servers, _Collection);

  function Servers() {
    (0, _classCallCheck3.default)(this, Servers);
    return (0, _possibleConstructorReturn3.default)(this, (Servers.__proto__ || (0, _getPrototypeOf2.default)(Servers)).apply(this, arguments));
  }

  (0, _createClass3.default)(Servers, [{
    key: 'create',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
        var label = _ref2.label,
            host = _ref2.host,
            username = _ref2.username,
            password = _ref2.password,
            readOnly = _ref2.readOnly;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.exists({ host });

              case 2:
                if (!_context.sent) {
                  _context.next = 4;
                  break;
                }

                throw new Error('server already exists');

              case 4:
                return _context.abrupt('return', /* await */this.add({ label, host, username, password, readOnly }));

              case 5:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function create(_x) {
        return _ref.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: 'get',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(properties) {
        var servers;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return (0, _get3.default)(Servers.prototype.__proto__ || (0, _getPrototypeOf2.default)(Servers.prototype), 'get', this).call(this, properties);

              case 2:
                servers = _context2.sent;


                // Deserializes
                (0, _utils.forEach)(servers, function (server) {
                  if (server.error) {
                    server.error = (0, _utils2.parseProp)('server', server, 'error', '');
                  } else {
                    delete server.error;
                  }
                });

                return _context2.abrupt('return', servers);

              case 5:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function get(_x2) {
        return _ref3.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: 'Model',
    get: function get() {
      return Server;
    }
  }]);
  return Servers;
}(_redis2.default);
//# sourceMappingURL=server.js.map
