'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Users = exports.default = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _redis = require('../collection/redis');

var _redis2 = _interopRequireDefault(_redis);

var _model = require('../model');

var _model2 = _interopRequireDefault(_model);

var _utils = require('../utils');

var _utils2 = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var User = function (_Model) {
  (0, _inherits3.default)(User, _Model);

  function User() {
    (0, _classCallCheck3.default)(this, User);
    return (0, _possibleConstructorReturn3.default)(this, (User.__proto__ || (0, _getPrototypeOf2.default)(User)).apply(this, arguments));
  }

  return User;
}(_model2.default);

exports.default = User;


User.prototype.default = {
  permission: 'none'
};

// -------------------------------------------------------------------

var Users = exports.Users = function (_Collection) {
  (0, _inherits3.default)(Users, _Collection);

  function Users() {
    (0, _classCallCheck3.default)(this, Users);
    return (0, _possibleConstructorReturn3.default)(this, (Users.__proto__ || (0, _getPrototypeOf2.default)(Users)).apply(this, arguments));
  }

  (0, _createClass3.default)(Users, [{
    key: 'create',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(properties) {
        var email, user;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                email = properties.email;

                // Avoid duplicates.

                _context.next = 3;
                return this.exists({ email });

              case 3:
                if (!_context.sent) {
                  _context.next = 5;
                  break;
                }

                throw new Error(`the user ${email} already exists`);

              case 5:

                // Create the user object.
                user = new User(properties);

                // Adds the user to the collection.

                return _context.abrupt('return', /* await */this.add(user));

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function create(_x) {
        return _ref.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: 'save',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(user) {
        var tmp;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                // Serializes.
                tmp = void 0;

                user.groups = (0, _isEmpty2.default)(tmp = user.groups) ? undefined : (0, _stringify2.default)(tmp);
                user.preferences = (0, _isEmpty2.default)(tmp = user.preferences) ? undefined : (0, _stringify2.default)(tmp);

                return _context2.abrupt('return', /* await */this.update(user));

              case 4:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function save(_x2) {
        return _ref2.apply(this, arguments);
      }

      return save;
    }()
  }, {
    key: 'get',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(properties) {
        var users;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return (0, _get3.default)(Users.prototype.__proto__ || (0, _getPrototypeOf2.default)(Users.prototype), 'get', this).call(this, properties);

              case 2:
                users = _context3.sent;


                // Deserializes
                (0, _utils.forEach)(users, function (user) {
                  user.groups = (0, _utils2.parseProp)('user', user, 'groups', []);
                  user.preferences = (0, _utils2.parseProp)('user', user, 'preferences', {});
                });

                return _context3.abrupt('return', users);

              case 5:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function get(_x3) {
        return _ref3.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: 'Model',
    get: function get() {
      return User;
    }
  }]);
  return Users;
}(_redis2.default);
//# sourceMappingURL=user.js.map
