'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _from = require('from2');

var _from2 = _interopRequireDefault(_from);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var constantStream = function constantStream(data) {
  var n = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

  if (!Buffer.isBuffer(data)) {
    data = Buffer.from(data);
  }

  var _data = data,
      length = _data.length;


  if (!length) {
    throw new Error('data should not be empty');
  }

  n *= length;
  var currentLength = length;

  return (0, _from2.default)(function (size, next) {
    if (n <= 0) {
      return next(null, null);
    }

    if (n < size) {
      size = n;
    }

    if (size < currentLength) {
      var m = Math.floor(size / length) * length || length;
      n -= m;
      return next(null, data.slice(0, m));
    }

    // if more than twice the data length is requested, repeat the data
    if (size > currentLength * 2) {
      currentLength = Math.floor(size / length) * length;
      data = Buffer.alloc(currentLength, data);
    }

    n -= currentLength;
    return next(null, data);
  });
};
exports.default = constantStream;
//# sourceMappingURL=constant-stream.js.map
