'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _eventToPromise = require('event-to-promise');

var _eventToPromise2 = _interopRequireDefault(_eventToPromise);

var _through = require('through2');

var _through2 = _interopRequireDefault(_through);

var _xoRemoteParser = require('xo-remote-parser');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RemoteHandlerAbstract = function () {
  function RemoteHandlerAbstract(remote) {
    (0, _classCallCheck3.default)(this, RemoteHandlerAbstract);

    this._remote = (0, _extends3.default)({}, remote, (0, _xoRemoteParser.parse)(remote.url));
    if (this._remote.type !== this.type) {
      throw new Error('Incorrect remote type');
    }
  }

  (0, _createClass3.default)(RemoteHandlerAbstract, [{
    key: 'sync',


    /**
     * Asks the handler to sync the state of the effective remote with its' metadata
     */
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', this._sync());

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function sync() {
        return _ref.apply(this, arguments);
      }

      return sync;
    }()
  }, {
    key: '_sync',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                throw new Error('Not implemented');

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _sync() {
        return _ref2.apply(this, arguments);
      }

      return _sync;
    }()

    /**
     * Free the resources possibly dedicated to put the remote at work, when it is no more needed
     */

  }, {
    key: 'forget',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt('return', this._forget());

              case 1:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function forget() {
        return _ref3.apply(this, arguments);
      }

      return forget;
    }()
  }, {
    key: '_forget',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                throw new Error('Not implemented');

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function _forget() {
        return _ref4.apply(this, arguments);
      }

      return _forget;
    }()
  }, {
    key: 'test',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
        var testFileName, data, step, read;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                testFileName = `${Date.now()}.test`;
                data = (0, _utils.getPseudoRandomBytes)(1024 * 1024);
                step = 'write';
                _context5.prev = 3;
                _context5.next = 6;
                return this.outputFile(testFileName, data);

              case 6:
                step = 'read';
                _context5.next = 9;
                return this.readFile(testFileName);

              case 9:
                read = _context5.sent;

                if (!(data.compare(read) !== 0)) {
                  _context5.next = 12;
                  break;
                }

                throw new Error('output and input did not match');

              case 12:
                return _context5.abrupt('return', {
                  success: true
                });

              case 15:
                _context5.prev = 15;
                _context5.t0 = _context5['catch'](3);
                return _context5.abrupt('return', {
                  success: false,
                  step,
                  file: testFileName,
                  error: _context5.t0.message || String(_context5.t0)
                });

              case 18:
                _context5.prev = 18;

                this.unlink(testFileName).catch(_utils.noop);
                return _context5.finish(18);

              case 21:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this, [[3, 15, 18, 21]]);
      }));

      function test() {
        return _ref5.apply(this, arguments);
      }

      return test;
    }()
  }, {
    key: 'outputFile',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(file, data, options) {
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt('return', this._outputFile(file, data, (0, _extends3.default)({
                  flags: 'wx'
                }, options)));

              case 1:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function outputFile(_x, _x2, _x3) {
        return _ref6.apply(this, arguments);
      }

      return outputFile;
    }()
  }, {
    key: '_outputFile',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(file, data, options) {
        var stream, promise;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this.createOutputStream(file, options);

              case 2:
                stream = _context7.sent;
                promise = (0, _eventToPromise2.default)(stream, 'finish');

                stream.end(data);
                return _context7.abrupt('return', promise);

              case 6:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function _outputFile(_x4, _x5, _x6) {
        return _ref7.apply(this, arguments);
      }

      return _outputFile;
    }()
  }, {
    key: 'readFile',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(file, options) {
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                return _context8.abrupt('return', this._readFile(file, options));

              case 1:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function readFile(_x7, _x8) {
        return _ref8.apply(this, arguments);
      }

      return readFile;
    }()
  }, {
    key: '_readFile',
    value: function _readFile(file, options) {
      return this.createReadStream(file, options).then(_utils.streamToBuffer);
    }
  }, {
    key: 'rename',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(oldPath, newPath) {
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                return _context9.abrupt('return', this._rename(oldPath, newPath));

              case 1:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function rename(_x9, _x10) {
        return _ref9.apply(this, arguments);
      }

      return rename;
    }()
  }, {
    key: '_rename',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(oldPath, newPath) {
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                throw new Error('Not implemented');

              case 1:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function _rename(_x11, _x12) {
        return _ref10.apply(this, arguments);
      }

      return _rename;
    }()
  }, {
    key: 'list',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11() {
        var dir = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '.';
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                return _context11.abrupt('return', this._list(dir));

              case 1:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function list() {
        return _ref11.apply(this, arguments);
      }

      return list;
    }()
  }, {
    key: '_list',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12(dir) {
        return _regenerator2.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                throw new Error('Not implemented');

              case 1:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function _list(_x14) {
        return _ref12.apply(this, arguments);
      }

      return _list;
    }()
  }, {
    key: 'createReadStream',
    value: function createReadStream(file) {
      var _this = this;

      var _ref13 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var _ref13$checksum = _ref13.checksum,
          checksum = _ref13$checksum === undefined ? false : _ref13$checksum,
          _ref13$ignoreMissingC = _ref13.ignoreMissingChecksum,
          ignoreMissingChecksum = _ref13$ignoreMissingC === undefined ? false : _ref13$ignoreMissingC,
          options = (0, _objectWithoutProperties3.default)(_ref13, ['checksum', 'ignoreMissingChecksum']);

      var streamP = this._createReadStream(file, options).then(function (stream) {
        // detect early errors
        var promise = (0, _eventToPromise2.default)(stream, 'readable');

        // try to add the length prop if missing and not a range stream
        if (stream.length === undefined && options.end === undefined && options.start === undefined) {
          promise = _promise2.default.all([promise, _this.getSize(file).then(function (size) {
            stream.length = size;
          }, _utils.noop)]);
        }

        return promise.then(function () {
          return stream;
        });
      });

      if (!checksum) {
        return streamP;
      }

      // avoid a unhandled rejection warning
      streamP.catch(_utils.noop);

      return this.readFile(`${file}.checksum`).then(function (checksum) {
        return streamP.then(function (stream) {
          var _stream = stream,
              length = _stream.length;

          stream = (0, _utils.validChecksumOfReadStream)(stream, String(checksum).trim());
          stream.length = length;

          return stream;
        });
      }, function (error) {
        if (ignoreMissingChecksum && error && error.code === 'ENOENT') {
          return streamP;
        }
        throw error;
      });
    }
  }, {
    key: '_createReadStream',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee13(file, options) {
        return _regenerator2.default.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                throw new Error('Not implemented');

              case 1:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function _createReadStream(_x16, _x17) {
        return _ref14.apply(this, arguments);
      }

      return _createReadStream;
    }()
  }, {
    key: 'refreshChecksum',
    value: function () {
      var _ref15 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee14(path) {
        var stream, checksum;
        return _regenerator2.default.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                _context14.t0 = _utils.addChecksumToReadStream;
                _context14.next = 3;
                return this.createReadStream(path);

              case 3:
                _context14.t1 = _context14.sent;
                stream = (0, _context14.t0)(_context14.t1);

                stream.resume(); // start reading the whole file
                _context14.next = 8;
                return stream.checksum;

              case 8:
                checksum = _context14.sent;
                _context14.next = 11;
                return this.outputFile(`${path}.checksum`, checksum);

              case 11:
              case 'end':
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function refreshChecksum(_x18) {
        return _ref15.apply(this, arguments);
      }

      return refreshChecksum;
    }()
  }, {
    key: 'createOutputStream',
    value: function () {
      var _ref16 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee15(file) {
        var _this2 = this;

        var _ref17 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        var _ref17$checksum = _ref17.checksum,
            checksum = _ref17$checksum === undefined ? false : _ref17$checksum,
            options = (0, _objectWithoutProperties3.default)(_ref17, ['checksum']);
        var streamP, connectorStream, forwardError, streamWithChecksum;
        return _regenerator2.default.wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                streamP = this._createOutputStream(file, (0, _extends3.default)({
                  flags: 'wx'
                }, options));

                if (checksum) {
                  _context15.next = 3;
                  break;
                }

                return _context15.abrupt('return', streamP);

              case 3:
                connectorStream = (0, _through2.default)();

                forwardError = function forwardError(error) {
                  connectorStream.emit('error', error);
                };

                streamWithChecksum = (0, _utils.addChecksumToReadStream)(connectorStream);
                _context15.t0 = streamWithChecksum;
                _context15.next = 9;
                return streamP;

              case 9:
                _context15.t1 = _context15.sent;

                _context15.t0.pipe.call(_context15.t0, _context15.t1);

                streamWithChecksum.checksum.then(function (value) {
                  return _this2.outputFile(`${file}.checksum`, value);
                }).catch(forwardError);

                return _context15.abrupt('return', connectorStream);

              case 13:
              case 'end':
                return _context15.stop();
            }
          }
        }, _callee15, this);
      }));

      function createOutputStream(_x19) {
        return _ref16.apply(this, arguments);
      }

      return createOutputStream;
    }()
  }, {
    key: '_createOutputStream',
    value: function () {
      var _ref18 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee16(file, options) {
        return _regenerator2.default.wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                throw new Error('Not implemented');

              case 1:
              case 'end':
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));

      function _createOutputStream(_x21, _x22) {
        return _ref18.apply(this, arguments);
      }

      return _createOutputStream;
    }()
  }, {
    key: 'unlink',
    value: function () {
      var _ref19 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee17(file) {
        var _ref20 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            _ref20$checksum = _ref20.checksum,
            checksum = _ref20$checksum === undefined ? false : _ref20$checksum;

        var _context17;

        return _regenerator2.default.wrap(function _callee17$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                if (checksum) {
                  (_context17 = this._unlink(`${file}.checksum`), _utils.pCatch).call(_context17, _utils.noop);
                }

                return _context18.abrupt('return', this._unlink(file));

              case 2:
              case 'end':
                return _context18.stop();
            }
          }
        }, _callee17, this);
      }));

      function unlink(_x23) {
        return _ref19.apply(this, arguments);
      }

      return unlink;
    }()
  }, {
    key: '_unlink',
    value: function () {
      var _ref21 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee18(file) {
        return _regenerator2.default.wrap(function _callee18$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                throw new Error('Not implemented');

              case 1:
              case 'end':
                return _context19.stop();
            }
          }
        }, _callee18, this);
      }));

      function _unlink(_x25) {
        return _ref21.apply(this, arguments);
      }

      return _unlink;
    }()
  }, {
    key: 'getSize',
    value: function () {
      var _ref22 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee19(file) {
        return _regenerator2.default.wrap(function _callee19$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                return _context20.abrupt('return', this._getSize(file));

              case 1:
              case 'end':
                return _context20.stop();
            }
          }
        }, _callee19, this);
      }));

      function getSize(_x26) {
        return _ref22.apply(this, arguments);
      }

      return getSize;
    }()
  }, {
    key: '_getSize',
    value: function () {
      var _ref23 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee20(file) {
        return _regenerator2.default.wrap(function _callee20$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                throw new Error('Not implemented');

              case 1:
              case 'end':
                return _context21.stop();
            }
          }
        }, _callee20, this);
      }));

      function _getSize(_x27) {
        return _ref23.apply(this, arguments);
      }

      return _getSize;
    }()
  }, {
    key: 'type',
    get: function get() {
      throw new Error('Not implemented');
    }
  }]);
  return RemoteHandlerAbstract;
}();

exports.default = RemoteHandlerAbstract;
//# sourceMappingURL=abstract.js.map
