'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _fsPromise = require('fs-promise');

var _fsPromise2 = _interopRequireDefault(_fsPromise);

var _startsWith = require('lodash/startsWith');

var _startsWith2 = _interopRequireDefault(_startsWith);

var _path = require('path');

var _abstract = require('./abstract');

var _abstract2 = _interopRequireDefault(_abstract);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LocalHandler = function (_RemoteHandlerAbstrac) {
  (0, _inherits3.default)(LocalHandler, _RemoteHandlerAbstrac);

  function LocalHandler() {
    (0, _classCallCheck3.default)(this, LocalHandler);
    return (0, _possibleConstructorReturn3.default)(this, (LocalHandler.__proto__ || (0, _getPrototypeOf2.default)(LocalHandler)).apply(this, arguments));
  }

  (0, _createClass3.default)(LocalHandler, [{
    key: '_getRealPath',
    value: function _getRealPath() {
      return this._remote.path;
    }
  }, {
    key: '_getFilePath',
    value: function _getFilePath(file) {
      var realPath = this._getRealPath();
      var parts = [realPath];
      if (file) {
        parts.push(file);
      }
      var path = _path.resolve.apply(null, parts);
      if (!(0, _startsWith2.default)(path, realPath)) {
        throw new Error('Remote path is unavailable');
      }
      return path;
    }
  }, {
    key: '_sync',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var path;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!this._remote.enabled) {
                  _context.next = 13;
                  break;
                }

                _context.prev = 1;
                path = this._getRealPath();
                _context.next = 5;
                return _fsPromise2.default.ensureDir(path);

              case 5:
                _context.next = 7;
                return _fsPromise2.default.access(path, _fsPromise2.default.R_OK | _fsPromise2.default.W_OK);

              case 7:
                _context.next = 13;
                break;

              case 9:
                _context.prev = 9;
                _context.t0 = _context['catch'](1);

                this._remote.enabled = false;
                this._remote.error = _context.t0.message;

              case 13:
                return _context.abrupt('return', this._remote);

              case 14:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[1, 9]]);
      }));

      function _sync() {
        return _ref.apply(this, arguments);
      }

      return _sync;
    }()
  }, {
    key: '_forget',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', (0, _utils.noop)());

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _forget() {
        return _ref2.apply(this, arguments);
      }

      return _forget;
    }()
  }, {
    key: '_outputFile',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(file, data, options) {
        var path;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                path = this._getFilePath(file);
                _context3.next = 3;
                return _fsPromise2.default.ensureDir((0, _path.dirname)(path));

              case 3:
                _context3.next = 5;
                return _fsPromise2.default.writeFile(path, data, options);

              case 5:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _outputFile(_x, _x2, _x3) {
        return _ref3.apply(this, arguments);
      }

      return _outputFile;
    }()
  }, {
    key: '_readFile',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(file, options) {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', _fsPromise2.default.readFile(this._getFilePath(file), options));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function _readFile(_x4, _x5) {
        return _ref4.apply(this, arguments);
      }

      return _readFile;
    }()
  }, {
    key: '_rename',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(oldPath, newPath) {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt('return', _fsPromise2.default.rename(this._getFilePath(oldPath), this._getFilePath(newPath)));

              case 1:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _rename(_x6, _x7) {
        return _ref5.apply(this, arguments);
      }

      return _rename;
    }()
  }, {
    key: '_list',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
        var dir = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '.';
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt('return', _fsPromise2.default.readdir(this._getFilePath(dir)));

              case 1:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _list() {
        return _ref6.apply(this, arguments);
      }

      return _list;
    }()
  }, {
    key: '_createReadStream',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(file, options) {
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                return _context7.abrupt('return', _fsPromise2.default.createReadStream(this._getFilePath(file), options));

              case 1:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function _createReadStream(_x9, _x10) {
        return _ref7.apply(this, arguments);
      }

      return _createReadStream;
    }()
  }, {
    key: '_createOutputStream',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(file, options) {
        var path;
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                path = this._getFilePath(file);
                _context8.next = 3;
                return _fsPromise2.default.ensureDir((0, _path.dirname)(path));

              case 3:
                return _context8.abrupt('return', _fsPromise2.default.createWriteStream(path, options));

              case 4:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function _createOutputStream(_x11, _x12) {
        return _ref8.apply(this, arguments);
      }

      return _createOutputStream;
    }()
  }, {
    key: '_unlink',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(file) {
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                return _context9.abrupt('return', _fsPromise2.default.unlink(this._getFilePath(file)));

              case 1:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function _unlink(_x13) {
        return _ref9.apply(this, arguments);
      }

      return _unlink;
    }()
  }, {
    key: '_getSize',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(file) {
        var stats;
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return _fsPromise2.default.stat(this._getFilePath(file));

              case 2:
                stats = _context10.sent;
                return _context10.abrupt('return', stats.size);

              case 4:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function _getSize(_x14) {
        return _ref10.apply(this, arguments);
      }

      return _getSize;
    }()
  }, {
    key: 'type',
    get: function get() {
      return 'file';
    }
  }]);
  return LocalHandler;
}(_abstract2.default);

exports.default = LocalHandler;
//# sourceMappingURL=local.js.map
