'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _execa = require('execa');

var _execa2 = _interopRequireDefault(_execa);

var _fsPromise = require('fs-promise');

var _fsPromise2 = _interopRequireDefault(_fsPromise);

var _local = require('./local');

var _local2 = _interopRequireDefault(_local);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NfsHandler = function (_LocalHandler) {
  (0, _inherits3.default)(NfsHandler, _LocalHandler);

  function NfsHandler() {
    (0, _classCallCheck3.default)(this, NfsHandler);
    return (0, _possibleConstructorReturn3.default)(this, (NfsHandler.__proto__ || (0, _getPrototypeOf2.default)(NfsHandler)).apply(this, arguments));
  }

  (0, _createClass3.default)(NfsHandler, [{
    key: '_getRealPath',
    value: function _getRealPath() {
      return `/run/xo-server/mounts/${this._remote.id}`;
    }
  }, {
    key: '_loadRealMounts',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var stdout, mounted, regex;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                stdout = void 0;
                mounted = {};
                _context.prev = 2;
                _context.next = 5;
                return _execa2.default.stdout('findmnt', ['-P', '-t', 'nfs,nfs4', '--output', 'SOURCE,TARGET', '--noheadings']);

              case 5:
                stdout = _context.sent;
                regex = /^SOURCE="([^:]*):(.*)" TARGET="(.*)"$/;

                (0, _utils.forEach)(stdout.split('\n'), function (m) {
                  if (m) {
                    var match = regex.exec(m);
                    mounted[match[3]] = {
                      host: match[1],
                      share: match[2]
                    };
                  }
                });
                _context.next = 14;
                break;

              case 10:
                _context.prev = 10;
                _context.t0 = _context['catch'](2);

                if (!(_context.t0.stderr !== '')) {
                  _context.next = 14;
                  break;
                }

                throw _context.t0;

              case 14:

                this._realMounts = mounted;
                return _context.abrupt('return', mounted);

              case 16:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[2, 10]]);
      }));

      function _loadRealMounts() {
        return _ref.apply(this, arguments);
      }

      return _loadRealMounts;
    }()
  }, {
    key: '_matchesRealMount',
    value: function _matchesRealMount() {
      return this._getRealPath() in this._realMounts;
    }
  }, {
    key: '_mount',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return _fsPromise2.default.ensureDir(this._getRealPath());

              case 2:
                return _context2.abrupt('return', (0, _execa2.default)('mount', ['-t', 'nfs', '-o', 'vers=3', `${this._remote.host}:${this._remote.path}`, this._getRealPath()]));

              case 3:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _mount() {
        return _ref2.apply(this, arguments);
      }

      return _mount;
    }()
  }, {
    key: '_sync',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._loadRealMounts();

              case 2:
                if (!(this._matchesRealMount() && !this._remote.enabled)) {
                  _context3.next = 14;
                  break;
                }

                _context3.prev = 3;
                _context3.next = 6;
                return this._umount(this._remote);

              case 6:
                _context3.next = 12;
                break;

              case 8:
                _context3.prev = 8;
                _context3.t0 = _context3['catch'](3);

                this._remote.enabled = true;
                this._remote.error = _context3.t0.message;

              case 12:
                _context3.next = 24;
                break;

              case 14:
                if (!(!this._matchesRealMount() && this._remote.enabled)) {
                  _context3.next = 24;
                  break;
                }

                _context3.prev = 15;
                _context3.next = 18;
                return this._mount();

              case 18:
                _context3.next = 24;
                break;

              case 20:
                _context3.prev = 20;
                _context3.t1 = _context3['catch'](15);

                this._remote.enabled = false;
                this._remote.error = _context3.t1.message;

              case 24:
                return _context3.abrupt('return', this._remote);

              case 25:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[3, 8], [15, 20]]);
      }));

      function _sync() {
        return _ref3.apply(this, arguments);
      }

      return _sync;
    }()
  }, {
    key: '_forget',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.prev = 0;
                _context4.next = 3;
                return this._umount(this._remote);

              case 3:
                _context4.next = 7;
                break;

              case 5:
                _context4.prev = 5;
                _context4.t0 = _context4['catch'](0);

              case 7:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this, [[0, 5]]);
      }));

      function _forget() {
        return _ref4.apply(this, arguments);
      }

      return _forget;
    }()
  }, {
    key: '_umount',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(remote) {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return (0, _execa2.default)('umount', [this._getRealPath()]);

              case 2:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _umount(_x) {
        return _ref5.apply(this, arguments);
      }

      return _umount;
    }()
  }, {
    key: 'type',
    get: function get() {
      return 'nfs';
    }
  }]);
  return NfsHandler;
}(_local2.default);

exports.default = NfsHandler;
//# sourceMappingURL=nfs.js.map
