'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _create = require('babel-runtime/core-js/object/create');

var _create2 = _interopRequireDefault(_create);

var _smb2Promise = require('@marsaud/smb2-promise');

var _smb2Promise2 = _interopRequireDefault(_smb2Promise);

var _abstract = require('./abstract');

var _abstract2 = _interopRequireDefault(_abstract);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Normalize the error code for file not found.
var normalizeError = function normalizeError(error) {
  var code = error.code;


  return code === 'STATUS_OBJECT_NAME_NOT_FOUND' || code === 'STATUS_OBJECT_PATH_NOT_FOUND' ? (0, _create2.default)(error, {
    code: {
      configurable: true,
      readable: true,
      value: 'ENOENT',
      writable: true
    }
  }) : error;
};

var SmbHandler = function (_RemoteHandlerAbstrac) {
  (0, _inherits3.default)(SmbHandler, _RemoteHandlerAbstrac);

  function SmbHandler(remote) {
    (0, _classCallCheck3.default)(this, SmbHandler);

    var _this = (0, _possibleConstructorReturn3.default)(this, (SmbHandler.__proto__ || (0, _getPrototypeOf2.default)(SmbHandler)).call(this, remote));

    _this._forget = _utils.noop;
    return _this;
  }

  (0, _createClass3.default)(SmbHandler, [{
    key: '_getClient',
    value: function _getClient(remote) {
      return new _smb2Promise2.default({
        share: `\\\\${remote.host}`,
        domain: remote.domain,
        username: remote.username,
        password: remote.password,
        autoCloseTimeout: 0
      });
    }
  }, {
    key: '_getFilePath',
    value: function _getFilePath(file) {
      if (file === '.') {
        file = undefined;
      }

      var path = this._remote.path !== '' ? this._remote.path : '';

      // Ensure remote path is a directory.
      if (path !== '' && path[path.length - 1] !== '\\') {
        path += '\\';
      }

      if (file) {
        path += file.replace(/\//g, '\\');
      }

      return path;
    }
  }, {
    key: '_dirname',
    value: function _dirname(file) {
      var parts = file.split('\\');
      parts.pop();
      return parts.join('\\');
    }
  }, {
    key: '_sync',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!this._remote.enabled) {
                  _context.next = 10;
                  break;
                }

                _context.prev = 1;
                _context.next = 4;
                return this.list();

              case 4:
                _context.next = 10;
                break;

              case 6:
                _context.prev = 6;
                _context.t0 = _context['catch'](1);

                this._remote.enabled = false;
                this._remote.error = _context.t0.message;

              case 10:
                return _context.abrupt('return', this._remote);

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[1, 6]]);
      }));

      function _sync() {
        return _ref.apply(this, arguments);
      }

      return _sync;
    }()
  }, {
    key: '_outputFile',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(file, data) {
        var _context2;

        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        var client, path, dir;
        return _regenerator2.default.wrap(function _callee2$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                client = this._getClient(this._remote);
                path = this._getFilePath(file);
                dir = this._dirname(path);

                if (!dir) {
                  _context3.next = 6;
                  break;
                }

                _context3.next = 6;
                return client.ensureDir(dir);

              case 6:
                return _context3.abrupt('return', (_context2 = client.writeFile(path, data, options), _utils.pFinally).call(_context2, function () {
                  client.close();
                }));

              case 7:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee2, this);
      }));

      function _outputFile(_x, _x2) {
        return _ref2.apply(this, arguments);
      }

      return _outputFile;
    }()
  }, {
    key: '_readFile',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(file) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        var client, content, _context4;

        return _regenerator2.default.wrap(function _callee3$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                client = this._getClient(this._remote);
                content = void 0;
                _context5.prev = 2;
                _context5.next = 5;
                return (_context4 = client.readFile(this._getFilePath(file), options), _utils.pFinally).call(_context4, function () {
                  client.close();
                });

              case 5:
                content = _context5.sent;
                _context5.next = 11;
                break;

              case 8:
                _context5.prev = 8;
                _context5.t0 = _context5['catch'](2);
                throw normalizeError(_context5.t0);

              case 11:
                return _context5.abrupt('return', content);

              case 12:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee3, this, [[2, 8]]);
      }));

      function _readFile(_x4) {
        return _ref3.apply(this, arguments);
      }

      return _readFile;
    }()
  }, {
    key: '_rename',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(oldPath, newPath) {
        var client, _context6;

        return _regenerator2.default.wrap(function _callee4$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                client = this._getClient(this._remote);
                _context7.prev = 1;
                _context7.next = 4;
                return (_context6 = client.rename(this._getFilePath(oldPath), this._getFilePath(newPath)), _utils.pFinally).call(_context6, function () {
                  client.close();
                });

              case 4:
                _context7.next = 9;
                break;

              case 6:
                _context7.prev = 6;
                _context7.t0 = _context7['catch'](1);
                throw normalizeError(_context7.t0);

              case 9:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee4, this, [[1, 6]]);
      }));

      function _rename(_x6, _x7) {
        return _ref4.apply(this, arguments);
      }

      return _rename;
    }()
  }, {
    key: '_list',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
        var dir = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '.';

        var client, list, _context8;

        return _regenerator2.default.wrap(function _callee5$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                client = this._getClient(this._remote);
                list = void 0;
                _context9.prev = 2;
                _context9.next = 5;
                return (_context8 = client.readdir(this._getFilePath(dir)), _utils.pFinally).call(_context8, function () {
                  client.close();
                });

              case 5:
                list = _context9.sent;
                _context9.next = 11;
                break;

              case 8:
                _context9.prev = 8;
                _context9.t0 = _context9['catch'](2);
                throw normalizeError(_context9.t0);

              case 11:
                return _context9.abrupt('return', list);

              case 12:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee5, this, [[2, 8]]);
      }));

      function _list() {
        return _ref5.apply(this, arguments);
      }

      return _list;
    }()
  }, {
    key: '_createReadStream',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(file) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var client, stream;
        return _regenerator2.default.wrap(function _callee6$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                client = this._getClient(this._remote);
                stream = void 0;
                _context10.prev = 2;
                _context10.next = 5;
                return client.createReadStream(this._getFilePath(file), options);

              case 5:
                stream = _context10.sent;

                stream.on('end', function () {
                  return client.close();
                });
                _context10.next = 12;
                break;

              case 9:
                _context10.prev = 9;
                _context10.t0 = _context10['catch'](2);
                throw normalizeError(_context10.t0);

              case 12:
                return _context10.abrupt('return', stream);

              case 13:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee6, this, [[2, 9]]);
      }));

      function _createReadStream(_x9) {
        return _ref6.apply(this, arguments);
      }

      return _createReadStream;
    }()
  }, {
    key: '_createOutputStream',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(file) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var client, path, dir, stream;
        return _regenerator2.default.wrap(function _callee7$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                client = this._getClient(this._remote);
                path = this._getFilePath(file);
                dir = this._dirname(path);
                stream = void 0;
                _context11.prev = 4;

                if (!dir) {
                  _context11.next = 8;
                  break;
                }

                _context11.next = 8;
                return client.ensureDir(dir);

              case 8:
                _context11.next = 10;
                return client.createWriteStream(path, options);

              case 10:
                stream = _context11.sent;
                _context11.next = 17;
                break;

              case 13:
                _context11.prev = 13;
                _context11.t0 = _context11['catch'](4);

                client.close();
                throw _context11.t0;

              case 17:
                stream.on('finish', function () {
                  return client.close();
                });
                return _context11.abrupt('return', stream);

              case 19:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee7, this, [[4, 13]]);
      }));

      function _createOutputStream(_x11) {
        return _ref7.apply(this, arguments);
      }

      return _createOutputStream;
    }()
  }, {
    key: '_unlink',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(file) {
        var client, _context12;

        return _regenerator2.default.wrap(function _callee8$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                client = this._getClient(this._remote);
                _context13.prev = 1;
                _context13.next = 4;
                return (_context12 = client.unlink(this._getFilePath(file)), _utils.pFinally).call(_context12, function () {
                  client.close();
                });

              case 4:
                _context13.next = 9;
                break;

              case 6:
                _context13.prev = 6;
                _context13.t0 = _context13['catch'](1);
                throw normalizeError(_context13.t0);

              case 9:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee8, this, [[1, 6]]);
      }));

      function _unlink(_x13) {
        return _ref8.apply(this, arguments);
      }

      return _unlink;
    }()
  }, {
    key: '_getSize',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(file) {
        var client, size, _context14;

        return _regenerator2.default.wrap(function _callee9$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _context15.next = 2;
                return this._getClient(this._remote);

              case 2:
                client = _context15.sent;
                size = void 0;
                _context15.prev = 4;
                _context15.next = 7;
                return (_context14 = client.getSize(this._getFilePath(file)), _utils.pFinally).call(_context14, function () {
                  client.close();
                });

              case 7:
                size = _context15.sent;
                _context15.next = 13;
                break;

              case 10:
                _context15.prev = 10;
                _context15.t0 = _context15['catch'](4);
                throw normalizeError(_context15.t0);

              case 13:
                return _context15.abrupt('return', size);

              case 14:
              case 'end':
                return _context15.stop();
            }
          }
        }, _callee9, this, [[4, 10]]);
      }));

      function _getSize(_x14) {
        return _ref9.apply(this, arguments);
      }

      return _getSize;
    }()
  }, {
    key: 'type',
    get: function get() {
      return 'smb';
    }
  }]);
  return SmbHandler;
}(_abstract2.default);

exports.default = SmbHandler;
//# sourceMappingURL=smb.js.map
