'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var streamToExistingBuffer = function streamToExistingBuffer(stream, buffer) {
  var offset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var end = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : buffer.length;
  return new _promise2.default(function (resolve, reject) {
    (0, _assert2.default)(offset >= 0);
    (0, _assert2.default)(end > offset);
    (0, _assert2.default)(end <= buffer.length);

    var i = offset;

    var onData = function onData(chunk) {
      var prev = i;
      i += chunk.length;

      if (i > end) {
        return onError(new Error('too much data'));
      }

      chunk.copy(buffer, prev);
    };
    stream.on('data', onData);

    var clean = function clean() {
      stream.removeListener('data', onData);
      stream.removeListener('end', onEnd);
      stream.removeListener('error', onError);
    };
    var onEnd = function onEnd() {
      resolve(i - offset);
      clean();
    };
    stream.on('end', onEnd);
    var onError = function onError(error) {
      reject(error);
      clean();
    };
    stream.on('error', onError);
  });
};

exports.default = streamToExistingBuffer;
//# sourceMappingURL=stream-to-existing-buffer.js.map
