'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var streamToNewBuffer = function streamToNewBuffer(stream) {
  return new _promise2.default(function (resolve, reject) {
    var chunks = [];
    var length = 0;

    var onData = function onData(chunk) {
      chunks.push(chunk);
      length += chunk.length;
    };
    stream.on('data', onData);

    var clean = function clean() {
      stream.removeListener('data', onData);
      stream.removeListener('end', onEnd);
      stream.removeListener('error', onError);
    };
    var onEnd = function onEnd() {
      resolve(Buffer.concat(chunks, length));
      clean();
    };
    stream.on('end', onEnd);
    var onError = function onError(error) {
      reject(error);
      clean();
    };
    stream.on('error', onError);
  });
};
exports.default = streamToNewBuffer;
//# sourceMappingURL=stream-to-new-buffer.js.map
