'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.chainVhd = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

// returns true if the child was actually modified
var chainVhd = exports.chainVhd = function () {
  var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(parentHandler, parentPath, childHandler, childPath) {
    var parentVhd, childVhd, header, parentName, parentUuid, rawHeader, checksum;
    return _regenerator2.default.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            parentVhd = new Vhd(parentHandler, parentPath);
            childVhd = new Vhd(childHandler, childPath);
            _context10.next = 4;
            return _promise2.default.all([parentVhd.readHeaderAndFooter(), childVhd.readHeaderAndFooter()]);

          case 4:
            header = childVhd.header;
            parentName = parentPath.split('/').pop();
            parentUuid = parentVhd.footer.uuid;

            if (!(header.parentUnicodeName !== parentName || !(0, _isEqual2.default)(header.parentUuid, parentUuid))) {
              _context10.next = 13;
              break;
            }

            header.parentUuid = parentUuid;
            header.parentUnicodeName = parentName;
            _context10.next = 12;
            return childVhd.writeHeader();

          case 12:
            return _context10.abrupt('return', true);

          case 13:
            rawHeader = fuHeader.pack(header);
            checksum = checksumStruct(rawHeader, fuHeader);

            if (!(checksum !== header.checksum)) {
              _context10.next = 19;
              break;
            }

            _context10.next = 18;
            return childVhd._write(rawHeader, VHD_FOOTER_SIZE);

          case 18:
            return _context10.abrupt('return', true);

          case 19:
            return _context10.abrupt('return', false);

          case 20:
          case 'end':
            return _context10.stop();
        }
      }
    }, _callee10, this);
  }));

  return function chainVhd(_x15, _x16, _x17, _x18) {
    return _ref12.apply(this, arguments);
  };
}();

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _constantStream = require('constant-stream');

var _constantStream2 = _interopRequireDefault(_constantStream);

var _eventToPromise = require('event-to-promise');

var _eventToPromise2 = _interopRequireDefault(_eventToPromise);

var _structFu = require('@nraynaud/struct-fu');

var _structFu2 = _interopRequireDefault(_structFu);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO: remove once completely merged in vhd.js

var VHD_UTIL_DEBUG = 0;
var debug = VHD_UTIL_DEBUG ? function (str) {
  return console.log(`[vhd-util]${str}`);
} : _utils.noop;

// ===================================================================
//
// Spec:
// https://www.microsoft.com/en-us/download/details.aspx?id=23850
//
// C implementation:
// https://github.com/rubiojr/vhd-util-convert
//
// ===================================================================

// Sizes in bytes.
var VHD_FOOTER_SIZE = 512;
var VHD_HEADER_SIZE = 1024;
var VHD_SECTOR_SIZE = 512;

// Block allocation table entry size. (Block addr)
var VHD_ENTRY_SIZE = 4;

var VHD_PARENT_LOCATOR_ENTRIES = 8;
var VHD_PLATFORM_CODE_NONE = 0;

// Types of backup treated. Others are not supported.
var HARD_DISK_TYPE_DYNAMIC = 3; // Full backup.
var HARD_DISK_TYPE_DIFFERENCING = 4; // Delta backup.

// Other.
var BLOCK_UNUSED = 0xFFFFFFFF;
var BIT_MASK = 0x80;

// unused block as buffer containing a uint32BE
var BUF_BLOCK_UNUSED = Buffer.allocUnsafe(VHD_ENTRY_SIZE);
BUF_BLOCK_UNUSED.writeUInt32BE(BLOCK_UNUSED, 0);

// ===================================================================

var fuFooter = _structFu2.default.struct([_structFu2.default.char('cookie', 8), // 0
_structFu2.default.uint32('features'), // 8
_structFu2.default.uint32('fileFormatVersion'), // 12
_structFu2.default.struct('dataOffset', [_structFu2.default.uint32('high'), // 16
_structFu2.default.uint32('low') // 20
]), _structFu2.default.uint32('timestamp'), // 24
_structFu2.default.char('creatorApplication', 4), // 28
_structFu2.default.uint32('creatorVersion'), // 32
_structFu2.default.uint32('creatorHostOs'), // 36
_structFu2.default.struct('originalSize', [// At the creation, current size of the hard disk.
_structFu2.default.uint32('high'), // 40
_structFu2.default.uint32('low') // 44
]), _structFu2.default.struct('currentSize', [// Current size of the virtual disk. At the creation: currentSize = originalSize.
_structFu2.default.uint32('high'), // 48
_structFu2.default.uint32('low') // 52
]), _structFu2.default.struct('diskGeometry', [_structFu2.default.uint16('cylinders'), // 56
_structFu2.default.uint8('heads'), // 58
_structFu2.default.uint8('sectorsPerTrackCylinder') // 59
]), _structFu2.default.uint32('diskType'), // 60 Disk type, must be equal to HARD_DISK_TYPE_DYNAMIC/HARD_DISK_TYPE_DIFFERENCING.
_structFu2.default.uint32('checksum'), // 64
_structFu2.default.uint8('uuid', 16), // 68
_structFu2.default.char('saved'), // 84
_structFu2.default.char('hidden'), // 85
_structFu2.default.char('reserved', 426) // 86
]);

var fuHeader = _structFu2.default.struct([_structFu2.default.char('cookie', 8), _structFu2.default.struct('dataOffset', [_structFu2.default.uint32('high'), _structFu2.default.uint32('low')]), _structFu2.default.struct('tableOffset', [// Absolute byte offset of the Block Allocation Table.
_structFu2.default.uint32('high'), _structFu2.default.uint32('low')]), _structFu2.default.uint32('headerVersion'), _structFu2.default.uint32('maxTableEntries'), // Max entries in the Block Allocation Table.
_structFu2.default.uint32('blockSize'), // Block size in bytes. Default (2097152 => 2MB)
_structFu2.default.uint32('checksum'), _structFu2.default.uint8('parentUuid', 16), _structFu2.default.uint32('parentTimestamp'), _structFu2.default.uint32('reserved1'), _structFu2.default.char16be('parentUnicodeName', 512), _structFu2.default.struct('parentLocatorEntry', [_structFu2.default.uint32('platformCode'), _structFu2.default.uint32('platformDataSpace'), _structFu2.default.uint32('platformDataLength'), _structFu2.default.uint32('reserved'), _structFu2.default.struct('platformDataOffset', [// Absolute byte offset of the locator data.
_structFu2.default.uint32('high'), _structFu2.default.uint32('low')])], VHD_PARENT_LOCATOR_ENTRIES), _structFu2.default.char('reserved2', 256)]);

// ===================================================================
// Helpers
// ===================================================================

var SIZE_OF_32_BITS = Math.pow(2, 32);
var uint32ToUint64 = function uint32ToUint64(fu) {
  return fu.high * SIZE_OF_32_BITS + fu.low;
};

// Returns a 32 bits integer corresponding to a Vhd version.
var getVhdVersion = function getVhdVersion(major, minor) {
  return major << 16 | minor & 0x0000FFFF;
};

// Sectors conversions.
var sectorsRoundUp = function sectorsRoundUp(bytes) {
  return Math.floor((bytes + VHD_SECTOR_SIZE - 1) / VHD_SECTOR_SIZE);
};
var sectorsRoundUpNoZero = function sectorsRoundUpNoZero(bytes) {
  return sectorsRoundUp(bytes) || 1;
};
var sectorsToBytes = function sectorsToBytes(sectors) {
  return sectors * VHD_SECTOR_SIZE;
};

// Check/Set a bit on a vhd map.
var mapTestBit = function mapTestBit(map, bit) {
  return (map[bit >> 3] << (bit & 7) & BIT_MASK) !== 0;
};
var mapSetBit = function mapSetBit(map, bit) {
  map[bit >> 3] |= BIT_MASK >> (bit & 7);
};

var packField = function packField(field, value, buf) {
  var offset = field.offset;


  field.pack(value, buf, typeof offset !== 'object' ? { bytes: offset, bits: 0 } : offset);
};

var unpackField = function unpackField(field, buf) {
  var offset = field.offset;


  return field.unpack(buf, typeof offset !== 'object' ? { bytes: offset, bits: 0 } : offset);
};
// ===================================================================

// Returns the checksum of a raw struct.
// The raw struct (footer or header) is altered with the new sum.
function checksumStruct(rawStruct, struct) {
  var checksumField = struct.fields.checksum;

  var sum = 0;

  // Reset current sum.
  packField(checksumField, 0, rawStruct);

  for (var i = 0, n = struct.size; i < n; i++) {
    sum = sum + rawStruct[i] & 0xFFFFFFFF;
  }

  sum = 0xFFFFFFFF - sum;

  // Write new sum.
  packField(checksumField, sum, rawStruct);

  return sum;
}

// ===================================================================

var Vhd = function () {
  function Vhd(handler, path) {
    (0, _classCallCheck3.default)(this, Vhd);

    this._handler = handler;
    this._path = path;
  }

  // =================================================================
  // Read functions.
  // =================================================================

  (0, _createClass3.default)(Vhd, [{
    key: '_readStream',
    value: function _readStream(start, n) {
      return this._handler.createReadStream(this._path, {
        start,
        end: start + n - 1 // end is inclusive
      });
    }
  }, {
    key: '_read',
    value: function _read(start, n) {
      return this._readStream(start, n).then(_utils.streamToBuffer);
    }

    // Returns the first address after metadata. (In bytes)

  }, {
    key: 'getEndOfHeaders',
    value: function getEndOfHeaders() {
      var header = this.header;


      var end = uint32ToUint64(this.footer.dataOffset) + VHD_HEADER_SIZE;

      var blockAllocationTableSize = sectorsToBytes(sectorsRoundUpNoZero(header.maxTableEntries * VHD_ENTRY_SIZE));

      // Max(end, block allocation table end)
      end = Math.max(end, uint32ToUint64(header.tableOffset) + blockAllocationTableSize);

      for (var i = 0; i < VHD_PARENT_LOCATOR_ENTRIES; i++) {
        var entry = header.parentLocatorEntry[i];

        if (entry.platformCode !== VHD_PLATFORM_CODE_NONE) {
          end = Math.max(end, uint32ToUint64(entry.platformDataOffset) + sectorsToBytes(entry.platformDataSpace));
        }
      }

      debug(`End of headers: ${end}.`);

      return end;
    }

    // Returns the first sector after data.

  }, {
    key: 'getEndOfData',
    value: function getEndOfData() {
      var end = Math.ceil(this.getEndOfHeaders() / VHD_SECTOR_SIZE);

      var fullBlockSize = this.sectorsOfBitmap + this.sectorsPerBlock;
      var maxTableEntries = this.header.maxTableEntries;

      for (var i = 0; i < maxTableEntries; i++) {
        var blockAddr = this._getBatEntry(i);

        if (blockAddr !== BLOCK_UNUSED) {
          end = Math.max(end, blockAddr + fullBlockSize);
        }
      }

      debug(`End of data: ${end}.`);

      return sectorsToBytes(end);
    }

    // Get the beginning (footer + header) of a vhd file.

  }, {
    key: 'readHeaderAndFooter',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var buf, sum, sumToTest, header, sectorsPerBlock, sectorsOfBitmap;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._read(0, VHD_FOOTER_SIZE + VHD_HEADER_SIZE);

              case 2:
                buf = _context.sent;
                sum = unpackField(fuFooter.fields.checksum, buf);
                sumToTest = checksumStruct(buf, fuFooter);

                // Checksum child & parent.

                if (!(sumToTest !== sum)) {
                  _context.next = 7;
                  break;
                }

                throw new Error(`Bad checksum in vhd. Expected: ${sum}. Given: ${sumToTest}. (data=${buf.toString('hex')})`);

              case 7:
                header = this.header = fuHeader.unpack(buf.slice(VHD_FOOTER_SIZE));

                this.footer = fuFooter.unpack(buf);

                // Compute the number of sectors in one block.
                // Default: One block contains 4096 sectors of 512 bytes.
                sectorsPerBlock = this.sectorsPerBlock = Math.floor(header.blockSize / VHD_SECTOR_SIZE);

                // Compute bitmap size in sectors.
                // Default: 1.

                sectorsOfBitmap = this.sectorsOfBitmap = sectorsRoundUpNoZero(sectorsPerBlock >> 3);

                // Full block size => data block size + bitmap size.

                this.fullBlockSize = sectorsToBytes(sectorsPerBlock + sectorsOfBitmap);

                // In bytes.
                // Default: 512.
                this.bitmapSize = sectorsToBytes(sectorsOfBitmap);

              case 13:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function readHeaderAndFooter() {
        return _ref.apply(this, arguments);
      }

      return readHeaderAndFooter;
    }()

    // Check if a vhd object has a block allocation table.

  }, {
    key: 'hasBlockAllocationTableMap',
    value: function hasBlockAllocationTableMap() {
      return this.footer.fileFormatVersion > getVhdVersion(1, 0);
    }

    // Returns a buffer that contains the block allocation table of a vhd file.

  }, {
    key: 'readBlockTable',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        var header, offset, size;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                header = this.header;
                offset = uint32ToUint64(header.tableOffset);
                size = sectorsToBytes(sectorsRoundUpNoZero(header.maxTableEntries * VHD_ENTRY_SIZE));
                _context2.next = 5;
                return this._read(offset, size);

              case 5:
                this.blockTable = _context2.sent;

              case 6:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function readBlockTable() {
        return _ref2.apply(this, arguments);
      }

      return readBlockTable;
    }()

    // return the first sector (bitmap) of a block

  }, {
    key: '_getBatEntry',
    value: function _getBatEntry(block) {
      return this.blockTable.readUInt32BE(block * VHD_ENTRY_SIZE);
    }
  }, {
    key: '_readBlock',
    value: function _readBlock(blockId) {
      var _this = this;

      var onlyBitmap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var blockAddr = this._getBatEntry(blockId);
      if (blockAddr === BLOCK_UNUSED) {
        throw new Error(`no such block ${blockId}`);
      }

      return this._read(sectorsToBytes(blockAddr), onlyBitmap ? this.bitmapSize : this.fullBlockSize).then(function (buf) {
        return onlyBitmap ? { bitmap: buf } : {
          bitmap: buf.slice(0, _this.bitmapSize),
          data: buf.slice(_this.bitmapSize)
        };
      });
    }

    // get the identifiers and first sectors of the first and last block
    // in the file
    //
    // return undefined if none

  }, {
    key: '_getFirstAndLastBlocks',
    value: function _getFirstAndLastBlocks() {
      var n = this.header.maxTableEntries;
      var bat = this.blockTable;
      var i = 0;
      var j = 0;
      var first = void 0,
          firstSector = void 0,
          last = void 0,
          lastSector = void 0;

      // get first allocated block for initialization
      while ((firstSector = bat.readUInt32BE(j)) === BLOCK_UNUSED) {
        i += 1;
        j += VHD_ENTRY_SIZE;

        if (i === n) {
          return;
        }
      }
      lastSector = firstSector;
      first = last = i;

      while (i < n) {
        var sector = bat.readUInt32BE(j);
        if (sector !== BLOCK_UNUSED) {
          if (sector < firstSector) {
            first = i;
            firstSector = sector;
          } else if (sector > lastSector) {
            last = i;
            lastSector = sector;
          }
        }

        i += 1;
        j += VHD_ENTRY_SIZE;
      }

      return { first, firstSector, last, lastSector };
    }

    // =================================================================
    // Write functions.
    // =================================================================

    // Write a buffer/stream at a given position in a vhd file.

  }, {
    key: '_write',
    value: function _write(data, offset) {
      debug(`_write offset=${offset} size=${Buffer.isBuffer(data) ? data.length : '???'}`);
      // TODO: could probably be merged in remote handlers.
      return this._handler.createOutputStream(this._path, {
        flags: 'r+',
        start: offset
      }).then(Buffer.isBuffer(data) ? function (stream) {
        return new _promise2.default(function (resolve, reject) {
          stream.on('error', reject);
          stream.end(data, resolve);
        });
      } : function (stream) {
        return (0, _eventToPromise2.default)(data.pipe(stream), 'finish');
      });
    }
  }, {
    key: 'ensureBatSize',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(size) {
        var _this2 = this;

        var header, prevMaxTableEntries, tableOffset, _getFirstAndLastBlock, first, firstSector, lastSector, maxTableEntries, batSize, prevBat, bat, extendBat, fullBlockSize, newFirstSector;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                header = this.header;
                prevMaxTableEntries = header.maxTableEntries;

                if (!(prevMaxTableEntries >= size)) {
                  _context3.next = 4;
                  break;
                }

                return _context3.abrupt('return');

              case 4:
                tableOffset = uint32ToUint64(header.tableOffset);
                _getFirstAndLastBlock = this._getFirstAndLastBlocks(), first = _getFirstAndLastBlock.first, firstSector = _getFirstAndLastBlock.firstSector, lastSector = _getFirstAndLastBlock.lastSector;

                // extend BAT

                maxTableEntries = header.maxTableEntries = size;
                batSize = maxTableEntries * VHD_ENTRY_SIZE;
                prevBat = this.blockTable;
                bat = this.blockTable = Buffer.allocUnsafe(batSize);

                prevBat.copy(bat);
                bat.fill(BUF_BLOCK_UNUSED, prevBat.length);
                debug(`ensureBatSize: extend in memory BAT ${prevMaxTableEntries} -> ${maxTableEntries}`);

                extendBat = function extendBat() {
                  debug(`ensureBatSize: extend in file BAT ${prevMaxTableEntries} -> ${maxTableEntries}`);

                  return _this2._write((0, _constantStream2.default)(BUF_BLOCK_UNUSED, maxTableEntries - prevMaxTableEntries), tableOffset + prevBat.length);
                };

                if (!(tableOffset + batSize < sectorsToBytes(firstSector))) {
                  _context3.next = 16;
                  break;
                }

                return _context3.abrupt('return', _promise2.default.all([extendBat(), this.writeHeader()]));

              case 16:
                fullBlockSize = this.fullBlockSize;
                newFirstSector = lastSector + fullBlockSize / VHD_SECTOR_SIZE;

                debug(`ensureBatSize: move first block ${firstSector} -> ${newFirstSector}`);

                return _context3.abrupt('return', _promise2.default.all([
                // copy the first block at the end
                this._readStream(sectorsToBytes(firstSector), fullBlockSize).then(function (stream) {
                  return _this2._write(stream, sectorsToBytes(newFirstSector));
                }).then(extendBat), this._setBatEntry(first, newFirstSector), this.writeHeader(), this.writeFooter()]));

              case 20:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function ensureBatSize(_x2) {
        return _ref3.apply(this, arguments);
      }

      return ensureBatSize;
    }()

    // set the first sector (bitmap) of a block

  }, {
    key: '_setBatEntry',
    value: function _setBatEntry(block, blockSector) {
      var i = block * VHD_ENTRY_SIZE;
      var blockTable = this.blockTable;


      blockTable.writeUInt32BE(blockSector, i);

      return this._write(blockTable.slice(i, i + VHD_ENTRY_SIZE), uint32ToUint64(this.header.tableOffset) + i);
    }

    // Make a new empty block at vhd end.
    // Update block allocation table in context and in file.

  }, {
    key: 'createBlock',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(blockId) {
        var blockAddr;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                blockAddr = Math.ceil(this.getEndOfData() / VHD_SECTOR_SIZE);


                debug(`create block ${blockId} at ${blockAddr}`);

                _context4.next = 4;
                return _promise2.default.all([
                // Write an empty block and addr in vhd file.
                this._write((0, _constantStream2.default)([0], this.fullBlockSize), sectorsToBytes(blockAddr)), this._setBatEntry(blockId, blockAddr)]);

              case 4:
                return _context4.abrupt('return', blockAddr);

              case 5:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function createBlock(_x3) {
        return _ref4.apply(this, arguments);
      }

      return createBlock;
    }()

    // Write a bitmap at a block address.

  }, {
    key: 'writeBlockBitmap',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(blockAddr, bitmap) {
        var bitmapSize, offset;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                bitmapSize = this.bitmapSize;

                if (!(bitmap.length !== bitmapSize)) {
                  _context5.next = 3;
                  break;
                }

                throw new Error(`Bitmap length is not correct ! ${bitmap.length}`);

              case 3:
                offset = sectorsToBytes(blockAddr);


                debug(`Write bitmap at: ${offset}. (size=${bitmapSize}, data=${bitmap.toString('hex')})`);
                _context5.next = 7;
                return this._write(bitmap, sectorsToBytes(blockAddr));

              case 7:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function writeBlockBitmap(_x4, _x5) {
        return _ref5.apply(this, arguments);
      }

      return writeBlockBitmap;
    }()
  }, {
    key: 'writeBlockSectors',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(block, beginSectorId, endSectorId) {
        var blockAddr, offset, _ref7, bitmap, i;

        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                blockAddr = this._getBatEntry(block.id);

                if (!(blockAddr === BLOCK_UNUSED)) {
                  _context6.next = 5;
                  break;
                }

                _context6.next = 4;
                return this.createBlock(block.id);

              case 4:
                blockAddr = _context6.sent;

              case 5:
                offset = blockAddr + this.sectorsOfBitmap + beginSectorId;


                debug(`writeBlockSectors at ${offset} block=${block.id}, sectors=${beginSectorId}...${endSectorId}`);

                _context6.next = 9;
                return this._write(block.data.slice(sectorsToBytes(beginSectorId), sectorsToBytes(endSectorId)), sectorsToBytes(offset));

              case 9:
                _context6.next = 11;
                return this._readBlock(block.id, true);

              case 11:
                _ref7 = _context6.sent;
                bitmap = _ref7.bitmap;


                for (i = beginSectorId; i < endSectorId; ++i) {
                  mapSetBit(bitmap, i);
                }

                _context6.next = 16;
                return this.writeBlockBitmap(blockAddr, bitmap);

              case 16:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function writeBlockSectors(_x6, _x7, _x8) {
        return _ref6.apply(this, arguments);
      }

      return writeBlockSectors;
    }()

    // Merge block id (of vhd child) into vhd parent.

  }, {
    key: 'coalesceBlock',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(child, blockId) {
        var _ref9, bitmap, data, sectorsPerBlock, i, endSector;

        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return child._readBlock(blockId);

              case 2:
                _ref9 = _context7.sent;
                bitmap = _ref9.bitmap;
                data = _ref9.data;


                debug(`coalesceBlock block=${blockId}`);

                // For each sector of block data...
                sectorsPerBlock = child.sectorsPerBlock;
                i = 0;

              case 8:
                if (!(i < sectorsPerBlock)) {
                  _context7.next = 20;
                  break;
                }

                if (mapTestBit(bitmap, i)) {
                  _context7.next = 11;
                  break;
                }

                return _context7.abrupt('continue', 17);

              case 11:
                endSector = i + 1;

                // Count changed sectors.

                while (endSector < sectorsPerBlock && mapTestBit(bitmap, endSector)) {
                  ++endSector;
                }

                // Write n sectors into parent.
                debug(`coalesceBlock: write sectors=${i}...${endSector}`);
                _context7.next = 16;
                return this.writeBlockSectors({ id: blockId, data }, i, endSector);

              case 16:

                i = endSector;

              case 17:
                i++;
                _context7.next = 8;
                break;

              case 20:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function coalesceBlock(_x9, _x10) {
        return _ref8.apply(this, arguments);
      }

      return coalesceBlock;
    }()

    // Write a context footer. (At the end and beginning of a vhd file.)

  }, {
    key: 'writeFooter',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8() {
        var footer, offset, rawFooter;
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                footer = this.footer;
                offset = this.getEndOfData();
                rawFooter = fuFooter.pack(footer);


                footer.checksum = checksumStruct(rawFooter, fuFooter);
                debug(`Write footer at: ${offset} (checksum=${footer.checksum}). (data=${rawFooter.toString('hex')})`);

                _context8.next = 7;
                return this._write(rawFooter, 0);

              case 7:
                _context8.next = 9;
                return this._write(rawFooter, offset);

              case 9:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function writeFooter() {
        return _ref10.apply(this, arguments);
      }

      return writeFooter;
    }()
  }, {
    key: 'writeHeader',
    value: function writeHeader() {
      var header = this.header;

      var rawHeader = fuHeader.pack(header);
      header.checksum = checksumStruct(rawHeader, fuHeader);
      var offset = VHD_FOOTER_SIZE;
      debug(`Write header at: ${offset} (checksum=${header.checksum}). (data=${rawHeader.toString('hex')})`);
      return this._write(rawHeader, offset);
    }
  }]);
  return Vhd;
}();

// Merge vhd child into vhd parent.
//
// Child must be a delta backup !
// Parent must be a full backup !
//
// TODO: update the identifier of the parent VHD.


exports.default = function () {
  var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(parentHandler, parentPath, childHandler, childPath) {
    var parentVhd, childVhd, blockId, cFooter, pFooter;
    return _regenerator2.default.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            parentVhd = new Vhd(parentHandler, parentPath);
            childVhd = new Vhd(childHandler, childPath);

            // Reading footer and header.

            _context9.next = 4;
            return _promise2.default.all([parentVhd.readHeaderAndFooter(), childVhd.readHeaderAndFooter()]);

          case 4:

            (0, _assert2.default)(childVhd.header.blockSize === parentVhd.header.blockSize);

            // Child must be a delta.

            if (!(childVhd.footer.diskType !== HARD_DISK_TYPE_DIFFERENCING)) {
              _context9.next = 7;
              break;
            }

            throw new Error('Unable to merge, child is not a delta backup.');

          case 7:
            if (!(parentVhd.footer.diskType !== HARD_DISK_TYPE_DYNAMIC)) {
              _context9.next = 9;
              break;
            }

            throw new Error('Unable to merge, parent is not a full backup.');

          case 9:
            if (!(parentVhd.hasBlockAllocationTableMap() || childVhd.hasBlockAllocationTableMap())) {
              _context9.next = 11;
              break;
            }

            throw new Error('Unsupported allocation table map.');

          case 11:
            _context9.next = 13;
            return _promise2.default.all([parentVhd.readBlockTable(), childVhd.readBlockTable()]);

          case 13:
            _context9.next = 15;
            return parentVhd.ensureBatSize(childVhd.header.maxTableEntries);

          case 15:
            blockId = 0;

          case 16:
            if (!(blockId < childVhd.header.maxTableEntries)) {
              _context9.next = 23;
              break;
            }

            if (!(childVhd._getBatEntry(blockId) !== BLOCK_UNUSED)) {
              _context9.next = 20;
              break;
            }

            _context9.next = 20;
            return parentVhd.coalesceBlock(childVhd, blockId);

          case 20:
            blockId++;
            _context9.next = 16;
            break;

          case 23:
            cFooter = childVhd.footer;
            pFooter = parentVhd.footer;


            pFooter.currentSize = (0, _extends3.default)({}, cFooter.currentSize);
            pFooter.diskGeometry = (0, _extends3.default)({}, cFooter.diskGeometry);
            pFooter.originalSize = (0, _extends3.default)({}, cFooter.originalSize);
            pFooter.timestamp = cFooter.timestamp;

            // necessary to update values and to recreate the footer after block
            // creation
            _context9.next = 31;
            return parentVhd.writeFooter();

          case 31:
          case 'end':
            return _context9.stop();
        }
      }
    }, _callee9, this);
  }));

  function vhdMerge(_x11, _x12, _x13, _x14) {
    return _ref11.apply(this, arguments);
  }

  return vhdMerge;
}();
//# sourceMappingURL=vhd-merge.js.map
