'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.IPV6_CONFIG_MODES = exports.IPV4_CONFIG_MODES = exports.VDI_FORMAT_RAW = exports.VDI_FORMAT_VHD = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise2 = require('babel-runtime/core-js/promise');

var _promise3 = _interopRequireDefault(_promise2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _uniq2 = require('lodash/uniq');

var _uniq3 = _interopRequireDefault(_uniq2);

var _startsWith2 = require('lodash/startsWith');

var _startsWith3 = _interopRequireDefault(_startsWith2);

var _omit2 = require('lodash/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _includes2 = require('lodash/includes');

var _includes3 = _interopRequireDefault(_includes2);

var _flatten2 = require('lodash/flatten');

var _flatten3 = _interopRequireDefault(_flatten2);

var _filter2 = require('lodash/filter');

var _filter3 = _interopRequireDefault(_filter2);

var _find2 = require('lodash/find');

var _find3 = _interopRequireDefault(_find2);

var _every2 = require('lodash/every');

var _every3 = _interopRequireDefault(_every2);

var _dec, _dec2, _dec3, _dec4, _dec5, _class, _desc, _value, _class2; /* eslint-disable camelcase */


var _golikeDefer = require('golike-defer');

var _golikeDefer2 = _interopRequireDefault(_golikeDefer);

var _fatfs = require('fatfs');

var _fatfs2 = _interopRequireDefault(_fatfs);

var _decoratorSynchronized = require('decorator-synchronized');

var _decoratorSynchronized2 = _interopRequireDefault(_decoratorSynchronized);

var _tarStream = require('tar-stream');

var _tarStream2 = _interopRequireDefault(_tarStream);

var _xoVmdkToVhd = require('xo-vmdk-to-vhd');

var _xoVmdkToVhd2 = _interopRequireDefault(_xoVmdkToVhd);

var _promiseToolbox = require('promise-toolbox');

var _stream = require('stream');

var _apiErrors = require('xo-common/api-errors');

var _xenApi = require('xen-api');

var _semver = require('semver');

var _httpRequest = require('../http-request');

var _httpRequest2 = _interopRequireDefault(_httpRequest);

var _fatfsBuffer = require('../fatfs-buffer');

var _fatfsBuffer2 = _interopRequireDefault(_fatfsBuffer);

var _decorators = require('../decorators');

var _utils = require('../utils');

var _mixins = require('./mixins');

var _mixins2 = _interopRequireDefault(_mixins);

var _otherConfigTemplate = require('./other-config-template');

var _otherConfigTemplate2 = _interopRequireDefault(_otherConfigTemplate);

var _utils2 = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

// ===================================================================

var TAG_BASE_DELTA = 'xo:base_delta';
var TAG_COPY_SRC = 'xo:copy_of';

// ===================================================================

// FIXME: remove this work around when fixed, https://phabricator.babeljs.io/T2877
//  export * from './utils'
require('lodash/assign')(module.exports, require('./utils'));

// VDI formats. (Raw is not available for delta vdi.)
var VDI_FORMAT_VHD = exports.VDI_FORMAT_VHD = 'vhd';
var VDI_FORMAT_RAW = exports.VDI_FORMAT_RAW = 'raw';

var IPV4_CONFIG_MODES = exports.IPV4_CONFIG_MODES = ['None', 'DHCP', 'Static'];
var IPV6_CONFIG_MODES = exports.IPV6_CONFIG_MODES = ['None', 'DHCP', 'Static', 'Autoconf'];

// ===================================================================

var Xapi = (_dec = (0, _decorators.mixin)((0, _utils.mapToArray)(_mixins2.default)), _dec2 = _golikeDefer2.default.onFailure, _dec3 = _golikeDefer2.default.onFailure, _dec4 = _golikeDefer2.default.onFailure, _dec5 = _golikeDefer2.default.onFailure, _dec(_class = (_class2 = function (_XapiBase) {
  (0, _inherits3.default)(Xapi, _XapiBase);

  function Xapi() {
    var _ref;

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    (0, _classCallCheck3.default)(this, Xapi);

    // Patch getObject to resolve _xapiId property.
    var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = Xapi.__proto__ || (0, _getPrototypeOf2.default)(Xapi)).call.apply(_ref, [this].concat(args)));

    _this.getObject = function (getObject) {
      return function () {
        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        var tmp = void 0;
        if ((tmp = args[0]) != null && (tmp = tmp._xapiId) != null) {
          args[0] = tmp;
        }
        return getObject.apply(_this, args);
      };
    }(_this.getObject);

    var genericWatchers = _this._genericWatchers = (0, _utils.createRawObject)();
    var objectsWatchers = _this._objectWatchers = (0, _utils.createRawObject)();
    var taskWatchers = _this._taskWatchers = (0, _utils.createRawObject)();

    var onAddOrUpdate = function onAddOrUpdate(objects) {
      (0, _utils.forEach)(objects, function (object) {
        var id = object.$id,
            ref = object.$ref;

        // Run generic watchers.

        for (var watcherId in genericWatchers) {
          genericWatchers[watcherId](object);
        }

        // Watched object.
        if (id in objectsWatchers) {
          objectsWatchers[id].resolve(object);
          delete objectsWatchers[id];
        }
        if (ref in objectsWatchers) {
          objectsWatchers[ref].resolve(object);
          delete objectsWatchers[ref];
        }

        // Watched task.
        if (ref in taskWatchers) {
          var status = object.status;


          if (status === 'success') {
            taskWatchers[ref].resolve(object.result);
          } else if (status === 'failure') {
            taskWatchers[ref].reject((0, _xenApi.wrapError)(object.error_info));
          } else {
            return;
          }

          delete taskWatchers[ref];
        }
      });
    };
    _this.objects.on('add', onAddOrUpdate);
    _this.objects.on('update', onAddOrUpdate);
    return _this;
  }

  (0, _createClass3.default)(Xapi, [{
    key: 'call',
    value: function call() {
      var _this2 = this;

      for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      var fn = (0, _get3.default)(Xapi.prototype.__proto__ || (0, _getPrototypeOf2.default)(Xapi.prototype), 'call', this);

      var loop = function loop() {
        var _context;

        return (_context = fn.apply(_this2, args), _utils.pCatch).call(_context, {
          code: 'TOO_MANY_PENDING_TASKS'
        }, function () {
          return (0, _utils.pDelay)(5e3).then(loop);
        });
      };

      return loop();
    }

    // =================================================================

  }, {
    key: '_registerGenericWatcher',
    value: function _registerGenericWatcher(fn) {
      var watchers = this._genericWatchers;
      var id = String(Math.random());

      watchers[id] = fn;

      return function () {
        delete watchers[id];
      };
    }

    // Wait for an object to appear or to be updated.
    //
    // Predicate can be either an id, a UUID, an opaque reference or a
    // function.
    //
    // TODO: implements a timeout.

  }, {
    key: '_waitObject',
    value: function _waitObject(predicate) {
      if ((0, _utils.isFunction)(predicate)) {
        var _defer = (0, _promiseToolbox.defer)(),
            promise = _defer.promise,
            resolve = _defer.resolve;

        var unregister = this._registerGenericWatcher(function (obj) {
          if (predicate(obj)) {
            unregister();

            resolve(obj);
          }
        });

        return promise;
      }

      var watcher = this._objectWatchers[predicate];
      if (!watcher) {
        var _defer2 = (0, _promiseToolbox.defer)(),
            _promise = _defer2.promise,
            _resolve = _defer2.resolve;

        // Register the watcher.


        watcher = this._objectWatchers[predicate] = {
          promise: _promise,
          resolve: _resolve
        };
      }

      return watcher.promise;
    }

    // Wait for an object to be in a given state.
    //
    // Faster than _waitObject() with a function.

  }, {
    key: '_waitObjectState',
    value: function _waitObjectState(idOrUuidOrRef, predicate) {
      var _this3 = this;

      var object = this.getObject(idOrUuidOrRef, null);
      if (object && predicate(object)) {
        return object;
      }

      var loop = function loop() {
        return _this3._waitObject(idOrUuidOrRef).then(function (object) {
          return predicate(object) ? object : loop();
        });
      };

      return loop();
    }

    // Returns the objects if already presents or waits for it.

  }, {
    key: '_getOrWaitObject',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(idOrUuidOrRef) {
        return _regenerator2.default.wrap(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', this.getObject(idOrUuidOrRef, null) || this._waitObject(idOrUuidOrRef));

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee, this);
      }));

      function _getOrWaitObject(_x) {
        return _ref2.apply(this, arguments);
      }

      return _getOrWaitObject;
    }()

    // =================================================================

    // Create a task.

  }, {
    key: '_createTask',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        var _context3,
            _this4 = this;

        var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'untitled task';
        var description = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
        var ref;
        return _regenerator2.default.wrap(function _callee2$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.call('task.create', `[XO] ${name}`, description);

              case 2:
                ref = _context4.sent;

                (0, _utils2.debug)('task created: %s (%s)', name, description);

                (_context3 = this._watchTask(ref), _utils.pFinally).call(_context3, function () {
                  _this4.call('task.destroy', ref).then(function () {
                    (0, _utils2.debug)('task destroyed: %s (%s)', name, description);
                  });
                });

                return _context4.abrupt('return', ref);

              case 6:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee2, this);
      }));

      function _createTask() {
        return _ref3.apply(this, arguments);
      }

      return _createTask;
    }()

    // Waits for a task to be resolved.

  }, {
    key: '_watchTask',
    value: function _watchTask(ref) {
      // If a task object is passed, unpacked the ref.
      if (typeof ref === 'object' && ref.$ref) ref = ref.$ref;

      var watcher = this._taskWatchers[ref];
      if (!watcher) {
        // Register the watcher.
        watcher = this._taskWatchers[ref] = (0, _promiseToolbox.defer)();
      }

      return watcher.promise;
    }

    // =================================================================

  }, {
    key: '_setObjectProperty',
    value: function _setObjectProperty(object, name, value) {
      return this.call(`${(0, _utils2.getNamespaceForType)(object.$type)}.set_${(0, _utils.camelToSnakeCase)(name)}`, object.$ref, (0, _utils2.prepareXapiParam)(value));
    }
  }, {
    key: '_setObjectProperties',
    value: function _setObjectProperties(object, props) {
      var _context5,
          _this5 = this;

      var ref = object.$ref,
          type = object.$type;


      var namespace = (0, _utils2.getNamespaceForType)(type);

      // TODO: the thrown error should contain the name of the
      // properties that failed to be set.
      return (_context5 = _promise3.default.all((0, _utils.mapToArray)(props, function (value, name) {
        if (value != null) {
          return _this5.call(`${namespace}.set_${(0, _utils.camelToSnakeCase)(name)}`, ref, (0, _utils2.prepareXapiParam)(value));
        }
      })), _utils.pCatch).call(_context5, _utils.noop);
    }
  }, {
    key: '_updateObjectMapProperty',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(object, prop, values) {
        var _this6 = this;

        var ref, type, namespace, add, remove;
        return _regenerator2.default.wrap(function _callee3$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                ref = object.$ref, type = object.$type;


                prop = (0, _utils.camelToSnakeCase)(prop);

                namespace = (0, _utils2.getNamespaceForType)(type);
                add = `${namespace}.add_to_${prop}`;
                remove = `${namespace}.remove_from_${prop}`;
                _context6.next = 7;
                return _promise3.default.all((0, _utils.mapToArray)(values, function (value, name) {
                  if (value !== undefined) {
                    name = (0, _utils.camelToSnakeCase)(name);
                    var removal = _this6.call(remove, ref, name);

                    return value === null ? removal : _utils.pCatch.call(removal, _utils.noop).then(function () {
                      return _this6.call(add, ref, name, (0, _utils2.prepareXapiParam)(value));
                    });
                  }
                }));

              case 7:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee3, this);
      }));

      function _updateObjectMapProperty(_x4, _x5, _x6) {
        return _ref4.apply(this, arguments);
      }

      return _updateObjectMapProperty;
    }()
  }, {
    key: 'setHostProperties',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(id, _ref6) {
        var nameLabel = _ref6.nameLabel,
            nameDescription = _ref6.nameDescription;
        return _regenerator2.default.wrap(function _callee4$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this._setObjectProperties(this.getObject(id), {
                  nameLabel,
                  nameDescription
                });

              case 2:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee4, this);
      }));

      function setHostProperties(_x7, _x8) {
        return _ref5.apply(this, arguments);
      }

      return setHostProperties;
    }()
  }, {
    key: 'setPoolProperties',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(_ref8) {
        var autoPoweron = _ref8.autoPoweron,
            nameLabel = _ref8.nameLabel,
            nameDescription = _ref8.nameDescription;
        var pool;
        return _regenerator2.default.wrap(function _callee5$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                pool = this.pool;
                _context8.next = 3;
                return _promise3.default.all([this._setObjectProperties(pool, {
                  nameLabel,
                  nameDescription
                }), autoPoweron != null && this._updateObjectMapProperty(pool, 'other_config', {
                  autoPoweron: autoPoweron ? 'true' : null
                })]);

              case 3:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee5, this);
      }));

      function setPoolProperties(_x9) {
        return _ref7.apply(this, arguments);
      }

      return setPoolProperties;
    }()
  }, {
    key: 'setSrProperties',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(id, _ref10) {
        var nameLabel = _ref10.nameLabel,
            nameDescription = _ref10.nameDescription;
        return _regenerator2.default.wrap(function _callee6$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this._setObjectProperties(this.getObject(id), {
                  nameLabel,
                  nameDescription
                });

              case 2:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee6, this);
      }));

      function setSrProperties(_x10, _x11) {
        return _ref9.apply(this, arguments);
      }

      return setSrProperties;
    }()
  }, {
    key: 'setNetworkProperties',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(id, _ref12) {
        var nameLabel = _ref12.nameLabel,
            nameDescription = _ref12.nameDescription,
            defaultIsLocked = _ref12.defaultIsLocked;
        var defaultLockingMode;
        return _regenerator2.default.wrap(function _callee7$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                defaultLockingMode = void 0;

                if (defaultIsLocked != null) {
                  defaultLockingMode = defaultIsLocked ? 'disabled' : 'unlocked';
                }
                _context10.next = 4;
                return this._setObjectProperties(this.getObject(id), {
                  nameLabel,
                  nameDescription,
                  defaultLockingMode
                });

              case 4:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee7, this);
      }));

      function setNetworkProperties(_x12, _x13) {
        return _ref11.apply(this, arguments);
      }

      return setNetworkProperties;
    }()

    // =================================================================

  }, {
    key: 'addTag',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(id, tag) {
        var _getObject, ref, type, namespace;

        return _regenerator2.default.wrap(function _callee8$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _getObject = this.getObject(id), ref = _getObject.$ref, type = _getObject.$type;
                namespace = (0, _utils2.getNamespaceForType)(type);
                _context11.next = 4;
                return this.call(`${namespace}.add_tags`, ref, tag);

              case 4:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee8, this);
      }));

      function addTag(_x14, _x15) {
        return _ref13.apply(this, arguments);
      }

      return addTag;
    }()
  }, {
    key: 'removeTag',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(id, tag) {
        var _getObject2, ref, type, namespace;

        return _regenerator2.default.wrap(function _callee9$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _getObject2 = this.getObject(id), ref = _getObject2.$ref, type = _getObject2.$type;
                namespace = (0, _utils2.getNamespaceForType)(type);
                _context12.next = 4;
                return this.call(`${namespace}.remove_tags`, ref, tag);

              case 4:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee9, this);
      }));

      function removeTag(_x16, _x17) {
        return _ref14.apply(this, arguments);
      }

      return removeTag;
    }()

    // =================================================================

  }, {
    key: 'setDefaultSr',
    value: function () {
      var _ref15 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(srId) {
        return _regenerator2.default.wrap(function _callee10$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                this._setObjectProperties(this.pool, {
                  default_SR: this.getObject(srId).$ref
                });

              case 1:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee10, this);
      }));

      function setDefaultSr(_x18) {
        return _ref15.apply(this, arguments);
      }

      return setDefaultSr;
    }()

    // =================================================================

  }, {
    key: 'joinPool',
    value: function () {
      var _ref16 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11(masterAddress, masterUsername, masterPassword) {
        var force = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
        return _regenerator2.default.wrap(function _callee11$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                _context14.next = 2;
                return this.call(force ? 'pool.join_force' : 'pool.join', masterAddress, masterUsername, masterPassword);

              case 2:
              case 'end':
                return _context14.stop();
            }
          }
        }, _callee11, this);
      }));

      function joinPool(_x19, _x20, _x21) {
        return _ref16.apply(this, arguments);
      }

      return joinPool;
    }()

    // =================================================================

  }, {
    key: 'emergencyShutdownHost',
    value: function () {
      var _ref17 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12(hostId) {
        var _this7 = this;

        var host, vms;
        return _regenerator2.default.wrap(function _callee12$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                host = this.getObject(hostId);
                vms = host.$resident_VMs;

                (0, _utils2.debug)(`Emergency shutdown: ${host.name_label}`);
                _context15.next = 5;
                return (0, _utils.pSettle)((0, _utils.mapToArray)(vms, function (vm) {
                  if (!vm.is_control_domain) {
                    return _this7.call('VM.suspend', vm.$ref);
                  }
                }));

              case 5:
                _context15.next = 7;
                return this.call('host.disable', host.$ref);

              case 7:
                _context15.next = 9;
                return this.call('host.shutdown', host.$ref);

              case 9:
              case 'end':
                return _context15.stop();
            }
          }
        }, _callee12, this);
      }));

      function emergencyShutdownHost(_x23) {
        return _ref17.apply(this, arguments);
      }

      return emergencyShutdownHost;
    }()

    // =================================================================

    // Disable the host and evacuate all its VMs.
    //
    // If `force` is false and the evacuation failed, the host is re-
    // enabled and the error is thrown.

  }, {
    key: '_clearHost',
    value: function () {
      var _ref18 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee13(_ref19, force) {
        var ref = _ref19.$ref;
        return _regenerator2.default.wrap(function _callee13$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                _context16.next = 2;
                return this.call('host.disable', ref);

              case 2:
                _context16.prev = 2;
                _context16.next = 5;
                return this.call('host.evacuate', ref);

              case 5:
                _context16.next = 13;
                break;

              case 7:
                _context16.prev = 7;
                _context16.t0 = _context16['catch'](2);

                if (force) {
                  _context16.next = 13;
                  break;
                }

                _context16.next = 12;
                return this.call('host.enable', ref);

              case 12:
                throw _context16.t0;

              case 13:
              case 'end':
                return _context16.stop();
            }
          }
        }, _callee13, this, [[2, 7]]);
      }));

      function _clearHost(_x24, _x25) {
        return _ref18.apply(this, arguments);
      }

      return _clearHost;
    }()
  }, {
    key: 'disableHost',
    value: function () {
      var _ref20 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee14(hostId) {
        return _regenerator2.default.wrap(function _callee14$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                _context17.next = 2;
                return this.call('host.disable', this.getObject(hostId).$ref);

              case 2:
              case 'end':
                return _context17.stop();
            }
          }
        }, _callee14, this);
      }));

      function disableHost(_x26) {
        return _ref20.apply(this, arguments);
      }

      return disableHost;
    }()
  }, {
    key: 'ejectHostFromPool',
    value: function () {
      var _ref21 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee15(hostId) {
        return _regenerator2.default.wrap(function _callee15$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                _context18.next = 2;
                return this.call('pool.eject', this.getObject(hostId).$ref);

              case 2:
              case 'end':
                return _context18.stop();
            }
          }
        }, _callee15, this);
      }));

      function ejectHostFromPool(_x27) {
        return _ref21.apply(this, arguments);
      }

      return ejectHostFromPool;
    }()
  }, {
    key: 'enableHost',
    value: function () {
      var _ref22 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee16(hostId) {
        return _regenerator2.default.wrap(function _callee16$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                _context19.next = 2;
                return this.call('host.enable', this.getObject(hostId).$ref);

              case 2:
              case 'end':
                return _context19.stop();
            }
          }
        }, _callee16, this);
      }));

      function enableHost(_x28) {
        return _ref22.apply(this, arguments);
      }

      return enableHost;
    }()
  }, {
    key: 'powerOnHost',
    value: function () {
      var _ref23 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee17(hostId) {
        return _regenerator2.default.wrap(function _callee17$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                _context20.next = 2;
                return this.call('host.power_on', this.getObject(hostId).$ref);

              case 2:
              case 'end':
                return _context20.stop();
            }
          }
        }, _callee17, this);
      }));

      function powerOnHost(_x29) {
        return _ref23.apply(this, arguments);
      }

      return powerOnHost;
    }()
  }, {
    key: 'rebootHost',
    value: function () {
      var _ref24 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee18(hostId) {
        var force = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var host;
        return _regenerator2.default.wrap(function _callee18$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                host = this.getObject(hostId);
                _context21.next = 3;
                return this._clearHost(host, force);

              case 3:
                _context21.next = 5;
                return this.call('host.reboot', host.$ref);

              case 5:
              case 'end':
                return _context21.stop();
            }
          }
        }, _callee18, this);
      }));

      function rebootHost(_x30) {
        return _ref24.apply(this, arguments);
      }

      return rebootHost;
    }()
  }, {
    key: 'restartHostAgent',
    value: function () {
      var _ref25 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee19(hostId) {
        return _regenerator2.default.wrap(function _callee19$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                _context22.next = 2;
                return this.call('host.restart_agent', this.getObject(hostId).$ref);

              case 2:
              case 'end':
                return _context22.stop();
            }
          }
        }, _callee19, this);
      }));

      function restartHostAgent(_x32) {
        return _ref25.apply(this, arguments);
      }

      return restartHostAgent;
    }()
  }, {
    key: 'shutdownHost',
    value: function () {
      var _ref26 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee20(hostId) {
        var force = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var host;
        return _regenerator2.default.wrap(function _callee20$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                host = this.getObject(hostId);
                _context23.next = 3;
                return this._clearHost(host, force);

              case 3:
                _context23.next = 5;
                return this.call('host.shutdown', host.$ref);

              case 5:
              case 'end':
                return _context23.stop();
            }
          }
        }, _callee20, this);
      }));

      function shutdownHost(_x33) {
        return _ref26.apply(this, arguments);
      }

      return shutdownHost;
    }()

    // =================================================================

    // Clone a VM: make a fast copy by fast copying each of its VDIs
    // (using snapshots where possible) on the same SRs.

  }, {
    key: '_cloneVm',
    value: function _cloneVm(vm) {
      var nameLabel = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : vm.name_label;

      (0, _utils2.debug)(`Cloning VM ${vm.name_label}${nameLabel !== vm.name_label ? ` as ${nameLabel}` : ''}`);

      return this.call('VM.clone', vm.$ref, nameLabel);
    }

    // Copy a VM: make a normal copy of a VM and all its VDIs.
    //
    // If a SR is specified, it will contains the copies of the VDIs,
    // otherwise they will use the SRs they are on.

  }, {
    key: '_copyVm',
    value: function () {
      var _ref27 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee21(vm) {
        var nameLabel = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : vm.name_label;
        var sr = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
        var snapshot;
        return _regenerator2.default.wrap(function _callee21$(_context24) {
          while (1) {
            switch (_context24.prev = _context24.next) {
              case 0:
                snapshot = void 0;

                if (!(0, _utils2.isVmRunning)(vm)) {
                  _context24.next = 5;
                  break;
                }

                _context24.next = 4;
                return this._snapshotVm(vm);

              case 4:
                snapshot = _context24.sent;

              case 5:

                (0, _utils2.debug)(`Copying VM ${vm.name_label}${nameLabel !== vm.name_label ? ` as ${nameLabel}` : ''}${sr ? ` on ${sr.name_label}` : ''}`);

                _context24.prev = 6;
                _context24.next = 9;
                return this.call('VM.copy', snapshot ? snapshot.$ref : vm.$ref, nameLabel, sr ? sr.$ref : '');

              case 9:
                return _context24.abrupt('return', _context24.sent);

              case 10:
                _context24.prev = 10;

                if (!snapshot) {
                  _context24.next = 14;
                  break;
                }

                _context24.next = 14;
                return this._deleteVm(snapshot);

              case 14:
                return _context24.finish(10);

              case 15:
              case 'end':
                return _context24.stop();
            }
          }
        }, _callee21, this, [[6,, 10, 15]]);
      }));

      function _copyVm(_x36) {
        return _ref27.apply(this, arguments);
      }

      return _copyVm;
    }()
  }, {
    key: 'cloneVm',
    value: function () {
      var _ref28 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee22(vmId) {
        var _ref29 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            _ref29$nameLabel = _ref29.nameLabel,
            nameLabel = _ref29$nameLabel === undefined ? undefined : _ref29$nameLabel,
            _ref29$fast = _ref29.fast,
            fast = _ref29$fast === undefined ? true : _ref29$fast;

        var vm, cloneRef;
        return _regenerator2.default.wrap(function _callee22$(_context25) {
          while (1) {
            switch (_context25.prev = _context25.next) {
              case 0:
                vm = this.getObject(vmId);
                _context25.next = 3;
                return fast ? this._cloneVm(vm, nameLabel) : this._copyVm(vm, nameLabel);

              case 3:
                cloneRef = _context25.sent;
                return _context25.abrupt('return', /* await */this._getOrWaitObject(cloneRef));

              case 5:
              case 'end':
                return _context25.stop();
            }
          }
        }, _callee22, this);
      }));

      function cloneVm(_x39) {
        return _ref28.apply(this, arguments);
      }

      return cloneVm;
    }()
  }, {
    key: 'copyVm',
    value: function () {
      var _ref30 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee23(vmId, srId) {
        var _ref31 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
            _ref31$nameLabel = _ref31.nameLabel,
            nameLabel = _ref31$nameLabel === undefined ? undefined : _ref31$nameLabel;

        return _regenerator2.default.wrap(function _callee23$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                _context26.t0 = this;
                _context26.next = 3;
                return this._copyVm(this.getObject(vmId), nameLabel, this.getObject(srId));

              case 3:
                _context26.t1 = _context26.sent;
                return _context26.abrupt('return', _context26.t0._getOrWaitObject.call(_context26.t0, _context26.t1));

              case 5:
              case 'end':
                return _context26.stop();
            }
          }
        }, _callee23, this);
      }));

      function copyVm(_x41, _x42) {
        return _ref30.apply(this, arguments);
      }

      return copyVm;
    }()
  }, {
    key: 'remoteCopyVm',
    value: function () {
      var _ref32 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee24(vmId, targetXapi, targetSrId) {
        var _ref33 = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {},
            _ref33$compress = _ref33.compress,
            compress = _ref33$compress === undefined ? true : _ref33$compress,
            _ref33$nameLabel = _ref33.nameLabel,
            nameLabel = _ref33$nameLabel === undefined ? undefined : _ref33$nameLabel;

        var sr, stream, onVmCreation, vm;
        return _regenerator2.default.wrap(function _callee24$(_context27) {
          while (1) {
            switch (_context27.prev = _context27.next) {
              case 0:
                if (!(targetXapi === this)) {
                  _context27.next = 2;
                  break;
                }

                return _context27.abrupt('return', this.copyVm(vmId, targetSrId, { nameLabel }));

              case 2:
                sr = targetXapi.getObject(targetSrId);
                _context27.next = 5;
                return this.exportVm(vmId, {
                  compress,
                  onlyMetadata: false
                });

              case 5:
                stream = _context27.sent;
                onVmCreation = nameLabel !== undefined ? function (vm) {
                  return targetXapi._setObjectProperties(vm, {
                    nameLabel
                  });
                } : null;
                _context27.t0 = targetXapi;
                _context27.next = 10;
                return targetXapi._importVm(stream, sr, false, onVmCreation);

              case 10:
                _context27.t1 = _context27.sent;
                _context27.next = 13;
                return _context27.t0._getOrWaitObject.call(_context27.t0, _context27.t1);

              case 13:
                vm = _context27.sent;
                return _context27.abrupt('return', vm);

              case 15:
              case 'end':
                return _context27.stop();
            }
          }
        }, _callee24, this);
      }));

      function remoteCopyVm(_x44, _x45, _x46) {
        return _ref32.apply(this, arguments);
      }

      return remoteCopyVm;
    }()

    // Low level create VM.

  }, {
    key: '_createVmRecord',
    value: function _createVmRecord(_ref34) {
      var actions_after_crash = _ref34.actions_after_crash,
          actions_after_reboot = _ref34.actions_after_reboot,
          actions_after_shutdown = _ref34.actions_after_shutdown,
          affinity = _ref34.affinity,
          blocked_operations = _ref34.blocked_operations,
          generation_id = _ref34.generation_id,
          ha_always_run = _ref34.ha_always_run,
          ha_restart_priority = _ref34.ha_restart_priority,
          _ref34$has_vendor_dev = _ref34.has_vendor_device,
          has_vendor_device = _ref34$has_vendor_dev === undefined ? false : _ref34$has_vendor_dev,
          hardware_platform_version = _ref34.hardware_platform_version,
          HVM_boot_params = _ref34.HVM_boot_params,
          HVM_boot_policy = _ref34.HVM_boot_policy,
          HVM_shadow_multiplier = _ref34.HVM_shadow_multiplier,
          is_a_template = _ref34.is_a_template,
          memory_dynamic_max = _ref34.memory_dynamic_max,
          memory_dynamic_min = _ref34.memory_dynamic_min,
          memory_static_max = _ref34.memory_static_max,
          memory_static_min = _ref34.memory_static_min,
          name_description = _ref34.name_description,
          name_label = _ref34.name_label,
          order = _ref34.order,
          other_config = _ref34.other_config,
          PCI_bus = _ref34.PCI_bus,
          platform = _ref34.platform,
          protection_policy = _ref34.protection_policy,
          PV_args = _ref34.PV_args,
          PV_bootloader = _ref34.PV_bootloader,
          PV_bootloader_args = _ref34.PV_bootloader_args,
          PV_kernel = _ref34.PV_kernel,
          PV_legacy_args = _ref34.PV_legacy_args,
          PV_ramdisk = _ref34.PV_ramdisk,
          recommendations = _ref34.recommendations,
          shutdown_delay = _ref34.shutdown_delay,
          start_delay = _ref34.start_delay,
          tags = _ref34.tags,
          user_version = _ref34.user_version,
          VCPUs_at_startup = _ref34.VCPUs_at_startup,
          VCPUs_max = _ref34.VCPUs_max,
          VCPUs_params = _ref34.VCPUs_params,
          version = _ref34.version,
          xenstore_data = _ref34.xenstore_data;

      (0, _utils2.debug)(`Creating VM ${name_label}`);

      return this.call('VM.create', (0, _utils2.filterUndefineds)({
        actions_after_crash,
        actions_after_reboot,
        actions_after_shutdown,
        affinity: affinity == null ? _utils2.NULL_REF : affinity,
        HVM_boot_params,
        HVM_boot_policy,
        is_a_template: (0, _utils2.asBoolean)(is_a_template),
        memory_dynamic_max: (0, _utils2.asInteger)(memory_dynamic_max),
        memory_dynamic_min: (0, _utils2.asInteger)(memory_dynamic_min),
        memory_static_max: (0, _utils2.asInteger)(memory_static_max),
        memory_static_min: (0, _utils2.asInteger)(memory_static_min),
        other_config,
        PCI_bus,
        platform,
        PV_args,
        PV_bootloader,
        PV_bootloader_args,
        PV_kernel,
        PV_legacy_args,
        PV_ramdisk,
        recommendations,
        user_version: (0, _utils2.asInteger)(user_version),
        VCPUs_at_startup: (0, _utils2.asInteger)(VCPUs_at_startup),
        VCPUs_max: (0, _utils2.asInteger)(VCPUs_max),
        VCPUs_params,

        // Optional fields.
        blocked_operations,
        generation_id,
        ha_always_run: (0, _utils2.asBoolean)(ha_always_run),
        ha_restart_priority,
        has_vendor_device,
        hardware_platform_version: (0, _utils2.optional)(hardware_platform_version, _utils2.asInteger),
        // HVM_shadow_multiplier: asFloat(HVM_shadow_multiplier), // FIXME: does not work FIELD_TYPE_ERROR(hVM_shadow_multiplier)
        name_description,
        name_label,
        order: (0, _utils2.optional)(order, _utils2.asInteger),
        protection_policy,
        shutdown_delay: (0, _utils2.asInteger)(shutdown_delay),
        start_delay: (0, _utils2.asInteger)(start_delay),
        tags,
        version: (0, _utils2.asInteger)(version),
        xenstore_data
      }));
    }
  }, {
    key: '_deleteVm',
    value: function () {
      var _ref35 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee25(vm) {
        var _this8 = this;

        var deleteDisks = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var vdis;
        return _regenerator2.default.wrap(function _callee25$(_context30) {
          while (1) {
            switch (_context30.prev = _context30.next) {
              case 0:
                (0, _utils2.debug)(`Deleting VM ${vm.name_label}`);

                // It is necessary for suspended VMs to be shut down
                // to be able to delete their VDIs.

                if (!(vm.power_state !== 'Halted')) {
                  _context30.next = 4;
                  break;
                }

                _context30.next = 4;
                return this.call('VM.hard_shutdown', vm.$ref);

              case 4:
                if (!deleteDisks) {
                  _context30.next = 9;
                  break;
                }

                // Compute the VDIs list without duplicates.
                vdis = {};

                (0, _utils.forEach)(vm.$VBDs, function (vbd) {
                  var vdi = void 0;
                  if (
                  // Do not remove CDs and Floppies.
                  vbd.type === 'Disk' && (

                  // Ignore VBD without VDI.
                  vdi = vbd.$VDI)) {
                    vdis[vdi.$id] = vdi;
                  }
                });

                _context30.next = 9;
                return _promise3.default.all((0, _utils.mapToArray)(vdis, function (vdi) {
                  if (
                  // Do not remove VBDs attached to other VMs.
                  vdi.VBDs.length < 2 || (0, _every3.default)(vdi.$VBDs, function (vbd) {
                    return vbd.VM === vm.$ref;
                  })) {
                    var _context28;

                    return (_context28 = _this8._deleteVdi(vdi), _utils.pCatch).call(_context28, _utils.noop);
                  }
                  console.error(`cannot delete VDI ${vdi.name_label} (from VM ${vm.name_label})`);
                }));

              case 9:
                _context30.next = 11;
                return _promise3.default.all((0, _utils.mapToArray)(vm.$snapshots, function (snapshot) {
                  var _context29;

                  return (_context29 = _this8.deleteVm(snapshot.$id), _utils.pCatch).call(_context29, _utils.noop);
                }));

              case 11:
                _context30.next = 13;
                return this.call('VM.destroy', vm.$ref);

              case 13:
              case 'end':
                return _context30.stop();
            }
          }
        }, _callee25, this);
      }));

      function _deleteVm(_x48) {
        return _ref35.apply(this, arguments);
      }

      return _deleteVm;
    }()
  }, {
    key: 'deleteVm',
    value: function () {
      var _ref36 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee26(vmId, deleteDisks) {
        return _regenerator2.default.wrap(function _callee26$(_context31) {
          while (1) {
            switch (_context31.prev = _context31.next) {
              case 0:
                return _context31.abrupt('return', /* await */this._deleteVm(this.getObject(vmId), deleteDisks));

              case 1:
              case 'end':
                return _context31.stop();
            }
          }
        }, _callee26, this);
      }));

      function deleteVm(_x50, _x51) {
        return _ref36.apply(this, arguments);
      }

      return deleteVm;
    }()
  }, {
    key: 'getVmConsole',
    value: function getVmConsole(vmId) {
      var vm = this.getObject(vmId);

      var console = (0, _find3.default)(vm.$consoles, { protocol: 'rfb' });
      if (!console) {
        throw new Error('no RFB console found');
      }

      return console;
    }

    // Returns a stream to the exported VM.

  }, {
    key: 'exportVm',
    value: function () {
      var _ref37 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee27(vmId) {
        var _this9 = this;

        var _ref38 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            _ref38$compress = _ref38.compress,
            compress = _ref38$compress === undefined ? true : _ref38$compress,
            _ref38$onlyMetadata = _ref38.onlyMetadata,
            onlyMetadata = _ref38$onlyMetadata === undefined ? false : _ref38$onlyMetadata;

        var vm, host, snapshotRef, taskRef, _context32;

        return _regenerator2.default.wrap(function _callee27$(_context34) {
          while (1) {
            switch (_context34.prev = _context34.next) {
              case 0:
                vm = this.getObject(vmId);
                host = void 0;
                snapshotRef = void 0;
                // It's not needed to snapshot the VM to get the metadata

                if (!((0, _utils2.isVmRunning)(vm) && !onlyMetadata)) {
                  _context34.next = 10;
                  break;
                }

                host = vm.$resident_on;
                _context34.next = 7;
                return this._snapshotVm(vm);

              case 7:
                snapshotRef = _context34.sent.$ref;
                _context34.next = 11;
                break;

              case 10:
                host = this.pool.$master;

              case 11:
                _context34.next = 13;
                return this._createTask('VM Export', vm.name_label);

              case 13:
                taskRef = _context34.sent;

                if (snapshotRef) {
                  (_context32 = this._watchTask(taskRef), _utils.pFinally).call(_context32, function () {
                    var _context33;

                    (_context33 = _this9.deleteVm(snapshotRef), _utils.pCatch).call(_context33, _utils.noop);
                  });
                }

                return _context34.abrupt('return', (0, _httpRequest2.default)({
                  hostname: host.address,
                  path: onlyMetadata ? '/export_metadata/' : '/export/',
                  protocol: 'https',
                  query: {
                    ref: snapshotRef || vm.$ref,
                    session_id: this.sessionId,
                    task_id: taskRef,
                    use_compression: compress ? 'true' : 'false'
                  },
                  rejectUnauthorized: false
                }));

              case 16:
              case 'end':
                return _context34.stop();
            }
          }
        }, _callee27, this);
      }));

      function exportVm(_x52) {
        return _ref37.apply(this, arguments);
      }

      return exportVm;
    }()

    // Create a snapshot of the VM and returns a delta export object.

  }, {
    key: 'exportDeltaVm',
    value: function () {
      var _ref39 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee28($onFailure, vmId) {
        var _this10 = this;

        var baseVmId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;

        var _ref40 = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {},
            _ref40$snapshotNameLa = _ref40.snapshotNameLabel,
            snapshotNameLabel = _ref40$snapshotNameLa === undefined ? undefined : _ref40$snapshotNameLa,
            _ref40$fullVdisRequir = _ref40.fullVdisRequired,
            fullVdisRequired = _ref40$fullVdisRequir === undefined ? [] : _ref40$fullVdisRequir,
            _ref40$disableBaseTag = _ref40.disableBaseTags,
            disableBaseTags = _ref40$disableBaseTag === undefined ? false : _ref40$disableBaseTag;

        var vm, _context35, baseVm, baseVdis, streams, vdis, vbds, vifs;

        return _regenerator2.default.wrap(function _callee28$(_context37) {
          while (1) {
            switch (_context37.prev = _context37.next) {
              case 0:
                _context37.next = 2;
                return this.snapshotVm(vmId);

              case 2:
                vm = _context37.sent;

                $onFailure(function () {
                  return _this10._deleteVm(vm);
                });
                if (snapshotNameLabel) {
                  (_context35 = this._setObjectProperties(vm, {
                    nameLabel: snapshotNameLabel
                  }), _utils.pCatch).call(_context35, _utils.noop);
                }

                baseVm = baseVmId && this.getObject(baseVmId);

                // refs of VM's VDIs → base's VDIs.

                baseVdis = {};

                baseVm && (0, _utils.forEach)(baseVm.$VBDs, function (vbd) {
                  var vdi = void 0,
                      snapshotOf = void 0;
                  if ((vdi = vbd.$VDI) && (snapshotOf = vdi.$snapshot_of) && !(0, _find3.default)(fullVdisRequired, function (id) {
                    return snapshotOf.$id === id;
                  })) {
                    baseVdis[vdi.snapshot_of] = vdi;
                  }
                });

                streams = {};
                vdis = {};
                vbds = {};

                (0, _utils.forEach)(vm.$VBDs, function (vbd) {
                  var vdi = void 0;
                  if (vbd.type !== 'Disk' || !(vdi = vbd.$VDI)) {
                    // Ignore this VBD.
                    return;
                  }

                  // If the VDI name start with `[NOBAK]`, do not export it.
                  if ((0, _startsWith3.default)(vdi.name_label, '[NOBAK]')) {
                    var _context36;

                    // FIXME: find a way to not create the VDI snapshot in the
                    // first time.
                    //
                    // The snapshot must not exist otherwise it could break the
                    // next export.
                    (_context36 = _this10._deleteVdi(vdi), _utils.pCatch).call(_context36, _utils.noop);
                    return;
                  }

                  vbds[vbd.$ref] = vbd;

                  var vdiRef = vdi.$ref;
                  if (vdiRef in vdis) {
                    // This VDI has already been managed.
                    return;
                  }

                  // Look for a snapshot of this vdi in the base VM.
                  var baseVdi = baseVdis[vdi.snapshot_of];

                  vdis[vdiRef] = baseVdi && !disableBaseTags ? (0, _extends3.default)({}, vdi, {
                    other_config: (0, _extends3.default)({}, vdi.other_config, {
                      [TAG_BASE_DELTA]: baseVdi.uuid
                    }),
                    $SR$uuid: vdi.$SR.uuid
                  }) : (0, _extends3.default)({}, vdi, {
                    $SR$uuid: vdi.$SR.uuid
                  });
                  var stream = streams[`${vdiRef}.vhd`] = _this10._exportVdi(vdi, baseVdi, VDI_FORMAT_VHD);
                  $onFailure(function () {
                    return stream.cancel();
                  });
                });

                vifs = {};

                (0, _utils.forEach)(vm.$VIFs, function (vif) {
                  vifs[vif.$ref] = (0, _extends3.default)({}, vif, {
                    $network$uuid: vif.$network.uuid
                  });
                });

                _context37.t0 = Object;
                _context37.t1 = {
                  version: '1.1.0',
                  vbds,
                  vdis,
                  vifs,
                  vm: baseVm && !disableBaseTags ? (0, _extends3.default)({}, vm, {
                    other_config: (0, _extends3.default)({}, vm.other_config, {
                      [TAG_BASE_DELTA]: baseVm.uuid
                    })
                  }) : (0, _extends3.default)({}, vm, {
                    other_config: (0, _omit3.default)(vm.other_config, TAG_BASE_DELTA)
                  })
                };
                _context37.next = 18;
                return _utils.pAll.call(streams);

              case 18:
                _context37.t2 = _context37.sent;
                _context37.t3 = {
                  value: _context37.t2
                };
                return _context37.abrupt('return', _context37.t0.defineProperty.call(_context37.t0, _context37.t1, 'streams', _context37.t3));

              case 21:
              case 'end':
                return _context37.stop();
            }
          }
        }, _callee28, this);
      }));

      function exportDeltaVm(_x54, _x55) {
        return _ref39.apply(this, arguments);
      }

      return exportDeltaVm;
    }()
  }, {
    key: 'importDeltaVm',
    value: function () {
      var _ref41 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee31($onFailure, delta) {
        var _this11 = this,
            _context39;

        var _ref42 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
            _ref42$deleteBase = _ref42.deleteBase,
            deleteBase = _ref42$deleteBase === undefined ? false : _ref42$deleteBase,
            _ref42$name_label = _ref42.name_label,
            name_label = _ref42$name_label === undefined ? delta.vm.name_label : _ref42$name_label,
            _ref42$srId = _ref42.srId,
            srId = _ref42$srId === undefined ? this.pool.default_SR : _ref42$srId,
            _ref42$disableStartAf = _ref42.disableStartAfterImport,
            disableStartAfterImport = _ref42$disableStartAf === undefined ? true : _ref42$disableStartAf;

        var version, remoteBaseVmUuid, baseVm, sr, baseVdis, streams, vm, newVdis, networksOnPoolMasterByDevice, defaultNetwork, _context42;

        return _regenerator2.default.wrap(function _callee31$(_context43) {
          while (1) {
            switch (_context43.prev = _context43.next) {
              case 0:
                version = delta.version;

                if ((0, _semver.satisfies)(version, '^1')) {
                  _context43.next = 3;
                  break;
                }

                throw new Error(`Unsupported delta backup version: ${version}`);

              case 3:
                remoteBaseVmUuid = delta.vm.other_config[TAG_BASE_DELTA];
                baseVm = void 0;

                if (!remoteBaseVmUuid) {
                  _context43.next = 9;
                  break;
                }

                baseVm = (0, _find3.default)(this.objects.all, function (obj) {
                  return (obj = obj.other_config) && obj[TAG_COPY_SRC] === remoteBaseVmUuid;
                });

                if (baseVm) {
                  _context43.next = 9;
                  break;
                }

                throw new Error('could not find the base VM');

              case 9:
                sr = this.getObject(srId);
                baseVdis = {};

                baseVm && (0, _utils.forEach)(baseVm.$VBDs, function (vbd) {
                  baseVdis[vbd.VDI] = vbd.$VDI;
                });

                streams = delta.streams;

                // 1. Create the VMs.

                _context43.t0 = this;
                _context43.next = 16;
                return this._createVmRecord((0, _extends3.default)({}, delta.vm, {
                  affinity: null,
                  is_a_template: false
                }));

              case 16:
                _context43.t1 = _context43.sent;
                _context43.next = 19;
                return _context43.t0._getOrWaitObject.call(_context43.t0, _context43.t1);

              case 19:
                vm = _context43.sent;

                $onFailure(function () {
                  return _this11._deleteVm(vm);
                });

                _context43.next = 23;
                return _promise3.default.all([this._setObjectProperties(vm, {
                  name_label: `[Importing…] ${name_label}`
                }), this._updateObjectMapProperty(vm, 'blocked_operations', {
                  start: 'Importing…'
                }), this._updateObjectMapProperty(vm, 'other_config', {
                  [TAG_COPY_SRC]: delta.vm.uuid
                })]);

              case 23:
                _context43.next = 25;
                return _promise3.default.all((0, _utils.mapToArray)(vm.$VBDs, function (vbd) {
                  var _context38;

                  return (_context38 = _this11._deleteVbd(vbd), _utils.pCatch).call(_context38, _utils.noop);
                }));

              case 25:
                _context43.next = 27;
                return (_context39 = (0, _utils.map)(delta.vdis, function () {
                  var _ref43 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee29(vdi) {
                    var remoteBaseVdiUuid, _newVdi, baseVdi, newVdi;

                    return _regenerator2.default.wrap(function _callee29$(_context40) {
                      while (1) {
                        switch (_context40.prev = _context40.next) {
                          case 0:
                            remoteBaseVdiUuid = vdi.other_config[TAG_BASE_DELTA];

                            if (remoteBaseVdiUuid) {
                              _context40.next = 7;
                              break;
                            }

                            _context40.next = 4;
                            return _this11.createVdi(vdi.virtual_size, (0, _extends3.default)({}, vdi, {
                              other_config: (0, _extends3.default)({}, vdi.other_config, {
                                [TAG_BASE_DELTA]: undefined,
                                [TAG_COPY_SRC]: vdi.uuid
                              }),
                              sr: sr.$id
                            }));

                          case 4:
                            _newVdi = _context40.sent;

                            $onFailure(function () {
                              return _this11._deleteVdi(_newVdi);
                            });

                            return _context40.abrupt('return', _newVdi);

                          case 7:
                            baseVdi = (0, _find3.default)(baseVdis, function (vdi) {
                              return vdi.other_config[TAG_COPY_SRC] === remoteBaseVdiUuid;
                            });

                            if (baseVdi) {
                              _context40.next = 10;
                              break;
                            }

                            throw new Error(`missing base VDI (copy of ${remoteBaseVdiUuid})`);

                          case 10:
                            _context40.t0 = _this11;
                            _context40.next = 13;
                            return _this11._cloneVdi(baseVdi);

                          case 13:
                            _context40.t1 = _context40.sent;
                            _context40.next = 16;
                            return _context40.t0._getOrWaitObject.call(_context40.t0, _context40.t1);

                          case 16:
                            newVdi = _context40.sent;

                            $onFailure(function () {
                              return _this11._deleteVdi(newVdi);
                            });

                            _context40.next = 20;
                            return _this11._updateObjectMapProperty(newVdi, 'other_config', {
                              [TAG_COPY_SRC]: vdi.uuid
                            });

                          case 20:
                            return _context40.abrupt('return', newVdi);

                          case 21:
                          case 'end':
                            return _context40.stop();
                        }
                      }
                    }, _callee29, _this11);
                  }));

                  return function (_x61) {
                    return _ref43.apply(this, arguments);
                  };
                }()), _utils.pAll).call(_context39);

              case 27:
                newVdis = _context43.sent;
                networksOnPoolMasterByDevice = {};
                defaultNetwork = void 0;

                (0, _utils.forEach)(this.pool.$master.$PIFs, function (pif) {
                  defaultNetwork = networksOnPoolMasterByDevice[pif.device] = pif.$network;
                });

                _context43.next = 33;
                return _promise3.default.all([
                // Create VBDs.
                _promise3.default.all((0, _utils.mapToArray)(delta.vbds, function (vbd) {
                  return _this11._createVbd(vm, newVdis[vbd.VDI], vbd);
                })),

                // Import VDI contents.
                _promise3.default.all((0, _utils.mapToArray)(newVdis, function () {
                  var _ref44 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee30(vdi, id) {
                    var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, stream;

                    return _regenerator2.default.wrap(function _callee30$(_context41) {
                      while (1) {
                        switch (_context41.prev = _context41.next) {
                          case 0:
                            _iteratorNormalCompletion = true;
                            _didIteratorError = false;
                            _iteratorError = undefined;
                            _context41.prev = 3;
                            _iterator = (0, _getIterator3.default)((0, _utils.ensureArray)(streams[`${id}.vhd`]));

                          case 5:
                            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                              _context41.next = 12;
                              break;
                            }

                            stream = _step.value;
                            _context41.next = 9;
                            return _this11._importVdiContent(vdi, stream, VDI_FORMAT_VHD);

                          case 9:
                            _iteratorNormalCompletion = true;
                            _context41.next = 5;
                            break;

                          case 12:
                            _context41.next = 18;
                            break;

                          case 14:
                            _context41.prev = 14;
                            _context41.t0 = _context41['catch'](3);
                            _didIteratorError = true;
                            _iteratorError = _context41.t0;

                          case 18:
                            _context41.prev = 18;
                            _context41.prev = 19;

                            if (!_iteratorNormalCompletion && _iterator.return) {
                              _iterator.return();
                            }

                          case 21:
                            _context41.prev = 21;

                            if (!_didIteratorError) {
                              _context41.next = 24;
                              break;
                            }

                            throw _iteratorError;

                          case 24:
                            return _context41.finish(21);

                          case 25:
                            return _context41.finish(18);

                          case 26:
                          case 'end':
                            return _context41.stop();
                        }
                      }
                    }, _callee30, _this11, [[3, 14, 18, 26], [19,, 21, 25]]);
                  }));

                  return function (_x62, _x63) {
                    return _ref44.apply(this, arguments);
                  };
                }())),

                // Wait for VDI export tasks (if any) termination.
                _promise3.default.all((0, _utils.mapToArray)(streams, function (stream) {
                  return stream.task;
                })),

                // Create VIFs.
                _promise3.default.all((0, _utils.mapToArray)(delta.vifs, function (vif) {
                  var network = vif.$network$uuid && _this11.getObject(vif.$network$uuid, null) || networksOnPoolMasterByDevice[vif.device] || defaultNetwork;

                  if (network) {
                    return _this11._createVif(vm, network, vif);
                  }
                }))]);

              case 33:

                if (deleteBase && baseVm) {
                  (_context42 = this._deleteVm(baseVm), _utils.pCatch).call(_context42, _utils.noop);
                }

                _context43.next = 36;
                return _promise3.default.all([this._setObjectProperties(vm, {
                  name_label
                }),
                // FIXME: move
                this._updateObjectMapProperty(vm, 'blocked_operations', {
                  start: disableStartAfterImport ? 'Do not start this VM, clone it if you want to use it.' : null
                })]);

              case 36:
                return _context43.abrupt('return', vm);

              case 37:
              case 'end':
                return _context43.stop();
            }
          }
        }, _callee31, this);
      }));

      function importDeltaVm(_x58, _x59) {
        return _ref41.apply(this, arguments);
      }

      return importDeltaVm;
    }()
  }, {
    key: '_migrateVmWithStorageMotion',
    value: function () {
      var _ref45 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee32(vm, hostXapi, host, _ref46) {
        var _this12 = this;

        var _ref46$migrationNetwo = _ref46.migrationNetwork,
            migrationNetwork = _ref46$migrationNetwo === undefined ? (0, _find3.default)(host.$PIFs, function (pif) {
          return pif.management;
        }).$network : _ref46$migrationNetwo,
            mapVdisSrs = _ref46.mapVdisSrs,
            mapVifsNetworks = _ref46.mapVifsNetworks;

        var vdis, defaultSr, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, vbd, vdi, vifsMap, defaultNetworkRef, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, vif, token, loop;

        return _regenerator2.default.wrap(function _callee32$(_context45) {
          while (1) {
            switch (_context45.prev = _context45.next) {
              case 0:
                // VDIs/SRs mapping
                vdis = {};
                defaultSr = host.$pool.$default_SR;
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context45.prev = 5;

                for (_iterator2 = (0, _getIterator3.default)(vm.$VBDs); !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  vbd = _step2.value;
                  vdi = vbd.$VDI;

                  if (vbd.type === 'Disk') {
                    vdis[vdi.$ref] = mapVdisSrs && mapVdisSrs[vdi.$id] ? hostXapi.getObject(mapVdisSrs[vdi.$id]).$ref : defaultSr.$ref; // Will error if there are no default SR.
                  }
                }

                // VIFs/Networks mapping
                _context45.next = 13;
                break;

              case 9:
                _context45.prev = 9;
                _context45.t0 = _context45['catch'](5);
                _didIteratorError2 = true;
                _iteratorError2 = _context45.t0;

              case 13:
                _context45.prev = 13;
                _context45.prev = 14;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 16:
                _context45.prev = 16;

                if (!_didIteratorError2) {
                  _context45.next = 19;
                  break;
                }

                throw _iteratorError2;

              case 19:
                return _context45.finish(16);

              case 20:
                return _context45.finish(13);

              case 21:
                vifsMap = {};

                if (!(vm.$pool !== host.$pool)) {
                  _context45.next = 43;
                  break;
                }

                defaultNetworkRef = (0, _find3.default)(host.$PIFs, function (pif) {
                  return pif.management;
                }).$network.$ref;
                _iteratorNormalCompletion3 = true;
                _didIteratorError3 = false;
                _iteratorError3 = undefined;
                _context45.prev = 27;

                for (_iterator3 = (0, _getIterator3.default)(vm.$VIFs); !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                  vif = _step3.value;

                  vifsMap[vif.$ref] = mapVifsNetworks && mapVifsNetworks[vif.$id] ? hostXapi.getObject(mapVifsNetworks[vif.$id]).$ref : defaultNetworkRef;
                }
                _context45.next = 35;
                break;

              case 31:
                _context45.prev = 31;
                _context45.t1 = _context45['catch'](27);
                _didIteratorError3 = true;
                _iteratorError3 = _context45.t1;

              case 35:
                _context45.prev = 35;
                _context45.prev = 36;

                if (!_iteratorNormalCompletion3 && _iterator3.return) {
                  _iterator3.return();
                }

              case 38:
                _context45.prev = 38;

                if (!_didIteratorError3) {
                  _context45.next = 41;
                  break;
                }

                throw _iteratorError3;

              case 41:
                return _context45.finish(38);

              case 42:
                return _context45.finish(35);

              case 43:
                _context45.next = 45;
                return hostXapi.call('host.migrate_receive', host.$ref, migrationNetwork.$ref, {});

              case 45:
                token = _context45.sent;

                loop = function loop() {
                  var _context44;

                  return (_context44 = _this12.call('VM.migrate_send', vm.$ref, token, true, // Live migration.
                  vdis, vifsMap, {
                    force: 'true'
                  }), _utils.pCatch).call(_context44, { code: 'TOO_MANY_STORAGE_MIGRATES' }, function () {
                    return (0, _utils.pDelay)(1e4).then(loop);
                  });
                };

                return _context45.abrupt('return', loop());

              case 48:
              case 'end':
                return _context45.stop();
            }
          }
        }, _callee32, this, [[5, 9, 13, 21], [14,, 16, 20], [27, 31, 35, 43], [36,, 38, 42]]);
      }));

      function _migrateVmWithStorageMotion(_x64, _x65, _x66, _x67) {
        return _ref45.apply(this, arguments);
      }

      return _migrateVmWithStorageMotion;
    }()
  }, {
    key: '_callInstallationPlugin',
    value: function _callInstallationPlugin(hostRef, vdi) {
      return this.call('host.call_plugin', hostRef, 'install-supp-pack', 'install', { vdi }).catch(function (error) {
        if (error.code !== 'XENAPI_PLUGIN_FAILURE') {
          console.warn('_callInstallationPlugin', error);
          throw error;
        }
      });
    }
  }, {
    key: 'installSupplementalPack',
    value: function () {
      var _ref47 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee33($defer, stream, _ref48) {
        var _this13 = this;

        var hostId = _ref48.hostId;
        var vdi;
        return _regenerator2.default.wrap(function _callee33$(_context46) {
          while (1) {
            switch (_context46.prev = _context46.next) {
              case 0:
                if (stream.length) {
                  _context46.next = 2;
                  break;
                }

                throw new Error('stream must have a length');

              case 2:
                _context46.next = 4;
                return this.createTemporaryVdiOnHost(stream, hostId, '[XO] Supplemental pack ISO', 'small temporary VDI to store a supplemental pack ISO');

              case 4:
                vdi = _context46.sent;

                $defer(function () {
                  return _this13._deleteVdi(vdi);
                });

                _context46.next = 8;
                return this._callInstallationPlugin(this.getObject(hostId).$ref, vdi.uuid);

              case 8:
              case 'end':
                return _context46.stop();
            }
          }
        }, _callee33, this);
      }));

      function installSupplementalPack(_x68, _x69, _x70) {
        return _ref47.apply(this, arguments);
      }

      return installSupplementalPack;
    }()
  }, {
    key: 'installSupplementalPackOnAllHosts',
    value: function () {
      var _ref49 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee35($defer, stream) {
        var _this14 = this;

        var isSrAvailable, hosts, sr, vdi, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, host;

        return _regenerator2.default.wrap(function _callee35$(_context48) {
          while (1) {
            switch (_context48.prev = _context48.next) {
              case 0:
                if (stream.length) {
                  _context48.next = 2;
                  break;
                }

                throw new Error('stream must have a length');

              case 2:
                isSrAvailable = function isSrAvailable(sr) {
                  return sr && sr.content_type === 'user' && sr.physical_size - sr.physical_utilisation >= stream.length;
                };

                hosts = (0, _filter3.default)(this.objects.all, { $type: 'host' });

                // Try to find a shared SR

                sr = (0, _find3.default)((0, _filter3.default)(this.objects.all, { $type: 'sr', shared: true }), isSrAvailable);

                // Shared SR available: create only 1 VDI for all the installations

                if (!sr) {
                  _context48.next = 37;
                  break;
                }

                _context48.next = 8;
                return this._createTemporaryVdiOnSr(stream, sr, '[XO] Supplemental pack ISO', 'small temporary VDI to store a supplemental pack ISO');

              case 8:
                vdi = _context48.sent;

                $defer(function () {
                  return _this14._deleteVdi(vdi);
                });

                // Install pack sequentially to prevent concurrent access to the unique VDI
                _iteratorNormalCompletion4 = true;
                _didIteratorError4 = false;
                _iteratorError4 = undefined;
                _context48.prev = 13;
                _iterator4 = (0, _getIterator3.default)(hosts);

              case 15:
                if (_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done) {
                  _context48.next = 22;
                  break;
                }

                host = _step4.value;
                _context48.next = 19;
                return this._callInstallationPlugin(host.$ref, vdi.uuid);

              case 19:
                _iteratorNormalCompletion4 = true;
                _context48.next = 15;
                break;

              case 22:
                _context48.next = 28;
                break;

              case 24:
                _context48.prev = 24;
                _context48.t0 = _context48['catch'](13);
                _didIteratorError4 = true;
                _iteratorError4 = _context48.t0;

              case 28:
                _context48.prev = 28;
                _context48.prev = 29;

                if (!_iteratorNormalCompletion4 && _iterator4.return) {
                  _iterator4.return();
                }

              case 31:
                _context48.prev = 31;

                if (!_didIteratorError4) {
                  _context48.next = 34;
                  break;
                }

                throw _iteratorError4;

              case 34:
                return _context48.finish(31);

              case 35:
                return _context48.finish(28);

              case 36:
                return _context48.abrupt('return');

              case 37:
                return _context48.abrupt('return', _promise3.default.all((0, _utils.mapToArray)(hosts, (0, _golikeDefer2.default)(function () {
                  var _ref50 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee34($defer, host) {
                    var pt, sr, vdi;
                    return _regenerator2.default.wrap(function _callee34$(_context47) {
                      while (1) {
                        switch (_context47.prev = _context47.next) {
                          case 0:
                            // pipe stream synchronously to several PassThroughs to be able to pipe them asynchronously later
                            pt = stream.pipe(new _stream.PassThrough());

                            pt.length = stream.length;

                            sr = (0, _find3.default)((0, _utils.mapToArray)(host.$PBDs, '$SR'), isSrAvailable);

                            if (sr) {
                              _context47.next = 5;
                              break;
                            }

                            throw new Error('no SR available to store installation file');

                          case 5:
                            _context47.next = 7;
                            return _this14._createTemporaryVdiOnSr(pt, sr, '[XO] Supplemental pack ISO', 'small temporary VDI to store a supplemental pack ISO');

                          case 7:
                            vdi = _context47.sent;

                            $defer(function () {
                              return _this14._deleteVdi(vdi);
                            });

                            _context47.next = 11;
                            return _this14._callInstallationPlugin(host.$ref, vdi.uuid);

                          case 11:
                          case 'end':
                            return _context47.stop();
                        }
                      }
                    }, _callee34, _this14);
                  }));

                  return function (_x73, _x74) {
                    return _ref50.apply(this, arguments);
                  };
                }()))));

              case 38:
              case 'end':
                return _context48.stop();
            }
          }
        }, _callee35, this, [[13, 24, 28, 36], [29,, 31, 35]]);
      }));

      function installSupplementalPackOnAllHosts(_x71, _x72) {
        return _ref49.apply(this, arguments);
      }

      return installSupplementalPackOnAllHosts;
    }()
  }, {
    key: '_importVm',
    value: function () {
      var _ref51 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee36(stream, sr) {
        var onlyMetadata = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
        var onVmCreation = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;

        var taskRef, query, host, path, _context49, _ref52, _ref53, vmRef;

        return _regenerator2.default.wrap(function _callee36$(_context50) {
          while (1) {
            switch (_context50.prev = _context50.next) {
              case 0:
                _context50.next = 2;
                return this._createTask('VM import');

              case 2:
                taskRef = _context50.sent;
                query = {
                  force: onlyMetadata ? 'true' : undefined,
                  session_id: this.sessionId,
                  task_id: taskRef
                };
                host = void 0;

                if (sr) {
                  host = sr.$PBDs[0].$host;
                  query.sr_id = sr.$ref;
                } else {
                  host = this.pool.$master;
                }

                path = onlyMetadata ? '/import_metadata/' : '/import/';


                if (onVmCreation) {
                  (_context49 = this._waitObject(function (obj) {
                    return obj && obj.current_operations && taskRef in obj.current_operations;
                  }).then(onVmCreation), _utils.pCatch).call(_context49, _utils.noop);
                }

                _context50.next = 10;
                return _promise3.default.all([this._watchTask(taskRef).then(_utils2.extractOpaqueRef), (0, _utils2.put)(stream, {
                  hostname: host.address,
                  path,
                  protocol: 'https',
                  query,
                  rejectUnauthorized: false
                })]);

              case 10:
                _ref52 = _context50.sent;
                _ref53 = (0, _slicedToArray3.default)(_ref52, 1);
                vmRef = _ref53[0];

                if (!onlyMetadata) {
                  _context50.next = 16;
                  break;
                }

                _context50.next = 16;
                return this.call('VM.power_state_reset', vmRef);

              case 16:
                return _context50.abrupt('return', vmRef);

              case 17:
              case 'end':
                return _context50.stop();
            }
          }
        }, _callee36, this);
      }));

      function _importVm(_x75, _x76) {
        return _ref51.apply(this, arguments);
      }

      return _importVm;
    }()
  }, {
    key: '_importOvaVm',
    value: function () {
      var _ref54 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee39($onFailure, stream, _ref55, sr) {
        var _this15 = this;

        var descriptionLabel = _ref55.descriptionLabel,
            disks = _ref55.disks,
            memory = _ref55.memory,
            nameLabel = _ref55.nameLabel,
            networks = _ref55.networks,
            nCpus = _ref55.nCpus;
        var vm, vdis, vifDevices;
        return _regenerator2.default.wrap(function _callee39$(_context54) {
          while (1) {
            switch (_context54.prev = _context54.next) {
              case 0:
                _context54.t0 = this;
                _context54.next = 3;
                return this._createVmRecord((0, _extends3.default)({}, _otherConfigTemplate2.default, {
                  memory_dynamic_max: memory,
                  memory_dynamic_min: memory,
                  memory_static_max: memory,
                  name_description: descriptionLabel,
                  name_label: nameLabel,
                  VCPUs_at_startup: nCpus,
                  VCPUs_max: nCpus
                }));

              case 3:
                _context54.t1 = _context54.sent;
                _context54.next = 6;
                return _context54.t0._getOrWaitObject.call(_context54.t0, _context54.t1);

              case 6:
                vm = _context54.sent;

                $onFailure(function () {
                  return _this15._deleteVm(vm);
                });
                // Disable start and change the VM name label during import.
                _context54.next = 10;
                return _promise3.default.all([this.addForbiddenOperationToVm(vm.$id, 'start', 'OVA import in progress...'), this._setObjectProperties(vm, { name_label: `[Importing...] ${nameLabel}` })]);

              case 10:

                // 2. Create VDIs & Vifs.
                vdis = {};
                _context54.next = 13;
                return this.call('VM.get_allowed_VIF_devices', vm.$ref);

              case 13:
                vifDevices = _context54.sent;
                _context54.next = 16;
                return _promise3.default.all((0, _utils.map)(disks, function () {
                  var _ref56 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee37(disk) {
                    var vdi;
                    return _regenerator2.default.wrap(function _callee37$(_context52) {
                      while (1) {
                        switch (_context52.prev = _context52.next) {
                          case 0:
                            _context52.next = 2;
                            return _this15.createVdi(disk.capacity, {
                              name_description: disk.descriptionLabel,
                              name_label: disk.nameLabel,
                              sr: sr.$ref
                            });

                          case 2:
                            vdi = vdis[disk.path] = _context52.sent;

                            $onFailure(function () {
                              var _context51;

                              return (_context51 = _this15._deleteVdi(vdi), _utils.pCatch).call(_context51, _utils.noop);
                            });

                            return _context52.abrupt('return', _this15._createVbd(vm, vdi, { position: disk.position }));

                          case 5:
                          case 'end':
                            return _context52.stop();
                        }
                      }
                    }, _callee37, _this15);
                  }));

                  return function (_x83) {
                    return _ref56.apply(this, arguments);
                  };
                }()).concat((0, _utils.map)(networks, function (networkId, i) {
                  return _this15._createVif(vm, _this15.getObject(networkId), {
                    device: vifDevices[i]
                  });
                })));

              case 16:
                _context54.next = 18;
                return new _promise3.default(function (resolve, reject) {
                  var extract = _tarStream2.default.extract();

                  stream.on('error', reject);

                  extract.on('finish', resolve);
                  extract.on('error', reject);
                  extract.on('entry', function () {
                    var _ref57 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee38(entry, stream, cb) {
                      var vdi, vhdStream;
                      return _regenerator2.default.wrap(function _callee38$(_context53) {
                        while (1) {
                          switch (_context53.prev = _context53.next) {
                            case 0:
                              // Not a disk to import.
                              vdi = vdis[entry.name];

                              if (vdi) {
                                _context53.next = 5;
                                break;
                              }

                              stream.on('end', cb);
                              stream.resume();
                              return _context53.abrupt('return');

                            case 5:
                              _context53.next = 7;
                              return (0, _xoVmdkToVhd2.default)(stream);

                            case 7:
                              vhdStream = _context53.sent;
                              _context53.next = 10;
                              return _this15._importVdiContent(vdi, vhdStream, VDI_FORMAT_RAW);

                            case 10:

                              // See: https://github.com/mafintosh/tar-stream#extracting
                              // No import parallelization.
                              cb();

                            case 11:
                            case 'end':
                              return _context53.stop();
                          }
                        }
                      }, _callee38, _this15);
                    }));

                    return function (_x84, _x85, _x86) {
                      return _ref57.apply(this, arguments);
                    };
                  }());
                  stream.pipe(extract);
                });

              case 18:
                _context54.next = 20;
                return _promise3.default.all([this.removeForbiddenOperationFromVm(vm.$id, 'start'), this._setObjectProperties(vm, { name_label: nameLabel })]);

              case 20:
                return _context54.abrupt('return', vm);

              case 21:
              case 'end':
                return _context54.stop();
            }
          }
        }, _callee39, this);
      }));

      function _importOvaVm(_x79, _x80, _x81, _x82) {
        return _ref54.apply(this, arguments);
      }

      return _importOvaVm;
    }()

    // TODO: an XVA can contain multiple VMs

  }, {
    key: 'importVm',
    value: function () {
      var _ref58 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee40(stream) {
        var _ref59 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            data = _ref59.data,
            _ref59$onlyMetadata = _ref59.onlyMetadata,
            onlyMetadata = _ref59$onlyMetadata === undefined ? false : _ref59$onlyMetadata,
            srId = _ref59.srId,
            _ref59$type = _ref59.type,
            type = _ref59$type === undefined ? 'xva' : _ref59$type;

        var sr;
        return _regenerator2.default.wrap(function _callee40$(_context55) {
          while (1) {
            switch (_context55.prev = _context55.next) {
              case 0:
                sr = srId && this.getObject(srId);

                if (!(type === 'xva')) {
                  _context55.next = 7;
                  break;
                }

                _context55.t0 = this;
                _context55.next = 5;
                return this._importVm(stream, sr, onlyMetadata);

              case 5:
                _context55.t1 = _context55.sent;
                return _context55.abrupt('return', _context55.t0._getOrWaitObject.call(_context55.t0, _context55.t1));

              case 7:
                if (!(type === 'ova')) {
                  _context55.next = 13;
                  break;
                }

                _context55.t2 = this;
                _context55.next = 11;
                return this._importOvaVm(stream, data, sr);

              case 11:
                _context55.t3 = _context55.sent;
                return _context55.abrupt('return', _context55.t2._getOrWaitObject.call(_context55.t2, _context55.t3));

              case 13:
                throw new Error(`unsupported type: '${type}'`);

              case 14:
              case 'end':
                return _context55.stop();
            }
          }
        }, _callee40, this);
      }));

      function importVm(_x87) {
        return _ref58.apply(this, arguments);
      }

      return importVm;
    }()
  }, {
    key: 'migrateVm',
    value: function () {
      var _ref60 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee41(vmId, hostXapi, hostId) {
        var _ref61 = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {},
            migrationNetworkId = _ref61.migrationNetworkId,
            mapVifsNetworks = _ref61.mapVifsNetworks,
            mapVdisSrs = _ref61.mapVdisSrs;

        var vm, host, accrossPools, useStorageMotion;
        return _regenerator2.default.wrap(function _callee41$(_context56) {
          while (1) {
            switch (_context56.prev = _context56.next) {
              case 0:
                vm = this.getObject(vmId);
                host = hostXapi.getObject(hostId);
                accrossPools = vm.$pool !== host.$pool;
                useStorageMotion = accrossPools || migrationNetworkId || mapVifsNetworks || mapVdisSrs;

                if (!useStorageMotion) {
                  _context56.next = 9;
                  break;
                }

                _context56.next = 7;
                return this._migrateVmWithStorageMotion(vm, hostXapi, host, {
                  migrationNetwork: migrationNetworkId && hostXapi.getObject(migrationNetworkId),
                  mapVdisSrs,
                  mapVifsNetworks
                });

              case 7:
                _context56.next = 20;
                break;

              case 9:
                _context56.prev = 9;
                _context56.next = 12;
                return this.call('VM.pool_migrate', vm.$ref, host.$ref, { force: 'true' });

              case 12:
                _context56.next = 20;
                break;

              case 14:
                _context56.prev = 14;
                _context56.t0 = _context56['catch'](9);

                if (!(_context56.t0.code !== 'VM_REQUIRES_SR')) {
                  _context56.next = 18;
                  break;
                }

                throw _context56.t0;

              case 18:
                _context56.next = 20;
                return this._migrateVmWithStorageMotion(vm, hostXapi, host, {});

              case 20:
              case 'end':
                return _context56.stop();
            }
          }
        }, _callee41, this, [[9, 14]]);
      }));

      function migrateVm(_x89, _x90, _x91) {
        return _ref60.apply(this, arguments);
      }

      return migrateVm;
    }()
  }, {
    key: '_snapshotVm',
    value: function () {
      var _ref62 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee42(vm) {
        var nameLabel = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : vm.name_label;

        var ref, _context57, code, _ref63, _ref64, snapshot;

        return _regenerator2.default.wrap(function _callee42$(_context58) {
          while (1) {
            switch (_context58.prev = _context58.next) {
              case 0:
                (0, _utils2.debug)(`Snapshotting VM ${vm.name_label}${nameLabel !== vm.name_label ? ` as ${nameLabel}` : ''}`);

                ref = void 0;
                _context58.prev = 2;
                _context58.next = 5;
                return this.call('VM.snapshot_with_quiesce', vm.$ref, nameLabel);

              case 5:
                ref = _context58.sent;

                (_context57 = this.addTag(ref, 'quiesce'), _utils.pCatch).call(_context57, _utils.noop); // ignore any failures

                _context58.next = 9;
                return this._waitObjectState(ref, function (vm) {
                  return (0, _includes3.default)(vm.tags, 'quiesce');
                });

              case 9:
                _context58.next = 19;
                break;

              case 11:
                _context58.prev = 11;
                _context58.t0 = _context58['catch'](2);
                code = _context58.t0.code;

                if (!(code !== 'VM_SNAPSHOT_WITH_QUIESCE_NOT_SUPPORTED' &&

                // quiesce only work on a running VM
                code !== 'VM_BAD_POWER_STATE' &&

                // quiesce failed, fallback on standard snapshot
                // TODO: emit warning
                code !== 'VM_SNAPSHOT_WITH_QUIESCE_FAILED')) {
                  _context58.next = 16;
                  break;
                }

                throw _context58.t0;

              case 16:
                _context58.next = 18;
                return this.call('VM.snapshot', vm.$ref, nameLabel);

              case 18:
                ref = _context58.sent;

              case 19:
                _context58.next = 21;
                return _promise3.default.all([this.call('VM.set_is_a_template', ref, false), this._waitObjectState(ref, function (snapshot) {
                  return !snapshot.is_a_template;
                })]);

              case 21:
                _ref63 = _context58.sent;
                _ref64 = (0, _slicedToArray3.default)(_ref63, 2);
                snapshot = _ref64[1];
                return _context58.abrupt('return', snapshot);

              case 25:
              case 'end':
                return _context58.stop();
            }
          }
        }, _callee42, this, [[2, 11]]);
      }));

      function _snapshotVm(_x93) {
        return _ref62.apply(this, arguments);
      }

      return _snapshotVm;
    }()
  }, {
    key: 'snapshotVm',
    value: function () {
      var _ref65 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee43(vmId) {
        var nameLabel = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
        return _regenerator2.default.wrap(function _callee43$(_context59) {
          while (1) {
            switch (_context59.prev = _context59.next) {
              case 0:
                return _context59.abrupt('return', /* await */this._snapshotVm(this.getObject(vmId), nameLabel));

              case 1:
              case 'end':
                return _context59.stop();
            }
          }
        }, _callee43, this);
      }));

      function snapshotVm(_x95) {
        return _ref65.apply(this, arguments);
      }

      return snapshotVm;
    }()
  }, {
    key: 'setVcpuWeight',
    value: function () {
      var _ref66 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee44(vmId, weight) {
        var vm;
        return _regenerator2.default.wrap(function _callee44$(_context60) {
          while (1) {
            switch (_context60.prev = _context60.next) {
              case 0:
                weight = weight || null; // Take all falsy values as a removal (0 included)
                vm = this.getObject(vmId);
                _context60.next = 4;
                return this._updateObjectMapProperty(vm, 'VCPUs_params', { weight });

              case 4:
              case 'end':
                return _context60.stop();
            }
          }
        }, _callee44, this);
      }));

      function setVcpuWeight(_x97, _x98) {
        return _ref66.apply(this, arguments);
      }

      return setVcpuWeight;
    }()
  }, {
    key: '_startVm',
    value: function _startVm(vm) {
      (0, _utils2.debug)(`Starting VM ${vm.name_label}`);

      return this.call('VM.start', vm.$ref, false, // Start paused?
      false // Skip pre-boot checks?
      );
    }
  }, {
    key: 'startVm',
    value: function () {
      var _ref67 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee45(vmId) {
        return _regenerator2.default.wrap(function _callee45$(_context61) {
          while (1) {
            switch (_context61.prev = _context61.next) {
              case 0:
                _context61.prev = 0;
                _context61.next = 3;
                return this._startVm(this.getObject(vmId));

              case 3:
                _context61.next = 10;
                break;

              case 5:
                _context61.prev = 5;
                _context61.t0 = _context61['catch'](0);

                if (!(_context61.t0.code === 'OPERATION_BLOCKED')) {
                  _context61.next = 9;
                  break;
                }

                throw (0, _apiErrors.forbiddenOperation)('Start', _context61.t0.params[1]);

              case 9:
                throw _context61.t0;

              case 10:
              case 'end':
                return _context61.stop();
            }
          }
        }, _callee45, this, [[0, 5]]);
      }));

      function startVm(_x99) {
        return _ref67.apply(this, arguments);
      }

      return startVm;
    }()
  }, {
    key: 'startVmOnCd',
    value: function () {
      var _ref68 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee46(vmId) {
        var _this16 = this;

        var vm, order, templateNameLabel, template, bootloader, bootables, promises, cdDrive, _context62;

        return _regenerator2.default.wrap(function _callee46$(_context64) {
          while (1) {
            switch (_context64.prev = _context64.next) {
              case 0:
                vm = this.getObject(vmId);

                if (!(0, _utils2.isVmHvm)(vm)) {
                  _context64.next = 14;
                  break;
                }

                order = vm.HVM_boot_params.order;
                _context64.next = 5;
                return this._updateObjectMapProperty(vm, 'HVM_boot_params', {
                  order: 'd'
                });

              case 5:
                _context64.prev = 5;
                _context64.next = 8;
                return this._startVm(vm);

              case 8:
                _context64.prev = 8;
                _context64.next = 11;
                return this._updateObjectMapProperty(vm, 'HVM_boot_params', {
                  order
                });

              case 11:
                return _context64.finish(8);

              case 12:
                _context64.next = 31;
                break;

              case 14:
                // Find the original template by name (*sigh*).
                templateNameLabel = vm.other_config['base_template_name'];
                template = templateNameLabel && (0, _find3.default)(this.objects.all, function (obj) {
                  return obj.$type === 'vm' && obj.is_a_template && obj.name_label === templateNameLabel;
                });
                bootloader = vm.PV_bootloader;
                bootables = [];
                _context64.prev = 18;
                promises = [];
                cdDrive = this._getVmCdDrive(vm);

                (0, _utils.forEach)(vm.$VBDs, function (vbd) {
                  promises.push(_this16._setObjectProperties(vbd, {
                    bootable: vbd === cdDrive
                  }));

                  bootables.push([vbd, Boolean(vbd.bootable)]);
                });

                promises.push(this._setObjectProperties(vm, {
                  PV_bootloader: 'eliloader'
                }), this._updateObjectMapProperty(vm, 'other_config', {
                  'install-distro': template && template.other_config['install-distro'],
                  'install-repository': 'cdrom'
                }));

                _context64.next = 25;
                return _promise3.default.all(promises);

              case 25:
                _context64.next = 27;
                return this._startVm(vm);

              case 27:
                _context64.prev = 27;

                (_context62 = this._setObjectProperties(vm, {
                  PV_bootloader: bootloader
                }), _utils.pCatch).call(_context62, _utils.noop);

                (0, _utils.forEach)(bootables, function (_ref69) {
                  var _context63;

                  var _ref70 = (0, _slicedToArray3.default)(_ref69, 2),
                      vbd = _ref70[0],
                      bootable = _ref70[1];

                  (_context63 = _this16._setObjectProperties(vbd, { bootable }), _utils.pCatch).call(_context63, _utils.noop);
                });
                return _context64.finish(27);

              case 31:
              case 'end':
                return _context64.stop();
            }
          }
        }, _callee46, this, [[5,, 8, 12], [18,, 27, 31]]);
      }));

      function startVmOnCd(_x100) {
        return _ref68.apply(this, arguments);
      }

      return startVmOnCd;
    }()

    // vm_operations: http://xapi-project.github.io/xen-api/classes/vm.html

  }, {
    key: 'addForbiddenOperationToVm',
    value: function () {
      var _ref71 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee47(vmId, operation, reason) {
        return _regenerator2.default.wrap(function _callee47$(_context65) {
          while (1) {
            switch (_context65.prev = _context65.next) {
              case 0:
                _context65.next = 2;
                return this.call('VM.add_to_blocked_operations', this.getObject(vmId).$ref, operation, `[XO] ${reason}`);

              case 2:
              case 'end':
                return _context65.stop();
            }
          }
        }, _callee47, this);
      }));

      function addForbiddenOperationToVm(_x101, _x102, _x103) {
        return _ref71.apply(this, arguments);
      }

      return addForbiddenOperationToVm;
    }()
  }, {
    key: 'removeForbiddenOperationFromVm',
    value: function () {
      var _ref72 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee48(vmId, operation) {
        return _regenerator2.default.wrap(function _callee48$(_context66) {
          while (1) {
            switch (_context66.prev = _context66.next) {
              case 0:
                _context66.next = 2;
                return this.call('VM.remove_from_blocked_operations', this.getObject(vmId).$ref, operation);

              case 2:
              case 'end':
                return _context66.stop();
            }
          }
        }, _callee48, this);
      }));

      function removeForbiddenOperationFromVm(_x104, _x105) {
        return _ref72.apply(this, arguments);
      }

      return removeForbiddenOperationFromVm;
    }()

    // =================================================================

  }, {
    key: '_createVbd',
    value: function () {
      var _ref73 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee49(vm, vdi) {
        var _ref74 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
            _ref74$bootable = _ref74.bootable,
            bootable = _ref74$bootable === undefined ? false : _ref74$bootable,
            _ref74$empty = _ref74.empty,
            empty = _ref74$empty === undefined ? !vdi : _ref74$empty,
            _ref74$type = _ref74.type,
            type = _ref74$type === undefined ? 'Disk' : _ref74$type,
            _ref74$unpluggable = _ref74.unpluggable,
            unpluggable = _ref74$unpluggable === undefined ? false : _ref74$unpluggable,
            _ref74$userdevice = _ref74.userdevice,
            userdevice = _ref74$userdevice === undefined ? undefined : _ref74$userdevice,
            _ref74$mode = _ref74.mode,
            mode = _ref74$mode === undefined ? type === 'Disk' ? 'RW' : 'RO' : _ref74$mode,
            _ref74$position = _ref74.position,
            position = _ref74$position === undefined ? userdevice : _ref74$position,
            _ref74$readOnly = _ref74.readOnly,
            readOnly = _ref74$readOnly === undefined ? mode === 'RO' : _ref74$readOnly;

        var allowed, length, vbdRef;
        return _regenerator2.default.wrap(function _callee49$(_context67) {
          while (1) {
            switch (_context67.prev = _context67.next) {
              case 0:
                (0, _utils2.debug)(`Creating VBD for VDI ${vdi.name_label} on VM ${vm.name_label}`);

                if (!(position == null)) {
                  _context67.next = 9;
                  break;
                }

                _context67.next = 4;
                return this.call('VM.get_allowed_VBD_devices', vm.$ref);

              case 4:
                allowed = _context67.sent;
                length = allowed.length;

                if (length) {
                  _context67.next = 8;
                  break;
                }

                throw new Error('no allowed VBD positions (devices)');

              case 8:

                if (type === 'CD') {
                  // Choose position 3 if allowed.
                  position = (0, _includes3.default)(allowed, '3') ? '3' : allowed[0];
                } else {
                  position = allowed[0];

                  // Avoid position 3 if possible.
                  if (position === '3' && length > 1) {
                    position = allowed[1];
                  }
                }

              case 9:
                _context67.next = 11;
                return this.call('VBD.create', {
                  bootable: Boolean(bootable),
                  empty: Boolean(empty),
                  mode: readOnly ? 'RO' : 'RW',
                  other_config: {},
                  qos_algorithm_params: {},
                  qos_algorithm_type: '',
                  type,
                  unpluggable: Boolean(unpluggable),
                  userdevice: String(position),
                  VDI: vdi.$ref,
                  VM: vm.$ref
                });

              case 11:
                vbdRef = _context67.sent;

                if (!(0, _utils2.isVmRunning)(vm)) {
                  _context67.next = 15;
                  break;
                }

                _context67.next = 15;
                return this.call('VBD.plug', vbdRef);

              case 15:
                return _context67.abrupt('return', vbdRef);

              case 16:
              case 'end':
                return _context67.stop();
            }
          }
        }, _callee49, this);
      }));

      function _createVbd(_x106, _x107) {
        return _ref73.apply(this, arguments);
      }

      return _createVbd;
    }()
  }, {
    key: '_cloneVdi',
    value: function _cloneVdi(vdi) {
      (0, _utils2.debug)(`Cloning VDI ${vdi.name_label}`);

      return this.call('VDI.clone', vdi.$ref);
    }
  }, {
    key: '_createVdi',
    value: function () {
      var _ref75 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee50(size) {
        var _ref76 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            _ref76$name_descripti = _ref76.name_description,
            name_description = _ref76$name_descripti === undefined ? undefined : _ref76$name_descripti,
            _ref76$name_label = _ref76.name_label,
            name_label = _ref76$name_label === undefined ? '' : _ref76$name_label,
            _ref76$other_config = _ref76.other_config,
            other_config = _ref76$other_config === undefined ? {} : _ref76$other_config,
            _ref76$read_only = _ref76.read_only,
            read_only = _ref76$read_only === undefined ? false : _ref76$read_only,
            _ref76$sharable = _ref76.sharable,
            sharable = _ref76$sharable === undefined ? false : _ref76$sharable,
            _ref76$sr = _ref76.sr,
            sr = _ref76$sr === undefined ? this.pool.default_SR : _ref76$sr,
            _ref76$tags = _ref76.tags,
            tags = _ref76$tags === undefined ? [] : _ref76$tags,
            _ref76$type = _ref76.type,
            type = _ref76$type === undefined ? 'user' : _ref76$type,
            _ref76$xenstore_data = _ref76.xenstore_data,
            xenstore_data = _ref76$xenstore_data === undefined ? undefined : _ref76$xenstore_data;

        var data;
        return _regenerator2.default.wrap(function _callee50$(_context68) {
          while (1) {
            switch (_context68.prev = _context68.next) {
              case 0:
                sr = this.getObject(sr);
                (0, _utils2.debug)(`Creating VDI ${name_label} on ${sr.name_label}`);

                sharable = Boolean(sharable);
                read_only = Boolean(read_only);

                data = {
                  name_description,
                  name_label,
                  other_config,
                  read_only,
                  sharable,
                  tags,
                  type,
                  virtual_size: String(size),
                  SR: sr.$ref
                };


                if (xenstore_data) {
                  data.xenstore_data = xenstore_data;
                }

                return _context68.abrupt('return', /* await */this.call('VDI.create', data));

              case 7:
              case 'end':
                return _context68.stop();
            }
          }
        }, _callee50, this);
      }));

      function _createVdi(_x109) {
        return _ref75.apply(this, arguments);
      }

      return _createVdi;
    }()
  }, {
    key: 'moveVdi',
    value: function () {
      var _ref77 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee52(vdiId, srId) {
        var _this17 = this;

        var vdi, sr, newVdiref, newVdi;
        return _regenerator2.default.wrap(function _callee52$(_context70) {
          while (1) {
            switch (_context70.prev = _context70.next) {
              case 0:
                vdi = this.getObject(vdiId);
                sr = this.getObject(srId);


                (0, _utils2.debug)(`Moving VDI ${vdi.name_label} from vdi.$SR.name_label to ${sr.name_label}`);
                _context70.prev = 3;
                _context70.next = 6;
                return this.call('VDI.pool_migrate', vdi.$ref, sr.$ref, {});

              case 6:
                _context70.next = 20;
                break;

              case 8:
                _context70.prev = 8;
                _context70.t0 = _context70['catch'](3);

                if (!(_context70.t0.code !== 'VDI_NEEDS_VM_FOR_MIGRATE')) {
                  _context70.next = 12;
                  break;
                }

                throw _context70.t0;

              case 12:
                _context70.next = 14;
                return this.call('VDI.copy', vdi.$ref, sr.$ref);

              case 14:
                newVdiref = _context70.sent;
                _context70.next = 17;
                return this._getOrWaitObject(newVdiref);

              case 17:
                newVdi = _context70.sent;
                _context70.next = 20;
                return _promise3.default.all((0, _utils.mapToArray)(vdi.$VBDs, function () {
                  var _ref78 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee51(vbd) {
                    return _regenerator2.default.wrap(function _callee51$(_context69) {
                      while (1) {
                        switch (_context69.prev = _context69.next) {
                          case 0:
                            _context69.next = 2;
                            return _this17.call('VBD.destroy', vbd.$ref);

                          case 2:
                            _context69.next = 4;
                            return _this17._createVbd(vbd.$VM, newVdi, {
                              bootable: vbd.bootable,
                              position: vbd.userdevice,
                              type: vbd.type,
                              readOnly: vbd.mode === 'RO'
                            });

                          case 4:
                            _context69.next = 6;
                            return _this17._deleteVdi(vdi);

                          case 6:
                          case 'end':
                            return _context69.stop();
                        }
                      }
                    }, _callee51, _this17);
                  }));

                  return function (_x113) {
                    return _ref78.apply(this, arguments);
                  };
                }()));

              case 20:
              case 'end':
                return _context70.stop();
            }
          }
        }, _callee52, this, [[3, 8]]);
      }));

      function moveVdi(_x111, _x112) {
        return _ref77.apply(this, arguments);
      }

      return moveVdi;
    }()

    // TODO: check whether the VDI is attached.

  }, {
    key: '_deleteVdi',
    value: function () {
      var _ref79 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee53(vdi) {
        return _regenerator2.default.wrap(function _callee53$(_context71) {
          while (1) {
            switch (_context71.prev = _context71.next) {
              case 0:
                (0, _utils2.debug)(`Deleting VDI ${vdi.name_label}`);

                _context71.next = 3;
                return this.call('VDI.destroy', vdi.$ref);

              case 3:
              case 'end':
                return _context71.stop();
            }
          }
        }, _callee53, this);
      }));

      function _deleteVdi(_x114) {
        return _ref79.apply(this, arguments);
      }

      return _deleteVdi;
    }()
  }, {
    key: '_resizeVdi',
    value: function () {
      var _ref80 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee54(vdi, size) {
        return _regenerator2.default.wrap(function _callee54$(_context72) {
          while (1) {
            switch (_context72.prev = _context72.next) {
              case 0:
                (0, _utils2.debug)(`Resizing VDI ${vdi.name_label} from ${vdi.virtual_size} to ${size}`);

                _context72.prev = 1;
                _context72.next = 4;
                return this.call('VDI.resize_online', vdi.$ref, String(size));

              case 4:
                _context72.next = 12;
                break;

              case 6:
                _context72.prev = 6;
                _context72.t0 = _context72['catch'](1);

                if (!(_context72.t0.code !== 'SR_OPERATION_NOT_SUPPORTED')) {
                  _context72.next = 10;
                  break;
                }

                throw _context72.t0;

              case 10:
                _context72.next = 12;
                return this.call('VDI.resize', vdi.$ref, String(size));

              case 12:
              case 'end':
                return _context72.stop();
            }
          }
        }, _callee54, this, [[1, 6]]);
      }));

      function _resizeVdi(_x115, _x116) {
        return _ref80.apply(this, arguments);
      }

      return _resizeVdi;
    }()
  }, {
    key: '_getVmCdDrive',
    value: function _getVmCdDrive(vm) {
      var _iteratorNormalCompletion5 = true;
      var _didIteratorError5 = false;
      var _iteratorError5 = undefined;

      try {
        for (var _iterator5 = (0, _getIterator3.default)(vm.$VBDs), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
          var vbd = _step5.value;

          if (vbd.type === 'CD') {
            return vbd;
          }
        }
      } catch (err) {
        _didIteratorError5 = true;
        _iteratorError5 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion5 && _iterator5.return) {
            _iterator5.return();
          }
        } finally {
          if (_didIteratorError5) {
            throw _iteratorError5;
          }
        }
      }
    }
  }, {
    key: '_ejectCdFromVm',
    value: function () {
      var _ref81 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee55(vm) {
        var cdDrive;
        return _regenerator2.default.wrap(function _callee55$(_context73) {
          while (1) {
            switch (_context73.prev = _context73.next) {
              case 0:
                cdDrive = this._getVmCdDrive(vm);

                if (!cdDrive) {
                  _context73.next = 4;
                  break;
                }

                _context73.next = 4;
                return this.call('VBD.eject', cdDrive.$ref);

              case 4:
              case 'end':
                return _context73.stop();
            }
          }
        }, _callee55, this);
      }));

      function _ejectCdFromVm(_x117) {
        return _ref81.apply(this, arguments);
      }

      return _ejectCdFromVm;
    }()
  }, {
    key: '_insertCdIntoVm',
    value: function () {
      var _ref82 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee56(cd, vm) {
        var _ref83 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
            _ref83$bootable = _ref83.bootable,
            bootable = _ref83$bootable === undefined ? false : _ref83$bootable,
            _ref83$force = _ref83.force,
            force = _ref83$force === undefined ? false : _ref83$force;

        var cdDrive, _context74;

        return _regenerator2.default.wrap(function _callee56$(_context75) {
          while (1) {
            switch (_context75.prev = _context75.next) {
              case 0:
                _context75.next = 2;
                return this._getVmCdDrive(vm);

              case 2:
                cdDrive = _context75.sent;

                if (!cdDrive) {
                  _context75.next = 22;
                  break;
                }

                _context75.prev = 4;
                _context75.next = 7;
                return this.call('VBD.insert', cdDrive.$ref, cd.$ref);

              case 7:
                _context75.next = 17;
                break;

              case 9:
                _context75.prev = 9;
                _context75.t0 = _context75['catch'](4);

                if (!(!force || _context75.t0.code !== 'VBD_NOT_EMPTY')) {
                  _context75.next = 13;
                  break;
                }

                throw _context75.t0;

              case 13:
                _context75.next = 15;
                return (_context74 = this.call('VBD.eject', cdDrive.$ref), _utils.pCatch).call(_context74, _utils.noop);

              case 15:
                _context75.next = 17;
                return this.call('VBD.insert', cdDrive.$ref, cd.$ref);

              case 17:
                if (!(bootable !== Boolean(cdDrive.bootable))) {
                  _context75.next = 20;
                  break;
                }

                _context75.next = 20;
                return this._setObjectProperties(cdDrive, { bootable });

              case 20:
                _context75.next = 24;
                break;

              case 22:
                _context75.next = 24;
                return this._createVbd(vm, cd, {
                  bootable,
                  type: 'CD'
                });

              case 24:
              case 'end':
                return _context75.stop();
            }
          }
        }, _callee56, this, [[4, 9]]);
      }));

      function _insertCdIntoVm(_x118, _x119) {
        return _ref82.apply(this, arguments);
      }

      return _insertCdIntoVm;
    }()
  }, {
    key: 'attachVdiToVm',
    value: function () {
      var _ref84 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee57(vdiId, vmId) {
        var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
        return _regenerator2.default.wrap(function _callee57$(_context76) {
          while (1) {
            switch (_context76.prev = _context76.next) {
              case 0:
                _context76.next = 2;
                return this._createVbd(this.getObject(vmId), this.getObject(vdiId), opts);

              case 2:
              case 'end':
                return _context76.stop();
            }
          }
        }, _callee57, this);
      }));

      function attachVdiToVm(_x121, _x122) {
        return _ref84.apply(this, arguments);
      }

      return attachVdiToVm;
    }()
  }, {
    key: 'connectVbd',
    value: function () {
      var _ref85 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee58(vbdId) {
        return _regenerator2.default.wrap(function _callee58$(_context77) {
          while (1) {
            switch (_context77.prev = _context77.next) {
              case 0:
                _context77.next = 2;
                return this.call('VBD.plug', vbdId);

              case 2:
              case 'end':
                return _context77.stop();
            }
          }
        }, _callee58, this);
      }));

      function connectVbd(_x124) {
        return _ref85.apply(this, arguments);
      }

      return connectVbd;
    }()
  }, {
    key: '_disconnectVbd',
    value: function () {
      var _ref86 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee59(vbd) {
        return _regenerator2.default.wrap(function _callee59$(_context78) {
          while (1) {
            switch (_context78.prev = _context78.next) {
              case 0:
                _context78.prev = 0;
                _context78.next = 3;
                return this.call('VBD.unplug_force', vbd.$ref);

              case 3:
                _context78.next = 11;
                break;

              case 5:
                _context78.prev = 5;
                _context78.t0 = _context78['catch'](0);

                if (!(_context78.t0.code === 'VBD_NOT_UNPLUGGABLE')) {
                  _context78.next = 11;
                  break;
                }

                _context78.next = 10;
                return this.call('VBD.set_unpluggable', vbd.$ref, true);

              case 10:
                return _context78.abrupt('return', this.call('VBD.unplug_force', vbd.$ref));

              case 11:
              case 'end':
                return _context78.stop();
            }
          }
        }, _callee59, this, [[0, 5]]);
      }));

      function _disconnectVbd(_x125) {
        return _ref86.apply(this, arguments);
      }

      return _disconnectVbd;
    }()
  }, {
    key: 'disconnectVbd',
    value: function () {
      var _ref87 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee60(vbdId) {
        return _regenerator2.default.wrap(function _callee60$(_context79) {
          while (1) {
            switch (_context79.prev = _context79.next) {
              case 0:
                _context79.next = 2;
                return this._disconnectVbd(this.getObject(vbdId));

              case 2:
              case 'end':
                return _context79.stop();
            }
          }
        }, _callee60, this);
      }));

      function disconnectVbd(_x126) {
        return _ref87.apply(this, arguments);
      }

      return disconnectVbd;
    }()
  }, {
    key: '_deleteVbd',
    value: function () {
      var _ref88 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee61(vbd) {
        var _context80;

        return _regenerator2.default.wrap(function _callee61$(_context81) {
          while (1) {
            switch (_context81.prev = _context81.next) {
              case 0:
                _context81.next = 2;
                return (_context80 = this._disconnectVbd(vbd), _utils.pCatch).call(_context80, _utils.noop);

              case 2:
                _context81.next = 4;
                return this.call('VBD.destroy', vbd.$ref);

              case 4:
              case 'end':
                return _context81.stop();
            }
          }
        }, _callee61, this);
      }));

      function _deleteVbd(_x127) {
        return _ref88.apply(this, arguments);
      }

      return _deleteVbd;
    }()

    // TODO: remove when no longer used.

  }, {
    key: 'destroyVbdsFromVm',
    value: function () {
      var _ref89 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee63(vmId) {
        var _this18 = this;

        return _regenerator2.default.wrap(function _callee63$(_context84) {
          while (1) {
            switch (_context84.prev = _context84.next) {
              case 0:
                _context84.next = 2;
                return _promise3.default.all((0, _utils.mapToArray)(this.getObject(vmId).$VBDs, function () {
                  var _ref90 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee62(vbd) {
                    var _context82;

                    return _regenerator2.default.wrap(function _callee62$(_context83) {
                      while (1) {
                        switch (_context83.prev = _context83.next) {
                          case 0:
                            _context83.next = 2;
                            return (_context82 = _this18.disconnectVbd(vbd.$ref), _utils.pCatch).call(_context82, _utils.noop);

                          case 2:
                            return _context83.abrupt('return', _this18.call('VBD.destroy', vbd.$ref));

                          case 3:
                          case 'end':
                            return _context83.stop();
                        }
                      }
                    }, _callee62, _this18);
                  }));

                  return function (_x129) {
                    return _ref90.apply(this, arguments);
                  };
                }()));

              case 2:
              case 'end':
                return _context84.stop();
            }
          }
        }, _callee63, this);
      }));

      function destroyVbdsFromVm(_x128) {
        return _ref89.apply(this, arguments);
      }

      return destroyVbdsFromVm;
    }()
  }, {
    key: 'createVdi',
    value: function () {
      var _ref91 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee64(size, opts) {
        return _regenerator2.default.wrap(function _callee64$(_context85) {
          while (1) {
            switch (_context85.prev = _context85.next) {
              case 0:
                _context85.t0 = this;
                _context85.next = 3;
                return this._createVdi(size, opts);

              case 3:
                _context85.t1 = _context85.sent;
                return _context85.abrupt('return', _context85.t0._getOrWaitObject.call(_context85.t0, _context85.t1));

              case 5:
              case 'end':
                return _context85.stop();
            }
          }
        }, _callee64, this);
      }));

      function createVdi(_x130, _x131) {
        return _ref91.apply(this, arguments);
      }

      return createVdi;
    }()
  }, {
    key: 'deleteVdi',
    value: function () {
      var _ref92 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee65(vdiId) {
        return _regenerator2.default.wrap(function _callee65$(_context86) {
          while (1) {
            switch (_context86.prev = _context86.next) {
              case 0:
                _context86.next = 2;
                return this._deleteVdi(this.getObject(vdiId));

              case 2:
              case 'end':
                return _context86.stop();
            }
          }
        }, _callee65, this);
      }));

      function deleteVdi(_x132) {
        return _ref92.apply(this, arguments);
      }

      return deleteVdi;
    }()
  }, {
    key: 'resizeVdi',
    value: function () {
      var _ref93 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee66(vdiId, size) {
        return _regenerator2.default.wrap(function _callee66$(_context87) {
          while (1) {
            switch (_context87.prev = _context87.next) {
              case 0:
                _context87.next = 2;
                return this._resizeVdi(this.getObject(vdiId), size);

              case 2:
              case 'end':
                return _context87.stop();
            }
          }
        }, _callee66, this);
      }));

      function resizeVdi(_x133, _x134) {
        return _ref93.apply(this, arguments);
      }

      return resizeVdi;
    }()
  }, {
    key: 'ejectCdFromVm',
    value: function () {
      var _ref94 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee67(vmId) {
        return _regenerator2.default.wrap(function _callee67$(_context88) {
          while (1) {
            switch (_context88.prev = _context88.next) {
              case 0:
                _context88.next = 2;
                return this._ejectCdFromVm(this.getObject(vmId));

              case 2:
              case 'end':
                return _context88.stop();
            }
          }
        }, _callee67, this);
      }));

      function ejectCdFromVm(_x135) {
        return _ref94.apply(this, arguments);
      }

      return ejectCdFromVm;
    }()
  }, {
    key: 'insertCdIntoVm',
    value: function () {
      var _ref95 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee68(cdId, vmId) {
        var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
        return _regenerator2.default.wrap(function _callee68$(_context89) {
          while (1) {
            switch (_context89.prev = _context89.next) {
              case 0:
                _context89.next = 2;
                return this._insertCdIntoVm(this.getObject(cdId), this.getObject(vmId), opts);

              case 2:
              case 'end':
                return _context89.stop();
            }
          }
        }, _callee68, this);
      }));

      function insertCdIntoVm(_x136, _x137) {
        return _ref95.apply(this, arguments);
      }

      return insertCdIntoVm;
    }()

    // -----------------------------------------------------------------

  }, {
    key: 'snapshotVdi',
    value: function () {
      var _ref96 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee69(vdiId, nameLabel) {
        var vdi, snap;
        return _regenerator2.default.wrap(function _callee69$(_context90) {
          while (1) {
            switch (_context90.prev = _context90.next) {
              case 0:
                vdi = this.getObject(vdiId);
                _context90.t0 = this;
                _context90.next = 4;
                return this.call('VDI.snapshot', vdi.$ref);

              case 4:
                _context90.t1 = _context90.sent;
                _context90.next = 7;
                return _context90.t0._getOrWaitObject.call(_context90.t0, _context90.t1);

              case 7:
                snap = _context90.sent;

                if (!nameLabel) {
                  _context90.next = 11;
                  break;
                }

                _context90.next = 11;
                return this.call('VDI.set_name_label', snap.$ref, nameLabel);

              case 11:
                return _context90.abrupt('return', snap);

              case 12:
              case 'end':
                return _context90.stop();
            }
          }
        }, _callee69, this);
      }));

      function snapshotVdi(_x139, _x140) {
        return _ref96.apply(this, arguments);
      }

      return snapshotVdi;
    }()
  }, {
    key: '_exportVdi',
    value: function () {
      var _ref97 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee70($cancelToken, vdi, base) {
        var format = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : VDI_FORMAT_VHD;
        var host, taskRef, query, task;
        return _regenerator2.default.wrap(function _callee70$(_context91) {
          while (1) {
            switch (_context91.prev = _context91.next) {
              case 0:
                host = vdi.$SR.$PBDs[0].$host;
                _context91.next = 3;
                return this._createTask('VDI Export', vdi.name_label);

              case 3:
                taskRef = _context91.sent;
                query = {
                  format,
                  session_id: this.sessionId,
                  task_id: taskRef,
                  vdi: vdi.$ref
                };

                if (base) {
                  query.base = base.$ref;
                }

                (0, _utils2.debug)(`exporting VDI ${vdi.name_label}${base ? ` (from base ${vdi.name_label})` : ''}`);

                task = this._watchTask(taskRef);
                return _context91.abrupt('return', (0, _httpRequest2.default)($cancelToken, {
                  hostname: host.address,
                  path: '/export_raw_vdi/',
                  protocol: 'https',
                  query,
                  rejectUnauthorized: false
                }).then(function (response) {
                  response.task = task;

                  return response;
                }));

              case 9:
              case 'end':
                return _context91.stop();
            }
          }
        }, _callee70, this);
      }));

      function _exportVdi(_x141, _x142, _x143) {
        return _ref97.apply(this, arguments);
      }

      return _exportVdi;
    }()

    // Returns a stream to the exported VDI.

  }, {
    key: 'exportVdi',
    value: function exportVdi(vdiId) {
      var _ref98 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          baseId = _ref98.baseId,
          format = _ref98.format;

      return this._exportVdi(this.getObject(vdiId), baseId && this.getObject(baseId), format);
    }

    // -----------------------------------------------------------------

  }, {
    key: '_importVdiContent',
    value: function () {
      var _ref99 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee71(vdi, stream) {
        var format = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : VDI_FORMAT_VHD;
        var taskRef, query, pbd, task;
        return _regenerator2.default.wrap(function _callee71$(_context92) {
          while (1) {
            switch (_context92.prev = _context92.next) {
              case 0:
                _context92.next = 2;
                return this._createTask('VDI Content Import', vdi.name_label);

              case 2:
                taskRef = _context92.sent;
                query = {
                  session_id: this.sessionId,
                  task_id: taskRef,
                  format,
                  vdi: vdi.$ref
                };
                pbd = (0, _find3.default)(vdi.$SR.$PBDs, 'currently_attached');

                if (pbd) {
                  _context92.next = 7;
                  break;
                }

                throw new Error('no valid PBDs found');

              case 7:
                task = this._watchTask(taskRef);
                _context92.next = 10;
                return _promise3.default.all([stream.checksumVerified, task, (0, _utils2.put)(stream, {
                  hostname: pbd.$host.address,
                  path: '/import_raw_vdi/',
                  protocol: 'https',
                  query,
                  rejectUnauthorized: false
                }, task)]);

              case 10:
              case 'end':
                return _context92.stop();
            }
          }
        }, _callee71, this);
      }));

      function _importVdiContent(_x146, _x147) {
        return _ref99.apply(this, arguments);
      }

      return _importVdiContent;
    }()
  }, {
    key: 'importVdiContent',
    value: function importVdiContent(vdiId, stream) {
      var _ref100 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
          format = _ref100.format;

      return this._importVdiContent(this.getObject(vdiId), stream, format);
    }

    // =================================================================

  }, {
    key: '_createVif',
    value: function () {
      var _ref101 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee72(vm, network) {
        var _ref102 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
            _ref102$mac = _ref102.mac,
            mac = _ref102$mac === undefined ? '' : _ref102$mac,
            _ref102$position = _ref102.position,
            position = _ref102$position === undefined ? undefined : _ref102$position,
            _ref102$currently_att = _ref102.currently_attached,
            currently_attached = _ref102$currently_att === undefined ? true : _ref102$currently_att,
            _ref102$device = _ref102.device,
            device = _ref102$device === undefined ? position != null ? String(position) : undefined : _ref102$device,
            _ref102$ipv4_allowed = _ref102.ipv4_allowed,
            ipv4_allowed = _ref102$ipv4_allowed === undefined ? undefined : _ref102$ipv4_allowed,
            _ref102$ipv6_allowed = _ref102.ipv6_allowed,
            ipv6_allowed = _ref102$ipv6_allowed === undefined ? undefined : _ref102$ipv6_allowed,
            _ref102$locking_mode = _ref102.locking_mode,
            locking_mode = _ref102$locking_mode === undefined ? undefined : _ref102$locking_mode,
            _ref102$MAC = _ref102.MAC,
            MAC = _ref102$MAC === undefined ? mac : _ref102$MAC,
            _ref102$other_config = _ref102.other_config,
            other_config = _ref102$other_config === undefined ? {} : _ref102$other_config,
            _ref102$qos_algorithm = _ref102.qos_algorithm_params,
            qos_algorithm_params = _ref102$qos_algorithm === undefined ? {} : _ref102$qos_algorithm,
            _ref102$qos_algorithm2 = _ref102.qos_algorithm_type,
            qos_algorithm_type = _ref102$qos_algorithm2 === undefined ? '' : _ref102$qos_algorithm2;

        var vifRef;
        return _regenerator2.default.wrap(function _callee72$(_context93) {
          while (1) {
            switch (_context93.prev = _context93.next) {
              case 0:
                (0, _utils2.debug)(`Creating VIF for VM ${vm.name_label} on network ${network.name_label}`);

                if (!(device == null)) {
                  _context93.next = 5;
                  break;
                }

                _context93.next = 4;
                return this.call('VM.get_allowed_VIF_devices', vm.$ref);

              case 4:
                device = _context93.sent[0];

              case 5:
                _context93.next = 7;
                return this.call('VIF.create', (0, _utils2.filterUndefineds)({
                  device,
                  ipv4_allowed,
                  ipv6_allowed,
                  locking_mode,
                  MAC,
                  MTU: (0, _utils2.asInteger)(network.MTU),
                  network: network.$ref,
                  other_config,
                  qos_algorithm_params,
                  qos_algorithm_type,
                  VM: vm.$ref
                }));

              case 7:
                vifRef = _context93.sent;

                if (!(currently_attached && (0, _utils2.isVmRunning)(vm))) {
                  _context93.next = 11;
                  break;
                }

                _context93.next = 11;
                return this.call('VIF.plug', vifRef);

              case 11:
                return _context93.abrupt('return', vifRef);

              case 12:
              case 'end':
                return _context93.stop();
            }
          }
        }, _callee72, this);
      }));

      function _createVif(_x150, _x151) {
        return _ref101.apply(this, arguments);
      }

      return _createVif;
    }()
  }, {
    key: 'createVif',
    value: function () {
      var _ref103 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee73(vmId, networkId) {
        var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
        return _regenerator2.default.wrap(function _callee73$(_context94) {
          while (1) {
            switch (_context94.prev = _context94.next) {
              case 0:
                _context94.t0 = this;
                _context94.next = 3;
                return this._createVif(this.getObject(vmId), this.getObject(networkId), opts);

              case 3:
                _context94.t1 = _context94.sent;
                return _context94.abrupt('return', _context94.t0._getOrWaitObject.call(_context94.t0, _context94.t1));

              case 5:
              case 'end':
                return _context94.stop();
            }
          }
        }, _callee73, this);
      }));

      function createVif(_x153, _x154) {
        return _ref103.apply(this, arguments);
      }

      return createVif;
    }()
  }, {
    key: 'createNetwork',
    value: function () {
      var _ref104 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee74(_ref105) {
        var name = _ref105.name,
            _ref105$description = _ref105.description,
            description = _ref105$description === undefined ? 'Created with Xen Orchestra' : _ref105$description,
            pifId = _ref105.pifId,
            mtu = _ref105.mtu,
            vlan = _ref105.vlan;
        var networkRef;
        return _regenerator2.default.wrap(function _callee74$(_context95) {
          while (1) {
            switch (_context95.prev = _context95.next) {
              case 0:
                _context95.next = 2;
                return this.call('network.create', {
                  name_label: name,
                  name_description: description,
                  MTU: (0, _utils2.asInteger)(mtu),
                  other_config: {}
                });

              case 2:
                networkRef = _context95.sent;

                if (!pifId) {
                  _context95.next = 6;
                  break;
                }

                _context95.next = 6;
                return this.call('pool.create_VLAN_from_PIF', this.getObject(pifId).$ref, networkRef, (0, _utils2.asInteger)(vlan));

              case 6:
                return _context95.abrupt('return', this._getOrWaitObject(networkRef));

              case 7:
              case 'end':
                return _context95.stop();
            }
          }
        }, _callee74, this);
      }));

      function createNetwork(_x156) {
        return _ref104.apply(this, arguments);
      }

      return createNetwork;
    }()
  }, {
    key: 'editPif',
    value: function () {
      var _ref106 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee75(pifId, _ref107) {
        var _this19 = this;

        var vlan = _ref107.vlan;
        var pif, physPif, pifs, wasAttached, vlans, newPifs;
        return _regenerator2.default.wrap(function _callee75$(_context97) {
          while (1) {
            switch (_context97.prev = _context97.next) {
              case 0:
                pif = this.getObject(pifId);
                physPif = (0, _find3.default)(this.objects.all, function (obj) {
                  return obj.$type === 'pif' && (obj.physical || !(0, _isEmpty3.default)(obj.bond_master_of)) && obj.$pool === pif.$pool && obj.device === pif.device;
                });

                if (physPif) {
                  _context97.next = 4;
                  break;
                }

                throw new Error('PIF not found');

              case 4:
                pifs = this.getObject(pif.network).$PIFs;
                wasAttached = {};

                (0, _utils.forEach)(pifs, function (pif) {
                  wasAttached[pif.host] = pif.currently_attached;
                });

                vlans = (0, _uniq3.default)((0, _utils.mapToArray)(pifs, function (pif) {
                  return pif.VLAN_master_of;
                }));
                _context97.next = 10;
                return _promise3.default.all((0, _utils.mapToArray)(vlans, function (vlan) {
                  return vlan !== _utils2.NULL_REF && _this19.call('VLAN.destroy', vlan);
                }));

              case 10:
                _context97.next = 12;
                return this.call('pool.create_VLAN_from_PIF', physPif.$ref, pif.network, (0, _utils2.asInteger)(vlan));

              case 12:
                newPifs = _context97.sent;
                _context97.next = 15;
                return _promise3.default.all((0, _utils.mapToArray)(newPifs, function (pifRef) {
                  var _context96;

                  return !wasAttached[_this19.getObject(pifRef).host] && (_context96 = _this19.call('PIF.unplug', pifRef), _utils.pCatch).call(_context96, _utils.noop);
                }));

              case 15:
              case 'end':
                return _context97.stop();
            }
          }
        }, _callee75, this);
      }));

      function editPif(_x157, _x158) {
        return _ref106.apply(this, arguments);
      }

      return editPif;
    }()
  }, {
    key: 'createBondedNetwork',
    value: function () {
      var _ref108 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee76(_ref109) {
        var _this20 = this;

        var bondMode = _ref109.bondMode,
            mac = _ref109.mac,
            pifIds = _ref109.pifIds,
            params = (0, _objectWithoutProperties3.default)(_ref109, ['bondMode', 'mac', 'pifIds']);
        var network;
        return _regenerator2.default.wrap(function _callee76$(_context98) {
          while (1) {
            switch (_context98.prev = _context98.next) {
              case 0:
                _context98.next = 2;
                return this.createNetwork(params);

              case 2:
                network = _context98.sent;
                _context98.next = 5;
                return this.call('Bond.create', network.$ref, (0, _utils.map)(pifIds, function (pifId) {
                  return _this20.getObject(pifId).$ref;
                }), mac, bondMode);

              case 5:
                return _context98.abrupt('return', network);

              case 6:
              case 'end':
                return _context98.stop();
            }
          }
        }, _callee76, this);
      }));

      function createBondedNetwork(_x159) {
        return _ref108.apply(this, arguments);
      }

      return createBondedNetwork;
    }()
  }, {
    key: 'deleteNetwork',
    value: function () {
      var _ref110 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee77(networkId) {
        var _this21 = this;

        var network, pifs, vlans, bonds;
        return _regenerator2.default.wrap(function _callee77$(_context99) {
          while (1) {
            switch (_context99.prev = _context99.next) {
              case 0:
                network = this.getObject(networkId);
                pifs = network.$PIFs;
                vlans = (0, _uniq3.default)((0, _utils.mapToArray)(pifs, function (pif) {
                  return pif.VLAN_master_of;
                }));
                _context99.next = 5;
                return _promise3.default.all((0, _utils.mapToArray)(vlans, function (vlan) {
                  return vlan !== _utils2.NULL_REF && _this21.call('VLAN.destroy', vlan);
                }));

              case 5:
                bonds = (0, _uniq3.default)((0, _flatten3.default)((0, _utils.mapToArray)(pifs, function (pif) {
                  return pif.bond_master_of;
                })));
                _context99.next = 8;
                return _promise3.default.all((0, _utils.mapToArray)(bonds, function (bond) {
                  return _this21.call('Bond.destroy', bond);
                }));

              case 8:
                _context99.next = 10;
                return this.call('network.destroy', network.$ref);

              case 10:
              case 'end':
                return _context99.stop();
            }
          }
        }, _callee77, this);
      }));

      function deleteNetwork(_x160) {
        return _ref110.apply(this, arguments);
      }

      return deleteNetwork;
    }()

    // =================================================================

  }, {
    key: '_doDockerAction',
    value: function () {
      var _ref111 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee78(vmId, action, containerId) {
        var vm, host;
        return _regenerator2.default.wrap(function _callee78$(_context100) {
          while (1) {
            switch (_context100.prev = _context100.next) {
              case 0:
                vm = this.getObject(vmId);
                host = vm.$resident_on || this.pool.$master;
                return _context100.abrupt('return', /* await */this.call('host.call_plugin', host.$ref, 'xscontainer', action, {
                  vmuuid: vm.uuid,
                  container: containerId
                }));

              case 3:
              case 'end':
                return _context100.stop();
            }
          }
        }, _callee78, this);
      }));

      function _doDockerAction(_x161, _x162, _x163) {
        return _ref111.apply(this, arguments);
      }

      return _doDockerAction;
    }()
  }, {
    key: 'registerDockerContainer',
    value: function () {
      var _ref112 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee79(vmId) {
        return _regenerator2.default.wrap(function _callee79$(_context101) {
          while (1) {
            switch (_context101.prev = _context101.next) {
              case 0:
                _context101.next = 2;
                return this._doDockerAction(vmId, 'register');

              case 2:
              case 'end':
                return _context101.stop();
            }
          }
        }, _callee79, this);
      }));

      function registerDockerContainer(_x164) {
        return _ref112.apply(this, arguments);
      }

      return registerDockerContainer;
    }()
  }, {
    key: 'deregisterDockerContainer',
    value: function () {
      var _ref113 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee80(vmId) {
        return _regenerator2.default.wrap(function _callee80$(_context102) {
          while (1) {
            switch (_context102.prev = _context102.next) {
              case 0:
                _context102.next = 2;
                return this._doDockerAction(vmId, 'deregister');

              case 2:
              case 'end':
                return _context102.stop();
            }
          }
        }, _callee80, this);
      }));

      function deregisterDockerContainer(_x165) {
        return _ref113.apply(this, arguments);
      }

      return deregisterDockerContainer;
    }()
  }, {
    key: 'startDockerContainer',
    value: function () {
      var _ref114 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee81(vmId, containerId) {
        return _regenerator2.default.wrap(function _callee81$(_context103) {
          while (1) {
            switch (_context103.prev = _context103.next) {
              case 0:
                _context103.next = 2;
                return this._doDockerAction(vmId, 'start', containerId);

              case 2:
              case 'end':
                return _context103.stop();
            }
          }
        }, _callee81, this);
      }));

      function startDockerContainer(_x166, _x167) {
        return _ref114.apply(this, arguments);
      }

      return startDockerContainer;
    }()
  }, {
    key: 'stopDockerContainer',
    value: function () {
      var _ref115 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee82(vmId, containerId) {
        return _regenerator2.default.wrap(function _callee82$(_context104) {
          while (1) {
            switch (_context104.prev = _context104.next) {
              case 0:
                _context104.next = 2;
                return this._doDockerAction(vmId, 'stop', containerId);

              case 2:
              case 'end':
                return _context104.stop();
            }
          }
        }, _callee82, this);
      }));

      function stopDockerContainer(_x168, _x169) {
        return _ref115.apply(this, arguments);
      }

      return stopDockerContainer;
    }()
  }, {
    key: 'restartDockerContainer',
    value: function () {
      var _ref116 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee83(vmId, containerId) {
        return _regenerator2.default.wrap(function _callee83$(_context105) {
          while (1) {
            switch (_context105.prev = _context105.next) {
              case 0:
                _context105.next = 2;
                return this._doDockerAction(vmId, 'restart', containerId);

              case 2:
              case 'end':
                return _context105.stop();
            }
          }
        }, _callee83, this);
      }));

      function restartDockerContainer(_x170, _x171) {
        return _ref116.apply(this, arguments);
      }

      return restartDockerContainer;
    }()
  }, {
    key: 'pauseDockerContainer',
    value: function () {
      var _ref117 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee84(vmId, containerId) {
        return _regenerator2.default.wrap(function _callee84$(_context106) {
          while (1) {
            switch (_context106.prev = _context106.next) {
              case 0:
                _context106.next = 2;
                return this._doDockerAction(vmId, 'pause', containerId);

              case 2:
              case 'end':
                return _context106.stop();
            }
          }
        }, _callee84, this);
      }));

      function pauseDockerContainer(_x172, _x173) {
        return _ref117.apply(this, arguments);
      }

      return pauseDockerContainer;
    }()
  }, {
    key: 'unpauseDockerContainer',
    value: function () {
      var _ref118 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee85(vmId, containerId) {
        return _regenerator2.default.wrap(function _callee85$(_context107) {
          while (1) {
            switch (_context107.prev = _context107.next) {
              case 0:
                _context107.next = 2;
                return this._doDockerAction(vmId, 'unpause', containerId);

              case 2:
              case 'end':
                return _context107.stop();
            }
          }
        }, _callee85, this);
      }));

      function unpauseDockerContainer(_x174, _x175) {
        return _ref118.apply(this, arguments);
      }

      return unpauseDockerContainer;
    }()
  }, {
    key: 'getCloudInitConfig',
    value: function () {
      var _ref119 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee86(templateId) {
        var template, host, config;
        return _regenerator2.default.wrap(function _callee86$(_context108) {
          while (1) {
            switch (_context108.prev = _context108.next) {
              case 0:
                template = this.getObject(templateId);
                host = this.pool.$master;
                _context108.next = 4;
                return this.call('host.call_plugin', host.$ref, 'xscontainer', 'get_config_drive_default', {
                  templateuuid: template.uuid
                });

              case 4:
                config = _context108.sent;
                return _context108.abrupt('return', config.slice(4));

              case 6:
              case 'end':
                return _context108.stop();
            }
          }
        }, _callee86, this);
      }));

      function getCloudInitConfig(_x176) {
        return _ref119.apply(this, arguments);
      }

      return getCloudInitConfig;
    }()

    // Specific CoreOS Config Drive

  }, {
    key: 'createCoreOsCloudInitConfigDrive',
    value: function () {
      var _ref120 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee87(vmId, srId, config) {
        var vm, host, sr;
        return _regenerator2.default.wrap(function _callee87$(_context109) {
          while (1) {
            switch (_context109.prev = _context109.next) {
              case 0:
                vm = this.getObject(vmId);
                host = this.pool.$master;
                sr = this.getObject(srId);
                _context109.next = 5;
                return this.call('host.call_plugin', host.$ref, 'xscontainer', 'create_config_drive', {
                  vmuuid: vm.uuid,
                  sruuid: sr.uuid,
                  configuration: config
                });

              case 5:
                _context109.next = 7;
                return this.registerDockerContainer(vmId);

              case 7:
              case 'end':
                return _context109.stop();
            }
          }
        }, _callee87, this);
      }));

      function createCoreOsCloudInitConfigDrive(_x177, _x178, _x179) {
        return _ref120.apply(this, arguments);
      }

      return createCoreOsCloudInitConfigDrive;
    }()

    // Generic Config Drive

  }, {
    key: 'createCloudInitConfigDrive',
    value: function () {
      var _ref121 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee88(vmId, srId, config) {
        var vm, sr, buffer, vdi, fs, stream;
        return _regenerator2.default.wrap(function _callee88$(_context110) {
          while (1) {
            switch (_context110.prev = _context110.next) {
              case 0:
                vm = this.getObject(vmId);
                sr = this.getObject(srId);

                // First, create a small VDI (10MB) which will become the ConfigDrive

                buffer = (0, _fatfsBuffer.init)();
                _context110.next = 5;
                return this.createVdi(buffer.length, { name_label: 'XO CloudConfigDrive', name_description: undefined, sr: sr.$ref });

              case 5:
                vdi = _context110.sent;

                // Then, generate a FAT fs
                fs = (0, _utils.promisifyAll)(_fatfs2.default.createFileSystem((0, _fatfsBuffer2.default)(buffer)));
                // Create Cloud config folders

                _context110.next = 9;
                return fs.mkdir('openstack');

              case 9:
                _context110.next = 11;
                return fs.mkdir('openstack/latest');

              case 11:
                _context110.next = 13;
                return fs.writeFile('openstack/latest/meta_data.json', '{\n    "uuid": "' + vm.uuid + '"\n}\n');

              case 13:
                _context110.next = 15;
                return fs.writeFile('openstack/latest/user_data', config);

              case 15:

                // Transform the buffer into a stream
                stream = (0, _utils.bufferToStream)(buffer);
                _context110.next = 18;
                return this.importVdiContent(vdi.$id, stream, {
                  format: VDI_FORMAT_RAW
                });

              case 18:
                _context110.next = 20;
                return this._createVbd(vm, vdi);

              case 20:
              case 'end':
                return _context110.stop();
            }
          }
        }, _callee88, this);
      }));

      function createCloudInitConfigDrive(_x180, _x181, _x182) {
        return _ref121.apply(this, arguments);
      }

      return createCloudInitConfigDrive;
    }()
  }, {
    key: '_createTemporaryVdiOnSr',
    value: function () {
      var _ref122 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee89($onFailure, stream, sr, name_label, name_description) {
        var _this22 = this;

        var vdi;
        return _regenerator2.default.wrap(function _callee89$(_context111) {
          while (1) {
            switch (_context111.prev = _context111.next) {
              case 0:
                _context111.next = 2;
                return this.createVdi(stream.length, {
                  sr: sr.$ref,
                  name_label,
                  name_description
                });

              case 2:
                vdi = _context111.sent;

                $onFailure(function () {
                  return _this22._deleteVdi(vdi);
                });

                _context111.next = 6;
                return this.importVdiContent(vdi.$id, stream, { format: VDI_FORMAT_RAW });

              case 6:
                return _context111.abrupt('return', vdi);

              case 7:
              case 'end':
                return _context111.stop();
            }
          }
        }, _callee89, this);
      }));

      function _createTemporaryVdiOnSr(_x183, _x184, _x185, _x186, _x187) {
        return _ref122.apply(this, arguments);
      }

      return _createTemporaryVdiOnSr;
    }()
  }, {
    key: 'createTemporaryVdiOnHost',
    value: function () {
      var _ref123 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee90(stream, hostId, name_label, name_description) {
        var sr;
        return _regenerator2.default.wrap(function _callee90$(_context112) {
          while (1) {
            switch (_context112.prev = _context112.next) {
              case 0:
                sr = this.pool.$default_SR;

                if (!(!sr || sr.physical_size - sr.physical_utilisation < stream.length)) {
                  _context112.next = 5;
                  break;
                }

                sr = (0, _find3.default)((0, _utils.mapToArray)(this.getObject(hostId).$PBDs, '$SR'), function (sr) {
                  return sr && sr.content_type === 'user' && sr.physical_size - sr.physical_utilisation >= stream.length;
                });

                if (sr) {
                  _context112.next = 5;
                  break;
                }

                throw new Error('no SR available to store installation file');

              case 5:
                return _context112.abrupt('return', this._createTemporaryVdiOnSr(stream, sr, name_label, name_description));

              case 6:
              case 'end':
                return _context112.stop();
            }
          }
        }, _callee90, this);
      }));

      function createTemporaryVdiOnHost(_x188, _x189, _x190, _x191) {
        return _ref123.apply(this, arguments);
      }

      return createTemporaryVdiOnHost;
    }()

    // =================================================================

  }]);
  return Xapi;
}(_xenApi.Xapi), (_applyDecoratedDescriptor(_class2.prototype, 'exportDeltaVm', [_dec2], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'exportDeltaVm'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'importDeltaVm', [_dec3], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'importDeltaVm'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, '_callInstallationPlugin', [_decoratorSynchronized2.default], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, '_callInstallationPlugin'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'installSupplementalPack', [_golikeDefer2.default], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'installSupplementalPack'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'installSupplementalPackOnAllHosts', [_golikeDefer2.default], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'installSupplementalPackOnAllHosts'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, '_importOvaVm', [_dec4], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, '_importOvaVm'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, '_exportVdi', [_promiseToolbox.cancellable], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, '_exportVdi'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, '_createTemporaryVdiOnSr', [_dec5], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, '_createTemporaryVdiOnSr'), _class2.prototype)), _class2)) || _class);
exports.default = Xapi;
//# sourceMappingURL=index.js.map
