'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _utils = require('../../utils');

var _utils2 = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  _connectVif(vif) {
    var _this = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _this.call('VIF.plug', vif.$ref);

            case 2:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    }))();
  },
  connectVif(vifId) {
    var _this2 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return _this2._connectVif(_this2.getObject(vifId));

            case 2:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this2);
    }))();
  },
  _deleteVif(vif) {
    var _this3 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return _this3.call('VIF.destroy', vif.$ref);

            case 2:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, _this3);
    }))();
  },
  deleteVif(vifId) {
    var _this4 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
      var vif;
      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              vif = _this4.getObject(vifId);

              if (!vif.currently_attached) {
                _context4.next = 4;
                break;
              }

              _context4.next = 4;
              return _this4._disconnectVif(vif);

            case 4:
              _context4.next = 6;
              return _this4._deleteVif(vif);

            case 6:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, _this4);
    }))();
  },
  _disconnectVif(vif) {
    var _this5 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return _this5.call('VIF.unplug_force', vif.$ref);

            case 2:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, _this5);
    }))();
  },
  disconnectVif(vifId) {
    var _this6 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.next = 2;
              return _this6._disconnectVif(_this6.getObject(vifId));

            case 2:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, _this6);
    }))();
  },
  editVif: (0, _utils2.makeEditObject)({
    ipv4Allowed: {
      get: true,
      set: ['ipv4Allowed', function (value, vif) {
        var lockingMode = (0, _utils.isEmpty)(value) && (0, _utils.isEmpty)(vif.ipv6_allowed) ? 'network_default' : 'locked';

        if (lockingMode !== vif.locking_mode) {
          return this._set('locking_mode', lockingMode);
        }
      }]
    },
    ipv6Allowed: {
      get: true,
      set: ['ipv6Allowed', function (value, vif) {
        var lockingMode = (0, _utils.isEmpty)(value) && (0, _utils.isEmpty)(vif.ipv4_allowed) ? 'network_default' : 'locked';

        if (lockingMode !== vif.locking_mode) {
          return this._set('locking_mode', lockingMode);
        }
      }]
    }
  })
};
//# sourceMappingURL=networking.js.map
