'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _dec, _desc, _value, _obj;

var _golikeDefer = require('golike-defer');

var _golikeDefer2 = _interopRequireDefault(_golikeDefer);

var _filter = require('lodash/filter');

var _filter2 = _interopRequireDefault(_filter);

var _includes = require('lodash/includes');

var _includes2 = _interopRequireDefault(_includes);

var _some = require('lodash/some');

var _some2 = _interopRequireDefault(_some);

var _sortBy = require('lodash/sortBy');

var _sortBy2 = _interopRequireDefault(_sortBy);

var _julienFUnzip = require('julien-f-unzip');

var _julienFUnzip2 = _interopRequireDefault(_julienFUnzip);

var _httpProxy = require('../../http-proxy');

var _httpProxy2 = _interopRequireDefault(_httpProxy);

var _httpRequest = require('../../http-request');

var _httpRequest2 = _interopRequireDefault(_httpRequest);

var _decorators = require('../../decorators');

var _utils = require('../../utils');

var _utils2 = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

exports.default = (_dec = (0, _decorators.debounce)(24 * 60 * 60 * 1000), (_obj = {
  _getXenUpdates() {
    var _this = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      var _ref, readAll, statusCode, data, patches, resolveVersionPatches, versions, latestVersion;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _httpRequest2.default)('http://updates.xensource.com/XenServer/updates.xml', { agent: _httpProxy2.default });

            case 2:
              _ref = _context.sent;
              readAll = _ref.readAll;
              statusCode = _ref.statusCode;

              if (!(statusCode !== 200)) {
                _context.next = 7;
                break;
              }

              throw new Error('cannot fetch patches list from Citrix');

            case 7:
              _context.t0 = _utils.parseXml;
              _context.next = 10;
              return readAll();

            case 10:
              _context.t1 = _context.sent;
              data = (0, _context.t0)(_context.t1).patchdata;
              patches = (0, _utils.createRawObject)();

              (0, _utils.forEach)(data.patches.patch, function (patch) {
                patches[patch.uuid] = {
                  date: patch.timestamp,
                  description: patch['name-description'],
                  documentationUrl: patch.url,
                  guidance: patch['after-apply-guidance'],
                  name: patch['name-label'],
                  url: patch['patch-url'],
                  uuid: patch.uuid,
                  conflicts: (0, _utils.mapToArray)((0, _utils.ensureArray)(patch.conflictingpatches), function (patch) {
                    return patch.conflictingpatch.uuid;
                  }),
                  requirements: (0, _utils.mapToArray)((0, _utils.ensureArray)(patch.requiredpatches), function (patch) {
                    return patch.requiredpatch.uuid;
                  })
                  // TODO: what does it mean, should we handle it?
                  // version: patch.version,
                };
                if (patches[patch.uuid].conflicts[0] === undefined) {
                  patches[patch.uuid].conflicts.length = 0;
                }
                if (patches[patch.uuid].requirements[0] === undefined) {
                  patches[patch.uuid].requirements.length = 0;
                }
              });

              resolveVersionPatches = function resolveVersionPatches(uuids) {
                var versionPatches = (0, _utils.createRawObject)();

                (0, _utils.forEach)((0, _utils.ensureArray)(uuids), function (_ref2) {
                  var uuid = _ref2.uuid;

                  versionPatches[uuid] = patches[uuid];
                });

                return versionPatches;
              };

              versions = (0, _utils.createRawObject)();
              latestVersion = void 0;

              (0, _utils.forEach)(data.serverversions.version, function (version) {
                versions[version.value] = {
                  date: version.timestamp,
                  name: version.name,
                  id: version.value,
                  documentationUrl: version.url,
                  patches: resolveVersionPatches(version.patch)
                };

                if (version.latest) {
                  latestVersion = versions[version.value];
                }
              });

              return _context.abrupt('return', {
                patches,
                latestVersion,
                versions
              });

            case 19:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    }))();
  },

  // =================================================================

  // Returns installed and not installed patches for a given host.
  _getPoolPatchesForHost(host) {
    var _this2 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
      var versions, hostVersions, version;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return _this2._getXenUpdates();

            case 2:
              versions = _context2.sent.versions;
              hostVersions = host.software_version;
              version = versions[hostVersions.product_version] || versions[hostVersions.product_version_text];
              return _context2.abrupt('return', version ? version.patches : []);

            case 6:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this2);
    }))();
  },

  _getInstalledPoolPatchesOnHost(host) {
    var installed = (0, _utils.createRawObject)();

    // platform_version < 2.1.1
    (0, _utils.forEach)(host.$patches, function (hostPatch) {
      installed[hostPatch.$pool_patch.uuid] = true;
    });

    // platform_version >= 2.1.1
    (0, _utils.forEach)(host.$updates, function (update) {
      installed[update.uuid] = true; // TODO: ignore packs
    });

    return installed;
  },

  _listMissingPoolPatchesOnHost(host) {
    var _this3 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
      var all, installed, installable;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return _this3._getPoolPatchesForHost(host);

            case 2:
              all = _context3.sent;
              installed = _this3._getInstalledPoolPatchesOnHost(host);
              installable = (0, _utils.createRawObject)();

              (0, _utils.forEach)(all, function (patch, uuid) {
                if (installed[uuid]) {
                  return;
                }

                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                  for (var _iterator = (0, _getIterator3.default)(patch.conflicts), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var _uuid = _step.value;

                    if (_uuid in installed) {
                      return;
                    }
                  }
                } catch (err) {
                  _didIteratorError = true;
                  _iteratorError = err;
                } finally {
                  try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                      _iterator.return();
                    }
                  } finally {
                    if (_didIteratorError) {
                      throw _iteratorError;
                    }
                  }
                }

                installable[uuid] = patch;
              });

              return _context3.abrupt('return', installable);

            case 7:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, _this3);
    }))();
  },

  listMissingPoolPatchesOnHost(hostId) {
    var _this4 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.t0 = _utils.mapToArray;
              _context4.next = 3;
              return _this4._listMissingPoolPatchesOnHost(_this4.getObject(hostId));

            case 3:
              _context4.t1 = _context4.sent;
              return _context4.abrupt('return', (0, _context4.t0)(_context4.t1));

            case 5:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, _this4);
    }))();
  },

  _ejectToolsIsos(hostRef) {
    var _this5 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              return _context5.abrupt('return', _promise2.default.all((0, _utils.mapFilter)(_this5.objects.all, function (vm) {
                if (vm.$type !== 'vm' || hostRef && vm.resident_on !== hostRef) {
                  return;
                }

                var shouldEjectCd = (0, _some2.default)(vm.$VBDs, function (vbd) {
                  var vdi = vbd.$VDI;

                  return vdi && vdi.is_tools_iso;
                });

                if (shouldEjectCd) {
                  return _this5.ejectCdFromVm(vm.$id);
                }
              })));

            case 1:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, _this5);
    }))();
  },

  // -----------------------------------------------------------------

  _isPoolPatchInstallableOnHost(patchUuid, host) {
    var installed = this._getInstalledPoolPatchesOnHost(host);

    if (installed[patchUuid]) {
      return false;
    }

    var installable = true;

    (0, _utils.forEach)(installed, function (patch) {
      if ((0, _includes2.default)(patch.conflicts, patchUuid)) {
        installable = false;

        return false;
      }
    });

    return installable;
  },

  // -----------------------------------------------------------------

  // platform_version < 2.1.1 ----------------------------------------
  uploadPoolPatch(stream) {
    var _this6 = this;

    var patchName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'unknown';
    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
      var taskRef, task, _ref3, _ref4, patchRef;

      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.next = 2;
              return _this6._createTask('Patch upload', patchName);

            case 2:
              taskRef = _context6.sent;
              task = _this6._watchTask(taskRef);
              _context6.next = 6;
              return _promise2.default.all([task, (0, _utils2.put)(stream, {
                hostname: _this6.pool.$master.address,
                path: '/pool_patch_upload',
                protocol: 'https',
                query: {
                  session_id: _this6.sessionId,
                  task_id: taskRef
                },
                rejectUnauthorized: false
              }, task)]);

            case 6:
              _ref3 = _context6.sent;
              _ref4 = (0, _slicedToArray3.default)(_ref3, 1);
              patchRef = _ref4[0];
              return _context6.abrupt('return', _this6._getOrWaitObject(patchRef));

            case 10:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, _this6);
    }))();
  },

  _getOrUploadPoolPatch(uuid) {
    var _this7 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7() {
      var patchInfo, stream;
      return _regenerator2.default.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              _context7.prev = 0;
              return _context7.abrupt('return', _this7.getObjectByUuid(uuid));

            case 4:
              _context7.prev = 4;
              _context7.t0 = _context7['catch'](0);

            case 6:

              (0, _utils2.debug)('downloading patch %s', uuid);

              _context7.next = 9;
              return _this7._getXenUpdates();

            case 9:
              _context7.t1 = uuid;
              patchInfo = _context7.sent.patches[_context7.t1];

              if (patchInfo) {
                _context7.next = 13;
                break;
              }

              throw new Error('no such patch ' + uuid);

            case 13:
              _context7.next = 15;
              return (0, _httpRequest2.default)(patchInfo.url, { agent: _httpProxy2.default });

            case 15:
              stream = _context7.sent;
              _context7.next = 18;
              return new _promise2.default(function (resolve, reject) {
                var PATCH_RE = /\.xsupdate$/;
                stream.pipe(_julienFUnzip2.default.Parse()).on('entry', function (entry) {
                  if (PATCH_RE.test(entry.path)) {
                    entry.length = entry.size;
                    resolve(entry);
                  } else {
                    entry.autodrain();
                  }
                }).on('error', reject);
              });

            case 18:
              stream = _context7.sent;
              return _context7.abrupt('return', _this7.uploadPoolPatch(stream, patchInfo.name));

            case 20:
            case 'end':
              return _context7.stop();
          }
        }
      }, _callee7, _this7, [[0, 4]]);
    }))();
  },

  // patform_version >= 2.1.1 ----------------------------------------
  _installPatch: (0, _golikeDefer2.default)(function () {
    var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8($defer, stream, _ref6) {
      var _this8 = this;

      var hostId = _ref6.hostId;
      var vdi, updateRef;
      return _regenerator2.default.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              if (stream.length) {
                _context8.next = 2;
                break;
              }

              throw new Error('stream must have a length');

            case 2:
              _context8.next = 4;
              return this.createTemporaryVdiOnHost(stream, hostId, '[XO] Patch ISO', 'small temporary VDI to store a patch ISO');

            case 4:
              vdi = _context8.sent;

              $defer(function () {
                return _this8._deleteVdi(vdi);
              });

              _context8.next = 8;
              return this.call('pool_update.introduce', vdi.$ref);

            case 8:
              updateRef = _context8.sent;
              _context8.next = 11;
              return this.call('pool_update.apply', updateRef, this.getObject(hostId).$ref);

            case 11:
            case 'end':
              return _context8.stop();
          }
        }
      }, _callee8, this);
    }));

    return function (_x2, _x3, _x4) {
      return _ref5.apply(this, arguments);
    };
  }()),

  _downloadPatchAndInstall(uuid, hostId) {
    var _this9 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9() {
      var patchInfo, stream;
      return _regenerator2.default.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              (0, _utils2.debug)('downloading patch %s', uuid);

              _context9.next = 3;
              return _this9._getXenUpdates();

            case 3:
              _context9.t0 = uuid;
              patchInfo = _context9.sent.patches[_context9.t0];

              if (patchInfo) {
                _context9.next = 7;
                break;
              }

              throw new Error('no such patch ' + uuid);

            case 7:
              _context9.next = 9;
              return (0, _httpRequest2.default)(patchInfo.url, { agent: _httpProxy2.default });

            case 9:
              stream = _context9.sent;
              _context9.next = 12;
              return new _promise2.default(function (resolve, reject) {
                stream.pipe(_julienFUnzip2.default.Parse()).on('entry', function (entry) {
                  entry.length = entry.size;
                  resolve(entry);
                }).on('error', reject);
              });

            case 12:
              stream = _context9.sent;
              return _context9.abrupt('return', _this9._installPatch(stream, { hostId }));

            case 14:
            case 'end':
              return _context9.stop();
          }
        }
      }, _callee9, _this9);
    }))();
  },

  // -----------------------------------------------------------------

  _installPoolPatchOnHost(patchUuid, host) {
    var _this10 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10() {
      var _ref7, _ref8, patch;

      return _regenerator2.default.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              _context10.next = 2;
              return _promise2.default.all([_this10._getOrUploadPoolPatch(patchUuid), _this10._ejectToolsIsos(host.$ref)]);

            case 2:
              _ref7 = _context10.sent;
              _ref8 = (0, _slicedToArray3.default)(_ref7, 1);
              patch = _ref8[0];
              _context10.next = 7;
              return _this10.call('pool_patch.apply', patch.$ref, host.$ref);

            case 7:
            case 'end':
              return _context10.stop();
          }
        }
      }, _callee10, _this10);
    }))();
  },

  _installPatchUpdateOnHost(patchUuid, host) {
    return _promise2.default.all([this._downloadPatchAndInstall(patchUuid, host.$id), this._ejectToolsIsos(host.$ref)]);
  },

  _checkSoftwareVersionAndInstallPatch(patchUuid, hostId) {
    var _this11 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11() {
      var host;
      return _regenerator2.default.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              host = _this11.getObject(hostId);
              return _context11.abrupt('return', (0, _utils2.useUpdateSystem)(host) ? _this11._installPatchUpdateOnHost(patchUuid, host) : _this11._installPoolPatchOnHost(patchUuid, host));

            case 2:
            case 'end':
              return _context11.stop();
          }
        }
      }, _callee11, _this11);
    }))();
  },

  installPoolPatchOnHost(patchUuid, hostId) {
    var _this12 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12() {
      return _regenerator2.default.wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              (0, _utils2.debug)('installing patch %s', patchUuid);

              return _context12.abrupt('return', _this12._checkSoftwareVersionAndInstallPatch(patchUuid, hostId));

            case 2:
            case 'end':
              return _context12.stop();
          }
        }
      }, _callee12, _this12);
    }))();
  },

  // -----------------------------------------------------------------

  installPoolPatchOnAllHosts(patchUuid) {
    var _this13 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee13() {
      var _ref9, _ref10, patch;

      return _regenerator2.default.wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              _context13.next = 2;
              return _promise2.default.all([_this13._getOrUploadPoolPatch(patchUuid), _this13._ejectToolsIsos()]);

            case 2:
              _ref9 = _context13.sent;
              _ref10 = (0, _slicedToArray3.default)(_ref9, 1);
              patch = _ref10[0];
              _context13.next = 7;
              return _this13.call('pool_patch.pool_apply', patch.$ref);

            case 7:
            case 'end':
              return _context13.stop();
          }
        }
      }, _callee13, _this13);
    }))();
  },

  // -----------------------------------------------------------------

  _installPoolPatchOnHostAndRequirements(patch, host, patchesByUuid) {
    var _this14 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee14() {
      var requirements, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, requirementUuid, requirement;

      return _regenerator2.default.wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              requirements = patch.requirements;

              if (!requirements.length) {
                _context14.next = 31;
                break;
              }

              _iteratorNormalCompletion2 = true;
              _didIteratorError2 = false;
              _iteratorError2 = undefined;
              _context14.prev = 5;
              _iterator2 = (0, _getIterator3.default)(requirements);

            case 7:
              if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                _context14.next = 17;
                break;
              }

              requirementUuid = _step2.value;

              if (!_this14._isPoolPatchInstallableOnHost(requirementUuid, host)) {
                _context14.next = 14;
                break;
              }

              requirement = patchesByUuid[requirementUuid];
              _context14.next = 13;
              return _this14._installPoolPatchOnHostAndRequirements(requirement, host, patchesByUuid);

            case 13:

              host = _this14.getObject(host.$id);

            case 14:
              _iteratorNormalCompletion2 = true;
              _context14.next = 7;
              break;

            case 17:
              _context14.next = 23;
              break;

            case 19:
              _context14.prev = 19;
              _context14.t0 = _context14['catch'](5);
              _didIteratorError2 = true;
              _iteratorError2 = _context14.t0;

            case 23:
              _context14.prev = 23;
              _context14.prev = 24;

              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }

            case 26:
              _context14.prev = 26;

              if (!_didIteratorError2) {
                _context14.next = 29;
                break;
              }

              throw _iteratorError2;

            case 29:
              return _context14.finish(26);

            case 30:
              return _context14.finish(23);

            case 31:
              _context14.next = 33;
              return _this14._checkSoftwareVersionAndInstallPatch(patch.uuid, host);

            case 33:
            case 'end':
              return _context14.stop();
          }
        }
      }, _callee14, _this14, [[5, 19, 23, 31], [24,, 26, 30]]);
    }))();
  },

  installAllPoolPatchesOnHost(hostId) {
    var _this15 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee15() {
      var host, installableByUuid, installable, i, n, patch;
      return _regenerator2.default.wrap(function _callee15$(_context15) {
        while (1) {
          switch (_context15.prev = _context15.next) {
            case 0:
              host = _this15.getObject(hostId);
              _context15.next = 3;
              return _this15._listMissingPoolPatchesOnHost(host);

            case 3:
              installableByUuid = _context15.sent;


              // List of all installable patches sorted from the newest to the
              // oldest.
              installable = (0, _sortBy2.default)(installableByUuid, function (patch) {
                return -Date.parse(patch.date);
              });
              i = 0, n = installable.length;

            case 6:
              if (!(i < n)) {
                _context15.next = 15;
                break;
              }

              patch = installable[i];

              if (!_this15._isPoolPatchInstallableOnHost(patch.uuid, host)) {
                _context15.next = 12;
                break;
              }

              _context15.next = 11;
              return _this15._installPoolPatchOnHostAndRequirements(patch, host, installableByUuid).catch(function (error) {
                if (error.code !== 'PATCH_ALREADY_APPLIED') {
                  throw error;
                }
              });

            case 11:
              host = _this15.getObject(host.$id);

            case 12:
              ++i;
              _context15.next = 6;
              break;

            case 15:
            case 'end':
              return _context15.stop();
          }
        }
      }, _callee15, _this15);
    }))();
  },

  installAllPoolPatchesOnAllHosts() {
    var _this16 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee16() {
      return _regenerator2.default.wrap(function _callee16$(_context16) {
        while (1) {
          switch (_context16.prev = _context16.next) {
            case 0:
              _context16.next = 2;
              return _this16.installAllPoolPatchesOnHost(_this16.pool.master);

            case 2:
              _context16.next = 4;
              return _promise2.default.all((0, _utils.mapToArray)((0, _filter2.default)(_this16.objects.all, { $type: 'host' }), function (host) {
                return _this16.installAllPoolPatchesOnHost(host.$id);
              }));

            case 4:
            case 'end':
              return _context16.stop();
          }
        }
      }, _callee16, _this16);
    }))();
  }
}, (_applyDecoratedDescriptor(_obj, '_getXenUpdates', [_dec], (0, _getOwnPropertyDescriptor2.default)(_obj, '_getXenUpdates'), _obj)), _obj));
//# sourceMappingURL=patching.js.map
