'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  _connectAllSrPbds(sr) {
    var _this = this;

    return _promise2.default.all((0, _utils.mapToArray)(sr.$PBDs, function (pbd) {
      return _this._plugPbd(pbd);
    }));
  },

  connectAllSrPbds(id) {
    var _this2 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _this2._connectAllSrPbds(_this2.getObject(id));

            case 2:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2);
    }))();
  },

  _disconnectAllSrPbds(sr) {
    var _this3 = this;

    return _promise2.default.all((0, _utils.mapToArray)(sr.$PBDs, function (pbd) {
      return _this3._unplugPbd(pbd);
    }));
  },

  disconnectAllSrPbds(id) {
    var _this4 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return _this4._disconnectAllSrPbds(_this4.getObject(id));

            case 2:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this4);
    }))();
  },

  destroySr(id) {
    var _this5 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
      var sr;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              sr = _this5.getObject(id);
              _context3.next = 3;
              return _this5._disconnectAllSrPbds(sr);

            case 3:
              _context3.next = 5;
              return _this5.call('SR.destroy', sr.$ref);

            case 5:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, _this5);
    }))();
  },

  forgetSr(id) {
    var _this6 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
      var sr;
      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              sr = _this6.getObject(id);
              _context4.next = 3;
              return _this6._disconnectAllSrPbds(sr);

            case 3:
              _context4.next = 5;
              return _this6.call('SR.forget', sr.$ref);

            case 5:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, _this6);
    }))();
  },

  _plugPbd(pbd) {
    return this.call('PBD.plug', pbd.$ref);
  },

  plugPbd(id) {
    var _this7 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return _this7._plugPbd(_this7.getObject(id));

            case 2:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, _this7);
    }))();
  },

  _unplugPbd(pbd) {
    return this.call('PBD.unplug', pbd.$ref);
  },

  unplugPbd(id) {
    var _this8 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.next = 2;
              return _this8._unplugPbd(_this8.getObject(id));

            case 2:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, _this8);
    }))();
  }
};
//# sourceMappingURL=storage.js.map
