'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _dec, _desc, _value, _obj;

var _golikeDefer = require('golike-defer');

var _golikeDefer2 = _interopRequireDefault(_golikeDefer);

var _find = require('lodash/find');

var _find2 = _interopRequireDefault(_find);

var _gte = require('lodash/gte');

var _gte2 = _interopRequireDefault(_gte);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _lte = require('lodash/lte');

var _lte2 = _interopRequireDefault(_lte);

var _utils = require('../../utils');

var _utils2 = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

exports.default = (_dec = _golikeDefer2.default.onFailure, (_obj = {
  createVm($onFailure, templateId) {
    var _this = this;

    var _ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    var name_label = _ref.name_label,
        _ref$nameLabel = _ref.nameLabel,
        nameLabel = _ref$nameLabel === undefined ? name_label : _ref$nameLabel,
        _ref$clone = _ref.clone,
        clone = _ref$clone === undefined ? true : _ref$clone,
        _ref$installRepositor = _ref.installRepository,
        installRepository = _ref$installRepositor === undefined ? undefined : _ref$installRepositor,
        _ref$vdis = _ref.vdis,
        vdis = _ref$vdis === undefined ? undefined : _ref$vdis,
        _ref$vifs = _ref.vifs,
        vifs = _ref$vifs === undefined ? undefined : _ref$vifs,
        _ref$existingVdis = _ref.existingVdis,
        existingVdis = _ref$existingVdis === undefined ? undefined : _ref$existingVdis,
        _ref$coreOs = _ref.coreOs,
        coreOs = _ref$coreOs === undefined ? false : _ref$coreOs,
        _ref$cloudConfig = _ref.cloudConfig,
        cloudConfig = _ref$cloudConfig === undefined ? undefined : _ref$cloudConfig,
        props = (0, _objectWithoutProperties3.default)(_ref, ['name_label', 'nameLabel', 'clone', 'installRepository', 'vdis', 'vifs', 'existingVdis', 'coreOs', 'cloudConfig']);
    var checkLimits = arguments[3];
    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
      var _context2;

      var installMethod, template, vmRef, vm, isHvm, _vm, bootParams, order, nVbds, hasBootableDisk, devices, nVifs, _devices, srRef, method;

      return _regenerator2.default.wrap(function _callee2$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              installMethod = function () {
                if (installRepository == null) {
                  return 'none';
                }

                try {
                  installRepository = _this.getObject(installRepository);
                  return 'cd';
                } catch (_) {
                  return 'network';
                }
              }();

              template = _this.getObject(templateId);

              // Clones the template.

              _context4.next = 4;
              return _this[clone ? '_cloneVm' : '_copyVm'](template, nameLabel);

            case 4:
              vmRef = _context4.sent;

              $onFailure(function () {
                var _context;

                return (_context = _this.deleteVm(vmRef), _utils.pCatch).call(_context, _utils.noop);
              });

              // TODO: copy BIOS strings?

              // Removes disks from the provision XML, we will create them by
              // ourselves.
              _context4.next = 8;
              return (_context2 = _this.call('VM.remove_from_other_config', vmRef, 'disks'), _utils.pCatch).call(_context2, _utils.noop);

            case 8:
              _context4.next = 10;
              return _this.call('VM.provision', vmRef);

            case 10:
              _context4.next = 12;
              return _this._getOrWaitObject(vmRef);

            case 12:
              vm = _context4.sent;
              _context4.next = 15;
              return _this._editVm(vm, props, checkLimits);

            case 15:
              isHvm = (0, _utils2.isVmHvm)(vm);

              if (!isHvm) {
                _context4.next = 20;
                break;
              }

              if (!(0, _isEmpty2.default)(vdis) || installMethod === 'network') {
                _vm = vm, bootParams = _vm.HVM_boot_params;
                order = bootParams.order;

                if (order) {
                  order = 'n' + order.replace('n', '');
                } else {
                  order = 'ncd';
                }

                _this._setObjectProperties(vm, {
                  HVM_boot_params: (0, _extends3.default)({}, bootParams, { order })
                });
              }
              _context4.next = 29;
              break;

            case 20:
              if (!(vm.PV_bootloader === 'eliloader')) {
                _context4.next = 29;
                break;
              }

              if (!(installMethod === 'network')) {
                _context4.next = 26;
                break;
              }

              _context4.next = 24;
              return _this._updateObjectMapProperty(vm, 'other_config', {
                'install-repository': installRepository
              });

            case 24:
              _context4.next = 29;
              break;

            case 26:
              if (!(installMethod === 'cd')) {
                _context4.next = 29;
                break;
              }

              _context4.next = 29;
              return _this._updateObjectMapProperty(vm, 'other_config', {
                'install-repository': 'cdrom'
              });

            case 29:
              nVbds = vm.VBDs.length;
              hasBootableDisk = !!(0, _find2.default)(vm.$VBDs, 'bootable');

              // Inserts the CD if necessary.

              if (!(installMethod === 'cd')) {
                _context4.next = 36;
                break;
              }

              _context4.next = 34;
              return _this._insertCdIntoVm(installRepository, vm, {
                bootable: true
              });

            case 34:
              hasBootableDisk = true;

              ++nVbds;

            case 36:
              _context4.t0 = existingVdis;

              if (!_context4.t0) {
                _context4.next = 40;
                break;
              }

              _context4.next = 40;
              return _promise2.default.all((0, _utils.mapToArray)(existingVdis, function () {
                var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref3, userdevice) {
                  var size = _ref3.size,
                      srId = _ref3.$SR,
                      properties = (0, _objectWithoutProperties3.default)(_ref3, ['size', '$SR']);
                  var vbd, vdi;
                  return _regenerator2.default.wrap(function _callee$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          vbd = (0, _find2.default)(vm.$VBDs, { userdevice });

                          if (vbd) {
                            _context3.next = 3;
                            break;
                          }

                          return _context3.abrupt('return');

                        case 3:
                          vdi = vbd.$VDI;
                          _context3.next = 6;
                          return _this._setObjectProperties(vdi, properties);

                        case 6:
                          if (!(size != null && size > vdi.virtual_size)) {
                            _context3.next = 9;
                            break;
                          }

                          _context3.next = 9;
                          return _this.resizeVdi(vdi.$id, size);

                        case 9:
                          if (!srId) {
                            _context3.next = 12;
                            break;
                          }

                          _context3.next = 12;
                          return _this.moveVdi(vdi.$id, srId);

                        case 12:
                        case 'end':
                          return _context3.stop();
                      }
                    }
                  }, _callee, _this);
                }));

                return function (_x2, _x3) {
                  return _ref2.apply(this, arguments);
                };
              }()));

            case 40:
              if ((0, _isEmpty2.default)(vdis)) {
                _context4.next = 46;
                break;
              }

              _context4.next = 43;
              return _this.call('VM.get_allowed_VBD_devices', vm.$ref);

            case 43:
              devices = _context4.sent;
              _context4.next = 46;
              return _promise2.default.all((0, _utils.mapToArray)(vdis, function (vdiDescription, i) {
                ++nVbds;

                return _this._createVdi(vdiDescription.size, // FIXME: Should not be done in Xapi.
                {
                  name_label: vdiDescription.name_label,
                  name_description: vdiDescription.name_description,
                  sr: vdiDescription.sr || vdiDescription.SR
                }).then(function (ref) {
                  return _this._getOrWaitObject(ref);
                }).then(function (vdi) {
                  return _this._createVbd(vm, vdi, {
                    // Either the CD or the 1st disk is bootable (only useful for PV VMs)
                    bootable: !(hasBootableDisk || i),
                    userdevice: devices[i]
                  });
                });
              }));

            case 46:
              _context4.next = 48;
              return _promise2.default.all((0, _utils.mapToArray)(vm.$VIFs, function (vif) {
                return _this._deleteVif(vif);
              }));

            case 48:

              // Creates the VIFs specified by the user.
              nVifs = 0;

              if (!vifs) {
                _context4.next = 55;
                break;
              }

              _context4.next = 52;
              return _this.call('VM.get_allowed_VIF_devices', vm.$ref);

            case 52:
              _devices = _context4.sent;
              _context4.next = 55;
              return _promise2.default.all((0, _utils.mapToArray)(vifs, function (vif, index) {
                ++nVifs;

                return _this._createVif(vm, _this.getObject(vif.network), {
                  ipv4_allowed: vif.ipv4_allowed,
                  ipv6_allowed: vif.ipv6_allowed,
                  device: _devices[index],
                  locking_mode: (0, _isEmpty2.default)(vif.ipv4_allowed) && (0, _isEmpty2.default)(vif.ipv6_allowed) ? 'network_default' : 'locked',
                  mac: vif.mac,
                  mtu: vif.mtu
                });
              }));

            case 55:
              if (!(cloudConfig != null)) {
                _context4.next = 65;
                break;
              }

              _context4.next = 58;
              return _this._waitObjectState(vm.$id, function (vm) {
                return vm.VBDs.length === nVbds;
              });

            case 58:
              vm = _context4.sent;


              // Find the SR of the first VDI.
              srRef = void 0;

              (0, _utils.forEach)(vm.$VBDs, function (vbd) {
                var vdi = void 0;
                if (vbd.type === 'Disk' && (vdi = vbd.$VDI)) {
                  srRef = vdi.SR;
                  return false;
                }
              });

              method = coreOs ? 'createCoreOsCloudInitConfigDrive' : 'createCloudInitConfigDrive';
              _context4.next = 64;
              return _this[method](vm.$id, srRef, cloudConfig);

            case 64:

              ++nVbds;

            case 65:
              return _context4.abrupt('return', _this._waitObjectState(vm.$id, function (vm) {
                return vm.VBDs.length === nVbds && vm.VIFs.length === nVifs;
              }));

            case 66:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee2, _this);
    }))();
  },

  // High level method to edit a VM.
  //
  // Params do not correspond directly to XAPI props.
  _editVm: (0, _utils2.makeEditObject)({
    affinityHost: {
      get: 'affinity',
      set(value, vm) {
        return this._setObjectProperty(vm, 'affinity', value ? this.getObject(value).$ref : _utils2.NULL_REF);
      }
    },

    autoPoweron: {
      set(value, vm) {
        return _promise2.default.all([this._updateObjectMapProperty(vm, 'other_config', {
          autoPoweron: value ? 'true' : null
        }), value && this.setPoolProperties({
          autoPoweron: true
        })]);
      }
    },

    CPUs: 'cpus',
    cpus: {
      addToLimits: true,

      // Current value may have constraints with other values.
      //
      // If the other value is not set and the constraint is not
      // respected, the other value is changed first.
      constraints: {
        cpusStaticMax: _gte2.default
      },

      get: function get(vm) {
        return +vm.VCPUs_at_startup;
      },
      set: ['VCPUs_at_startup', function (value, vm) {
        return (0, _utils2.isVmRunning)(vm) && this._set('VCPUs_number_live', value);
      }]
    },

    cpuCap: {
      get: function get(vm) {
        return vm.VCPUs_params.cap && +vm.VCPUs_params.cap;
      },
      set(cap, vm) {
        return this._updateObjectMapProperty(vm, 'VCPUs_params', { cap });
      }
    },

    cpusMax: 'cpusStaticMax',
    cpusStaticMax: {
      constraints: {
        cpus: _lte2.default
      },
      get: function get(vm) {
        return +vm.VCPUs_max;
      },
      set: 'VCPUs_max'
    },

    cpuWeight: {
      get: function get(vm) {
        return vm.VCPUs_params.weight && +vm.VCPUs_params.weight;
      },
      set(weight, vm) {
        return this._updateObjectMapProperty(vm, 'VCPUs_params', { weight });
      }
    },

    highAvailability: {
      set(ha, vm) {
        return this.call('VM.set_ha_restart_priority', vm.$ref, ha ? 'restart' : '');
      }
    },

    memoryMin: {
      constraints: {
        memoryMax: _gte2.default
      },
      get: function get(vm) {
        return +vm.memory_dynamic_min;
      },
      preprocess: _utils.parseSize,
      set: 'memory_dynamic_min'
    },

    memory: 'memoryMax',
    memoryMax: {
      addToLimits: true,
      limitName: 'memory',
      constraints: {
        memoryMin: _lte2.default,
        memoryStaticMax: _gte2.default
      },
      get: function get(vm) {
        return +vm.memory_dynamic_max;
      },
      preprocess: _utils.parseSize,
      set: 'memory_dynamic_max'
    },

    memoryStaticMax: {
      constraints: {
        memoryMax: _lte2.default
      },
      get: function get(vm) {
        return +vm.memory_static_max;
      },
      preprocess: _utils.parseSize,
      set: 'memory_static_max'
    },

    nameDescription: true,

    nameLabel: true,

    PV_args: true,

    tags: true
  }),

  editVm(id, props, checkLimits) {
    var _this2 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
      return _regenerator2.default.wrap(function _callee3$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              return _context5.abrupt('return', /* await */_this2._editVm(_this2.getObject(id), props, checkLimits));

            case 1:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee3, _this2);
    }))();
  },

  revertVm(snapshotId) {
    var _this3 = this;

    var snapshotBefore = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
      var snapshot, vm, _context6, _context7;

      return _regenerator2.default.wrap(function _callee4$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              snapshot = _this3.getObject(snapshotId);

              if (!snapshotBefore) {
                _context8.next = 4;
                break;
              }

              _context8.next = 4;
              return _this3._snapshotVm(snapshot.$snapshot_of);

            case 4:
              _context8.next = 6;
              return _this3.call('VM.revert', snapshot.$ref);

            case 6:
              if (snapshot.snapshot_info['power-state-at-snapshot'] === 'Running') {
                vm = snapshot.$snapshot_of;

                if (vm.power_state === 'Halted') {
                  (_context6 = _this3.startVm(vm.$id), _utils.pCatch).call(_context6, _utils.noop);
                } else if (vm.power_state === 'Suspended') {
                  (_context7 = _this3.resumeVm(vm.$id), _utils.pCatch).call(_context7, _utils.noop);
                }
              }

            case 7:
            case 'end':
              return _context8.stop();
          }
        }
      }, _callee4, _this3);
    }))();
  },

  resumeVm(vmId) {
    var _this4 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
      return _regenerator2.default.wrap(function _callee5$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              return _context9.abrupt('return', _this4.call('VM.resume', _this4.getObject(vmId).$ref, false, true));

            case 1:
            case 'end':
              return _context9.stop();
          }
        }
      }, _callee5, _this4);
    }))();
  }
}, (_applyDecoratedDescriptor(_obj, 'createVm', [_dec], (0, _getOwnPropertyDescriptor2.default)(_obj, 'createVm'), _obj)), _obj));
//# sourceMappingURL=vm.js.map
