'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _xoAclResolver = require('xo-acl-resolver');

var _xoAclResolver2 = _interopRequireDefault(_xoAclResolver);

var _collection = require('../collection');

var _acl = require('../models/acl');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var _default = function () {
  function _default(xo) {
    var _this = this;

    (0, _classCallCheck3.default)(this, _default);

    this._xo = xo;

    var aclsDb = this._acls = new _acl.Acls({
      connection: xo._redis,
      prefix: 'xo:acl',
      indexes: ['subject', 'object']
    });

    xo.on('start', function () {
      xo.addConfigManager('acls', function () {
        return aclsDb.get();
      }, function (acls) {
        return aclsDb.update(acls);
      });
    });

    xo.on('clean', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      var acls, toRemove;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return aclsDb.get();

            case 2:
              acls = _context.sent;
              toRemove = [];

              (0, _utils.forEach)(acls, function (_ref2) {
                var subject = _ref2.subject,
                    object = _ref2.object,
                    action = _ref2.action,
                    id = _ref2.id;

                if (!subject || !object || !action) {
                  toRemove.push(id);
                }
              });
              _context.next = 7;
              return aclsDb.remove(toRemove);

            case 7:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    })));
  }

  (0, _createClass3.default)(_default, [{
    key: '_getAclsForUser',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(userId) {
        var _this2 = this;

        var user, groups, subjects, acls, pushAcls;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._xo.getUser(userId);

              case 2:
                user = _context2.sent;
                groups = user.groups;
                subjects = groups ? groups.concat(userId) : [userId];
                acls = [];

                pushAcls = function (push) {
                  return function (entries) {
                    push.apply(acls, entries);
                  };
                }(acls.push);

                _context2.next = 9;
                return _promise2.default.all((0, _utils.mapToArray)(subjects, function (subject) {
                  return _this2.getAclsForSubject(subject).then(pushAcls);
                }));

              case 9:
                return _context2.abrupt('return', acls);

              case 10:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _getAclsForUser(_x) {
        return _ref3.apply(this, arguments);
      }

      return _getAclsForUser;
    }()
  }, {
    key: 'addAcl',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(subjectId, objectId, action) {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.prev = 0;
                _context3.next = 3;
                return this._acls.create(subjectId, objectId, action);

              case 3:
                _context3.next = 9;
                break;

              case 5:
                _context3.prev = 5;
                _context3.t0 = _context3['catch'](0);

                if (_context3.t0 instanceof _collection.ModelAlreadyExists) {
                  _context3.next = 9;
                  break;
                }

                throw _context3.t0;

              case 9:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[0, 5]]);
      }));

      function addAcl(_x2, _x3, _x4) {
        return _ref4.apply(this, arguments);
      }

      return addAcl;
    }()
  }, {
    key: 'removeAcl',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(subjectId, objectId, action) {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this._acls.delete(subjectId, objectId, action);

              case 2:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function removeAcl(_x5, _x6, _x7) {
        return _ref5.apply(this, arguments);
      }

      return removeAcl;
    }()

    // TODO: remove when new collection.

  }, {
    key: 'getAllAcls',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt('return', this._acls.get());

              case 1:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getAllAcls() {
        return _ref6.apply(this, arguments);
      }

      return getAllAcls;
    }()
  }, {
    key: 'getAclsForSubject',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(subjectId) {
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt('return', this._acls.get({ subject: subjectId }));

              case 1:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getAclsForSubject(_x8) {
        return _ref7.apply(this, arguments);
      }

      return getAclsForSubject;
    }()
  }, {
    key: 'getPermissionsForUser',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(userId) {
        var _ref9, _ref10, acls, permissionsByRole, permissions, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _ref11, action, objectId, current, permissionsForRole, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, permission;

        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return _promise2.default.all([this._getAclsForUser(userId), this._getPermissionsByRole()]);

              case 2:
                _ref9 = _context7.sent;
                _ref10 = (0, _slicedToArray3.default)(_ref9, 2);
                acls = _ref10[0];
                permissionsByRole = _ref10[1];
                permissions = (0, _utils.createRawObject)();
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context7.prev = 10;
                _iterator = (0, _getIterator3.default)(acls);

              case 12:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context7.next = 43;
                  break;
                }

                _ref11 = _step.value;
                action = _ref11.action, objectId = _ref11.object;
                current = permissions[objectId] || (permissions[objectId] = (0, _utils.createRawObject)());
                permissionsForRole = permissionsByRole[action];

                if (!permissionsForRole) {
                  _context7.next = 39;
                  break;
                }

                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context7.prev = 21;

                for (_iterator2 = (0, _getIterator3.default)(permissionsForRole); !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  permission = _step2.value;

                  current[permission] = 1;
                }
                _context7.next = 29;
                break;

              case 25:
                _context7.prev = 25;
                _context7.t0 = _context7['catch'](21);
                _didIteratorError2 = true;
                _iteratorError2 = _context7.t0;

              case 29:
                _context7.prev = 29;
                _context7.prev = 30;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 32:
                _context7.prev = 32;

                if (!_didIteratorError2) {
                  _context7.next = 35;
                  break;
                }

                throw _iteratorError2;

              case 35:
                return _context7.finish(32);

              case 36:
                return _context7.finish(29);

              case 37:
                _context7.next = 40;
                break;

              case 39:
                current[action] = 1;

              case 40:
                _iteratorNormalCompletion = true;
                _context7.next = 12;
                break;

              case 43:
                _context7.next = 49;
                break;

              case 45:
                _context7.prev = 45;
                _context7.t1 = _context7['catch'](10);
                _didIteratorError = true;
                _iteratorError = _context7.t1;

              case 49:
                _context7.prev = 49;
                _context7.prev = 50;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 52:
                _context7.prev = 52;

                if (!_didIteratorError) {
                  _context7.next = 55;
                  break;
                }

                throw _iteratorError;

              case 55:
                return _context7.finish(52);

              case 56:
                return _context7.finish(49);

              case 57:
                return _context7.abrupt('return', permissions);

              case 58:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this, [[10, 45, 49, 57], [21, 25, 29, 37], [30,, 32, 36], [50,, 52, 56]]);
      }));

      function getPermissionsForUser(_x9) {
        return _ref8.apply(this, arguments);
      }

      return getPermissionsForUser;
    }()
  }, {
    key: 'hasPermissions',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(userId, permissions) {
        var _this3 = this;

        var user;
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this._xo.getUser(userId);

              case 2:
                user = _context8.sent;

                if (!(user.permission === 'admin')) {
                  _context8.next = 5;
                  break;
                }

                return _context8.abrupt('return', true);

              case 5:
                _context8.t0 = _xoAclResolver2.default;
                _context8.next = 8;
                return this.getPermissionsForUser(userId);

              case 8:
                _context8.t1 = _context8.sent;

                _context8.t2 = function (id) {
                  return _this3._xo.getObject(id);
                };

                _context8.t3 = permissions;
                return _context8.abrupt('return', (0, _context8.t0)(_context8.t1, _context8.t2, _context8.t3));

              case 12:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function hasPermissions(_x10, _x11) {
        return _ref12.apply(this, arguments);
      }

      return hasPermissions;
    }()

    // -----------------------------------------------------------------

  }, {
    key: '_getPermissionsByRole',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9() {
        var roles, permissions, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, role;

        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this.getRoles();

              case 2:
                roles = _context9.sent;
                permissions = (0, _utils.createRawObject)();
                _iteratorNormalCompletion3 = true;
                _didIteratorError3 = false;
                _iteratorError3 = undefined;
                _context9.prev = 7;

                for (_iterator3 = (0, _getIterator3.default)(roles); !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                  role = _step3.value;

                  permissions[role.id] = role.permissions;
                }
                _context9.next = 15;
                break;

              case 11:
                _context9.prev = 11;
                _context9.t0 = _context9['catch'](7);
                _didIteratorError3 = true;
                _iteratorError3 = _context9.t0;

              case 15:
                _context9.prev = 15;
                _context9.prev = 16;

                if (!_iteratorNormalCompletion3 && _iterator3.return) {
                  _iterator3.return();
                }

              case 18:
                _context9.prev = 18;

                if (!_didIteratorError3) {
                  _context9.next = 21;
                  break;
                }

                throw _iteratorError3;

              case 21:
                return _context9.finish(18);

              case 22:
                return _context9.finish(15);

              case 23:
                return _context9.abrupt('return', permissions);

              case 24:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this, [[7, 11, 15, 23], [16,, 18, 22]]);
      }));

      function _getPermissionsByRole() {
        return _ref13.apply(this, arguments);
      }

      return _getPermissionsByRole;
    }()

    // TODO: delete when merged with the new collection.

  }, {
    key: 'getRoles',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10() {
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                return _context10.abrupt('return', [{
                  id: 'viewer',
                  name: 'Viewer',
                  permissions: ['view']
                }, {
                  id: 'operator',
                  name: 'Operator',
                  permissions: ['view', 'operate']
                }, {
                  id: 'admin',
                  name: 'Admin',
                  permissions: ['view', 'operate', 'administrate']
                }]);

              case 1:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function getRoles() {
        return _ref14.apply(this, arguments);
      }

      return getRoles;
    }()

    // Returns an array of roles which have a given permission.

  }, {
    key: 'getRolesForPermission',
    value: function () {
      var _ref15 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11(permission) {
        var roles;
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                roles = [];
                _context11.t0 = _utils.forEach;
                _context11.next = 4;
                return this.getRoles();

              case 4:
                _context11.t1 = _context11.sent;

                _context11.t2 = function (role) {
                  if ((0, _utils.includes)(role.permissions, permission)) {
                    roles.push(role.id);
                  }
                };

                (0, _context11.t0)(_context11.t1, _context11.t2);
                return _context11.abrupt('return', roles);

              case 8:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function getRolesForPermission(_x12) {
        return _ref15.apply(this, arguments);
      }

      return getRolesForPermission;
    }()
  }]);
  return _default;
}();

exports.default = _default;
//# sourceMappingURL=acls.js.map
