'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _token = require('../models/token');

var _token2 = _interopRequireDefault(_token);

var _apiErrors = require('xo-common/api-errors');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var noSuchAuthenticationToken = function noSuchAuthenticationToken(id) {
  return (0, _apiErrors.noSuchObject)(id, 'authenticationToken');
};

var ONE_MONTH = 1e3 * 60 * 60 * 24 * 30;

var _default = function () {
  function _default(xo) {
    var _this = this;

    (0, _classCallCheck3.default)(this, _default);

    this._xo = xo;

    // Store last failures by user to throttle tries (slow bruteforce
    // attacks).
    this._failures = (0, _utils.createRawObject)();

    this._providers = new _set2.default();

    // Creates persistent collections.
    var tokensDb = this._tokens = new _token.Tokens({
      connection: xo._redis,
      prefix: 'xo:token',
      indexes: ['user_id']
    });

    // Password authentication provider.
    this.registerAuthenticationProvider(function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
        var username = _ref2.username,
            password = _ref2.password;
        var user;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(username === undefined || password === undefined)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt('return');

              case 2:
                _context.next = 4;
                return xo.getUserByName(username, true);

              case 4:
                user = _context.sent;
                _context.t0 = user;

                if (!_context.t0) {
                  _context.next = 10;
                  break;
                }

                _context.next = 9;
                return xo.checkUserPassword(user.id, password);

              case 9:
                _context.t0 = _context.sent;

              case 10:
                if (!_context.t0) {
                  _context.next = 12;
                  break;
                }

                return _context.abrupt('return', user.id);

              case 12:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());

    // Token authentication provider.
    this.registerAuthenticationProvider(function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
        var tokenId = _ref4.token;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (tokenId) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt('return');

              case 2:
                _context2.prev = 2;
                _context2.next = 5;
                return xo.getAuthenticationToken(tokenId);

              case 5:
                return _context2.abrupt('return', _context2.sent.user_id);

              case 8:
                _context2.prev = 8;
                _context2.t0 = _context2['catch'](2);

              case 10:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this, [[2, 8]]);
      }));

      return function (_x2) {
        return _ref3.apply(this, arguments);
      };
    }());

    xo.on('clean', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
      var tokens, toRemove, now;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return tokensDb.get();

            case 2:
              tokens = _context3.sent;
              toRemove = [];
              now = Date.now();

              (0, _utils.forEach)(tokens, function (_ref6) {
                var expiration = _ref6.expiration,
                    id = _ref6.id;

                if (!expiration || expiration < now) {
                  toRemove.push(id);
                }
              });
              _context3.next = 8;
              return tokensDb.remove(toRemove);

            case 8:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, _this);
    })));

    xo.on('start', function () {
      xo.addConfigManager('authTokens', function () {
        return tokensDb.get();
      }, function (tokens) {
        return tokensDb.update(tokens);
      });
    });
  }

  (0, _createClass3.default)(_default, [{
    key: 'registerAuthenticationProvider',
    value: function registerAuthenticationProvider(provider) {
      return this._providers.add(provider);
    }
  }, {
    key: 'unregisterAuthenticationProvider',
    value: function unregisterAuthenticationProvider(provider) {
      return this._providers.delete(provider);
    }
  }, {
    key: '_authenticateUser',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(credentials) {
        var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, provider, result;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context4.prev = 3;
                _iterator = (0, _getIterator3.default)(this._providers);

              case 5:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context4.next = 31;
                  break;
                }

                provider = _step.value;
                _context4.prev = 7;
                _context4.next = 10;
                return provider(credentials);

              case 10:
                result = _context4.sent;

                if (result) {
                  _context4.next = 13;
                  break;
                }

                return _context4.abrupt('continue', 28);

              case 13:
                if (!result.username) {
                  _context4.next = 19;
                  break;
                }

                _context4.next = 16;
                return this._xo.registerUser(undefined, result.username);

              case 16:
                _context4.t0 = _context4.sent;
                _context4.next = 22;
                break;

              case 19:
                _context4.next = 21;
                return this._xo.getUser(result);

              case 21:
                _context4.t0 = _context4.sent;

              case 22:
                return _context4.abrupt('return', _context4.t0);

              case 25:
                _context4.prev = 25;
                _context4.t1 = _context4['catch'](7);

                // DEPRECATED: Authentication providers may just throw `null`
                // to indicate they could not authenticate the user without
                // any special errors.
                if (_context4.t1) console.error(_context4.t1.stack || _context4.t1);

              case 28:
                _iteratorNormalCompletion = true;
                _context4.next = 5;
                break;

              case 31:
                _context4.next = 37;
                break;

              case 33:
                _context4.prev = 33;
                _context4.t2 = _context4['catch'](3);
                _didIteratorError = true;
                _iteratorError = _context4.t2;

              case 37:
                _context4.prev = 37;
                _context4.prev = 38;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 40:
                _context4.prev = 40;

                if (!_didIteratorError) {
                  _context4.next = 43;
                  break;
                }

                throw _iteratorError;

              case 43:
                return _context4.finish(40);

              case 44:
                return _context4.finish(37);

              case 45:
                return _context4.abrupt('return', false);

              case 46:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this, [[3, 33, 37, 45], [7, 25], [38,, 40, 44]]);
      }));

      function _authenticateUser(_x3) {
        return _ref7.apply(this, arguments);
      }

      return _authenticateUser;
    }()
  }, {
    key: 'authenticateUser',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(credentials) {
        var failures, username, now, lastFailure, user;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                // TODO: remove when email has been replaced by username.
                if (credentials.email) {
                  credentials.username = credentials.email;
                } else if (credentials.username) {
                  credentials.email = credentials.username;
                }

                failures = this._failures;
                username = credentials.username;
                now = Date.now();
                lastFailure = void 0;

                if (!(username && (lastFailure = failures[username]) && lastFailure + 2e3 > now)) {
                  _context5.next = 7;
                  break;
                }

                throw new Error('too fast authentication tries');

              case 7:
                _context5.next = 9;
                return this._authenticateUser(credentials);

              case 9:
                user = _context5.sent;

                if (user) {
                  delete failures[username];
                } else {
                  failures[username] = now;
                }

                return _context5.abrupt('return', user);

              case 12:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function authenticateUser(_x4) {
        return _ref8.apply(this, arguments);
      }

      return authenticateUser;
    }()

    // -----------------------------------------------------------------

  }, {
    key: 'createAuthenticationToken',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(_ref10) {
        var userId = _ref10.userId;
        var token;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.t0 = _token2.default;
                _context6.next = 3;
                return (0, _utils.generateToken)();

              case 3:
                _context6.t1 = _context6.sent;
                _context6.t2 = userId;
                _context6.t3 = Date.now() + ONE_MONTH;
                _context6.t4 = {
                  id: _context6.t1,
                  user_id: _context6.t2,
                  expiration: _context6.t3
                };
                token = new _context6.t0(_context6.t4);
                _context6.next = 10;
                return this._tokens.add(token);

              case 10:
                return _context6.abrupt('return', token.properties);

              case 11:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function createAuthenticationToken(_x5) {
        return _ref9.apply(this, arguments);
      }

      return createAuthenticationToken;
    }()
  }, {
    key: 'deleteAuthenticationToken',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(id) {
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this._tokens.remove(id);

              case 2:
                if (_context7.sent) {
                  _context7.next = 4;
                  break;
                }

                throw noSuchAuthenticationToken(id);

              case 4:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function deleteAuthenticationToken(_x6) {
        return _ref11.apply(this, arguments);
      }

      return deleteAuthenticationToken;
    }()
  }, {
    key: 'getAuthenticationToken',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(id) {
        var token, _context8;

        return _regenerator2.default.wrap(function _callee8$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this._tokens.first(id);

              case 2:
                token = _context9.sent;

                if (token) {
                  _context9.next = 5;
                  break;
                }

                throw noSuchAuthenticationToken(id);

              case 5:

                token = token.properties;

                if (token.expiration > Date.now()) {
                  _context9.next = 9;
                  break;
                }

                (_context8 = this._tokens.remove(id), _utils.pCatch).call(_context8, _utils.noop);

                throw noSuchAuthenticationToken(id);

              case 9:
                return _context9.abrupt('return', token);

              case 10:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee8, this);
      }));

      function getAuthenticationToken(_x7) {
        return _ref12.apply(this, arguments);
      }

      return getAuthenticationToken;
    }()
  }, {
    key: 'getAuthenticationTokensForUser',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(userId) {
        return _regenerator2.default.wrap(function _callee9$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                return _context10.abrupt('return', this._tokens.get({ user_id: userId }));

              case 1:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee9, this);
      }));

      function getAuthenticationTokensForUser(_x8) {
        return _ref13.apply(this, arguments);
      }

      return getAuthenticationTokensForUser;
    }()
  }]);
  return _default;
}();

exports.default = _default;
//# sourceMappingURL=authentication.js.map
