'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _trim2 = require('lodash/trim');

var _trim3 = _interopRequireDefault(_trim2);

var _startsWith2 = require('lodash/startsWith');

var _startsWith3 = _interopRequireDefault(_startsWith2);

var _sortBy2 = require('lodash/sortBy');

var _sortBy3 = _interopRequireDefault(_sortBy2);

var _once2 = require('lodash/once');

var _once3 = _interopRequireDefault(_once2);

var _includes2 = require('lodash/includes');

var _includes3 = _interopRequireDefault(_includes2);

var _findIndex2 = require('lodash/findIndex');

var _findIndex3 = _interopRequireDefault(_findIndex2);

var _find2 = require('lodash/find');

var _find3 = _interopRequireDefault(_find2);

var _filter2 = require('lodash/filter');

var _filter3 = _interopRequireDefault(_filter2);

var _endsWith2 = require('lodash/endsWith');

var _endsWith3 = _interopRequireDefault(_endsWith2);

var _dec, _dec2, _desc, _value, _class;

// Checksums have been corrupted between 5.2.6 and 5.2.7.
//
// For a short period of time, bad checksums will be regenerated
// instead of rejected.
//
// TODO: restore when enough time has passed (a week/a month).
var checkFileIntegrity = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(handler, name) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return handler.refreshChecksum(name);

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function checkFileIntegrity(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

// -------------------------------------------------------------------

var _golikeDefer = require('golike-defer');

var _golikeDefer2 = _interopRequireDefault(_golikeDefer);

var _escapeStringRegexp = require('escape-string-regexp');

var _escapeStringRegexp2 = _interopRequireDefault(_escapeStringRegexp);

var _eventToPromise = require('event-to-promise');

var _eventToPromise2 = _interopRequireDefault(_eventToPromise);

var _execa = require('execa');

var _execa2 = _interopRequireDefault(_execa);

var _splitLines = require('split-lines');

var _splitLines2 = _interopRequireDefault(_splitLines);

var _parsePairs = require('parse-pairs');

var _fs = require('fs');

var _semver = require('semver');

var _d3TimeFormat = require('d3-time-format');

var _path = require('path');

var _vhdMerge = require('../vhd-merge');

var _vhdMerge2 = _interopRequireDefault(_vhdMerge);

var _xapiObjectToXo = require('../xapi-object-to-xo');

var _xapiObjectToXo2 = _interopRequireDefault(_xapiObjectToXo);

var _lvm = require('../lvm');

var _utils = require('../utils');

var _xapi = require('../xapi');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

// ===================================================================

var DELTA_BACKUP_EXT = '.json';
var DELTA_BACKUP_EXT_LENGTH = DELTA_BACKUP_EXT.length;

var shortDate = (0, _d3TimeFormat.utcFormat)('%Y-%m-%d');

// Test if a file is a vdi backup. (full or delta)
var isVdiBackup = function isVdiBackup(name) {
  return (/^\d+T\d+Z_(?:full|delta)\.vhd$/.test(name)
  );
};

// Test if a file is a delta/full vdi backup.
var isDeltaVdiBackup = function isDeltaVdiBackup(name) {
  return (/^\d+T\d+Z_delta\.vhd$/.test(name)
  );
};
var isFullVdiBackup = function isFullVdiBackup(name) {
  return (/^\d+T\d+Z_full\.vhd$/.test(name)
  );
};

var toTimestamp = function toTimestamp(date) {
  return date && Math.round(date.getTime() / 1000);
};

var parseVmBackupPath = function parseVmBackupPath(name) {
  var base = (0, _path.basename)(name);
  var baseMatches = void 0;

  baseMatches = /^([^_]+)_([^_]+)_(.+)\.xva$/.exec(base);
  if (baseMatches) {
    return {
      datetime: toTimestamp((0, _utils.safeDateParse)(baseMatches[1])),
      id: name,
      name: baseMatches[3],
      tag: baseMatches[2],
      type: 'xva'
    };
  }

  var dirMatches = void 0;
  if ((baseMatches = /^([^_]+)_(.+)\.json$/.exec(base)) && (dirMatches = /^vm_delta_([^_]+)_(.+)$/.exec((0, _path.basename)((0, _path.dirname)(name))))) {
    return {
      datetime: toTimestamp((0, _utils.safeDateParse)(baseMatches[1])),
      id: name,
      name: baseMatches[2],
      tag: dirMatches[1],
      type: 'delta',
      uuid: dirMatches[2]
    };
  }

  throw new Error('invalid VM backup filename');
};

// Get the timestamp of a vdi backup. (full or delta)
var getVdiTimestamp = function getVdiTimestamp(name) {
  var arr = /^(\d+T\d+Z)_(?:full|delta)\.vhd$/.exec(name);
  return arr[1];
};

var getDeltaBackupNameWithoutExt = function getDeltaBackupNameWithoutExt(name) {
  return name.slice(0, -DELTA_BACKUP_EXT_LENGTH);
};
var isDeltaBackup = function isDeltaBackup(name) {
  return (0, _endsWith3.default)(name, DELTA_BACKUP_EXT);
};var listPartitions = function () {
  var IGNORED = {};
  (0, _utils.forEach)([
  // https://github.com/jhermsmeier/node-mbr/blob/master/lib/partition.js#L38
  0x05, 0x0F, 0x85, 0x15, 0x91, 0x9B, 0x5E, 0x5F, 0xCF, 0xD5, 0xC5, 0x82 // swap
  ], function (type) {
    IGNORED[type] = true;
  });

  var TYPES = {
    0x7: 'NTFS',
    0x83: 'linux',
    0xc: 'FAT'
  };

  var parseLine = (0, _parsePairs.createParser)({
    keyTransform: function keyTransform(key) {
      return key === 'UUID' ? 'id' : key.toLowerCase();
    },
    valueTransform: function valueTransform(value, key) {
      return key === 'start' || key === 'size' ? +value : key === 'type' ? TYPES[+value] || value : value;
    }
  });

  return function (device) {
    return _execa2.default.stdout('partx', ['--bytes', '--output=NR,START,SIZE,NAME,UUID,TYPE', '--pairs', device.path]).then(function (stdout) {
      return (0, _utils.mapFilter)((0, _splitLines2.default)(stdout), function (line) {
        var partition = parseLine(line);
        var type = partition.type;

        if (type != null && !IGNORED[+type]) {
          return partition;
        }
      });
    });
  };
}();

// handle LVM logical volumes automatically
var listPartitions2 = function listPartitions2(device) {
  return listPartitions(device).then(function (partitions) {
    var partitions2 = [];
    var promises = [];
    (0, _utils.forEach)(partitions, function (partition) {
      if (+partition.type === 0x8e) {
        promises.push(mountLvmPv(device, partition).then(function (device) {
          var promise = listLvmLvs(device).then(function (lvs) {
            (0, _utils.forEach)(lvs, function (lv) {
              partitions2.push({
                name: lv.lv_name,
                size: +lv.lv_size,
                id: `${partition.id}/${lv.vg_name}/${lv.lv_name}`
              });
            });
          });
          _utils.pFinally.call(promise, device.unmount);
          return promise;
        }));
      } else {
        partitions2.push(partition);
      }
    });
    return _promise2.default.all(promises).then(function () {
      return partitions2;
    });
  });
};

var mountPartition = function mountPartition(device, partitionId) {
  return _promise2.default.all([partitionId != null && listPartitions(device), (0, _utils.tmpDir)()]).then(function (_ref2) {
    var _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
        partitions = _ref3[0],
        path = _ref3[1];

    var options = ['loop', 'ro'];

    if (partitions) {
      var partition = (0, _find3.default)(partitions, { id: partitionId });

      var start = partition.start;

      if (start != null) {
        options.push(`offset=${start * 512}`);
      }
    }

    var mount = function mount(options) {
      return (0, _execa2.default)('mount', [`--options=${options.join(',')}`, `--source=${device.path}`, `--target=${path}`]);
    };

    // `noload` option is used for ext3/ext4, if it fails it might
    // `be another fs, try without
    return mount([].concat(options, ['noload'])).catch(function () {
      return mount(options);
    }).then(function () {
      return {
        path,
        unmount: (0, _once3.default)(function () {
          return (0, _execa2.default)('umount', ['--lazy', path]);
        })
      };
    }, function (error) {
      console.log(error);

      throw error;
    });
  });
};

// handle LVM logical volumes automatically
var mountPartition2 = function mountPartition2(device, partitionId) {
  if (partitionId == null || !(0, _includes3.default)(partitionId, '/')) {
    return mountPartition(device, partitionId);
  }

  var _partitionId$split = partitionId.split('/'),
      _partitionId$split2 = (0, _slicedToArray3.default)(_partitionId$split, 3),
      pvId = _partitionId$split2[0],
      vgName = _partitionId$split2[1],
      lvName = _partitionId$split2[2];

  return listPartitions(device).then(function (partitions) {
    return (0, _find3.default)(partitions, { id: pvId });
  }).then(function (pvId) {
    return mountLvmPv(device, pvId);
  }).then(function (device1) {
    return (0, _execa2.default)('vgchange', ['-ay', vgName]).then(function () {
      return (0, _lvm.lvs)(['lv_name', 'lv_path'], vgName).then(function (lvs) {
        return (0, _find3.default)(lvs, { lv_name: lvName }).lv_path;
      });
    }).then(function (path) {
      return mountPartition({ path }).then(function (device2) {
        return (0, _extends3.default)({}, device2, {
          unmount: function unmount() {
            return device2.unmount().then(device1.unmount);
          }
        });
      });
    }).catch(function (error) {
      return device1.unmount().then(function () {
        throw error;
      });
    });
  });
};

// -------------------------------------------------------------------

var listLvmLvs = function listLvmLvs(device) {
  return (0, _lvm.pvs)(['lv_name', 'lv_path', 'lv_size', 'vg_name'], device.path).then(function (pvs) {
    return (0, _filter3.default)(pvs, 'lv_name');
  });
};

var mountLvmPv = function mountLvmPv(device, partition) {
  var args = [];
  if (partition) {
    args.push('-o', partition.start * 512);
  }
  args.push('--show', '-f', device.path);

  return _execa2.default.stdout('losetup', args).then(function (stdout) {
    var path = (0, _trim3.default)(stdout);
    return {
      path,
      unmount: (0, _once3.default)(function () {
        return _promise2.default.all([(0, _execa2.default)('losetup', ['-d', path]), (0, _lvm.pvs)('vg_name', path).then(function (vgNames) {
          return (0, _execa2.default)('vgchange', ['-an'].concat((0, _toConsumableArray3.default)(vgNames)));
        })]);
      })
    };
  });
};

// ===================================================================

var _default = (_dec = _golikeDefer2.default.onFailure, _dec2 = _golikeDefer2.default.onFailure, (_class = function () {
  function _default(xo) {
    (0, _classCallCheck3.default)(this, _default);

    this._xo = xo;

    // clean any LVM volumes that might have not been properly
    // unmounted
    xo.on('start', function () {
      return _promise2.default.all([(0, _execa2.default)('losetup', ['-D']), (0, _execa2.default)('vgchange', ['-an'])]).then(function () {
        return (0, _execa2.default)('pvscan', ['--cache']);
      });
    });
  }

  (0, _createClass3.default)(_default, [{
    key: 'listRemoteBackups',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(remoteId) {
        var _this = this;

        var handler, backupFilter, files, backups, deltaDirs, _loop, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, deltaDir;

        return _regenerator2.default.wrap(function _callee2$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._xo.getRemoteHandler(remoteId);

              case 2:
                handler = _context3.sent;

                // List backups. (No delta)
                backupFilter = function backupFilter(file) {
                  return (0, _endsWith3.default)(file, '.xva');
                };

                _context3.next = 6;
                return handler.list();

              case 6:
                files = _context3.sent;
                backups = (0, _filter3.default)(files, backupFilter);

                // List delta backups.

                deltaDirs = (0, _filter3.default)(files, function (file) {
                  return (0, _startsWith3.default)(file, 'vm_delta_');
                });
                _loop = _regenerator2.default.mark(function _loop(deltaDir) {
                  var files, deltaBackups;
                  return _regenerator2.default.wrap(function _loop$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          _context2.next = 2;
                          return handler.list(deltaDir);

                        case 2:
                          files = _context2.sent;
                          deltaBackups = (0, _filter3.default)(files, isDeltaBackup);


                          backups.push.apply(backups, (0, _toConsumableArray3.default)((0, _utils.mapToArray)(deltaBackups, function (deltaBackup) {
                            return `${deltaDir}/${getDeltaBackupNameWithoutExt(deltaBackup)}`;
                          })));

                        case 5:
                        case 'end':
                          return _context2.stop();
                      }
                    }
                  }, _loop, _this);
                });
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context3.prev = 13;
                _iterator = (0, _getIterator3.default)(deltaDirs);

              case 15:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context3.next = 21;
                  break;
                }

                deltaDir = _step.value;
                return _context3.delegateYield(_loop(deltaDir), 't0', 18);

              case 18:
                _iteratorNormalCompletion = true;
                _context3.next = 15;
                break;

              case 21:
                _context3.next = 27;
                break;

              case 23:
                _context3.prev = 23;
                _context3.t1 = _context3['catch'](13);
                _didIteratorError = true;
                _iteratorError = _context3.t1;

              case 27:
                _context3.prev = 27;
                _context3.prev = 28;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 30:
                _context3.prev = 30;

                if (!_didIteratorError) {
                  _context3.next = 33;
                  break;
                }

                throw _iteratorError;

              case 33:
                return _context3.finish(30);

              case 34:
                return _context3.finish(27);

              case 35:
                return _context3.abrupt('return', backups);

              case 36:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee2, this, [[13, 23, 27, 35], [28,, 30, 34]]);
      }));

      function listRemoteBackups(_x3) {
        return _ref4.apply(this, arguments);
      }

      return listRemoteBackups;
    }()
  }, {
    key: 'listVmBackups',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(remoteId) {
        var handler, backups;
        return _regenerator2.default.wrap(function _callee3$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this._xo.getRemoteHandler(remoteId);

              case 2:
                handler = _context4.sent;
                backups = [];
                _context4.t0 = _promise2.default;
                _context4.t1 = _utils.mapToArray;
                _context4.next = 8;
                return handler.list();

              case 8:
                _context4.t2 = _context4.sent;

                _context4.t3 = function (entry) {
                  if ((0, _endsWith3.default)(entry, '.xva')) {
                    backups.push(parseVmBackupPath(entry));
                  } else if ((0, _startsWith3.default)(entry, 'vm_delta_')) {
                    return handler.list(entry).then(function (children) {
                      return _promise2.default.all((0, _utils.mapToArray)(children, function (child) {
                        if ((0, _endsWith3.default)(child, '.json')) {
                          var path = `${entry}/${child}`;

                          var record = parseVmBackupPath(path);
                          backups.push(record);

                          return handler.readFile(path).then(function (data) {
                            record.disks = (0, _utils.mapToArray)(JSON.parse(data).vdis, function (vdi) {
                              return {
                                id: `${entry}/${vdi.xoPath}`,
                                name: vdi.name_label,
                                uuid: vdi.uuid
                              };
                            });
                          }).catch(_utils.noop);
                        }
                      }));
                    });
                  }
                };

                _context4.t4 = (0, _context4.t1)(_context4.t2, _context4.t3);
                _context4.next = 13;
                return _context4.t0.all.call(_context4.t0, _context4.t4);

              case 13:
                return _context4.abrupt('return', backups);

              case 14:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee3, this);
      }));

      function listVmBackups(_x4) {
        return _ref5.apply(this, arguments);
      }

      return listVmBackups;
    }()
  }, {
    key: 'importVmBackup',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(remoteId, file, sr) {
        var handler, stream, xapi, vm, _parseVmBackupPath, datetime;

        return _regenerator2.default.wrap(function _callee4$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this._xo.getRemoteHandler(remoteId);

              case 2:
                handler = _context5.sent;
                _context5.next = 5;
                return handler.createReadStream(file);

              case 5:
                stream = _context5.sent;
                xapi = this._xo.getXapi(sr);
                _context5.next = 9;
                return xapi.importVm(stream, { srId: sr._xapiId });

              case 9:
                vm = _context5.sent;
                _parseVmBackupPath = parseVmBackupPath(file), datetime = _parseVmBackupPath.datetime;
                _context5.next = 13;
                return _promise2.default.all([xapi.addTag(vm.$id, 'restored from backup'), xapi.editVm(vm.$id, {
                  name_label: `${vm.name_label} (${shortDate(datetime * 1e3)})`
                })]);

              case 13:
                return _context5.abrupt('return', (0, _xapiObjectToXo2.default)(vm).id);

              case 14:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee4, this);
      }));

      function importVmBackup(_x5, _x6, _x7) {
        return _ref6.apply(this, arguments);
      }

      return importVmBackup;
    }()

    // -----------------------------------------------------------------

  }, {
    key: 'deltaCopyVm',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7($onFailure, srcVm, targetSr) {
        var _this2 = this;

        var srcXapi, targetXapi, TAG_LAST_BASE_DELTA, localBaseUuid, dstVm;
        return _regenerator2.default.wrap(function _callee7$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                srcXapi = this._xo.getXapi(srcVm);
                targetXapi = this._xo.getXapi(targetSr);

                // Get Xen objects from XO objects.

                srcVm = srcXapi.getObject(srcVm._xapiId);
                targetSr = targetXapi.getObject(targetSr._xapiId);

                // 1. Find the local base for this SR (if any).
                TAG_LAST_BASE_DELTA = `xo:base_delta:${targetSr.uuid}`;

                localBaseUuid = function (id) {
                  if (id != null) {
                    var base = srcXapi.getObject(id, null);
                    return base && base.uuid;
                  }
                }(srcVm.other_config[TAG_LAST_BASE_DELTA]);

                // 2. Copy.


                _context10.next = 8;
                return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
                  var _context8;

                  var delta, promise, _context7;

                  return _regenerator2.default.wrap(function _callee6$(_context9) {
                    while (1) {
                      switch (_context9.prev = _context9.next) {
                        case 0:
                          _context9.next = 2;
                          return srcXapi.exportDeltaVm(srcVm.$id, localBaseUuid, {
                            snapshotNameLabel: `XO_DELTA_EXPORT: ${targetSr.name_label} (${targetSr.uuid})`
                          });

                        case 2:
                          delta = _context9.sent;

                          $onFailure((0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
                            return _regenerator2.default.wrap(function _callee5$(_context6) {
                              while (1) {
                                switch (_context6.prev = _context6.next) {
                                  case 0:
                                    _context6.next = 2;
                                    return _promise2.default.all((0, _utils.mapToArray)(delta.streams, function (stream) {
                                      return stream.cancel();
                                    }));

                                  case 2:
                                    return _context6.abrupt('return', srcXapi.deleteVm(delta.vm.uuid));

                                  case 3:
                                  case 'end':
                                    return _context6.stop();
                                }
                              }
                            }, _callee5, _this2);
                          })));

                          promise = targetXapi.importDeltaVm(delta, {
                            deleteBase: true, // Remove the remote base.
                            srId: targetSr.$id
                          });

                          // Once done, (asynchronously) remove the (now obsolete) local
                          // base.

                          if (localBaseUuid) {
                            (_context7 = promise.then(function () {
                              return srcXapi.deleteVm(localBaseUuid);
                            }), _utils.pCatch).call(_context7, _utils.noop);
                          }

                          // (Asynchronously) Identify snapshot as future base.
                          (_context8 = promise.then(function () {
                            return srcXapi._updateObjectMapProperty(srcVm, 'other_config', {
                              [TAG_LAST_BASE_DELTA]: delta.vm.uuid
                            });
                          }), _utils.pCatch).call(_context8, _utils.noop);

                          return _context9.abrupt('return', promise);

                        case 8:
                        case 'end':
                          return _context9.stop();
                      }
                    }
                  }, _callee6, _this2);
                }))();

              case 8:
                dstVm = _context10.sent;
                return _context10.abrupt('return', (0, _xapiObjectToXo2.default)(dstVm).id);

              case 10:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee7, this);
      }));

      function deltaCopyVm(_x8, _x9, _x10) {
        return _ref7.apply(this, arguments);
      }

      return deltaCopyVm;
    }()

    // -----------------------------------------------------------------

    // TODO: The other backup methods must use this function !
    // Prerequisite: The backups array must be ordered. (old to new backups)

  }, {
    key: '_removeOldBackups',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(backups, handler, dir, n) {
        var _this3 = this;

        var getPath;
        return _regenerator2.default.wrap(function _callee9$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                if (!(n <= 0)) {
                  _context12.next = 2;
                  break;
                }

                return _context12.abrupt('return');

              case 2:
                getPath = function getPath(file, dir) {
                  return dir ? `${dir}/${file}` : file;
                };

                _context12.next = 5;
                return _promise2.default.all((0, _utils.mapToArray)(backups.slice(0, n), function () {
                  var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(backup) {
                    return _regenerator2.default.wrap(function _callee8$(_context11) {
                      while (1) {
                        switch (_context11.prev = _context11.next) {
                          case 0:
                            return _context11.abrupt('return', /* await */handler.unlink(getPath(backup, dir)));

                          case 1:
                          case 'end':
                            return _context11.stop();
                        }
                      }
                    }, _callee8, _this3);
                  }));

                  return function (_x15) {
                    return _ref11.apply(this, arguments);
                  };
                }()));

              case 5:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee9, this);
      }));

      function _removeOldBackups(_x11, _x12, _x13, _x14) {
        return _ref10.apply(this, arguments);
      }

      return _removeOldBackups;
    }()

    // -----------------------------------------------------------------

  }, {
    key: '_legacyImportDeltaVdiBackup',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(xapi, _ref13) {
        var vmId = _ref13.vmId,
            handler = _ref13.handler,
            dir = _ref13.dir,
            vdiInfo = _ref13.vdiInfo;

        var vdi, vdiId, xoPath, filePath, vdiDir, backups, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, backup, stream;

        return _regenerator2.default.wrap(function _callee10$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return xapi.createVdi(vdiInfo.virtual_size, vdiInfo);

              case 2:
                vdi = _context13.sent;
                vdiId = vdi.$id;

                // dir = vm_delta_xxx
                // xoPath = vdi_xxx/timestamp_(full|delta).vhd
                // vdiDir = vdi_xxx

                xoPath = vdiInfo.xoPath;
                filePath = `${dir}/${xoPath}`;
                vdiDir = (0, _path.dirname)(xoPath);
                _context13.next = 9;
                return this._listDeltaVdiDependencies(handler, filePath);

              case 9:
                backups = _context13.sent;
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context13.prev = 13;
                _iterator2 = (0, _getIterator3.default)(backups);

              case 15:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context13.next = 25;
                  break;
                }

                backup = _step2.value;
                _context13.next = 19;
                return handler.createReadStream(`${dir}/${vdiDir}/${backup}`);

              case 19:
                stream = _context13.sent;
                _context13.next = 22;
                return xapi.importVdiContent(vdiId, stream, {
                  format: _xapi.VDI_FORMAT_VHD
                });

              case 22:
                _iteratorNormalCompletion2 = true;
                _context13.next = 15;
                break;

              case 25:
                _context13.next = 31;
                break;

              case 27:
                _context13.prev = 27;
                _context13.t0 = _context13['catch'](13);
                _didIteratorError2 = true;
                _iteratorError2 = _context13.t0;

              case 31:
                _context13.prev = 31;
                _context13.prev = 32;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 34:
                _context13.prev = 34;

                if (!_didIteratorError2) {
                  _context13.next = 37;
                  break;
                }

                throw _iteratorError2;

              case 37:
                return _context13.finish(34);

              case 38:
                return _context13.finish(31);

              case 39:
                return _context13.abrupt('return', vdiId);

              case 40:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee10, this, [[13, 27, 31, 39], [32,, 34, 38]]);
      }));

      function _legacyImportDeltaVdiBackup(_x16, _x17) {
        return _ref12.apply(this, arguments);
      }

      return _legacyImportDeltaVdiBackup;
    }()
  }, {
    key: '_legacyImportDeltaVmBackup',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee13(xapi, _ref15) {
        var _this4 = this;

        var remoteId = _ref15.remoteId,
            handler = _ref15.handler,
            filePath = _ref15.filePath,
            info = _ref15.info,
            sr = _ref15.sr;
        var vm, vmName, dir, vdiIds;
        return _regenerator2.default.wrap(function _callee13$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                _context16.next = 2;
                return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11() {
                  var stream;
                  return _regenerator2.default.wrap(function _callee11$(_context14) {
                    while (1) {
                      switch (_context14.prev = _context14.next) {
                        case 0:
                          _context14.next = 2;
                          return handler.createReadStream(`${filePath}.xva`);

                        case 2:
                          stream = _context14.sent;
                          return _context14.abrupt('return', /* await */xapi.importVm(stream, { onlyMetadata: true }));

                        case 4:
                        case 'end':
                          return _context14.stop();
                      }
                    }
                  }, _callee11, _this4);
                }))();

              case 2:
                vm = _context16.sent;
                vmName = vm.name_label;
                dir = (0, _path.dirname)(filePath);

                // Disable start and change the VM name label during import.

                _context16.next = 7;
                return _promise2.default.all([xapi.addForbiddenOperationToVm(vm.$id, 'start', 'Delta backup import...'), xapi._setObjectProperties(vm, { name_label: `[Importing...] ${vmName}` })]);

              case 7:
                _context16.next = 9;
                return xapi.destroyVbdsFromVm(vm.uuid);

              case 9:

                // Import VDIs.
                vdiIds = {};
                _context16.next = 12;
                return _promise2.default.all((0, _utils.mapToArray)(info.vdis, function () {
                  var _ref17 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12(vdiInfo) {
                    var vdiId;
                    return _regenerator2.default.wrap(function _callee12$(_context15) {
                      while (1) {
                        switch (_context15.prev = _context15.next) {
                          case 0:
                            vdiInfo.sr = sr._xapiId;

                            _context15.next = 3;
                            return _this4._legacyImportDeltaVdiBackup(xapi, { vmId: vm.$id, handler, dir, vdiInfo });

                          case 3:
                            vdiId = _context15.sent;

                            vdiIds[vdiInfo.uuid] = vdiId;

                          case 5:
                          case 'end':
                            return _context15.stop();
                        }
                      }
                    }, _callee12, _this4);
                  }));

                  return function (_x20) {
                    return _ref17.apply(this, arguments);
                  };
                }()));

              case 12:
                _context16.next = 14;
                return _promise2.default.all((0, _utils.mapToArray)(info.vbds, function (vbdInfo) {
                  xapi.attachVdiToVm(vdiIds[vbdInfo.xoVdi], vm.$id, vbdInfo);
                }));

              case 14:
                _context16.next = 16;
                return _promise2.default.all([xapi.removeForbiddenOperationFromVm(vm.$id, 'start'), xapi._setObjectProperties(vm, { name_label: vmName })]);

              case 16:
                return _context16.abrupt('return', vm);

              case 17:
              case 'end':
                return _context16.stop();
            }
          }
        }, _callee13, this);
      }));

      function _legacyImportDeltaVmBackup(_x18, _x19) {
        return _ref14.apply(this, arguments);
      }

      return _legacyImportDeltaVmBackup;
    }()

    // -----------------------------------------------------------------

  }, {
    key: '_listVdiBackups',
    value: function () {
      var _ref18 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee14(handler, dir) {
        var files, backups, i;
        return _regenerator2.default.wrap(function _callee14$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                files = void 0;
                _context17.prev = 1;
                _context17.next = 4;
                return handler.list(dir);

              case 4:
                files = _context17.sent;
                _context17.next = 14;
                break;

              case 7:
                _context17.prev = 7;
                _context17.t0 = _context17['catch'](1);

                if (!(_context17.t0.code === 'ENOENT')) {
                  _context17.next = 13;
                  break;
                }

                files = [];
                _context17.next = 14;
                break;

              case 13:
                throw _context17.t0;

              case 14:
                backups = (0, _sortBy3.default)((0, _filter3.default)(files, function (fileName) {
                  return isVdiBackup(fileName);
                }));
                i = void 0;

                // Avoid unstable state: No full vdi found to the beginning of array. (base)

                for (i = 0; i < backups.length && isDeltaVdiBackup(backups[i]); i++) {}
                _context17.next = 19;
                return this._removeOldBackups(backups, handler, dir, i);

              case 19:
                return _context17.abrupt('return', backups.slice(i));

              case 20:
              case 'end':
                return _context17.stop();
            }
          }
        }, _callee14, this, [[1, 7]]);
      }));

      function _listVdiBackups(_x21, _x22) {
        return _ref18.apply(this, arguments);
      }

      return _listVdiBackups;
    }()

    // fix the parent UUID and filename in delta files after download from xapi or backup compression

  }, {
    key: '_chainDeltaVdiBackups',
    value: function () {
      var _ref19 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee15(_ref20) {
        var handler = _ref20.handler,
            dir = _ref20.dir;
        var backups, i, childPath, modified;
        return _regenerator2.default.wrap(function _callee15$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                _context18.next = 2;
                return this._listVdiBackups(handler, dir);

              case 2:
                backups = _context18.sent;
                i = 1;

              case 4:
                if (!(i < backups.length)) {
                  _context18.next = 15;
                  break;
                }

                childPath = dir + '/' + backups[i];
                _context18.next = 8;
                return (0, _vhdMerge.chainVhd)(handler, dir + '/' + backups[i - 1], handler, childPath);

              case 8:
                modified = _context18.sent;

                if (!modified) {
                  _context18.next = 12;
                  break;
                }

                _context18.next = 12;
                return handler.refreshChecksum(childPath);

              case 12:
                i++;
                _context18.next = 4;
                break;

              case 15:
              case 'end':
                return _context18.stop();
            }
          }
        }, _callee15, this);
      }));

      function _chainDeltaVdiBackups(_x23) {
        return _ref19.apply(this, arguments);
      }

      return _chainDeltaVdiBackups;
    }()
  }, {
    key: '_mergeDeltaVdiBackups',
    value: function () {
      var _ref21 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee16(_ref22) {
        var handler = _ref22.handler,
            dir = _ref22.dir,
            depth = _ref22.depth;
        var backups, i, timestamp, newFullBackup, j, fullBackupId, parent, backup;
        return _regenerator2.default.wrap(function _callee16$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                _context19.next = 2;
                return this._listVdiBackups(handler, dir);

              case 2:
                backups = _context19.sent;
                i = backups.length - depth;

                // No merge.

                if (!(i <= 0)) {
                  _context19.next = 6;
                  break;
                }

                return _context19.abrupt('return');

              case 6:
                timestamp = getVdiTimestamp(backups[i]);
                newFullBackup = `${dir}/${timestamp}_full.vhd`;
                _context19.next = 10;
                return checkFileIntegrity(handler, `${dir}/${backups[i]}`);

              case 10:
                j = i;

                for (; j > 0 && isDeltaVdiBackup(backups[j]); j--) {}
                fullBackupId = j;

                // Remove old backups before the most recent full.

                if (!(j > 0)) {
                  _context19.next = 21;
                  break;
                }

                j--;

              case 15:
                if (!(j >= 0)) {
                  _context19.next = 21;
                  break;
                }

                _context19.next = 18;
                return handler.unlink(`${dir}/${backups[j]}`, { checksum: true });

              case 18:
                j--;
                _context19.next = 15;
                break;

              case 21:
                parent = `${dir}/${backups[fullBackupId]}`;
                j = fullBackupId + 1;

              case 23:
                if (!(j <= i)) {
                  _context19.next = 41;
                  break;
                }

                backup = `${dir}/${backups[j]}`;
                _context19.prev = 25;
                _context19.next = 28;
                return checkFileIntegrity(handler, backup);

              case 28:
                _context19.next = 30;
                return (0, _vhdMerge2.default)(handler, parent, handler, backup);

              case 30:
                _context19.next = 36;
                break;

              case 32:
                _context19.prev = 32;
                _context19.t0 = _context19['catch'](25);

                console.error('Unable to use vhd-util.', _context19.t0);
                throw _context19.t0;

              case 36:
                _context19.next = 38;
                return handler.unlink(backup, { checksum: true });

              case 38:
                j++;
                _context19.next = 23;
                break;

              case 41:
                _context19.next = 43;
                return handler.rename(parent, newFullBackup);

              case 43:
              case 'end':
                return _context19.stop();
            }
          }
        }, _callee16, this, [[25, 32]]);
      }));

      function _mergeDeltaVdiBackups(_x24) {
        return _ref21.apply(this, arguments);
      }

      return _mergeDeltaVdiBackups;
    }()
  }, {
    key: '_listDeltaVdiDependencies',
    value: function () {
      var _ref23 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee17(handler, filePath) {
        var dir, filename, backups, i, j;
        return _regenerator2.default.wrap(function _callee17$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                dir = (0, _path.dirname)(filePath);
                filename = (0, _path.basename)(filePath);
                _context20.next = 4;
                return this._listVdiBackups(handler, dir);

              case 4:
                backups = _context20.sent;


                // Search file. (delta or full backup)
                i = (0, _findIndex3.default)(backups, function (backup) {
                  return getVdiTimestamp(backup) === getVdiTimestamp(filename);
                });

                if (!(i === -1)) {
                  _context20.next = 8;
                  break;
                }

                throw new Error('VDI to import not found in this remote.');

              case 8:

                // Search full backup.
                j = void 0;


                for (j = i; j >= 0 && isDeltaVdiBackup(backups[j]); j--) {}

                if (!(j === -1)) {
                  _context20.next = 12;
                  break;
                }

                throw new Error(`Unable to found full vdi backup of: ${filePath}`);

              case 12:
                return _context20.abrupt('return', backups.slice(j, i + 1));

              case 13:
              case 'end':
                return _context20.stop();
            }
          }
        }, _callee17, this);
      }));

      function _listDeltaVdiDependencies(_x25, _x26) {
        return _ref23.apply(this, arguments);
      }

      return _listDeltaVdiDependencies;
    }()

    // -----------------------------------------------------------------

  }, {
    key: '_listDeltaVmBackups',
    value: function () {
      var _ref24 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee18(handler, dir) {
        var files;
        return _regenerator2.default.wrap(function _callee18$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                _context21.next = 2;
                return handler.list(dir);

              case 2:
                files = _context21.sent;
                return _context21.abrupt('return', (0, _sortBy3.default)((0, _filter3.default)(files, isDeltaBackup)));

              case 4:
              case 'end':
                return _context21.stop();
            }
          }
        }, _callee18, this);
      }));

      function _listDeltaVmBackups(_x27, _x28) {
        return _ref24.apply(this, arguments);
      }

      return _listDeltaVmBackups;
    }()
  }, {
    key: '_saveDeltaVdiBackup',
    value: function () {
      var _ref25 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee19(xapi, _ref26) {
        var vdiParent = _ref26.vdiParent,
            isFull = _ref26.isFull,
            handler = _ref26.handler,
            stream = _ref26.stream,
            dir = _ref26.dir,
            depth = _ref26.depth;

        var backupDirectory, date, bases, vdiFilename, backupFullPath, targetStream, _context23;

        return _regenerator2.default.wrap(function _callee19$(_context24) {
          while (1) {
            switch (_context24.prev = _context24.next) {
              case 0:
                backupDirectory = `vdi_${vdiParent.uuid}`;

                dir = `${dir}/${backupDirectory}`;

                date = (0, _utils.safeDateFormat)(new Date());

                // For old versions: remove old bases if exists.

                bases = (0, _sortBy3.default)((0, _filter3.default)(vdiParent.$snapshots, { name_label: 'XO_DELTA_BASE_VDI_SNAPSHOT' }), function (base) {
                  return base.snapshot_time;
                });

                (0, _utils.forEach)(bases, function (base) {
                  var _context22;

                  (_context22 = xapi.deleteVdi(base.$id), _utils.pCatch).call(_context22, _utils.noop);
                });

                // Export full or delta backup.
                vdiFilename = `${date}_${isFull ? 'full' : 'delta'}.vhd`;
                backupFullPath = `${dir}/${vdiFilename}`;
                _context24.prev = 7;
                _context24.next = 10;
                return handler.createOutputStream(backupFullPath, {
                  // FIXME: Checksum is not computed for full vdi backups.
                  // The problem is in the merge case, a delta merged in a full vdi
                  // backup forces us to browse the resulting file =>
                  // Significant transfer time on the network !
                  checksum: !isFull
                });

              case 10:
                targetStream = _context24.sent;


                stream.on('error', function (error) {
                  return targetStream.emit('error', error);
                });

                _context24.next = 14;
                return _promise2.default.all([(0, _eventToPromise2.default)(stream.pipe(targetStream), 'finish'), stream.task]);

              case 14:
                _context24.next = 21;
                break;

              case 16:
                _context24.prev = 16;
                _context24.t0 = _context24['catch'](7);
                _context24.next = 20;
                return (_context23 = handler.unlink(backupFullPath, { checksum: true }), _utils.pCatch).call(_context23, _utils.noop);

              case 20:
                throw _context24.t0;

              case 21:
                return _context24.abrupt('return', `${backupDirectory}/${vdiFilename}`);

              case 22:
              case 'end':
                return _context24.stop();
            }
          }
        }, _callee19, this, [[7, 16]]);
      }));

      function _saveDeltaVdiBackup(_x29, _x30) {
        return _ref25.apply(this, arguments);
      }

      return _saveDeltaVdiBackup;
    }()
  }, {
    key: '_removeOldDeltaVmBackups',
    value: function () {
      var _ref27 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee21(xapi, _ref28) {
        var _this5 = this;

        var handler = _ref28.handler,
            dir = _ref28.dir,
            depth = _ref28.depth;
        var backups, nOldBackups;
        return _regenerator2.default.wrap(function _callee21$(_context27) {
          while (1) {
            switch (_context27.prev = _context27.next) {
              case 0:
                _context27.next = 2;
                return this._listDeltaVmBackups(handler, dir);

              case 2:
                backups = _context27.sent;
                nOldBackups = backups.length - depth;

                if (!(nOldBackups > 0)) {
                  _context27.next = 7;
                  break;
                }

                _context27.next = 7;
                return _promise2.default.all((0, _utils.mapToArray)(backups.slice(0, nOldBackups), function () {
                  var _ref29 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee20(backup) {
                    var _context25;

                    return _regenerator2.default.wrap(function _callee20$(_context26) {
                      while (1) {
                        switch (_context26.prev = _context26.next) {
                          case 0:
                            _context26.next = 2;
                            return handler.unlink(`${dir}/${backup}`);

                          case 2:

                            // Remove xva file.
                            // Version 0.0.0 (Legacy) Delta Backup.
                            (_context25 = handler.unlink(`${dir}/${getDeltaBackupNameWithoutExt(backup)}.xva`), _utils.pCatch).call(_context25, _utils.noop);

                          case 3:
                          case 'end':
                            return _context26.stop();
                        }
                      }
                    }, _callee20, _this5);
                  }));

                  return function (_x33) {
                    return _ref29.apply(this, arguments);
                  };
                }()));

              case 7:
              case 'end':
                return _context27.stop();
            }
          }
        }, _callee21, this);
      }));

      function _removeOldDeltaVmBackups(_x31, _x32) {
        return _ref27.apply(this, arguments);
      }

      return _removeOldDeltaVmBackups;
    }()
  }, {
    key: 'rollingDeltaVmBackup',
    value: function () {
      var _ref30 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee26($onFailure, _ref31) {
        var _this6 = this;

        var vm = _ref31.vm,
            remoteId = _ref31.remoteId,
            tag = _ref31.tag,
            depth = _ref31.depth;

        var handler, xapi, bases, baseVm, dir, fullVdisRequired, delta, vdiBackups, fulFilledVdiBackups, error, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, vdiBackup, date, backupFormat, infoPath, _context35;

        return _regenerator2.default.wrap(function _callee26$(_context36) {
          while (1) {
            switch (_context36.prev = _context36.next) {
              case 0:
                _context36.next = 2;
                return this._xo.getRemoteHandler(remoteId);

              case 2:
                handler = _context36.sent;
                xapi = this._xo.getXapi(vm);


                vm = xapi.getObject(vm._xapiId);

                // Get most recent base.
                bases = (0, _sortBy3.default)((0, _filter3.default)(vm.$snapshots, { name_label: `XO_DELTA_BASE_VM_SNAPSHOT_${tag}` }), function (base) {
                  return base.snapshot_time;
                });
                baseVm = bases.pop();

                (0, _utils.forEach)(bases, function (base) {
                  var _context28;

                  (_context28 = xapi.deleteVm(base.$id), _utils.pCatch).call(_context28, _utils.noop);
                });

                // Check backup dirs.
                dir = `vm_delta_${tag}_${vm.uuid}`;
                fullVdisRequired = [];
                _context36.next = 12;
                return _promise2.default.all((0, _utils.mapToArray)(vm.$VBDs, function () {
                  var _ref32 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee22(vbd) {
                    var vdi, backups;
                    return _regenerator2.default.wrap(function _callee22$(_context29) {
                      while (1) {
                        switch (_context29.prev = _context29.next) {
                          case 0:
                            if (!(!vbd.VDI || vbd.type !== 'Disk')) {
                              _context29.next = 2;
                              break;
                            }

                            return _context29.abrupt('return');

                          case 2:
                            vdi = vbd.$VDI;
                            _context29.next = 5;
                            return _this6._listVdiBackups(handler, `${dir}/vdi_${vdi.uuid}`);

                          case 5:
                            backups = _context29.sent;


                            // Force full if missing full.
                            if (!(0, _find3.default)(backups, isFullVdiBackup)) {
                              fullVdisRequired.push(vdi.$id);
                            }

                          case 7:
                          case 'end':
                            return _context29.stop();
                        }
                      }
                    }, _callee22, _this6);
                  }));

                  return function (_x36) {
                    return _ref32.apply(this, arguments);
                  };
                }()));

              case 12:
                _context36.next = 14;
                return xapi.exportDeltaVm(vm.$id, baseVm && baseVm.$id, {
                  snapshotNameLabel: `XO_DELTA_BASE_VM_SNAPSHOT_${tag}`,
                  fullVdisRequired,
                  disableBaseTags: true
                });

              case 14:
                delta = _context36.sent;


                $onFailure((0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee23() {
                  return _regenerator2.default.wrap(function _callee23$(_context30) {
                    while (1) {
                      switch (_context30.prev = _context30.next) {
                        case 0:
                          _context30.next = 2;
                          return _promise2.default.all((0, _utils.mapToArray)(delta.streams, function (stream) {
                            return stream.cancel();
                          }));

                        case 2:
                          _context30.next = 4;
                          return xapi.deleteVm(delta.vm.uuid);

                        case 4:
                        case 'end':
                          return _context30.stop();
                      }
                    }
                  }, _callee23, _this6);
                })));

                // Save vdis.
                _context36.next = 18;
                return (0, _utils.pSettle)((0, _utils.mapToArray)(delta.vdis, function () {
                  var _ref34 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee24(vdi, key) {
                    var vdiParent;
                    return _regenerator2.default.wrap(function _callee24$(_context31) {
                      while (1) {
                        switch (_context31.prev = _context31.next) {
                          case 0:
                            vdiParent = xapi.getObject(vdi.snapshot_of);
                            return _context31.abrupt('return', _this6._saveDeltaVdiBackup(xapi, {
                              vdiParent,
                              isFull: !baseVm || (0, _find3.default)(fullVdisRequired, function (id) {
                                return vdiParent.$id === id;
                              }),
                              handler,
                              stream: delta.streams[`${key}.vhd`],
                              dir,
                              depth
                            }).then(function (path) {
                              delta.vdis[key] = (0, _extends3.default)({}, delta.vdis[key], {
                                xoPath: path
                              });

                              return path;
                            }));

                          case 2:
                          case 'end':
                            return _context31.stop();
                        }
                      }
                    }, _callee24, _this6);
                  }));

                  return function (_x37, _x38) {
                    return _ref34.apply(this, arguments);
                  };
                }()));

              case 18:
                vdiBackups = _context36.sent;
                fulFilledVdiBackups = [];
                error = void 0;

                // One or many vdi backups have failed.

                _iteratorNormalCompletion3 = true;
                _didIteratorError3 = false;
                _iteratorError3 = undefined;
                _context36.prev = 24;
                for (_iterator3 = (0, _getIterator3.default)(vdiBackups); !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                  vdiBackup = _step3.value;

                  if (vdiBackup.isFulfilled()) {
                    fulFilledVdiBackups.push(vdiBackup);
                  } else {
                    error = vdiBackup.reason();
                    console.error('Rejected backup:', error);
                  }
                }

                _context36.next = 32;
                break;

              case 28:
                _context36.prev = 28;
                _context36.t0 = _context36['catch'](24);
                _didIteratorError3 = true;
                _iteratorError3 = _context36.t0;

              case 32:
                _context36.prev = 32;
                _context36.prev = 33;

                if (!_iteratorNormalCompletion3 && _iterator3.return) {
                  _iterator3.return();
                }

              case 35:
                _context36.prev = 35;

                if (!_didIteratorError3) {
                  _context36.next = 38;
                  break;
                }

                throw _iteratorError3;

              case 38:
                return _context36.finish(35);

              case 39:
                return _context36.finish(32);

              case 40:
                $onFailure((0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee25() {
                  return _regenerator2.default.wrap(function _callee25$(_context33) {
                    while (1) {
                      switch (_context33.prev = _context33.next) {
                        case 0:
                          _context33.next = 2;
                          return _promise2.default.all((0, _utils.mapToArray)(fulFilledVdiBackups, function (vdiBackup) {
                            var _context32;

                            return (_context32 = handler.unlink(`${dir}/${vdiBackup.value()}`, { checksum: true }), _utils.pCatch).call(_context32, _utils.noop);
                          }));

                        case 2:
                        case 'end':
                          return _context33.stop();
                      }
                    }
                  }, _callee25, _this6);
                })));

                if (!error) {
                  _context36.next = 43;
                  break;
                }

                throw error;

              case 43:
                date = (0, _utils.safeDateFormat)(new Date());
                backupFormat = `${date}_${vm.name_label}`;
                infoPath = `${dir}/${backupFormat}${DELTA_BACKUP_EXT}`;


                $onFailure(function () {
                  var _context34;

                  return (_context34 = handler.unlink(infoPath), _utils.pCatch).call(_context34, _utils.noop);
                });

                // Write Metadata.
                _context36.next = 49;
                return handler.outputFile(infoPath, (0, _stringify2.default)(delta, null, 2));

              case 49:
                _context36.next = 51;
                return _promise2.default.all((0, _utils.mapToArray)(vdiBackups, function (vdiBackup) {
                  var backupName = vdiBackup.value();
                  var backupDirectory = backupName.slice(0, backupName.lastIndexOf('/'));
                  var backupDir = `${dir}/${backupDirectory}`;
                  return _this6._mergeDeltaVdiBackups({ handler, dir: backupDir, depth }).then(function () {
                    _this6._chainDeltaVdiBackups({ handler, dir: backupDir });
                  });
                }));

              case 51:
                _context36.next = 53;
                return this._removeOldDeltaVmBackups(xapi, { vm, handler, dir, depth });

              case 53:

                if (baseVm) {
                  (_context35 = xapi.deleteVm(baseVm.$id), _utils.pCatch).call(_context35, _utils.noop);
                }

                // Returns relative path.
                return _context36.abrupt('return', `${dir}/${backupFormat}`);

              case 55:
              case 'end':
                return _context36.stop();
            }
          }
        }, _callee26, this, [[24, 28, 32, 40], [33,, 35, 39]]);
      }));

      function rollingDeltaVmBackup(_x34, _x35) {
        return _ref30.apply(this, arguments);
      }

      return rollingDeltaVmBackup;
    }()
  }, {
    key: 'importDeltaVmBackup',
    value: function () {
      var _ref36 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee29(_ref37) {
        var _this7 = this;

        var sr = _ref37.sr,
            remoteId = _ref37.remoteId,
            filePath = _ref37.filePath;

        var _parseVmBackupPath2, datetime, handler, xapi, delta, vm, version, basePath, streams;

        return _regenerator2.default.wrap(function _callee29$(_context39) {
          while (1) {
            switch (_context39.prev = _context39.next) {
              case 0:
                filePath = `${filePath}${DELTA_BACKUP_EXT}`;
                _parseVmBackupPath2 = parseVmBackupPath(filePath), datetime = _parseVmBackupPath2.datetime;
                _context39.next = 4;
                return this._xo.getRemoteHandler(remoteId);

              case 4:
                handler = _context39.sent;
                xapi = this._xo.getXapi(sr);
                _context39.t0 = JSON;
                _context39.next = 9;
                return handler.readFile(filePath);

              case 9:
                _context39.t1 = _context39.sent;
                delta = _context39.t0.parse.call(_context39.t0, _context39.t1);
                vm = void 0;
                version = delta.version;

                if (version) {
                  _context39.next = 19;
                  break;
                }

                _context39.next = 16;
                return this._legacyImportDeltaVmBackup(xapi, {
                  remoteId, handler, filePath, info: delta, sr
                });

              case 16:
                vm = _context39.sent;
                _context39.next = 32;
                break;

              case 19:
                if (!(0, _semver.satisfies)(delta.version, '^1')) {
                  _context39.next = 31;
                  break;
                }

                basePath = (0, _path.dirname)(filePath);
                streams = delta.streams = {};
                _context39.next = 24;
                return _promise2.default.all((0, _utils.mapToArray)(delta.vdis, function () {
                  var _ref38 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee28(vdi, id) {
                    var vdisFolder, backups;
                    return _regenerator2.default.wrap(function _callee28$(_context38) {
                      while (1) {
                        switch (_context38.prev = _context38.next) {
                          case 0:
                            vdisFolder = `${basePath}/${(0, _path.dirname)(vdi.xoPath)}`;
                            _context38.next = 3;
                            return _this7._listDeltaVdiDependencies(handler, `${basePath}/${vdi.xoPath}`);

                          case 3:
                            backups = _context38.sent;
                            _context38.next = 6;
                            return _promise2.default.all((0, _utils.mapToArray)(backups, function () {
                              var _ref39 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee27(backup) {
                                return _regenerator2.default.wrap(function _callee27$(_context37) {
                                  while (1) {
                                    switch (_context37.prev = _context37.next) {
                                      case 0:
                                        return _context37.abrupt('return', handler.createReadStream(`${vdisFolder}/${backup}`, { checksum: true, ignoreMissingChecksum: true }));

                                      case 1:
                                      case 'end':
                                        return _context37.stop();
                                    }
                                  }
                                }, _callee27, _this7);
                              }));

                              return function (_x42) {
                                return _ref39.apply(this, arguments);
                              };
                            }()));

                          case 6:
                            streams[`${id}.vhd`] = _context38.sent;

                          case 7:
                          case 'end':
                            return _context38.stop();
                        }
                      }
                    }, _callee28, _this7);
                  }));

                  return function (_x40, _x41) {
                    return _ref38.apply(this, arguments);
                  };
                }()));

              case 24:

                delta.vm.name_label += ` (${shortDate(datetime * 1e3)})`;
                delta.vm.tags.push('restored from backup');

                _context39.next = 28;
                return xapi.importDeltaVm(delta, {
                  disableStartAfterImport: false,
                  srId: sr._xapiId
                });

              case 28:
                vm = _context39.sent;
                _context39.next = 32;
                break;

              case 31:
                throw new Error(`Unsupported delta backup version: ${version}`);

              case 32:
                return _context39.abrupt('return', (0, _xapiObjectToXo2.default)(vm).id);

              case 33:
              case 'end':
                return _context39.stop();
            }
          }
        }, _callee29, this);
      }));

      function importDeltaVmBackup(_x39) {
        return _ref36.apply(this, arguments);
      }

      return importDeltaVmBackup;
    }()

    // -----------------------------------------------------------------

  }, {
    key: 'backupVm',
    value: function () {
      var _ref40 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee30(_ref41) {
        var vm = _ref41.vm,
            remoteId = _ref41.remoteId,
            file = _ref41.file,
            compress = _ref41.compress,
            onlyMetadata = _ref41.onlyMetadata;
        var handler;
        return _regenerator2.default.wrap(function _callee30$(_context40) {
          while (1) {
            switch (_context40.prev = _context40.next) {
              case 0:
                _context40.next = 2;
                return this._xo.getRemoteHandler(remoteId);

              case 2:
                handler = _context40.sent;
                return _context40.abrupt('return', this._backupVm(vm, handler, file, { compress, onlyMetadata }));

              case 4:
              case 'end':
                return _context40.stop();
            }
          }
        }, _callee30, this);
      }));

      function backupVm(_x43) {
        return _ref40.apply(this, arguments);
      }

      return backupVm;
    }()
  }, {
    key: '_backupVm',
    value: function () {
      var _ref42 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee31(vm, handler, file, _ref43) {
        var compress = _ref43.compress,
            onlyMetadata = _ref43.onlyMetadata;
        var targetStream, promise, sourceStream;
        return _regenerator2.default.wrap(function _callee31$(_context41) {
          while (1) {
            switch (_context41.prev = _context41.next) {
              case 0:
                _context41.next = 2;
                return handler.createOutputStream(file);

              case 2:
                targetStream = _context41.sent;
                promise = (0, _eventToPromise2.default)(targetStream, 'finish');
                _context41.next = 6;
                return this._xo.getXapi(vm).exportVm(vm._xapiId, {
                  compress,
                  onlyMetadata: onlyMetadata || false
                });

              case 6:
                sourceStream = _context41.sent;

                sourceStream.pipe(targetStream);

                _context41.next = 10;
                return promise;

              case 10:
              case 'end':
                return _context41.stop();
            }
          }
        }, _callee31, this);
      }));

      function _backupVm(_x44, _x45, _x46, _x47) {
        return _ref42.apply(this, arguments);
      }

      return _backupVm;
    }()
  }, {
    key: 'rollingBackupVm',
    value: function () {
      var _ref44 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee32(_ref45) {
        var vm = _ref45.vm,
            remoteId = _ref45.remoteId,
            tag = _ref45.tag,
            depth = _ref45.depth,
            compress = _ref45.compress,
            onlyMetadata = _ref45.onlyMetadata;
        var handler, files, reg, backups, date, file;
        return _regenerator2.default.wrap(function _callee32$(_context42) {
          while (1) {
            switch (_context42.prev = _context42.next) {
              case 0:
                _context42.next = 2;
                return this._xo.getRemoteHandler(remoteId);

              case 2:
                handler = _context42.sent;
                _context42.next = 5;
                return handler.list();

              case 5:
                files = _context42.sent;
                reg = new RegExp('^[^_]+_' + (0, _escapeStringRegexp2.default)(`${tag}_${vm.name_label}.xva`));
                backups = (0, _sortBy3.default)((0, _filter3.default)(files, function (fileName) {
                  return reg.test(fileName);
                }));
                date = (0, _utils.safeDateFormat)(new Date());
                file = `${date}_${tag}_${vm.name_label}.xva`;
                _context42.next = 12;
                return this._backupVm(vm, handler, file, { compress, onlyMetadata });

              case 12:
                _context42.next = 14;
                return this._removeOldBackups(backups, handler, undefined, backups.length - (depth - 1));

              case 14:
              case 'end':
                return _context42.stop();
            }
          }
        }, _callee32, this);
      }));

      function rollingBackupVm(_x48) {
        return _ref44.apply(this, arguments);
      }

      return rollingBackupVm;
    }()
  }, {
    key: 'rollingSnapshotVm',
    value: function () {
      var _ref46 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee33(vm, tag, depth) {
        var xapi, reg, snapshots, date, promises, surplus, oldSnap;
        return _regenerator2.default.wrap(function _callee33$(_context43) {
          while (1) {
            switch (_context43.prev = _context43.next) {
              case 0:
                xapi = this._xo.getXapi(vm);

                vm = xapi.getObject(vm._xapiId);

                reg = new RegExp('^rollingSnapshot_[^_]+_' + (0, _escapeStringRegexp2.default)(tag) + '_');
                snapshots = (0, _sortBy3.default)((0, _filter3.default)(vm.$snapshots, function (snapshot) {
                  return reg.test(snapshot.name_label);
                }), 'name_label');
                date = (0, _utils.safeDateFormat)(new Date());
                _context43.next = 7;
                return xapi.snapshotVm(vm.$id, `rollingSnapshot_${date}_${tag}_${vm.name_label}`);

              case 7:
                promises = [];

                for (surplus = snapshots.length - (depth - 1); surplus > 0; surplus--) {
                  oldSnap = snapshots.shift();

                  promises.push(xapi.deleteVm(oldSnap.uuid));
                }
                _context43.next = 11;
                return _promise2.default.all(promises);

              case 11:
              case 'end':
                return _context43.stop();
            }
          }
        }, _callee33, this);
      }));

      function rollingSnapshotVm(_x49, _x50, _x51) {
        return _ref46.apply(this, arguments);
      }

      return rollingSnapshotVm;
    }()
  }, {
    key: 'rollingDrCopyVm',
    value: function () {
      var _ref47 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee34(_ref48) {
        var vm = _ref48.vm,
            sr = _ref48.sr,
            tag = _ref48.tag,
            depth = _ref48.depth;
        var reg, targetXapi, sourceXapi, vms, olderCopies, copyName, drCopy, n;
        return _regenerator2.default.wrap(function _callee34$(_context45) {
          while (1) {
            switch (_context45.prev = _context45.next) {
              case 0:
                tag = 'DR_' + tag;
                reg = new RegExp('^' + (0, _escapeStringRegexp2.default)(`${vm.name_label}_${tag}_`) + '[0-9]{8}T[0-9]{6}Z$');
                targetXapi = this._xo.getXapi(sr);

                sr = targetXapi.getObject(sr._xapiId);
                sourceXapi = this._xo.getXapi(vm);

                vm = sourceXapi.getObject(vm._xapiId);

                vms = {};

                (0, _utils.forEach)(sr.$VDIs, function (vdi) {
                  var vbds = vdi.$VBDs;
                  var vm = vbds && vbds[0] && vbds[0].$VM;
                  if (vm && reg.test(vm.name_label)) {
                    vms[vm.$id] = vm;
                  }
                });
                olderCopies = (0, _sortBy3.default)(vms, 'name_label');
                copyName = `${vm.name_label}_${tag}_${(0, _utils.safeDateFormat)(new Date())}`;
                _context45.next = 12;
                return sourceXapi.remoteCopyVm(vm.$id, targetXapi, sr.$id, {
                  nameLabel: copyName
                });

              case 12:
                drCopy = _context45.sent;
                _context45.next = 15;
                return targetXapi.addTag(drCopy.$id, 'Disaster Recovery');

              case 15:
                n = 1 - depth;
                _context45.next = 18;
                return _promise2.default.all((0, _utils.mapToArray)(n ? olderCopies.slice(0, n) : olderCopies, function (vm) {
                  var _context44;

                  return (
                    // Do not consider a failure to delete an old copy as a fatal error.
                    (_context44 = targetXapi.deleteVm(vm.$id), _utils.pCatch).call(_context44, _utils.noop)
                  );
                }));

              case 18:
              case 'end':
                return _context45.stop();
            }
          }
        }, _callee34, this);
      }));

      function rollingDrCopyVm(_x52) {
        return _ref47.apply(this, arguments);
      }

      return rollingDrCopyVm;
    }()

    // -----------------------------------------------------------------

  }, {
    key: '_mountVhd',
    value: function _mountVhd(remoteId, vhdPath) {
      return _promise2.default.all([this._xo.getRemoteHandler(remoteId), (0, _utils.tmpDir)()]).then(function (_ref49) {
        var _ref50 = (0, _slicedToArray3.default)(_ref49, 2),
            handler = _ref50[0],
            mountDir = _ref50[1];

        if (!handler._getRealPath) {
          throw new Error(`this remote is not supported`);
        }

        var remotePath = handler._getRealPath();
        vhdPath = (0, _utils.resolveSubpath)(remotePath, vhdPath);

        return _promise2.default.resolve().then(function () {
          // TODO: remove when no longer necessary.
          //
          // Currently, the filenames of the VHD changes over time
          // (delta → full), but the JSON is not updated, therefore the
          // VHD path may need to be fixed.
          return (0, _endsWith3.default)(vhdPath, '_delta.vhd') ? (0, _utils.pFromCallback)(function (cb) {
            return (0, _fs.stat)(vhdPath, cb);
          }).then(function () {
            return vhdPath;
          }, function (error) {
            if (error && error.code === 'ENOENT') {
              return `${vhdPath.slice(0, -10)}_full.vhd`;
            }
          }) : vhdPath;
        }).then(function (vhdPath) {
          return (0, _execa2.default)('vhdimount', [vhdPath, mountDir]);
        }).then(function () {
          return (0, _utils.pFromCallback)(function (cb) {
            return (0, _fs.readdir)(mountDir, cb);
          }).then(function (entries) {
            var max = 0;
            (0, _utils.forEach)(entries, function (entry) {
              var matches = /^vhdi(\d+)/.exec(entry);
              if (matches) {
                var value = +matches[1];
                if (value > max) {
                  max = value;
                }
              }
            });

            if (!max) {
              throw new Error('no disks found');
            }

            return {
              path: `${mountDir}/vhdi${max}`,
              unmount: (0, _once3.default)(function () {
                return (0, _execa2.default)('fusermount', ['-uz', mountDir]);
              })
            };
          });
        });
      });
    }
  }, {
    key: '_mountPartition',
    value: function _mountPartition(remoteId, vhdPath, partitionId) {
      return this._mountVhd(remoteId, vhdPath).then(function (device) {
        return mountPartition2(device, partitionId).then(function (partition) {
          return (0, _extends3.default)({}, partition, {
            unmount: function unmount() {
              return partition.unmount().then(device.unmount);
            }
          });
        }).catch(function (error) {
          return device.unmount().then(function () {
            throw error;
          });
        });
      });
    }
  }, {
    key: 'scanDiskBackup',
    value: function () {
      var _ref51 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee35($defer, remoteId, vhdPath) {
        var device;
        return _regenerator2.default.wrap(function _callee35$(_context46) {
          while (1) {
            switch (_context46.prev = _context46.next) {
              case 0:
                _context46.next = 2;
                return this._mountVhd(remoteId, vhdPath);

              case 2:
                device = _context46.sent;

                $defer(device.unmount);

                _context46.next = 6;
                return listPartitions2(device);

              case 6:
                _context46.t0 = _context46.sent;
                return _context46.abrupt('return', {
                  partitions: _context46.t0
                });

              case 8:
              case 'end':
                return _context46.stop();
            }
          }
        }, _callee35, this);
      }));

      function scanDiskBackup(_x53, _x54, _x55) {
        return _ref51.apply(this, arguments);
      }

      return scanDiskBackup;
    }()
  }, {
    key: 'scanFilesInDiskBackup',
    value: function () {
      var _ref52 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee37($defer, remoteId, vhdPath, partitionId, path) {
        var _this8 = this;

        var partition, entries, entriesMap;
        return _regenerator2.default.wrap(function _callee37$(_context49) {
          while (1) {
            switch (_context49.prev = _context49.next) {
              case 0:
                _context49.next = 2;
                return this._mountPartition(remoteId, vhdPath, partitionId);

              case 2:
                partition = _context49.sent;

                $defer(partition.unmount);

                path = (0, _utils.resolveSubpath)(partition.path, path);

                _context49.next = 7;
                return (0, _utils.pFromCallback)(function (cb) {
                  return (0, _fs.readdir)(path, cb);
                });

              case 7:
                entries = _context49.sent;
                entriesMap = {};
                _context49.next = 11;
                return _promise2.default.all((0, _utils.mapToArray)(entries, function () {
                  var _ref53 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee36(name) {
                    var _context47;

                    var stats;
                    return _regenerator2.default.wrap(function _callee36$(_context48) {
                      while (1) {
                        switch (_context48.prev = _context48.next) {
                          case 0:
                            _context48.next = 2;
                            return (_context47 = (0, _utils.pFromCallback)(function (cb) {
                              return (0, _fs.stat)(`${path}/${name}`, cb);
                            }), _utils.pCatch).call(_context47, _utils.noop);

                          case 2:
                            stats = _context48.sent;

                            if (stats) {
                              entriesMap[stats.isDirectory() ? `${name}/` : name] = {};
                            }

                          case 4:
                          case 'end':
                            return _context48.stop();
                        }
                      }
                    }, _callee36, _this8);
                  }));

                  return function (_x61) {
                    return _ref53.apply(this, arguments);
                  };
                }()));

              case 11:
                return _context49.abrupt('return', entriesMap);

              case 12:
              case 'end':
                return _context49.stop();
            }
          }
        }, _callee37, this);
      }));

      function scanFilesInDiskBackup(_x56, _x57, _x58, _x59, _x60) {
        return _ref52.apply(this, arguments);
      }

      return scanFilesInDiskBackup;
    }()
  }, {
    key: 'fetchFilesInDiskBackup',
    value: function () {
      var _ref54 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee38(remoteId, vhdPath, partitionId, paths) {
        var partition, i, onEnd;
        return _regenerator2.default.wrap(function _callee38$(_context50) {
          while (1) {
            switch (_context50.prev = _context50.next) {
              case 0:
                _context50.next = 2;
                return this._mountPartition(remoteId, vhdPath, partitionId);

              case 2:
                partition = _context50.sent;
                i = 0;

                onEnd = function onEnd() {
                  if (! --i) {
                    partition.unmount();
                  }
                };

                return _context50.abrupt('return', (0, _utils.mapToArray)(paths, function (path) {
                  ++i;
                  return (0, _fs.createReadStream)((0, _utils.resolveSubpath)(partition.path, path)).once('end', onEnd);
                }));

              case 6:
              case 'end':
                return _context50.stop();
            }
          }
        }, _callee38, this);
      }));

      function fetchFilesInDiskBackup(_x62, _x63, _x64, _x65) {
        return _ref54.apply(this, arguments);
      }

      return fetchFilesInDiskBackup;
    }()
  }]);
  return _default;
}(), (_applyDecoratedDescriptor(_class.prototype, 'deltaCopyVm', [_dec], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'deltaCopyVm'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'rollingDeltaVmBackup', [_dec2], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'rollingDeltaVmBackup'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'scanDiskBackup', [_golikeDefer2.default], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'scanDiskBackup'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'scanFilesInDiskBackup', [_golikeDefer2.default], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'scanFilesInDiskBackup'), _class.prototype)), _class));

exports.default = _default;
//# sourceMappingURL=backups.js.map
