'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _utils = require('../utils');

var _promiseToolbox = require('promise-toolbox');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ConfigManagement = function () {
  function ConfigManagement() {
    (0, _classCallCheck3.default)(this, ConfigManagement);

    this._managers = { __proto__: null };
  }

  (0, _createClass3.default)(ConfigManagement, [{
    key: 'addConfigManager',
    value: function addConfigManager(id, exporter, importer) {
      var managers = this._managers;
      if (id in managers) {
        throw new Error(`${id} is already taken`);
      }

      this._managers[id] = { exporter, importer };
    }
  }, {
    key: 'exportConfig',
    value: function exportConfig() {
      var _context;

      return (_context = (0, _utils.map)(this._managers, function (_ref, key) {
        var exporter = _ref.exporter;
        return exporter();
      }), _promiseToolbox.all).call(_context);
    }
  }, {
    key: 'importConfig',
    value: function importConfig(config) {
      var _context2;

      var managers = this._managers;

      return (_context2 = (0, _utils.map)(config, function (entry, key) {
        var manager = managers[key];
        if (manager) {
          return manager.importer(entry);
        }
      }), _promiseToolbox.all).call(_context2).then(_utils.noop);
    }
  }]);
  return ConfigManagement;
}();

exports.default = ConfigManagement;
//# sourceMappingURL=config-management.js.map
