'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _desc, _value, _class;

var _concat = require('lodash/concat');

var _concat2 = _interopRequireDefault(_concat);

var _countBy = require('lodash/countBy');

var _countBy2 = _interopRequireDefault(_countBy);

var _difference = require('lodash/difference');

var _difference2 = _interopRequireDefault(_difference);

var _findIndex = require('lodash/findIndex');

var _findIndex2 = _interopRequireDefault(_findIndex);

var _flatten = require('lodash/flatten');

var _flatten2 = _interopRequireDefault(_flatten);

var _highland = require('highland');

var _highland2 = _interopRequireDefault(_highland);

var _includes = require('lodash/includes');

var _includes2 = _interopRequireDefault(_includes);

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _keys = require('lodash/keys');

var _keys2 = _interopRequireDefault(_keys);

var _mapValues = require('lodash/mapValues');

var _mapValues2 = _interopRequireDefault(_mapValues);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _remove = require('lodash/remove');

var _remove2 = _interopRequireDefault(_remove);

var _decoratorSynchronized = require('decorator-synchronized');

var _decoratorSynchronized2 = _interopRequireDefault(_decoratorSynchronized);

var _apiErrors = require('xo-common/api-errors');

var _promiseToolbox = require('promise-toolbox');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

// ===================================================================

var normalize = function normalize(_ref) {
  var addresses = _ref.addresses,
      _ref$id = _ref.id,
      id = _ref$id === undefined ? (0, _utils.throwFn)('id is a required field') : _ref$id,
      _ref$name = _ref.name,
      name = _ref$name === undefined ? '' : _ref$name,
      networks = _ref.networks,
      resourceSets = _ref.resourceSets;
  return {
    addresses,
    id,
    name,
    networks,
    resourceSets
  };
};

var _isAddressInIpPool = function _isAddressInIpPool(address, network, ipPool) {
  return ipPool.addresses && address in ipPool.addresses && (0, _includes2.default)(ipPool.networks, (0, _isObject2.default)(network) ? network.id : network);
};

// ===================================================================

// Note: an address cannot be in two different pools sharing a
// network.
var IpPools = (_class = function () {
  function IpPools(xo) {
    var _this = this;

    (0, _classCallCheck3.default)(this, IpPools);

    this._store = null;
    this._xo = xo;

    xo.on('start', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return xo.getStore('ipPools');

            case 2:
              _this._store = _context.sent;


              xo.addConfigManager('ipPools', function () {
                return _this.getAllIpPools();
              }, function (ipPools) {
                return _promise2.default.all((0, _utils.mapToArray)(ipPools, function (ipPool) {
                  return _this._save(ipPool);
                }));
              });

            case 4:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    })));
  }

  (0, _createClass3.default)(IpPools, [{
    key: 'createIpPool',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
        var addresses = _ref4.addresses,
            name = _ref4.name,
            networks = _ref4.networks;
        var id;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._generateId();

              case 2:
                id = _context2.sent;
                _context2.next = 5;
                return this._save({
                  addresses,
                  id,
                  name,
                  networks
                });

              case 5:
                return _context2.abrupt('return', id);

              case 6:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function createIpPool(_x) {
        return _ref3.apply(this, arguments);
      }

      return createIpPool;
    }()
  }, {
    key: 'deleteIpPool',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(id) {
        var _this2 = this;

        var store;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                store = this._store;
                _context4.next = 3;
                return store.has(id);

              case 3:
                if (!_context4.sent) {
                  _context4.next = 22;
                  break;
                }

                _context4.t0 = _promise2.default;
                _context4.t1 = _utils.mapToArray;
                _context4.next = 8;
                return this._xo.getAllResourceSets();

              case 8:
                _context4.t2 = _context4.sent;

                _context4.t3 = function () {
                  var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(set) {
                    return _regenerator2.default.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.next = 2;
                            return _this2._xo.removeLimitFromResourceSet(`ipPool:${id}`, set.id);

                          case 2:
                            return _context3.abrupt('return', _this2._xo.removeIpPoolFromResourceSet(id, set.id));

                          case 3:
                          case 'end':
                            return _context3.stop();
                        }
                      }
                    }, _callee3, _this2);
                  }));

                  return function (_x3) {
                    return _ref6.apply(this, arguments);
                  };
                }();

                _context4.t4 = (0, _context4.t1)(_context4.t2, _context4.t3);
                _context4.next = 13;
                return _context4.t0.all.call(_context4.t0, _context4.t4);

              case 13:
                _context4.t5 = this;
                _context4.t6 = _mapValues2.default;
                _context4.next = 17;
                return this.getIpPool(id);

              case 17:
                _context4.t7 = _context4.sent.addresses;
                _context4.t8 = (0, _context4.t6)(_context4.t7, 'vifs');
                _context4.next = 21;
                return _context4.t5._removeIpAddressesFromVifs.call(_context4.t5, _context4.t8);

              case 21:
                return _context4.abrupt('return', store.del(id));

              case 22:
                throw (0, _apiErrors.noSuchObject)(id, 'ipPool');

              case 23:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function deleteIpPool(_x2) {
        return _ref5.apply(this, arguments);
      }

      return deleteIpPool;
    }()
  }, {
    key: '_getAllIpPools',
    value: function _getAllIpPools(filter) {
      return (0, _utils.streamToArray)(this._store.createValueStream(), {
        filter,
        mapper: normalize
      });
    }
  }, {
    key: 'getAllIpPools',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(userId) {
        var filter, user, resourceSets, ipPools;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                filter = void 0;

                if (!(userId != null)) {
                  _context5.next = 11;
                  break;
                }

                _context5.next = 4;
                return this._xo.getUser(userId);

              case 4:
                user = _context5.sent;

                if (!(user.permission !== 'admin')) {
                  _context5.next = 11;
                  break;
                }

                _context5.next = 8;
                return this._xo.getAllResourceSets(userId);

              case 8:
                resourceSets = _context5.sent;
                ipPools = (0, _utils.lightSet)((0, _flatten2.default)((0, _utils.mapToArray)(resourceSets, 'ipPools')));

                filter = function filter(_ref8) {
                  var id = _ref8.id;
                  return ipPools.has(id);
                };

              case 11:
                return _context5.abrupt('return', this._getAllIpPools(filter));

              case 12:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getAllIpPools(_x4) {
        return _ref7.apply(this, arguments);
      }

      return getAllIpPools;
    }()
  }, {
    key: 'getIpPool',
    value: function getIpPool(id) {
      return this._store.get(id).then(normalize, function (error) {
        throw error.notFound ? (0, _apiErrors.noSuchObject)(id, 'ipPool') : error;
      });
    }
  }, {
    key: '_getAddressIpPool',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(address, network) {
        var ipPools;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this._getAllIpPools(function (ipPool) {
                  return _isAddressInIpPool(address, network, ipPool);
                });

              case 2:
                ipPools = _context6.sent;
                return _context6.abrupt('return', ipPools && ipPools[0]);

              case 4:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _getAddressIpPool(_x5, _x6) {
        return _ref9.apply(this, arguments);
      }

      return _getAddressIpPool;
    }()

    // Returns a map that indicates how many IPs from each IP pool the VM uses
    // e.g.: { 'ipPool:abc': 3, 'ipPool:xyz': 7 }

  }, {
    key: 'computeVmIpPoolsUsage',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(vm) {
        var vifs, ipPools, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, vifId, _xo$getObject, allowedIpv4Addresses, allowedIpv6Addresses, $network, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, address, ipPool;

        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                vifs = vm.VIFs;
                ipPools = [];
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context7.prev = 5;
                _iterator = (0, _getIterator3.default)(vifs);

              case 7:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context7.next = 41;
                  break;
                }

                vifId = _step.value;
                _xo$getObject = this._xo.getObject(vifId), allowedIpv4Addresses = _xo$getObject.allowedIpv4Addresses, allowedIpv6Addresses = _xo$getObject.allowedIpv6Addresses, $network = _xo$getObject.$network;
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context7.prev = 13;
                _iterator2 = (0, _getIterator3.default)((0, _concat2.default)(allowedIpv4Addresses, allowedIpv6Addresses));

              case 15:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context7.next = 24;
                  break;
                }

                address = _step2.value;
                _context7.next = 19;
                return this._getAddressIpPool(address, $network);

              case 19:
                ipPool = _context7.sent;

                ipPool && ipPools.push(ipPool.id);

              case 21:
                _iteratorNormalCompletion2 = true;
                _context7.next = 15;
                break;

              case 24:
                _context7.next = 30;
                break;

              case 26:
                _context7.prev = 26;
                _context7.t0 = _context7['catch'](13);
                _didIteratorError2 = true;
                _iteratorError2 = _context7.t0;

              case 30:
                _context7.prev = 30;
                _context7.prev = 31;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 33:
                _context7.prev = 33;

                if (!_didIteratorError2) {
                  _context7.next = 36;
                  break;
                }

                throw _iteratorError2;

              case 36:
                return _context7.finish(33);

              case 37:
                return _context7.finish(30);

              case 38:
                _iteratorNormalCompletion = true;
                _context7.next = 7;
                break;

              case 41:
                _context7.next = 47;
                break;

              case 43:
                _context7.prev = 43;
                _context7.t1 = _context7['catch'](5);
                _didIteratorError = true;
                _iteratorError = _context7.t1;

              case 47:
                _context7.prev = 47;
                _context7.prev = 48;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 50:
                _context7.prev = 50;

                if (!_didIteratorError) {
                  _context7.next = 53;
                  break;
                }

                throw _iteratorError;

              case 53:
                return _context7.finish(50);

              case 54:
                return _context7.finish(47);

              case 55:
                return _context7.abrupt('return', (0, _countBy2.default)(ipPools, function (_ref11) {
                  var id = _ref11.id;
                  return `ipPool:${id}`;
                }));

              case 56:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this, [[5, 43, 47, 55], [13, 26, 30, 38], [31,, 33, 37], [48,, 50, 54]]);
      }));

      function computeVmIpPoolsUsage(_x7) {
        return _ref10.apply(this, arguments);
      }

      return computeVmIpPoolsUsage;
    }()
  }, {
    key: 'allocIpAddresses',
    value: function allocIpAddresses(vifId, addAddresses, removeAddresses) {
      var _this3 = this;

      var updatedIpPools = {};
      var limits = {};

      var xoVif = this._xo.getObject(vifId);
      var xapi = this._xo.getXapi(xoVif);
      var vif = xapi.getObject(xoVif._xapiId);

      var allocAndSave = function () {
        var resourseSetId = xapi.xo.getData(vif.VM, 'resourceSet');

        return function () {
          var saveIpPools = function saveIpPools() {
            return _promise2.default.all((0, _utils.mapToArray)(updatedIpPools, function (ipPool) {
              return _this3._save(ipPool);
            }));
          };
          return resourseSetId ? _this3._xo.allocateLimitsInResourceSet(limits, resourseSetId).then(saveIpPools) : saveIpPools();
        };
      }();

      return (0, _promiseToolbox.fromCallback)(function (cb) {
        var network = vif.$network;
        var networkId = network.$id;

        var isVif = function isVif(id) {
          return id === vifId;
        };

        (0, _highland2.default)(_this3._store.createValueStream()).each(function (ipPool) {
          var _ref12 = updatedIpPools[ipPool.id] || ipPool,
              addresses = _ref12.addresses,
              networks = _ref12.networks;

          if (!(addresses && networks && (0, _includes2.default)(networks, networkId))) {
            return false;
          }

          var allocations = 0;
          var changed = false;
          (0, _utils.forEach)(removeAddresses, function (address) {
            var vifs = void 0,
                i = void 0;
            if ((vifs = addresses[address]) && (vifs = vifs.vifs) && (i = (0, _findIndex2.default)(vifs, isVif)) !== -1) {
              vifs.splice(i, 1);
              --allocations;
              changed = true;
            }
          });
          (0, _utils.forEach)(addAddresses, function (address) {
            var data = addresses[address];
            if (!data) {
              return;
            }
            var vifs = data.vifs || (data.vifs = []);
            if (!(0, _includes2.default)(vifs, vifId)) {
              vifs.push(vifId);
              ++allocations;
              changed = true;
            }
          });

          if (changed) {
            var id = ipPool.id;

            updatedIpPools[id] = ipPool;
            limits[`ipPool:${id}`] = (limits[`ipPool:${id}`] || 0) + allocations;
          }
        }).toCallback(cb);
      }).then(allocAndSave);
    }
  }, {
    key: '_removeIpAddressesFromVifs',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(mapAddressVifs) {
        var _this4 = this;

        var mapVifAddresses, getXapi;
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                mapVifAddresses = {};

                (0, _utils.forEach)(mapAddressVifs, function (vifs, address) {
                  (0, _utils.forEach)(vifs, function (vifId) {
                    if (mapVifAddresses[vifId]) {
                      mapVifAddresses[vifId].push(address);
                    } else {
                      mapVifAddresses[vifId] = [address];
                    }
                  });
                });

                getXapi = this._xo.getXapi;
                return _context8.abrupt('return', _promise2.default.all((0, _utils.mapToArray)(mapVifAddresses, function (addresses, vifId) {
                  var vif = void 0;
                  try {
                    // The IP may not have been correctly deallocated from the IP pool when the VIF was deleted
                    vif = _this4._xo.getObject(vifId);
                  } catch (error) {
                    return;
                  }
                  var _vif = vif,
                      allowedIpv4Addresses = _vif.allowedIpv4Addresses,
                      allowedIpv6Addresses = _vif.allowedIpv6Addresses;

                  (0, _remove2.default)(allowedIpv4Addresses, function (address) {
                    return (0, _includes2.default)(addresses, address);
                  });
                  (0, _remove2.default)(allowedIpv6Addresses, function (address) {
                    return (0, _includes2.default)(addresses, address);
                  });
                  _this4.allocIpAddresses(vifId, undefined, (0, _concat2.default)(allowedIpv4Addresses, allowedIpv6Addresses));

                  return getXapi(vif).editVif(vif._xapiId, {
                    ipv4Allowed: allowedIpv4Addresses,
                    ipv6Allowed: allowedIpv6Addresses
                  });
                })));

              case 4:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function _removeIpAddressesFromVifs(_x8) {
        return _ref13.apply(this, arguments);
      }

      return _removeIpAddressesFromVifs;
    }()
  }, {
    key: 'updateIpPool',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(id, _ref15) {
        var addresses = _ref15.addresses,
            name = _ref15.name,
            networks = _ref15.networks,
            resourceSets = _ref15.resourceSets;
        var ipPool, previousAddresses, addresses_, deletedAddresses;
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this.getIpPool(id);

              case 2:
                ipPool = _context9.sent;
                previousAddresses = (0, _extends3.default)({}, ipPool.addresses);


                name != null && (ipPool.name = name);

                if (!addresses) {
                  _context9.next = 12;
                  break;
                }

                addresses_ = ipPool.addresses || {};

                (0, _utils.forEach)(addresses, function (props, address) {
                  if (props === null) {
                    delete addresses_[address];
                  } else {
                    addresses_[address] = props;
                  }
                });

                // Remove the addresses that are no longer in the IP pool from the concerned VIFs
                deletedAddresses = (0, _difference2.default)((0, _keys2.default)(previousAddresses), (0, _keys2.default)(addresses_));
                _context9.next = 11;
                return this._removeIpAddressesFromVifs((0, _pick2.default)(previousAddresses, deletedAddresses));

              case 11:

                if ((0, _utils.isEmpty)(addresses_)) {
                  delete ipPool.addresses;
                } else {
                  ipPool.addresses = addresses_;
                }

              case 12:

                // TODO: Implement patching like for addresses.
                if (networks) {
                  ipPool.networks = networks;
                }

                // TODO: Implement patching like for addresses.
                if (resourceSets) {
                  ipPool.resourceSets = resourceSets;
                }

                _context9.next = 16;
                return this._save(ipPool);

              case 16:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function updateIpPool(_x9, _x10) {
        return _ref14.apply(this, arguments);
      }

      return updateIpPool;
    }()
  }, {
    key: '_generateId',
    value: function () {
      var _ref16 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10() {
        var id;
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                id = void 0;

              case 1:
                id = (0, _utils.generateUnsecureToken)(8);

              case 2:
                _context10.next = 4;
                return this._store.has(id);

              case 4:
                if (_context10.sent) {
                  _context10.next = 1;
                  break;
                }

              case 5:
                return _context10.abrupt('return', id);

              case 6:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function _generateId() {
        return _ref16.apply(this, arguments);
      }

      return _generateId;
    }()
  }, {
    key: '_save',
    value: function _save(ipPool) {
      ipPool = normalize(ipPool);
      return this._store.put(ipPool.id, ipPool);
    }
  }]);
  return IpPools;
}(), (_applyDecoratedDescriptor(_class.prototype, 'allocIpAddresses', [_decoratorSynchronized2.default], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'allocIpAddresses'), _class.prototype)), _class);
exports.default = IpPools;
//# sourceMappingURL=ip-pools.js.map
