'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _assign = require('lodash/assign');

var _assign2 = _interopRequireDefault(_assign);

var _jobExecutor = require('../job-executor');

var _jobExecutor2 = _interopRequireDefault(_jobExecutor);

var _job = require('../models/job');

var _utils = require('../utils');

var _apiErrors = require('xo-common/api-errors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var _default = function () {
  function _default(xo) {
    (0, _classCallCheck3.default)(this, _default);

    this._executor = new _jobExecutor2.default(xo);
    var jobsDb = this._jobs = new _job.Jobs({
      connection: xo._redis,
      prefix: 'xo:job',
      indexes: ['user_id', 'key']
    });

    xo.on('start', function () {
      xo.addConfigManager('jobs', function () {
        return jobsDb.get();
      }, function (jobs) {
        return _promise2.default.all((0, _utils.mapToArray)(jobs, function (job) {
          return jobsDb.save(job);
        }));
      });
    });
  }

  (0, _createClass3.default)(_default, [{
    key: 'getAllJobs',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', /* await */this._jobs.get());

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getAllJobs() {
        return _ref.apply(this, arguments);
      }

      return getAllJobs;
    }()
  }, {
    key: 'getJob',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(id) {
        var job;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._jobs.first(id);

              case 2:
                job = _context2.sent;

                if (job) {
                  _context2.next = 5;
                  break;
                }

                throw (0, _apiErrors.noSuchObject)(id, 'job');

              case 5:
                return _context2.abrupt('return', job.properties);

              case 6:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getJob(_x) {
        return _ref2.apply(this, arguments);
      }

      return getJob;
    }()
  }, {
    key: 'createJob',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(job) {
        var job_;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._jobs.create(job);

              case 2:
                job_ = _context3.sent;
                return _context3.abrupt('return', job_.properties);

              case 4:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function createJob(_x2) {
        return _ref3.apply(this, arguments);
      }

      return createJob;
    }()
  }, {
    key: 'updateJob',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(_ref5) {
        var id = _ref5.id,
            props = (0, _objectWithoutProperties3.default)(_ref5, ['id']);
        var job;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.getJob(id);

              case 2:
                job = _context4.sent;


                (0, _assign2.default)(job, props);
                if (job.timeout === null) {
                  delete job.timeout;
                }

                return _context4.abrupt('return', /* await */this._jobs.save(job));

              case 6:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function updateJob(_x3) {
        return _ref4.apply(this, arguments);
      }

      return updateJob;
    }()
  }, {
    key: 'removeJob',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(id) {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt('return', /* await */this._jobs.remove(id));

              case 1:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function removeJob(_x4) {
        return _ref6.apply(this, arguments);
      }

      return removeJob;
    }()
  }, {
    key: 'runJobSequence',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(idSequence) {
        var _this = this;

        var jobs, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, job;

        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return _promise2.default.all((0, _utils.mapToArray)(idSequence, function (id) {
                  return _this.getJob(id);
                }));

              case 2:
                jobs = _context6.sent;
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context6.prev = 6;
                _iterator = (0, _getIterator3.default)(jobs);

              case 8:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context6.next = 15;
                  break;
                }

                job = _step.value;
                _context6.next = 12;
                return this._executor.exec(job);

              case 12:
                _iteratorNormalCompletion = true;
                _context6.next = 8;
                break;

              case 15:
                _context6.next = 21;
                break;

              case 17:
                _context6.prev = 17;
                _context6.t0 = _context6['catch'](6);
                _didIteratorError = true;
                _iteratorError = _context6.t0;

              case 21:
                _context6.prev = 21;
                _context6.prev = 22;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 24:
                _context6.prev = 24;

                if (!_didIteratorError) {
                  _context6.next = 27;
                  break;
                }

                throw _iteratorError;

              case 27:
                return _context6.finish(24);

              case 28:
                return _context6.finish(21);

              case 29:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this, [[6, 17, 21, 29], [22,, 24, 28]]);
      }));

      function runJobSequence(_x5) {
        return _ref7.apply(this, arguments);
      }

      return runJobSequence;
    }()
  }]);
  return _default;
}();

exports.default = _default;
//# sourceMappingURL=jobs.js.map
