'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _isMyJsonValid = require('is-my-json-valid');

var _isMyJsonValid2 = _interopRequireDefault(_isMyJsonValid);

var _pluginMetadata = require('../models/plugin-metadata');

var _apiErrors = require('xo-common/api-errors');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var _default = function () {
  function _default(xo) {
    var _this = this;

    (0, _classCallCheck3.default)(this, _default);

    this._plugins = (0, _utils.createRawObject)();

    this._pluginsMetadata = new _pluginMetadata.PluginsMetadata({
      connection: xo._redis,
      prefix: 'xo:plugin-metadata'
    });

    xo.on('start', function () {
      xo.addConfigManager('plugins', function () {
        return _this._pluginsMetadata.get();
      }, function (plugins) {
        return _promise2.default.all((0, _utils.mapToArray)(plugins, function (plugin) {
          return _this._pluginsMetadata.save(plugin);
        }));
      });
    });
  }

  (0, _createClass3.default)(_default, [{
    key: '_getRawPlugin',
    value: function _getRawPlugin(id) {
      var plugin = this._plugins[id];
      if (!plugin) {
        throw (0, _apiErrors.noSuchObject)(id, 'plugin');
      }
      return plugin;
    }
  }, {
    key: '_getPluginMetadata',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(id) {
        var metadata;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._pluginsMetadata.first(id);

              case 2:
                metadata = _context.sent;
                return _context.abrupt('return', metadata ? metadata.properties : null);

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _getPluginMetadata(_x) {
        return _ref.apply(this, arguments);
      }

      return _getPluginMetadata;
    }()
  }, {
    key: 'registerPlugin',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(name, instance, configurationSchema, configurationPresets, description, testSchema, version) {
        var _this2 = this;

        var id, plugin, metadata, autoload, configuration;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                id = name;
                plugin = this._plugins[id] = {
                  configurationPresets,
                  configurationSchema,
                  configured: !configurationSchema,
                  description,
                  id,
                  instance,
                  name,
                  testable: (0, _utils.isFunction)(instance.test),
                  testSchema,
                  unloadable: (0, _utils.isFunction)(instance.unload),
                  version
                };
                _context2.next = 4;
                return this._getPluginMetadata(id);

              case 4:
                metadata = _context2.sent;
                autoload = true;
                configuration = void 0;

                if (!metadata) {
                  _context2.next = 12;
                  break;
                }

                autoload = metadata.autoload;
                configuration = metadata.configuration;
                _context2.next = 15;
                break;

              case 12:
                console.log(`[NOTICE] register plugin ${name} for the first time`);
                _context2.next = 15;
                return this._pluginsMetadata.save({
                  id,
                  autoload
                });

              case 15:

                // Configure plugin if necessary. (i.e. configurationSchema)
                // Load plugin.
                // Ignore configuration and loading errors.
                _promise2.default.resolve().then(function () {
                  if (!plugin.configured) {
                    return _this2._configurePlugin(plugin, configuration);
                  }
                }).then(function () {
                  if (autoload) {
                    return _this2.loadPlugin(id);
                  }
                }).catch(function (error) {
                  console.error('register plugin %s: %s', name, error && error.stack || error);
                });

              case 16:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function registerPlugin(_x2, _x3, _x4, _x5, _x6, _x7, _x8) {
        return _ref2.apply(this, arguments);
      }

      return registerPlugin;
    }()
  }, {
    key: '_getPlugin',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(id) {
        var _getRawPlugin2, configurationPresets, configurationSchema, description, loaded, name, testable, testSchema, unloadable, version, _ref4, autoload, configuration;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _getRawPlugin2 = this._getRawPlugin(id), configurationPresets = _getRawPlugin2.configurationPresets, configurationSchema = _getRawPlugin2.configurationSchema, description = _getRawPlugin2.description, loaded = _getRawPlugin2.loaded, name = _getRawPlugin2.name, testable = _getRawPlugin2.testable, testSchema = _getRawPlugin2.testSchema, unloadable = _getRawPlugin2.unloadable, version = _getRawPlugin2.version;
                _context3.next = 3;
                return this._getPluginMetadata(id);

              case 3:
                _context3.t0 = _context3.sent;

                if (_context3.t0) {
                  _context3.next = 6;
                  break;
                }

                _context3.t0 = {};

              case 6:
                _ref4 = _context3.t0;
                autoload = _ref4.autoload;
                configuration = _ref4.configuration;
                return _context3.abrupt('return', {
                  id,
                  name,
                  autoload,
                  description,
                  loaded,
                  unloadable,
                  version,
                  configuration,
                  configurationPresets,
                  configurationSchema,
                  testable,
                  testSchema
                });

              case 10:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _getPlugin(_x9) {
        return _ref3.apply(this, arguments);
      }

      return _getPlugin;
    }()
  }, {
    key: 'getPlugins',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        var _this3 = this;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', /* await */_promise2.default.all((0, _utils.mapToArray)(this._plugins, function (_ref6) {
                  var id = _ref6.id;
                  return _this3._getPlugin(id);
                })));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getPlugins() {
        return _ref5.apply(this, arguments);
      }

      return getPlugins;
    }()

    // Validate the configuration and configure the plugin instance.

  }, {
    key: '_configurePlugin',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(plugin, configuration) {
        var configurationSchema, validate;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                configurationSchema = plugin.configurationSchema;

                if (configurationSchema) {
                  _context5.next = 3;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)('plugin not configurable');

              case 3:
                if (!(configuration == null)) {
                  _context5.next = 5;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)([{
                  field: 'data',
                  message: 'is the wrong type'
                }]);

              case 5:
                validate = (0, _isMyJsonValid2.default)(configurationSchema);

                if (validate(configuration)) {
                  _context5.next = 8;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)(validate.errors);

              case 8:
                _context5.next = 10;
                return plugin.instance.configure((0, _extends3.default)({}, configuration));

              case 10:
                plugin.configured = true;

              case 11:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _configurePlugin(_x10, _x11) {
        return _ref7.apply(this, arguments);
      }

      return _configurePlugin;
    }()

    // Validate the configuration, configure the plugin instance and
    // save the new configuration.

  }, {
    key: 'configurePlugin',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(id, configuration) {
        var plugin;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                plugin = this._getRawPlugin(id);
                _context6.next = 3;
                return this._configurePlugin(plugin, configuration);

              case 3:
                _context6.next = 5;
                return this._pluginsMetadata.merge(id, { configuration });

              case 5:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function configurePlugin(_x12, _x13) {
        return _ref8.apply(this, arguments);
      }

      return configurePlugin;
    }()
  }, {
    key: 'disablePluginAutoload',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(id) {
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this._pluginsMetadata.merge(id, { autoload: false });

              case 2:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function disablePluginAutoload(_x14) {
        return _ref9.apply(this, arguments);
      }

      return disablePluginAutoload;
    }()
  }, {
    key: 'enablePluginAutoload',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(id) {
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this._pluginsMetadata.merge(id, { autoload: true });

              case 2:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function enablePluginAutoload(_x15) {
        return _ref10.apply(this, arguments);
      }

      return enablePluginAutoload;
    }()
  }, {
    key: 'loadPlugin',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(id) {
        var plugin;
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                plugin = this._getRawPlugin(id);

                if (!plugin.loaded) {
                  _context9.next = 3;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)('plugin already loaded');

              case 3:
                if (plugin.configured) {
                  _context9.next = 5;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)('plugin not configured');

              case 5:
                _context9.next = 7;
                return plugin.instance.load();

              case 7:
                plugin.loaded = true;

              case 8:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function loadPlugin(_x16) {
        return _ref11.apply(this, arguments);
      }

      return loadPlugin;
    }()
  }, {
    key: 'unloadPlugin',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(id) {
        var plugin;
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                plugin = this._getRawPlugin(id);

                if (plugin.loaded) {
                  _context10.next = 3;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)('plugin already unloaded');

              case 3:
                if (!(plugin.unloadable === false)) {
                  _context10.next = 5;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)('plugin cannot be unloaded');

              case 5:
                _context10.next = 7;
                return plugin.instance.unload();

              case 7:
                plugin.loaded = false;

              case 8:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function unloadPlugin(_x17) {
        return _ref12.apply(this, arguments);
      }

      return unloadPlugin;
    }()
  }, {
    key: 'purgePluginConfiguration',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11(id) {
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this._pluginsMetadata.merge(id, { configuration: undefined });

              case 2:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function purgePluginConfiguration(_x18) {
        return _ref13.apply(this, arguments);
      }

      return purgePluginConfiguration;
    }()
  }, {
    key: 'testPlugin',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12(id, data) {
        var plugin, testSchema, validate;
        return _regenerator2.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                plugin = this._getRawPlugin(id);

                if (plugin.testable) {
                  _context12.next = 3;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)('plugin not testable');

              case 3:
                if (plugin.loaded) {
                  _context12.next = 5;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)('plugin not loaded');

              case 5:
                testSchema = plugin.testSchema;

                if (!testSchema) {
                  _context12.next = 12;
                  break;
                }

                if (!(data == null)) {
                  _context12.next = 9;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)([{
                  field: 'data',
                  message: 'is the wrong type'
                }]);

              case 9:
                validate = (0, _isMyJsonValid2.default)(testSchema);

                if (validate(data)) {
                  _context12.next = 12;
                  break;
                }

                throw (0, _apiErrors.invalidParameters)(validate.errors);

              case 12:
                _context12.next = 14;
                return plugin.instance.test(data);

              case 14:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function testPlugin(_x19, _x20) {
        return _ref14.apply(this, arguments);
      }

      return testPlugin;
    }()
  }]);
  return _default;
}();

exports.default = _default;
//# sourceMappingURL=plugins.js.map
