'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _apiErrors = require('xo-common/api-errors');

var _local = require('../remote-handlers/local');

var _local2 = _interopRequireDefault(_local);

var _nfs = require('../remote-handlers/nfs');

var _nfs2 = _interopRequireDefault(_nfs);

var _smb = require('../remote-handlers/smb');

var _smb2 = _interopRequireDefault(_smb);

var _utils = require('../utils');

var _remote = require('../models/remote');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var _default = function () {
  function _default(xo) {
    var _this = this;

    (0, _classCallCheck3.default)(this, _default);

    this._remotes = new _remote.Remotes({
      connection: xo._redis,
      prefix: 'xo:remote',
      indexes: ['enabled']
    });

    xo.on('start', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              xo.addConfigManager('remotes', function () {
                return _this._remotes.get();
              }, function (remotes) {
                return _promise2.default.all((0, _utils.mapToArray)(remotes, function (remote) {
                  return _this._remotes.save(remote);
                }));
              });

              _context.next = 3;
              return _this.initRemotes();

            case 3:
              _context.next = 5;
              return _this.syncAllRemotes();

            case 5:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    })));
    xo.on('stop', function () {
      return _this.forgetAllRemotes();
    });
  }

  (0, _createClass3.default)(_default, [{
    key: 'getRemoteHandler',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(remote, ignoreDisabled) {
        var HANDLERS, type, Handler;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(typeof remote === 'string')) {
                  _context2.next = 4;
                  break;
                }

                _context2.next = 3;
                return this.getRemote(remote);

              case 3:
                remote = _context2.sent;

              case 4:
                if (ignoreDisabled || remote.enabled) {
                  _context2.next = 6;
                  break;
                }

                throw new Error('remote is disabled');

              case 6:
                HANDLERS = {
                  file: _local2.default,
                  smb: _smb2.default,
                  nfs: _nfs2.default
                };

                // FIXME: should be done in xo-remote-parser.

                type = remote.url.split('://')[0];
                Handler = HANDLERS[type];

                if (Handler) {
                  _context2.next = 11;
                  break;
                }

                throw new Error('Unhandled remote type');

              case 11:
                return _context2.abrupt('return', new Handler(remote));

              case 12:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getRemoteHandler(_x, _x2) {
        return _ref2.apply(this, arguments);
      }

      return getRemoteHandler;
    }()
  }, {
    key: 'testRemote',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(remote) {
        var handler;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.getRemoteHandler(remote, true);

              case 2:
                handler = _context3.sent;
                return _context3.abrupt('return', handler.test());

              case 4:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function testRemote(_x3) {
        return _ref3.apply(this, arguments);
      }

      return testRemote;
    }()
  }, {
    key: 'getAllRemotes',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', this._remotes.get());

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getAllRemotes() {
        return _ref4.apply(this, arguments);
      }

      return getAllRemotes;
    }()
  }, {
    key: '_getRemote',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(id) {
        var remote;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this._remotes.first(id);

              case 2:
                remote = _context5.sent;

                if (remote) {
                  _context5.next = 5;
                  break;
                }

                throw (0, _apiErrors.noSuchObject)(id, 'remote');

              case 5:
                return _context5.abrupt('return', remote);

              case 6:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _getRemote(_x4) {
        return _ref5.apply(this, arguments);
      }

      return _getRemote;
    }()
  }, {
    key: 'getRemote',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(id) {
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this._getRemote(id);

              case 2:
                return _context6.abrupt('return', _context6.sent.properties);

              case 3:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getRemote(_x5) {
        return _ref6.apply(this, arguments);
      }

      return getRemote;
    }()
  }, {
    key: 'createRemote',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(_ref8) {
        var name = _ref8.name,
            url = _ref8.url;
        var remote;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this._remotes.create(name, url);

              case 2:
                remote = _context7.sent;
                return _context7.abrupt('return', /* await */this.updateRemote(remote.get('id'), { enabled: true }));

              case 4:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function createRemote(_x6) {
        return _ref7.apply(this, arguments);
      }

      return createRemote;
    }()
  }, {
    key: 'updateRemote',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(id, _ref10) {
        var name = _ref10.name,
            url = _ref10.url,
            enabled = _ref10.enabled,
            error = _ref10.error;
        var remote, handler, props;
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this._getRemote(id);

              case 2:
                remote = _context8.sent;

                this._updateRemote(remote, { name, url, enabled, error });
                _context8.next = 6;
                return this.getRemoteHandler(remote.properties, true);

              case 6:
                handler = _context8.sent;
                _context8.next = 9;
                return handler.sync();

              case 9:
                props = _context8.sent;

                this._updateRemote(remote, props);
                _context8.next = 13;
                return this._remotes.save(remote);

              case 13:
                return _context8.abrupt('return', _context8.sent.properties);

              case 14:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function updateRemote(_x7, _x8) {
        return _ref9.apply(this, arguments);
      }

      return updateRemote;
    }()
  }, {
    key: '_updateRemote',
    value: function _updateRemote(remote, _ref11) {
      var name = _ref11.name,
          url = _ref11.url,
          enabled = _ref11.enabled,
          error = _ref11.error;

      if (name) remote.set('name', name);
      if (url) remote.set('url', url);
      if (enabled !== undefined) remote.set('enabled', enabled);
      if (error) {
        remote.set('error', error);
      } else {
        remote.set('error', '');
      }
    }
  }, {
    key: 'removeRemote',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(id) {
        var handler;
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this.getRemoteHandler(id, true);

              case 2:
                handler = _context9.sent;
                _context9.next = 5;
                return handler.forget();

              case 5:
                _context9.next = 7;
                return this._remotes.remove(id);

              case 7:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function removeRemote(_x9) {
        return _ref12.apply(this, arguments);
      }

      return removeRemote;
    }()

    // TODO: Should it be private?

  }, {
    key: 'syncAllRemotes',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10() {
        var _this2 = this;

        var remotes;
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this.getAllRemotes();

              case 2:
                remotes = _context10.sent;

                (0, _utils.forEach)(remotes, function (remote) {
                  _this2.updateRemote(remote.id, {});
                });

              case 4:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function syncAllRemotes() {
        return _ref13.apply(this, arguments);
      }

      return syncAllRemotes;
    }()

    // TODO: Should it be private?

  }, {
    key: 'forgetAllRemotes',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11() {
        var remotes, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, remote;

        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this.getAllRemotes();

              case 2:
                remotes = _context11.sent;
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context11.prev = 6;
                _iterator = (0, _getIterator3.default)(remotes);

              case 8:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context11.next = 21;
                  break;
                }

                remote = _step.value;
                _context11.prev = 10;
                _context11.next = 13;
                return this.getRemoteHandler(remote, true);

              case 13:
                _context11.sent.forget();

                _context11.next = 18;
                break;

              case 16:
                _context11.prev = 16;
                _context11.t0 = _context11['catch'](10);

              case 18:
                _iteratorNormalCompletion = true;
                _context11.next = 8;
                break;

              case 21:
                _context11.next = 27;
                break;

              case 23:
                _context11.prev = 23;
                _context11.t1 = _context11['catch'](6);
                _didIteratorError = true;
                _iteratorError = _context11.t1;

              case 27:
                _context11.prev = 27;
                _context11.prev = 28;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 30:
                _context11.prev = 30;

                if (!_didIteratorError) {
                  _context11.next = 33;
                  break;
                }

                throw _iteratorError;

              case 33:
                return _context11.finish(30);

              case 34:
                return _context11.finish(27);

              case 35:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this, [[6, 23, 27, 35], [10, 16], [28,, 30, 34]]);
      }));

      function forgetAllRemotes() {
        return _ref14.apply(this, arguments);
      }

      return forgetAllRemotes;
    }()

    // TODO: Should it be private?

  }, {
    key: 'initRemotes',
    value: function () {
      var _ref15 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12() {
        var remotes;
        return _regenerator2.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this.getAllRemotes();

              case 2:
                remotes = _context12.sent;

                if (!(!remotes || !remotes.length)) {
                  _context12.next = 6;
                  break;
                }

                _context12.next = 6;
                return this.createRemote({ name: 'default', url: 'file://var/lib/xoa-backups' });

              case 6:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function initRemotes() {
        return _ref15.apply(this, arguments);
      }

      return initRemotes;
    }()
  }]);
  return _default;
}();

exports.default = _default;
//# sourceMappingURL=remotes.js.map
