'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _desc, _value, _class;

var _every = require('lodash/every');

var _every2 = _interopRequireDefault(_every);

var _keyBy = require('lodash/keyBy');

var _keyBy2 = _interopRequireDefault(_keyBy);

var _remove = require('lodash/remove');

var _remove2 = _interopRequireDefault(_remove);

var _some = require('lodash/some');

var _some2 = _interopRequireDefault(_some);

var _decoratorSynchronized = require('decorator-synchronized');

var _decoratorSynchronized2 = _interopRequireDefault(_decoratorSynchronized);

var _apiErrors = require('xo-common/api-errors');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

// ===================================================================

var VM_RESOURCES = {
  cpus: true,
  disk: true,
  disks: true,
  memory: true,
  vms: true
};

var _computeVmResourcesUsage = function _computeVmResourcesUsage(vm) {
  var processed = {};
  var disks = 0;
  var disk = 0;

  (0, _utils.forEach)(vm.$VBDs, function (vbd) {
    var vdi = void 0,
        vdiId = void 0;
    if (vbd.type === 'Disk' && !processed[vdiId = vbd.VDI] && (vdi = vbd.$VDI)) {
      processed[vdiId] = true;
      ++disks;
      disk += +vdi.virtual_size;
    }
  });

  return {
    cpus: vm.VCPUs_at_startup,
    disk,
    disks,
    memory: vm.memory_dynamic_max,
    vms: 1
  };
};

var normalize = function normalize(set) {
  return {
    id: set.id,
    ipPools: set.ipPools || [],
    limits: set.limits ? (0, _utils.map)(set.limits, function (limit) {
      return (0, _utils.isObject)(limit) ? limit : {
        available: limit,
        total: limit
      };
    }) : {},
    name: set.name || '',
    objects: set.objects || [],
    subjects: set.subjects || []
  };
};

// ===================================================================

var _default = (_class = function () {
  function _default(xo) {
    var _this = this;

    (0, _classCallCheck3.default)(this, _default);

    this._xo = xo;

    this._store = null;
    xo.on('start', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              xo.addConfigManager('resourceSets', function () {
                return _this.getAllResourceSets();
              }, function (resourceSets) {
                return _promise2.default.all((0, _utils.mapToArray)(resourceSets, function (resourceSet) {
                  return _this._save(resourceSet);
                }));
              });

              _context.next = 3;
              return xo.getStore('resourceSets');

            case 3:
              _this._store = _context.sent;

            case 4:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    })));
  }

  (0, _createClass3.default)(_default, [{
    key: '_generateId',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        var id;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                id = void 0;

              case 1:
                id = (0, _utils.generateUnsecureToken)(8);

              case 2:
                _context2.next = 4;
                return this._store.has(id);

              case 4:
                if (_context2.sent) {
                  _context2.next = 1;
                  break;
                }

              case 5:
                return _context2.abrupt('return', id);

              case 6:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _generateId() {
        return _ref2.apply(this, arguments);
      }

      return _generateId;
    }()
  }, {
    key: '_save',
    value: function _save(set) {
      return this._store.put(set.id, set);
    }
  }, {
    key: 'checkResourceSetConstraints',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(id, userId, objectIds) {
        var set, user;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.getResourceSet(id);

              case 2:
                set = _context3.sent;
                _context3.next = 5;
                return this._xo.getUser(userId);

              case 5:
                user = _context3.sent;

                if (!(user.permission !== 'admin' &&

                // The set does not contains ANY subjects related to this user
                // (itself or its groups).
                !(0, _some2.default)(set.subjects, (0, _utils.lightSet)(user.groups).add(user.id).has) || objectIds &&

                // The set does not contains ALL objects.
                !(0, _every2.default)(objectIds, (0, _utils.lightSet)(set.objects).has))) {
                  _context3.next = 8;
                  break;
                }

                throw (0, _apiErrors.unauthorized)();

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function checkResourceSetConstraints(_x, _x2, _x3) {
        return _ref3.apply(this, arguments);
      }

      return checkResourceSetConstraints;
    }()
  }, {
    key: 'computeVmResourcesUsage',
    value: function computeVmResourcesUsage(vm) {
      return _computeVmResourcesUsage(this._xo.getXapi(vm).getObject(vm._xapiId));
    }
  }, {
    key: 'createResourceSet',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(name) {
        var subjects = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
        var objects = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
        var limits = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
        var id, set;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this._generateId();

              case 2:
                id = _context4.sent;
                set = normalize({
                  id,
                  name,
                  objects,
                  subjects,
                  limits
                });
                _context4.next = 6;
                return this._store.put(id, set);

              case 6:
                return _context4.abrupt('return', set);

              case 7:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function createResourceSet(_x4) {
        return _ref4.apply(this, arguments);
      }

      return createResourceSet;
    }()
  }, {
    key: 'deleteResourceSet',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(id) {
        var store;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                store = this._store;
                _context5.next = 3;
                return store.has(id);

              case 3:
                if (!_context5.sent) {
                  _context5.next = 5;
                  break;
                }

                return _context5.abrupt('return', store.del(id));

              case 5:
                throw (0, _apiErrors.noSuchObject)(id, 'resourceSet');

              case 6:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function deleteResourceSet(_x8) {
        return _ref5.apply(this, arguments);
      }

      return deleteResourceSet;
    }()
  }, {
    key: 'updateResourceSet',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(id, _ref7) {
        var _ref7$name = _ref7.name,
            name = _ref7$name === undefined ? undefined : _ref7$name,
            _ref7$subjects = _ref7.subjects,
            subjects = _ref7$subjects === undefined ? undefined : _ref7$subjects,
            _ref7$objects = _ref7.objects,
            objects = _ref7$objects === undefined ? undefined : _ref7$objects,
            _ref7$limits = _ref7.limits,
            limits = _ref7$limits === undefined ? undefined : _ref7$limits,
            _ref7$ipPools = _ref7.ipPools,
            ipPools = _ref7$ipPools === undefined ? undefined : _ref7$ipPools;
        var set, previousLimits;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.getResourceSet(id);

              case 2:
                set = _context6.sent;

                if (name) {
                  set.name = name;
                }
                if (subjects) {
                  set.subjects = subjects;
                }
                if (objects) {
                  set.objects = objects;
                }
                if (limits) {
                  previousLimits = set.limits;

                  set.limits = (0, _utils.map)(limits, function (quantity, id) {
                    var previous = previousLimits[id];
                    if (!previous) {
                      return {
                        available: quantity,
                        total: quantity
                      };
                    }

                    var available = previous.available,
                        total = previous.total;


                    return {
                      available: available - total + quantity,
                      total: quantity
                    };
                  });
                }
                if (ipPools) {
                  set.ipPools = ipPools;
                }

                _context6.next = 10;
                return this._save(set);

              case 10:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function updateResourceSet(_x9, _x10) {
        return _ref6.apply(this, arguments);
      }

      return updateResourceSet;
    }()

    // If userId is provided, only resource sets available to that user
    // will be returned.

  }, {
    key: 'getAllResourceSets',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7() {
        var userId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
        var filter, user, userHasSubject;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                filter = void 0;

                if (!(userId != null)) {
                  _context7.next = 6;
                  break;
                }

                _context7.next = 4;
                return this._xo.getUser(userId);

              case 4:
                user = _context7.sent;

                if (user.permission !== 'admin') {
                  userHasSubject = (0, _utils.lightSet)(user.groups).add(user.id).has;

                  filter = function filter(set) {
                    return (0, _some2.default)(set.subjects, userHasSubject);
                  };
                }

              case 6:
                return _context7.abrupt('return', (0, _utils.streamToArray)(this._store.createValueStream(), {
                  filter,
                  mapper: normalize
                }));

              case 7:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function getAllResourceSets() {
        return _ref8.apply(this, arguments);
      }

      return getAllResourceSets;
    }()
  }, {
    key: 'getResourceSet',
    value: function getResourceSet(id) {
      return this._store.get(id).then(normalize, function (error) {
        if (error.notFound) {
          throw (0, _apiErrors.noSuchObject)(id, 'resourceSet');
        }

        throw error;
      });
    }
  }, {
    key: 'addObjectToResourceSet',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(objectId, setId) {
        var set;
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this.getResourceSet(setId);

              case 2:
                set = _context8.sent;

                set.objects.push(objectId);
                _context8.next = 6;
                return this._save(set);

              case 6:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function addObjectToResourceSet(_x12, _x13) {
        return _ref9.apply(this, arguments);
      }

      return addObjectToResourceSet;
    }()
  }, {
    key: 'removeObjectFromResourceSet',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(objectId, setId) {
        var set;
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this.getResourceSet(setId);

              case 2:
                set = _context9.sent;

                (0, _remove2.default)(set.objects, function (id) {
                  return id === objectId;
                });
                _context9.next = 6;
                return this._save(set);

              case 6:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function removeObjectFromResourceSet(_x14, _x15) {
        return _ref10.apply(this, arguments);
      }

      return removeObjectFromResourceSet;
    }()
  }, {
    key: 'addIpPoolToResourceSet',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(ipPoolId, setId) {
        var set;
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this.getResourceSet(setId);

              case 2:
                set = _context10.sent;

                set.ipPools.push(ipPoolId);
                _context10.next = 6;
                return this._save(set);

              case 6:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function addIpPoolToResourceSet(_x16, _x17) {
        return _ref11.apply(this, arguments);
      }

      return addIpPoolToResourceSet;
    }()
  }, {
    key: 'removeIpPoolFromResourceSet',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11(ipPoolId, setId) {
        var set;
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this.getResourceSet(setId);

              case 2:
                set = _context11.sent;

                (0, _remove2.default)(set.ipPools, function (id) {
                  return id === ipPoolId;
                });
                _context11.next = 6;
                return this._save(set);

              case 6:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function removeIpPoolFromResourceSet(_x18, _x19) {
        return _ref12.apply(this, arguments);
      }

      return removeIpPoolFromResourceSet;
    }()
  }, {
    key: 'addSubjectToResourceSet',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12(subjectId, setId) {
        var set;
        return _regenerator2.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this.getResourceSet(setId);

              case 2:
                set = _context12.sent;

                set.subjects.push(subjectId);
                _context12.next = 6;
                return this._save(set);

              case 6:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function addSubjectToResourceSet(_x20, _x21) {
        return _ref13.apply(this, arguments);
      }

      return addSubjectToResourceSet;
    }()
  }, {
    key: 'removeSubjectToResourceSet',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee13(subjectId, setId) {
        var set;
        return _regenerator2.default.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return this.getResourceSet(setId);

              case 2:
                set = _context13.sent;

                (0, _remove2.default)(set.subjects, function (id) {
                  return id === subjectId;
                });
                _context13.next = 6;
                return this._save(set);

              case 6:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function removeSubjectToResourceSet(_x22, _x23) {
        return _ref14.apply(this, arguments);
      }

      return removeSubjectToResourceSet;
    }()
  }, {
    key: 'addLimitToResourceSet',
    value: function () {
      var _ref15 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee14(limitId, quantity, setId) {
        var set;
        return _regenerator2.default.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                _context14.next = 2;
                return this.getResourceSet(setId);

              case 2:
                set = _context14.sent;

                set.limits[limitId] = quantity;
                _context14.next = 6;
                return this._save(set);

              case 6:
              case 'end':
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function addLimitToResourceSet(_x24, _x25, _x26) {
        return _ref15.apply(this, arguments);
      }

      return addLimitToResourceSet;
    }()
  }, {
    key: 'removeLimitFromResourceSet',
    value: function () {
      var _ref16 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee15(limitId, setId) {
        var set;
        return _regenerator2.default.wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _context15.next = 2;
                return this.getResourceSet(setId);

              case 2:
                set = _context15.sent;

                delete set.limits[limitId];
                _context15.next = 6;
                return this._save(set);

              case 6:
              case 'end':
                return _context15.stop();
            }
          }
        }, _callee15, this);
      }));

      function removeLimitFromResourceSet(_x27, _x28) {
        return _ref16.apply(this, arguments);
      }

      return removeLimitFromResourceSet;
    }()
  }, {
    key: 'allocateLimitsInResourceSet',
    value: function () {
      var _ref17 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee16(limits, setId) {
        var set;
        return _regenerator2.default.wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                _context16.next = 2;
                return this.getResourceSet(setId);

              case 2:
                set = _context16.sent;

                (0, _utils.forEach)(limits, function (quantity, id) {
                  var limit = set.limits[id];
                  if (!limit) {
                    return;
                  }

                  if ((limit.available -= quantity) < 0) {
                    throw new Error(`not enough ${id} available in the set ${setId}`);
                  }
                });
                _context16.next = 6;
                return this._save(set);

              case 6:
              case 'end':
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));

      function allocateLimitsInResourceSet(_x29, _x30) {
        return _ref17.apply(this, arguments);
      }

      return allocateLimitsInResourceSet;
    }()
  }, {
    key: 'releaseLimitsInResourceSet',
    value: function () {
      var _ref18 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee17(limits, setId) {
        var set;
        return _regenerator2.default.wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                _context17.next = 2;
                return this.getResourceSet(setId);

              case 2:
                set = _context17.sent;

                (0, _utils.forEach)(limits, function (quantity, id) {
                  var limit = set.limits[id];
                  if (!limit) {
                    return;
                  }

                  if ((limit.available += quantity) > limit.total) {
                    limit.available = limit.total;
                  }
                });
                _context17.next = 6;
                return this._save(set);

              case 6:
              case 'end':
                return _context17.stop();
            }
          }
        }, _callee17, this);
      }));

      function releaseLimitsInResourceSet(_x31, _x32) {
        return _ref18.apply(this, arguments);
      }

      return releaseLimitsInResourceSet;
    }()
  }, {
    key: 'recomputeResourceSetsLimits',
    value: function () {
      var _ref19 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee18() {
        var _this2 = this;

        var sets;
        return _regenerator2.default.wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                _context18.t0 = _keyBy2.default;
                _context18.next = 3;
                return this.getAllResourceSets();

              case 3:
                _context18.t1 = _context18.sent;
                sets = (0, _context18.t0)(_context18.t1, 'id');

                (0, _utils.forEach)(sets, function (_ref20) {
                  var limits = _ref20.limits;

                  (0, _utils.forEach)(limits, function (limit, id) {
                    if (VM_RESOURCES[id]) {
                      // only reset VMs related limits
                      limit.available = limit.total;
                    }
                  });
                });

                (0, _utils.forEach)(this._xo.getAllXapis(), function (xapi) {
                  (0, _utils.forEach)(xapi.objects.all, function (object) {
                    var id = void 0;
                    var set = void 0;
                    if (object.$type !== 'vm' ||

                    // No set for this VM.
                    !(id = xapi.xo.getData(object, 'resourceSet')) ||

                    // Not our set.
                    !(set = sets[id])) {
                      return;
                    }

                    var _set = set,
                        limits = _set.limits;

                    (0, _utils.forEach)(_computeVmResourcesUsage(object), function (usage, resource) {
                      var limit = limits[resource];
                      if (limit) {
                        limit.available -= usage;
                      }
                    });
                  });
                });

                _context18.next = 9;
                return _promise2.default.all((0, _utils.mapToArray)(sets, function (set) {
                  return _this2._save(set);
                }));

              case 9:
              case 'end':
                return _context18.stop();
            }
          }
        }, _callee18, this);
      }));

      function recomputeResourceSetsLimits() {
        return _ref19.apply(this, arguments);
      }

      return recomputeResourceSetsLimits;
    }()
  }]);
  return _default;
}(), (_applyDecoratedDescriptor(_class.prototype, 'allocateLimitsInResourceSet', [_decoratorSynchronized2.default], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'allocateLimitsInResourceSet'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'releaseLimitsInResourceSet', [_decoratorSynchronized2.default], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'releaseLimitsInResourceSet'), _class.prototype)), _class);

exports.default = _default;
//# sourceMappingURL=resource-sets.js.map
