'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _filter = require('lodash/filter');

var _filter2 = _interopRequireDefault(_filter);

var _includes = require('lodash/includes');

var _includes2 = _interopRequireDefault(_includes);

var _hashy = require('hashy');

var _apiErrors = require('xo-common/api-errors');

var _group = require('../models/group');

var _user = require('../models/user');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var addToArraySet = function addToArraySet(set, value) {
  return set && !(0, _includes2.default)(set, value) ? set.concat(value) : [value];
};
var removeFromArraySet = function removeFromArraySet(set, value) {
  return set && (0, _filter2.default)(set, function (current) {
    return current !== value;
  });
};

// ===================================================================

var _default = function () {
  function _default(xo) {
    var _this = this;

    (0, _classCallCheck3.default)(this, _default);

    this._xo = xo;

    var redis = xo._redis;

    var groupsDb = this._groups = new _group.Groups({
      connection: redis,
      prefix: 'xo:group'
    });
    var usersDb = this._users = new _user.Users({
      connection: redis,
      prefix: 'xo:user',
      indexes: ['email']
    });

    xo.on('start', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
      var email, password;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              xo.addConfigManager('groups', function () {
                return groupsDb.get();
              }, function (groups) {
                return _promise2.default.all((0, _utils.mapToArray)(groups, function (group) {
                  return groupsDb.save(group);
                }));
              });
              xo.addConfigManager('users', function () {
                return usersDb.get();
              }, function (users) {
                return _promise2.default.all((0, _utils.mapToArray)(users, function () {
                  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(user) {
                    var userId, conflictUsers;
                    return _regenerator2.default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            userId = user.id;
                            _context.next = 3;
                            return usersDb.get({ email: user.email });

                          case 3:
                            conflictUsers = _context.sent;

                            if ((0, _utils.isEmpty)(conflictUsers)) {
                              _context.next = 7;
                              break;
                            }

                            _context.next = 7;
                            return _promise2.default.all((0, _utils.mapToArray)(conflictUsers, function (_ref3) {
                              var id = _ref3.id;
                              return id !== userId && _this.deleteUser(user.id);
                            }));

                          case 7:
                            return _context.abrupt('return', usersDb.save(user));

                          case 8:
                          case 'end':
                            return _context.stop();
                        }
                      }
                    }, _callee, _this);
                  }));

                  return function (_x) {
                    return _ref2.apply(this, arguments);
                  };
                }()));
              });

              _context2.next = 4;
              return usersDb.exists();

            case 4:
              if (_context2.sent) {
                _context2.next = 10;
                break;
              }

              email = 'admin@admin.net';
              password = 'admin';
              _context2.next = 9;
              return _this.createUser({ email, password, permission: 'admin' });

            case 9:
              console.log('[INFO] Default user created:', email, ' with password', password);

            case 10:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this);
    })));
  }

  // -----------------------------------------------------------------

  (0, _createClass3.default)(_default, [{
    key: 'createUser',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref5) {
        var name = _ref5.name,
            password = _ref5.password,
            properties = (0, _objectWithoutProperties3.default)(_ref5, ['name', 'password']);
        var user;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (name) {
                  properties.email = name;
                }

                if (!password) {
                  _context3.next = 5;
                  break;
                }

                _context3.next = 4;
                return (0, _hashy.hash)(password);

              case 4:
                properties.pw_hash = _context3.sent;

              case 5:
                _context3.next = 7;
                return this._users.create(properties);

              case 7:
                user = _context3.sent;
                return _context3.abrupt('return', user.properties);

              case 9:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function createUser(_x2) {
        return _ref4.apply(this, arguments);
      }

      return createUser;
    }()
  }, {
    key: 'deleteUser',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(id) {
        var _context4,
            _this2 = this;

        var user;
        return _regenerator2.default.wrap(function _callee4$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this.getUser(id);

              case 2:
                user = _context8.sent;
                _context8.next = 5;
                return this._users.remove(id);

              case 5:

                // Remove tokens of user.
                (_context4 = this._xo.getAuthenticationTokensForUser(id).then(function (tokens) {
                  (0, _utils.forEach)(tokens, function (token) {
                    var _context5;

                    (_context5 = _this2._xo.deleteAuthenticationToken(id), _utils.pCatch).call(_context5, _utils.noop);
                  });
                }), _utils.pCatch).call(_context4, _utils.noop); // Ignore any failures.

                // Remove ACLs for this user.
                this._xo.getAclsForSubject(id).then(function (acls) {
                  (0, _utils.forEach)(acls, function (acl) {
                    var _context6;

                    (_context6 = _this2._xo.removeAcl(id, acl.object, acl.action), _utils.pCatch).call(_context6, _utils.noop);
                  });
                });

                // Remove the user from all its groups.
                (0, _utils.forEach)(user.groups, function (groupId) {
                  var _context7;

                  (_context7 = _this2.getGroup(groupId).then(function (group) {
                    return _this2._removeUserFromGroup(id, group);
                  }), _utils.pCatch).call(_context7, _utils.noop); // Ignore any failures.
                });

              case 8:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee4, this);
      }));

      function deleteUser(_x3) {
        return _ref6.apply(this, arguments);
      }

      return deleteUser;
    }()
  }, {
    key: 'updateUser',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(id, _ref8) {
        var email = _ref8.email,
            _ref8$name = _ref8.name,
            name = _ref8$name === undefined ? email : _ref8$name,
            password = _ref8.password,
            permission = _ref8.permission,
            preferences = _ref8.preferences;
        var user, newPreferences;
        return _regenerator2.default.wrap(function _callee5$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this.getUser(id);

              case 2:
                user = _context9.sent;


                if (name) {
                  user.name = name;
                }
                if (permission) {
                  user.permission = permission;
                }

                if (!password) {
                  _context9.next = 9;
                  break;
                }

                _context9.next = 8;
                return (0, _hashy.hash)(password);

              case 8:
                user.pw_hash = _context9.sent;

              case 9:
                newPreferences = (0, _extends3.default)({}, user.preferences);

                (0, _utils.forEach)(preferences, function (value, name) {
                  if (value == null) {
                    delete newPreferences[name];
                  } else {
                    newPreferences[name] = value;
                  }
                });
                user.preferences = (0, _utils.isEmpty)(newPreferences) ? undefined : newPreferences;

                // TODO: remove
                user.email = user.name;
                delete user.name;

                _context9.next = 16;
                return this._users.save(user);

              case 16:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee5, this);
      }));

      function updateUser(_x4, _x5) {
        return _ref7.apply(this, arguments);
      }

      return updateUser;
    }()

    // Merge this method in getUser() when plain objects.

  }, {
    key: '_getUser',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(id) {
        var user;
        return _regenerator2.default.wrap(function _callee6$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this._users.first(id);

              case 2:
                user = _context10.sent;

                if (user) {
                  _context10.next = 5;
                  break;
                }

                throw (0, _apiErrors.noSuchObject)(id, 'user');

              case 5:
                return _context10.abrupt('return', user);

              case 6:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee6, this);
      }));

      function _getUser(_x6) {
        return _ref9.apply(this, arguments);
      }

      return _getUser;
    }()

    // TODO: this method will no longer be async when users are
    // integrated to the main collection.

  }, {
    key: 'getUser',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(id) {
        var user;
        return _regenerator2.default.wrap(function _callee7$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this._getUser(id);

              case 2:
                user = _context11.sent.properties;


                // TODO: remove when no longer the email property has been
                // completely eradicated.
                user.name = user.email;

                return _context11.abrupt('return', user);

              case 5:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee7, this);
      }));

      function getUser(_x7) {
        return _ref10.apply(this, arguments);
      }

      return getUser;
    }()
  }, {
    key: 'getAllUsers',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8() {
        return _regenerator2.default.wrap(function _callee8$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                return _context12.abrupt('return', this._users.get());

              case 1:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee8, this);
      }));

      function getAllUsers() {
        return _ref11.apply(this, arguments);
      }

      return getAllUsers;
    }()
  }, {
    key: 'getUserByName',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(username, returnNullIfMissing) {
        var user;
        return _regenerator2.default.wrap(function _callee9$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return this._users.first({ email: username });

              case 2:
                user = _context13.sent;

                if (!user) {
                  _context13.next = 5;
                  break;
                }

                return _context13.abrupt('return', user.properties);

              case 5:
                if (!returnNullIfMissing) {
                  _context13.next = 7;
                  break;
                }

                return _context13.abrupt('return', null);

              case 7:
                throw (0, _apiErrors.noSuchObject)(username, 'user');

              case 8:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee9, this);
      }));

      function getUserByName(_x8, _x9) {
        return _ref12.apply(this, arguments);
      }

      return getUserByName;
    }()

    // Get or create a user associated with an auth provider.

  }, {
    key: 'registerUser',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(provider, name) {
        var user;
        return _regenerator2.default.wrap(function _callee10$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                _context14.next = 2;
                return this.getUserByName(name, true);

              case 2:
                user = _context14.sent;

                if (!user) {
                  _context14.next = 7;
                  break;
                }

                if (!(user._provider !== provider)) {
                  _context14.next = 6;
                  break;
                }

                throw new Error(`the name ${name} is already taken`);

              case 6:
                return _context14.abrupt('return', user);

              case 7:
                if (this._xo._config.createUserOnFirstSignin) {
                  _context14.next = 9;
                  break;
                }

                throw new Error(`registering ${name} user is forbidden`);

              case 9:
                return _context14.abrupt('return', /* await */this.createUser({
                  name,
                  _provider: provider
                }));

              case 10:
              case 'end':
                return _context14.stop();
            }
          }
        }, _callee10, this);
      }));

      function registerUser(_x10, _x11) {
        return _ref13.apply(this, arguments);
      }

      return registerUser;
    }()
  }, {
    key: 'changeUserPassword',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11(userId, oldPassword, newPassword) {
        return _regenerator2.default.wrap(function _callee11$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _context15.next = 2;
                return this.checkUserPassword(userId, oldPassword, false);

              case 2:
                if (_context15.sent) {
                  _context15.next = 4;
                  break;
                }

                throw (0, _apiErrors.invalidCredentials)();

              case 4:
                _context15.next = 6;
                return this.updateUser(userId, { password: newPassword });

              case 6:
              case 'end':
                return _context15.stop();
            }
          }
        }, _callee11, this);
      }));

      function changeUserPassword(_x12, _x13, _x14) {
        return _ref14.apply(this, arguments);
      }

      return changeUserPassword;
    }()
  }, {
    key: 'checkUserPassword',
    value: function () {
      var _ref15 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12(userId, password) {
        var updateIfNecessary = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

        var _ref16, hash;

        return _regenerator2.default.wrap(function _callee12$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                _context16.next = 2;
                return this.getUser(userId);

              case 2:
                _ref16 = _context16.sent;
                hash = _ref16.pw_hash;
                _context16.t0 = hash;

                if (!_context16.t0) {
                  _context16.next = 9;
                  break;
                }

                _context16.next = 8;
                return (0, _hashy.verify)(password, hash);

              case 8:
                _context16.t0 = _context16.sent;

              case 9:
                if (_context16.t0) {
                  _context16.next = 11;
                  break;
                }

                return _context16.abrupt('return', false);

              case 11:
                if (!(updateIfNecessary && (0, _hashy.needsRehash)(hash))) {
                  _context16.next = 14;
                  break;
                }

                _context16.next = 14;
                return this.updateUser(userId, { password });

              case 14:
                return _context16.abrupt('return', true);

              case 15:
              case 'end':
                return _context16.stop();
            }
          }
        }, _callee12, this);
      }));

      function checkUserPassword(_x15, _x16) {
        return _ref15.apply(this, arguments);
      }

      return checkUserPassword;
    }()

    // -----------------------------------------------------------------

  }, {
    key: 'createGroup',
    value: function () {
      var _ref17 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee13(_ref18) {
        var name = _ref18.name;
        var group;
        return _regenerator2.default.wrap(function _callee13$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                _context17.next = 2;
                return this._groups.create(name);

              case 2:
                group = _context17.sent.properties;
                return _context17.abrupt('return', group);

              case 4:
              case 'end':
                return _context17.stop();
            }
          }
        }, _callee13, this);
      }));

      function createGroup(_x18) {
        return _ref17.apply(this, arguments);
      }

      return createGroup;
    }()
  }, {
    key: 'deleteGroup',
    value: function () {
      var _ref19 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee14(id) {
        var _this3 = this;

        var group;
        return _regenerator2.default.wrap(function _callee14$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                _context20.next = 2;
                return this.getGroup(id);

              case 2:
                group = _context20.sent;
                _context20.next = 5;
                return this._groups.remove(id);

              case 5:

                // Remove ACLs for this group.
                this._xo.getAclsForSubject(id).then(function (acls) {
                  (0, _utils.forEach)(acls, function (acl) {
                    var _context18;

                    (_context18 = _this3._xo.removeAcl(id, acl.object, acl.action), _utils.pCatch).call(_context18, _utils.noop);
                  });
                });

                // Remove the group from all its users.
                (0, _utils.forEach)(group.users, function (userId) {
                  var _context19;

                  (_context19 = _this3.getUser(userId).then(function (user) {
                    return _this3._removeGroupFromUser(id, user);
                  }), _utils.pCatch).call(_context19, _utils.noop); // Ignore any failures.
                });

              case 7:
              case 'end':
                return _context20.stop();
            }
          }
        }, _callee14, this);
      }));

      function deleteGroup(_x19) {
        return _ref19.apply(this, arguments);
      }

      return deleteGroup;
    }()
  }, {
    key: 'updateGroup',
    value: function () {
      var _ref20 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee15(id, _ref21) {
        var name = _ref21.name;
        var group;
        return _regenerator2.default.wrap(function _callee15$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                _context21.next = 2;
                return this.getGroup(id);

              case 2:
                group = _context21.sent;


                if (name) group.name = name;

                _context21.next = 6;
                return this._groups.save(group);

              case 6:
              case 'end':
                return _context21.stop();
            }
          }
        }, _callee15, this);
      }));

      function updateGroup(_x20, _x21) {
        return _ref20.apply(this, arguments);
      }

      return updateGroup;
    }()
  }, {
    key: 'getGroup',
    value: function () {
      var _ref22 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee16(id) {
        var group;
        return _regenerator2.default.wrap(function _callee16$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                _context22.next = 2;
                return this._groups.first(id);

              case 2:
                group = _context22.sent;

                if (group) {
                  _context22.next = 5;
                  break;
                }

                throw (0, _apiErrors.noSuchObject)(id, 'group');

              case 5:
                return _context22.abrupt('return', group.properties);

              case 6:
              case 'end':
                return _context22.stop();
            }
          }
        }, _callee16, this);
      }));

      function getGroup(_x22) {
        return _ref22.apply(this, arguments);
      }

      return getGroup;
    }()
  }, {
    key: 'getAllGroups',
    value: function () {
      var _ref23 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee17() {
        return _regenerator2.default.wrap(function _callee17$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                return _context23.abrupt('return', this._groups.get());

              case 1:
              case 'end':
                return _context23.stop();
            }
          }
        }, _callee17, this);
      }));

      function getAllGroups() {
        return _ref23.apply(this, arguments);
      }

      return getAllGroups;
    }()
  }, {
    key: 'addUserToGroup',
    value: function () {
      var _ref24 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee18(userId, groupId) {
        var _ref25, _ref26, user, group;

        return _regenerator2.default.wrap(function _callee18$(_context24) {
          while (1) {
            switch (_context24.prev = _context24.next) {
              case 0:
                _context24.next = 2;
                return _promise2.default.all([this.getUser(userId), this.getGroup(groupId)]);

              case 2:
                _ref25 = _context24.sent;
                _ref26 = (0, _slicedToArray3.default)(_ref25, 2);
                user = _ref26[0];
                group = _ref26[1];


                user.groups = addToArraySet(user.groups, groupId);
                group.users = addToArraySet(group.users, userId);

                _context24.next = 10;
                return _promise2.default.all([this._users.save(user), this._groups.save(group)]);

              case 10:
              case 'end':
                return _context24.stop();
            }
          }
        }, _callee18, this);
      }));

      function addUserToGroup(_x23, _x24) {
        return _ref24.apply(this, arguments);
      }

      return addUserToGroup;
    }()
  }, {
    key: '_removeUserFromGroup',
    value: function () {
      var _ref27 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee19(userId, group) {
        return _regenerator2.default.wrap(function _callee19$(_context25) {
          while (1) {
            switch (_context25.prev = _context25.next) {
              case 0:
                group.users = removeFromArraySet(group.users, userId);
                return _context25.abrupt('return', this._groups.save(group));

              case 2:
              case 'end':
                return _context25.stop();
            }
          }
        }, _callee19, this);
      }));

      function _removeUserFromGroup(_x25, _x26) {
        return _ref27.apply(this, arguments);
      }

      return _removeUserFromGroup;
    }()
  }, {
    key: '_removeGroupFromUser',
    value: function () {
      var _ref28 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee20(groupId, user) {
        return _regenerator2.default.wrap(function _callee20$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                user.groups = removeFromArraySet(user.groups, groupId);
                return _context26.abrupt('return', this._users.save(user));

              case 2:
              case 'end':
                return _context26.stop();
            }
          }
        }, _callee20, this);
      }));

      function _removeGroupFromUser(_x27, _x28) {
        return _ref28.apply(this, arguments);
      }

      return _removeGroupFromUser;
    }()
  }, {
    key: 'removeUserFromGroup',
    value: function () {
      var _ref29 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee21(userId, groupId) {
        var _ref30, _ref31, user, group;

        return _regenerator2.default.wrap(function _callee21$(_context27) {
          while (1) {
            switch (_context27.prev = _context27.next) {
              case 0:
                _context27.next = 2;
                return _promise2.default.all([this.getUser(userId), this.getGroup(groupId)]);

              case 2:
                _ref30 = _context27.sent;
                _ref31 = (0, _slicedToArray3.default)(_ref30, 2);
                user = _ref31[0];
                group = _ref31[1];
                _context27.next = 8;
                return _promise2.default.all([this._removeUserFromGroup(userId, group), this._removeGroupFromUser(groupId, user)]);

              case 8:
              case 'end':
                return _context27.stop();
            }
          }
        }, _callee21, this);
      }));

      function removeUserFromGroup(_x29, _x30) {
        return _ref29.apply(this, arguments);
      }

      return removeUserFromGroup;
    }()
  }, {
    key: 'setGroupUsers',
    value: function () {
      var _ref32 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee22(groupId, userIds) {
        var _context28;

        var group, newUsersIds, oldUsersIds, getUser, _ref33, _ref34, newUsers, oldUsers, saveUser;

        return _regenerator2.default.wrap(function _callee22$(_context29) {
          while (1) {
            switch (_context29.prev = _context29.next) {
              case 0:
                _context29.next = 2;
                return this.getGroup(groupId);

              case 2:
                group = _context29.sent;
                newUsersIds = (0, _utils.lightSet)(userIds);
                oldUsersIds = [];

                (0, _utils.forEach)(group.users, function (id) {
                  if (newUsersIds.has(id)) {
                    newUsersIds.delete(id);
                  } else {
                    oldUsersIds.push(id);
                  }
                });
                newUsersIds = newUsersIds.toArray();

                getUser = this.getUser.bind(this);
                _context29.next = 10;
                return _promise2.default.all([_promise2.default.all(newUsersIds.map(getUser)), _promise2.default.all(oldUsersIds.map(getUser))]);

              case 10:
                _ref33 = _context29.sent;
                _ref34 = (0, _slicedToArray3.default)(_ref33, 2);
                newUsers = _ref34[0];
                oldUsers = _ref34[1];


                (0, _utils.forEach)(newUsers, function (user) {
                  user.groups = addToArraySet(user.groups, groupId);
                });
                (0, _utils.forEach)(oldUsers, function (user) {
                  user.groups = removeFromArraySet(user.groups, groupId);
                });

                group.users = userIds;

                saveUser = (_context28 = this._users).save.bind(_context28);
                _context29.next = 20;
                return _promise2.default.all([_promise2.default.all((0, _utils.mapToArray)(newUsers, saveUser)), _promise2.default.all((0, _utils.mapToArray)(oldUsers, saveUser)), this._groups.save(group)]);

              case 20:
              case 'end':
                return _context29.stop();
            }
          }
        }, _callee22, this);
      }));

      function setGroupUsers(_x31, _x32) {
        return _ref32.apply(this, arguments);
      }

      return setGroupUsers;
    }()
  }]);
  return _default;
}();

exports.default = _default;
//# sourceMappingURL=subjects.js.map
