'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _apiErrors = require('xo-common/api-errors');

var _xapi = require('../xapi');

var _xapi2 = _interopRequireDefault(_xapi);

var _xapiObjectToXo = require('../xapi-object-to-xo');

var _xapiObjectToXo2 = _interopRequireDefault(_xapiObjectToXo);

var _xapiStats = require('../xapi-stats');

var _xapiStats2 = _interopRequireDefault(_xapiStats);

var _utils = require('../utils');

var _server = require('../models/server');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var _default = function () {
  function _default(xo) {
    var _this = this;

    (0, _classCallCheck3.default)(this, _default);

    this._objectConflicts = (0, _utils.createRawObject)(); // TODO: clean when a server is disconnected.
    var serversDb = this._servers = new _server.Servers({
      connection: xo._redis,
      prefix: 'xo:server',
      indexes: ['host']
    });
    this._stats = new _xapiStats2.default();
    this._xapis = (0, _utils.createRawObject)();
    this._xapisByPool = (0, _utils.createRawObject)();
    this._xo = xo;

    xo.on('start', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      var servers, _loop, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, server;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              xo.addConfigManager('xenServers', function () {
                return serversDb.get();
              }, function (servers) {
                return serversDb.update(servers);
              });

              // Connects to existing servers.
              _context.next = 3;
              return serversDb.get();

            case 3:
              servers = _context.sent;

              _loop = function _loop(server) {
                if (server.enabled) {
                  _this.connectXenServer(server.id).catch(function (error) {
                    console.error(`[WARN] ${server.host}:`, error[0] || error.stack || error.code || error);
                  });
                }
              };

              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context.prev = 8;

              for (_iterator = (0, _getIterator3.default)(servers); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                server = _step.value;

                _loop(server);
              }
              _context.next = 16;
              break;

            case 12:
              _context.prev = 12;
              _context.t0 = _context['catch'](8);
              _didIteratorError = true;
              _iteratorError = _context.t0;

            case 16:
              _context.prev = 16;
              _context.prev = 17;

              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }

            case 19:
              _context.prev = 19;

              if (!_didIteratorError) {
                _context.next = 22;
                break;
              }

              throw _iteratorError;

            case 22:
              return _context.finish(19);

            case 23:
              return _context.finish(16);

            case 24:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this, [[8, 12, 16, 24], [17,, 19, 23]]);
    })));

    // TODO: disconnect servers on stop.
  }

  (0, _createClass3.default)(_default, [{
    key: 'registerXenServer',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref3) {
        var label = _ref3.label,
            host = _ref3.host,
            username = _ref3.username,
            password = _ref3.password,
            _ref3$readOnly = _ref3.readOnly,
            readOnly = _ref3$readOnly === undefined ? false : _ref3$readOnly;
        var server;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._servers.create({
                  label: label || undefined,
                  host,
                  username,
                  password,
                  readOnly: readOnly ? 'true' : undefined,
                  enabled: 'true'
                });

              case 2:
                server = _context2.sent;
                return _context2.abrupt('return', server.properties);

              case 4:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function registerXenServer(_x) {
        return _ref2.apply(this, arguments);
      }

      return registerXenServer;
    }()
  }, {
    key: 'unregisterXenServer',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(id) {
        var _context3;

        return _regenerator2.default.wrap(function _callee3$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                (_context3 = this.disconnectXenServer(id), _utils.pCatch).call(_context3, _utils.noop);

                _context4.next = 3;
                return this._servers.remove(id);

              case 3:
                if (_context4.sent) {
                  _context4.next = 5;
                  break;
                }

                throw (0, _apiErrors.noSuchObject)(id, 'xenServer');

              case 5:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee3, this);
      }));

      function unregisterXenServer(_x2) {
        return _ref4.apply(this, arguments);
      }

      return unregisterXenServer;
    }()
  }, {
    key: 'updateXenServer',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(id, _ref6) {
        var label = _ref6.label,
            host = _ref6.host,
            username = _ref6.username,
            password = _ref6.password,
            readOnly = _ref6.readOnly,
            enabled = _ref6.enabled,
            error = _ref6.error;
        var server, xapi;
        return _regenerator2.default.wrap(function _callee4$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this._getXenServer(id);

              case 2:
                server = _context5.sent;


                if (label !== undefined) server.set('label', label || undefined);
                if (host) server.set('host', host);
                if (username) server.set('username', username);
                if (password) server.set('password', password);

                if (error !== undefined) {
                  server.set('error', error ? (0, _stringify2.default)(error) : '');
                }

                if (enabled !== undefined) {
                  server.set('enabled', enabled ? 'true' : undefined);
                }

                if (readOnly !== undefined) {
                  server.set('readOnly', readOnly ? 'true' : undefined);
                  xapi = this._xapis[id];

                  if (xapi) {
                    xapi.readOnly = readOnly;
                  }
                }

                _context5.next = 12;
                return this._servers.update(server);

              case 12:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee4, this);
      }));

      function updateXenServer(_x3, _x4) {
        return _ref5.apply(this, arguments);
      }

      return updateXenServer;
    }()

    // TODO: this method will no longer be async when servers are
    // integrated to the main collection.

  }, {
    key: '_getXenServer',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(id) {
        var server;
        return _regenerator2.default.wrap(function _callee5$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this._servers.first(id);

              case 2:
                server = _context6.sent;

                if (server) {
                  _context6.next = 5;
                  break;
                }

                throw (0, _apiErrors.noSuchObject)(id, 'xenServer');

              case 5:
                return _context6.abrupt('return', server);

              case 6:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee5, this);
      }));

      function _getXenServer(_x5) {
        return _ref7.apply(this, arguments);
      }

      return _getXenServer;
    }()
  }, {
    key: '_onXenAdd',
    value: function _onXenAdd(xapiObjects, xapiIdsToXo, toRetry, conId) {
      var conflicts = this._objectConflicts;
      var objects = this._xo._objects;

      (0, _utils.forEach)(xapiObjects, function (xapiObject, xapiId) {
        try {
          var xoObject = (0, _xapiObjectToXo2.default)(xapiObject);
          if (!xoObject) {
            return;
          }

          var xoId = xoObject.id;
          xapiIdsToXo[xapiId] = xoId;

          var previous = objects.get(xoId, undefined);
          if (previous && previous._xapiRef !== xapiObject.$ref) {
            (conflicts[xoId] || (conflicts[xoId] = (0, _utils.createRawObject)()))[conId] = xoObject;
          } else {
            objects.set(xoId, xoObject);
          }
        } catch (error) {
          console.error('ERROR: xapiObjectToXo', error);

          toRetry[xapiId] = xapiObject;
        }
      });
    }
  }, {
    key: '_onXenRemove',
    value: function _onXenRemove(xapiObjects, xapiIdsToXo, toRetry, conId) {
      var conflicts = this._objectConflicts;
      var objects = this._xo._objects;

      (0, _utils.forEach)(xapiObjects, function (_, xapiId) {
        toRetry && delete toRetry[xapiId];

        var xoId = xapiIdsToXo[xapiId];
        if (!xoId) {
          // This object was not known previously.
          return;
        }

        delete xapiIdsToXo[xapiId];

        var objConflicts = conflicts[xoId];
        if (objConflicts) {
          if (objConflicts[conId]) {
            delete objConflicts[conId];
          } else {
            objects.set(xoId, (0, _utils.popProperty)(objConflicts));
          }

          if ((0, _utils.isEmpty)(objConflicts)) {
            delete conflicts[xoId];
          }
        } else {
          objects.unset(xoId);
        }
      });
    }
  }, {
    key: 'connectXenServer',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(id) {
        var _this2 = this;

        var server, xapi;
        return _regenerator2.default.wrap(function _callee7$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this._getXenServer(id);

              case 2:
                server = _context8.sent.properties;
                xapi = this._xapis[server.id] = new _xapi2.default({
                  url: server.host,
                  auth: {
                    user: server.username,
                    password: server.password
                  },
                  readOnly: Boolean(server.readOnly)
                });


                xapi.xo = function () {
                  var conId = server.id;

                  // Maps ids of XAPI objects to ids of XO objects.
                  var xapiIdsToXo = (0, _utils.createRawObject)();

                  // Map of XAPI objects which failed to be transformed to XO
                  // objects.
                  //
                  // At each `finish` there will be another attempt to transform
                  // until they succeed.
                  var toRetry = void 0;
                  var toRetryNext = (0, _utils.createRawObject)();

                  var onAddOrUpdate = function onAddOrUpdate(objects) {
                    _this2._onXenAdd(objects, xapiIdsToXo, toRetryNext, conId);
                  };
                  var onRemove = function onRemove(objects) {
                    _this2._onXenRemove(objects, xapiIdsToXo, toRetry, conId);
                  };

                  var xapisByPool = _this2._xapisByPool;
                  var onFinish = function onFinish() {
                    var pool = xapi.pool;

                    if (pool) {
                      xapisByPool[pool.$id] = xapi;
                    }

                    if (!(0, _utils.isEmpty)(toRetry)) {
                      onAddOrUpdate(toRetry);
                      toRetry = null;
                    }

                    if (!(0, _utils.isEmpty)(toRetryNext)) {
                      toRetry = toRetryNext;
                      toRetryNext = (0, _utils.createRawObject)();
                    }
                  };

                  var objects = xapi.objects;


                  var addObject = function addObject(object) {
                    // TODO: optimize.
                    onAddOrUpdate({ [object.$id]: object });
                    return (0, _xapiObjectToXo2.default)(object);
                  };

                  return {
                    install() {
                      objects.on('add', onAddOrUpdate);
                      objects.on('update', onAddOrUpdate);
                      objects.on('remove', onRemove);
                      objects.on('finish', onFinish);

                      onAddOrUpdate(objects.all);
                    },
                    uninstall() {
                      objects.removeListener('add', onAddOrUpdate);
                      objects.removeListener('update', onAddOrUpdate);
                      objects.removeListener('remove', onRemove);
                      objects.removeListener('finish', onFinish);

                      onRemove(objects.all);
                    },

                    addObject,
                    getData: function getData(id, key) {
                      var value = (typeof id === 'string' ? xapi.getObject(id) : id).other_config[`xo:${(0, _utils.camelToSnakeCase)(key)}`];
                      return value && JSON.parse(value);
                    },
                    setData: function () {
                      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(id, key, value) {
                        return _regenerator2.default.wrap(function _callee6$(_context7) {
                          while (1) {
                            switch (_context7.prev = _context7.next) {
                              case 0:
                                _context7.next = 2;
                                return xapi._updateObjectMapProperty(xapi.getObject(id), 'other_config', { [`xo:${(0, _utils.camelToSnakeCase)(key)}`]: (0, _stringify2.default)(value) });

                              case 2:
                                _context7.t0 = addObject;
                                _context7.next = 5;
                                return xapi._waitObject(id);

                              case 5:
                                _context7.t1 = _context7.sent;
                                (0, _context7.t0)(_context7.t1);

                              case 7:
                              case 'end':
                                return _context7.stop();
                            }
                          }
                        }, _callee6, _this2);
                      }));

                      return function setData(_x7, _x8, _x9) {
                        return _ref9.apply(this, arguments);
                      };
                    }()
                  };
                }();

                xapi.xo.install();

                _context8.next = 8;
                return xapi.connect().then(function () {
                  return _this2.updateXenServer(id, { error: null });
                }, function (error) {
                  _this2.updateXenServer(id, { error: (0, _utils.serializeError)(error) });

                  throw error;
                });

              case 8:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee7, this);
      }));

      function connectXenServer(_x6) {
        return _ref8.apply(this, arguments);
      }

      return connectXenServer;
    }()
  }, {
    key: 'disconnectXenServer',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(id) {
        var xapi, pool;
        return _regenerator2.default.wrap(function _callee8$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                xapi = this._xapis[id];

                if (xapi) {
                  _context9.next = 3;
                  break;
                }

                throw (0, _apiErrors.noSuchObject)(id, 'xenServer');

              case 3:

                delete this._xapis[id];

                pool = xapi.pool;

                if (pool) {
                  delete this._xapisByPool[pool.id];
                }

                xapi.xo.uninstall();
                return _context9.abrupt('return', xapi.disconnect());

              case 8:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee8, this);
      }));

      function disconnectXenServer(_x10) {
        return _ref10.apply(this, arguments);
      }

      return disconnectXenServer;
    }()
  }, {
    key: 'getAllXapis',
    value: function getAllXapis() {
      return this._xapis;
    }

    // Returns the XAPI connection associated to an object.

  }, {
    key: 'getXapi',
    value: function getXapi(object, type) {
      if ((0, _utils.isString)(object)) {
        object = this._xo.getObject(object, type);
      }

      var _object = object,
          poolId = _object.$pool;

      if (!poolId) {
        throw new Error(`object ${object.id} does not belong to a pool`);
      }

      var xapi = this._xapisByPool[poolId];
      if (!xapi) {
        throw new Error(`no connection found for object ${object.id}`);
      }

      return xapi;
    }
  }, {
    key: 'getAllXenServers',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9() {
        var servers, xapis;
        return _regenerator2.default.wrap(function _callee9$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this._servers.get();

              case 2:
                servers = _context10.sent;
                xapis = this._xapis;

                (0, _utils.forEach)(servers, function (server) {
                  var xapi = xapis[server.id];
                  server.status = xapi ? xapi.status : 'disconnected';

                  // Do not expose password.
                  delete server.password;
                });

                return _context10.abrupt('return', servers);

              case 6:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee9, this);
      }));

      function getAllXenServers() {
        return _ref11.apply(this, arguments);
      }

      return getAllXenServers;
    }()
  }, {
    key: 'getXapiVmStats',
    value: function getXapiVmStats(vm, granularity) {
      var xapi = this.getXapi(vm);
      return this._stats.getVmPoints(xapi, vm._xapiId, granularity);
    }
  }, {
    key: 'getXapiHostStats',
    value: function getXapiHostStats(host, granularity) {
      var xapi = this.getXapi(host);
      return this._stats.getHostPoints(xapi, host._xapiId, granularity);
    }
  }, {
    key: 'mergeXenPools',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(sourceId, targetId) {
        var force = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

        var sourceXapi, _getXapi, _getXapi$_auth, user, password, hostname;

        return _regenerator2.default.wrap(function _callee10$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                sourceXapi = this.getXapi(sourceId);
                _getXapi = this.getXapi(targetId), _getXapi$_auth = _getXapi._auth, user = _getXapi$_auth.user, password = _getXapi$_auth.password, hostname = _getXapi._url.hostname;

                // We don't want the events of the source XAPI to interfere with
                // the events of the new XAPI.

                sourceXapi.xo.uninstall();

                _context11.prev = 3;
                _context11.next = 6;
                return sourceXapi.joinPool(hostname, user, password, force);

              case 6:
                _context11.next = 12;
                break;

              case 8:
                _context11.prev = 8;
                _context11.t0 = _context11['catch'](3);

                sourceXapi.xo.install();

                throw _context11.t0;

              case 12:
                _context11.next = 14;
                return this.unregisterXenServer(sourceId);

              case 14:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee10, this, [[3, 8]]);
      }));

      function mergeXenPools(_x11, _x12) {
        return _ref12.apply(this, arguments);
      }

      return mergeXenPools;
    }()
  }]);
  return _default;
}();

exports.default = _default;
//# sourceMappingURL=xen-servers.js.map
