'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _includes = require('lodash/includes');

var _includes2 = _interopRequireDefault(_includes);

var _xoCollection = require('xo-collection');

var _xoCollection2 = _interopRequireDefault(_xoCollection);

var _uniqueIndex = require('xo-collection/unique-index');

var _uniqueIndex2 = _interopRequireDefault(_uniqueIndex);

var _redis = require('redis');

var _events = require('events');

var _apiErrors = require('xo-common/api-errors');

var _xoMixins = require('./xo-mixins');

var _xoMixins2 = _interopRequireDefault(_xoMixins);

var _connection = require('./connection');

var _connection2 = _interopRequireDefault(_connection);

var _leveldb = require('./loggers/leveldb');

var _leveldb2 = _interopRequireDefault(_leveldb);

var _decorators = require('./decorators');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ===================================================================

var Xo = (_dec = (0, _decorators.mixin)((0, _utils.mapToArray)(_xoMixins2.default)), _dec(_class = function (_EventEmitter) {
  (0, _inherits3.default)(Xo, _EventEmitter);

  function Xo(config) {
    (0, _classCallCheck3.default)(this, Xo);

    // a lot of mixins adds listener for start/stop/… events
    var _this = (0, _possibleConstructorReturn3.default)(this, (Xo.__proto__ || (0, _getPrototypeOf2.default)(Xo)).call(this));

    _this.setMaxListeners(0);

    _this._config = config;

    _this._objects = new _xoCollection2.default();
    _this._objects.createIndex('byRef', new _uniqueIndex2.default('_xapiRef'));

    // Connections to users.
    _this._nextConId = 0;
    _this._connections = (0, _utils.createRawObject)();

    _this._httpRequestWatchers = (0, _utils.createRawObject)();

    // Connects to Redis.
    {
      var _ref = config.redis || {},
          rename_commands = _ref.renameCommands,
          path = _ref.socket,
          url = _ref.uri;

      _this._redis = (0, _redis.createClient)({ path, rename_commands, url });
    }
    return _this;
  }

  // -----------------------------------------------------------------

  (0, _createClass3.default)(Xo, [{
    key: 'clean',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var _this2 = this;

        var handleCleanError;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                handleCleanError = function handleCleanError(error) {
                  console.error('[WARN] clean error:', error && error.stack || error);
                };

                _context.next = 3;
                return _promise2.default.all((0, _utils.mapToArray)(this.listeners('clean'), function (listener) {
                  return new _promise2.default(function (resolve) {
                    resolve(listener.call(_this2));
                  }).catch(handleCleanError);
                }));

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function clean() {
        return _ref2.apply(this, arguments);
      }

      return clean;
    }()

    // -----------------------------------------------------------------

  }, {
    key: 'start',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        var _this3 = this;

        var handleStartError;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.start = _utils.noop;

                this._watchObjects();

                // ---------------------------------------------------------------

                handleStartError = function handleStartError(error) {
                  console.error('[WARN] start error:', error && error.stack || error);
                };

                _context2.next = 5;
                return _promise2.default.all((0, _utils.mapToArray)(this.listeners('start'), function (listener) {
                  return new _promise2.default(function (resolve) {
                    resolve(listener.call(_this3));
                  }).catch(handleStartError);
                }));

              case 5:
                this.removeAllListeners('start');

                this.emit('started');
                this.removeAllListeners('started');

              case 8:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function start() {
        return _ref3.apply(this, arguments);
      }

      return start;
    }()

    // -----------------------------------------------------------------

  }, {
    key: 'stop',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
        var _this4 = this;

        var handleStopError;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                this.stop = _utils.noop;

                handleStopError = function handleStopError(error) {
                  console.error('[WARN] stop error:', error && error.stack || error);
                };

                _context3.next = 4;
                return _promise2.default.all((0, _utils.mapToArray)(this.listeners('stop'), function (listener) {
                  return new _promise2.default(function (resolve) {
                    resolve(listener.call(_this4));
                  }).catch(handleStopError);
                }));

              case 4:
                this.removeAllListeners('stop');

                this.emit('stopped');
                this.removeAllListeners('stopped');

              case 7:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function stop() {
        return _ref4.apply(this, arguments);
      }

      return stop;
    }()

    // -----------------------------------------------------------------

  }, {
    key: 'getLogger',
    value: function getLogger(namespace) {
      return this.getStore('logs').then(function (store) {
        return new _leveldb2.default(store, namespace);
      });
    }

    // -----------------------------------------------------------------

    // Returns an object from its key or UUID.
    //
    // TODO: should throw a NoSuchObject error on failure.

  }, {
    key: 'getObject',
    value: function getObject(key, type) {
      var _objects = this._objects,
          all = _objects.all,
          byRef = _objects.indexes.byRef;


      var obj = all[key] || byRef[key];
      if (!obj) {
        throw (0, _apiErrors.noSuchObject)(key, type);
      }

      if (type != null && ((0, _utils.isString)(type) && type !== obj.type || !(0, _includes2.default)(type, obj.type) // Array
      )) {
        throw (0, _apiErrors.noSuchObject)(key, type);
      }

      return obj;
    }
  }, {
    key: 'getObjects',
    value: function getObjects(keys) {
      var _objects2 = this._objects,
          all = _objects2.all,
          byRef = _objects2.indexes.byRef;

      // Returns all objects if no keys have been passed.

      if (!keys) {
        return all;
      }

      // Fetches all objects and ignores those missing.
      var result = [];
      (0, _utils.forEach)(keys, function (key) {
        var object = all[key] || byRef[key];
        if (object) {
          result.push(object);
        }
      });
      return result;
    }

    // -----------------------------------------------------------------

  }, {
    key: 'createUserConnection',
    value: function createUserConnection() {
      var connections = this._connections;


      var connection = new _connection2.default();
      var id = connection.id = this._nextConId++;

      connections[id] = connection;
      connection.on('close', function () {
        delete connections[id];
      });

      return connection;
    }

    // -----------------------------------------------------------------

  }, {
    key: '_handleHttpRequest',
    value: function _handleHttpRequest(req, res, next) {
      var _this5 = this;

      var url = req.url;
      var watchers = this._httpRequestWatchers;

      var watcher = watchers[url];
      if (!watcher) {
        next();
        return;
      }
      if (!watcher.persistent) {
        delete watchers[url];
      }

      var fn = watcher.fn,
          data = watcher.data;

      new _promise2.default(function (resolve) {
        resolve(fn.call(_this5, req, res, data, next));
      }).then(function (result) {
        if (result != null) {
          res.end((0, _stringify2.default)(result));
        }
      }, function (error) {
        console.error('HTTP request error', error.stack || error);

        if (!res.headersSent) {
          res.writeHead(500);
        }
        res.end('unknown error');
      });
    }
  }, {
    key: 'registerHttpRequest',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(fn, data) {
        var _ref6 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
            _ref6$suffix = _ref6.suffix,
            suffix = _ref6$suffix === undefined ? '' : _ref6$suffix;

        var watchers, url;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                watchers = this._httpRequestWatchers;
                _context4.next = 3;
                return function generateUniqueUrl() {
                  return (0, _utils.generateToken)().then(function (token) {
                    var url = `/api/${token}${suffix}`;

                    return url in watchers ? generateUniqueUrl() : url;
                  });
                }();

              case 3:
                url = _context4.sent;


                watchers[url] = {
                  data,
                  fn
                };

                return _context4.abrupt('return', url);

              case 6:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function registerHttpRequest(_x, _x2) {
        return _ref5.apply(this, arguments);
      }

      return registerHttpRequest;
    }()
  }, {
    key: 'registerHttpRequestHandler',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(url, fn) {
        var _ref8 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
            _ref8$data = _ref8.data,
            data = _ref8$data === undefined ? undefined : _ref8$data,
            _ref8$persistent = _ref8.persistent,
            persistent = _ref8$persistent === undefined ? true : _ref8$persistent;

        var watchers;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                watchers = this._httpRequestWatchers;

                if (!(url in watchers)) {
                  _context5.next = 3;
                  break;
                }

                throw new Error(`a handler is already registered for ${url}`);

              case 3:

                watchers[url] = {
                  data,
                  fn,
                  persistent
                };

              case 4:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function registerHttpRequestHandler(_x4, _x5) {
        return _ref7.apply(this, arguments);
      }

      return registerHttpRequestHandler;
    }()
  }, {
    key: 'unregisterHttpRequestHandler',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(url) {
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                delete this._httpRequestWatchers[url];

              case 1:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function unregisterHttpRequestHandler(_x7) {
        return _ref9.apply(this, arguments);
      }

      return unregisterHttpRequestHandler;
    }()

    // -----------------------------------------------------------------

    // Plugins can use this method to expose methods directly on XO.

  }, {
    key: 'defineProperty',
    value: function defineProperty(name, value) {
      var _this6 = this;

      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      if (name in this) {
        throw new Error(`Xo#${name} is already defined`);
      }

      // For security, prevent from accessing `this`.
      if ((0, _utils.isFunction)(value)) {
        value = function (value) {
          return function () {
            return value.apply(thisArg, arguments);
          };
        }(value);
      }

      (0, _defineProperty2.default)(this, name, {
        configurable: true,
        value
      });

      var _unset = function unset() {
        delete _this6[name];
        _unset = _utils.noop;
      };
      return function () {
        return _unset();
      };
    }

    // Convenience method to define multiple properties at once.

  }, {
    key: 'defineProperties',
    value: function defineProperties(props, thisArg) {
      var _this7 = this;

      var unsets = [];
      var unset = function unset() {
        return (0, _utils.forEach)(unsets, function (unset) {
          return unset();
        });
      };

      try {
        (0, _utils.forEach)(props, function (value, name) {
          unsets.push(_this7.defineProperty(name, value, thisArg));
        });
      } catch (error) {
        unset();
        throw error;
      }

      return unset;
    }

    // -----------------------------------------------------------------

    // Watches objects changes.
    //
    // Some should be forwarded to connected clients.
    // Some should be persistently saved.

  }, {
    key: '_watchObjects',
    value: function _watchObjects() {
      var connections = this._connections,
          objects = this._objects;


      var entered = void 0,
          exited = void 0;
      function reset() {
        entered = (0, _utils.createRawObject)();
        exited = (0, _utils.createRawObject)();
      }
      reset();

      function onAdd(items) {
        (0, _utils.forEach)(items, function (item, id) {
          entered[id] = item;
        });
      }
      objects.on('add', onAdd);
      objects.on('update', onAdd);

      objects.on('remove', function (items) {
        (0, _utils.forEach)(items, function (_, id) {
          // We don't care about the value here, so we choose `0`
          // because it is small in JSON.
          exited[id] = 0;
        });
      });

      objects.on('finish', function () {
        var enteredMessage = !(0, _utils.isEmpty)(entered) && {
          type: 'enter',
          items: entered
        };
        var exitedMessage = !(0, _utils.isEmpty)(exited) && {
          type: 'exit',
          items: exited
        };

        if (!enteredMessage && !exitedMessage) {
          return;
        }

        (0, _utils.forEach)(connections, function (connection) {
          // Notifies only authenticated clients.
          if (connection.has('user_id') && connection.notify) {
            if (enteredMessage) {
              connection.notify('all', enteredMessage);
            }
            if (exitedMessage) {
              connection.notify('all', exitedMessage);
            }
          }
        });

        reset();
      });
    }
  }]);
  return Xo;
}(_events.EventEmitter)) || _class);
exports.default = Xo;
//# sourceMappingURL=xo.js.map
